/* File: linalg_utilsmodule.c
 * This file is auto-generated with f2py (version:2).
 * f2py is a Fortran to Python Interface Generator (FPIG), Second Edition,
 * written by Pearu Peterson <pearu@cens.ioc.ee>.
 * See http://cens.ioc.ee/projects/f2py2e/
 * Generation date: Thu Oct 16 23:34:17 2014
 * $Revision:$
 * $Date:$
 * Do not edit this file directly unless you know what you are doing!!!
 */
#ifdef __cplusplus
extern "C" {
#endif

/*********************** See f2py2e/cfuncs.py: includes ***********************/
#include "Python.h"
#include <stdarg.h>
#include "fortranobject.h"
#include <string.h>
#include <setjmp.h>
#include <math.h>

/**************** See f2py2e/rules.py: mod_rules['modulebody'] ****************/
static PyObject *linalg_utils_error;
static PyObject *linalg_utils_module;

/*********************** See f2py2e/cfuncs.py: typedefs ***********************/
typedef char * string;
typedef struct {double r,i;} complex_double;

/****************** See f2py2e/cfuncs.py: typedefs_generated ******************/
typedef double(*cb_cov_fun_in_diag_call__user__routines_typedef)(double *,int *);

/********************** See f2py2e/cfuncs.py: cppmacros **********************/
\
#define FAILNULL(p) do {                                            \
    if ((p) == NULL) {                                              \
        PyErr_SetString(PyExc_MemoryError, "NULL pointer found");   \
        goto capi_fail;                                             \
    }                                                               \
} while (0)

#define STRINGMALLOC(str,len)\
  if ((str = (string)malloc(sizeof(char)*(len+1))) == NULL) {\
    PyErr_SetString(PyExc_MemoryError, "out of memory");\
    goto capi_fail;\
  } else {\
    (str)[len] = '\0';\
  }

#define PRINTPYOBJERR(obj)\
  fprintf(stderr,"linalg_utils.error is related to ");\
  PyObject_Print((PyObject *)obj,stderr,Py_PRINT_RAW);\
  fprintf(stderr,"\n");

#define GETSCALARFROMPYTUPLE(tuple,index,var,ctype,mess) {\
    if ((capi_tmp = PyTuple_GetItem((tuple),(index)))==NULL) goto capi_fail;\
    if (!(ctype ## _from_pyobj((var),capi_tmp,mess)))\
      goto capi_fail;\
  }

#ifdef DEBUGCFUNCS
#define CFUNCSMESS(mess) fprintf(stderr,"debug-capi:"mess);
#define CFUNCSMESSPY(mess,obj) CFUNCSMESS(mess) \
  PyObject_Print((PyObject *)obj,stderr,Py_PRINT_RAW);\
  fprintf(stderr,"\n");
#else
#define CFUNCSMESS(mess)
#define CFUNCSMESSPY(mess,obj)
#endif

#if defined(PREPEND_FORTRAN)
#if defined(NO_APPEND_FORTRAN)
#if defined(UPPERCASE_FORTRAN)
#define F_FUNC(f,F) _##F
#else
#define F_FUNC(f,F) _##f
#endif
#else
#if defined(UPPERCASE_FORTRAN)
#define F_FUNC(f,F) _##F##_
#else
#define F_FUNC(f,F) _##f##_
#endif
#endif
#else
#if defined(NO_APPEND_FORTRAN)
#if defined(UPPERCASE_FORTRAN)
#define F_FUNC(f,F) F
#else
#define F_FUNC(f,F) f
#endif
#else
#if defined(UPPERCASE_FORTRAN)
#define F_FUNC(f,F) F##_
#else
#define F_FUNC(f,F) f##_
#endif
#endif
#endif
#if defined(UNDERSCORE_G77)
#define F_FUNC_US(f,F) F_FUNC(f##_,F##_)
#else
#define F_FUNC_US(f,F) F_FUNC(f,F)
#endif

#define rank(var) var ## _Rank
#define shape(var,dim) var ## _Dims[dim]
#define old_rank(var) (((PyArrayObject *)(capi_ ## var ## _tmp))->nd)
#define old_shape(var,dim) (((PyArrayObject *)(capi_ ## var ## _tmp))->dimensions[dim])
#define fshape(var,dim) shape(var,rank(var)-dim-1)
#define len(var) shape(var,0)
#define flen(var) fshape(var,0)
#define old_size(var) PyArray_SIZE((PyArrayObject *)(capi_ ## var ## _tmp))
/* #define index(i) capi_i ## i */
#define slen(var) capi_ ## var ## _len
#define size(var, ...) f2py_size((PyArrayObject *)(capi_ ## var ## _tmp), ## __VA_ARGS__, -1)

#define CHECKSCALAR(check,tcheck,name,show,var)\
  if (!(check)) {\
    char errstring[256];\
    sprintf(errstring, "%s: "show, "("tcheck") failed for "name, var);\
    PyErr_SetString(linalg_utils_error,errstring);\
    /*goto capi_fail;*/\
  } else 
#ifndef max
#define max(a,b) ((a > b) ? (a) : (b))
#endif
#ifndef min
#define min(a,b) ((a < b) ? (a) : (b))
#endif
#ifndef MAX
#define MAX(a,b) ((a > b) ? (a) : (b))
#endif
#ifndef MIN
#define MIN(a,b) ((a < b) ? (a) : (b))
#endif

#define SWAP(a,b,t) {\
  t *c;\
  c = a;\
  a = b;\
  b = c;}

#define STRINGFREE(str) do {if (!(str == NULL)) free(str);} while (0)

#if defined(PREPEND_FORTRAN)
#if defined(NO_APPEND_FORTRAN)
#if defined(UPPERCASE_FORTRAN)
#define F_WRAPPEDFUNC(f,F) _F2PYWRAP##F
#else
#define F_WRAPPEDFUNC(f,F) _f2pywrap##f
#endif
#else
#if defined(UPPERCASE_FORTRAN)
#define F_WRAPPEDFUNC(f,F) _F2PYWRAP##F##_
#else
#define F_WRAPPEDFUNC(f,F) _f2pywrap##f##_
#endif
#endif
#else
#if defined(NO_APPEND_FORTRAN)
#if defined(UPPERCASE_FORTRAN)
#define F_WRAPPEDFUNC(f,F) F2PYWRAP##F
#else
#define F_WRAPPEDFUNC(f,F) f2pywrap##f
#endif
#else
#if defined(UPPERCASE_FORTRAN)
#define F_WRAPPEDFUNC(f,F) F2PYWRAP##F##_
#else
#define F_WRAPPEDFUNC(f,F) f2pywrap##f##_
#endif
#endif
#endif
#if defined(UNDERSCORE_G77)
#define F_WRAPPEDFUNC_US(f,F) F_WRAPPEDFUNC(f##_,F##_)
#else
#define F_WRAPPEDFUNC_US(f,F) F_WRAPPEDFUNC(f,F)
#endif

#define pyobj_from_complex_double1(v) (PyComplex_FromDoubles(v.r,v.i))
#define STRINGCOPYN(to,from,buf_size)                           \
    do {                                                        \
        int _m = (buf_size);                                    \
        char *_to = (to);                                       \
        char *_from = (from);                                   \
        FAILNULL(_to); FAILNULL(_from);                         \
        (void)strncpy(_to, _from, sizeof(char)*_m);             \
        _to[_m-1] = '\0';                                      \
        /* Padding with spaces instead of nulls */              \
        for (_m -= 2; _m >= 0 && _to[_m] == '\0'; _m--) {      \
            _to[_m] = ' ';                                      \
        }                                                       \
    } while (0)


/************************ See f2py2e/cfuncs.py: cfuncs ************************/
static int f2py_size(PyArrayObject* var, ...)
{
  npy_int sz = 0;
  npy_int dim;
  npy_int rank;
  va_list argp;
  va_start(argp, var);
  dim = va_arg(argp, npy_int);
  if (dim==-1)
    {
      sz = PyArray_SIZE(var);
    }
  else
    {
      rank = PyArray_NDIM(var);
      if (dim>=1 && dim<=rank)
        sz = PyArray_DIM(var, dim-1);
      else
        fprintf(stderr, "f2py_size: 2nd argument value=%d fails to satisfy 1<=value<=%d. Result will be 0.\n", dim, rank);
    }
  va_end(argp);
  return sz;
}

static int double_from_pyobj(double* v,PyObject *obj,const char *errmess) {
  PyObject* tmp = NULL;
  if (PyFloat_Check(obj)) {
#ifdef __sgi
    *v = PyFloat_AsDouble(obj);
#else
    *v = PyFloat_AS_DOUBLE(obj);
#endif
    return 1;
  }
  tmp = PyNumber_Float(obj);
  if (tmp) {
#ifdef __sgi
    *v = PyFloat_AsDouble(tmp);
#else
    *v = PyFloat_AS_DOUBLE(tmp);
#endif
    Py_DECREF(tmp);
    return 1;
  }
  if (PyComplex_Check(obj))
    tmp = PyObject_GetAttrString(obj,"real");
  else if (PyString_Check(obj) || PyUnicode_Check(obj))
    /*pass*/;
  else if (PySequence_Check(obj))
    tmp = PySequence_GetItem(obj,0);
  if (tmp) {
    PyErr_Clear();
    if (double_from_pyobj(v,tmp,errmess)) {Py_DECREF(tmp); return 1;}
    Py_DECREF(tmp);
  }
  {
    PyObject* err = PyErr_Occurred();
    if (err==NULL) err = linalg_utils_error;
    PyErr_SetString(err,errmess);
  }
  return 0;
}

static int create_cb_arglist(PyObject* fun,PyTupleObject* xa,const int maxnofargs,const int nofoptargs,int *nofargs,PyTupleObject **args,const char *errmess) {
  PyObject *tmp = NULL;
  PyObject *tmp_fun = NULL;
  int tot,opt,ext,siz,i,di=0;
  CFUNCSMESS("create_cb_arglist\n");
  tot=opt=ext=siz=0;
  /* Get the total number of arguments */
  if (PyFunction_Check(fun))
    tmp_fun = fun;
  else {
    di = 1;
    if (PyObject_HasAttrString(fun,"im_func")) {
      tmp_fun = PyObject_GetAttrString(fun,"im_func");
    }
    else if (PyObject_HasAttrString(fun,"__call__")) {
      tmp = PyObject_GetAttrString(fun,"__call__");
      if (PyObject_HasAttrString(tmp,"im_func"))
        tmp_fun = PyObject_GetAttrString(tmp,"im_func");
      else {
        tmp_fun = fun; /* built-in function */
        tot = maxnofargs;
        if (xa != NULL)
          tot += PyTuple_Size((PyObject *)xa);
      }
      Py_XDECREF(tmp);
    }
    else if (PyFortran_Check(fun) || PyFortran_Check1(fun)) {
      tot = maxnofargs;
      if (xa != NULL)
        tot += PyTuple_Size((PyObject *)xa);
      tmp_fun = fun;
    }
    else if (F2PyCapsule_Check(fun)) {
      tot = maxnofargs;
      if (xa != NULL)
        ext = PyTuple_Size((PyObject *)xa);
      if(ext>0) {
        fprintf(stderr,"extra arguments tuple cannot be used with CObject call-back\n");
        goto capi_fail;
      }
      tmp_fun = fun;
    }
  }
if (tmp_fun==NULL) {
fprintf(stderr,"Call-back argument must be function|instance|instance.__call__|f2py-function but got %s.\n",(fun==NULL?"NULL":Py_TYPE(fun)->tp_name));
goto capi_fail;
}
#if PY_VERSION_HEX >= 0x03000000
  if (PyObject_HasAttrString(tmp_fun,"__code__")) {
    if (PyObject_HasAttrString(tmp = PyObject_GetAttrString(tmp_fun,"__code__"),"co_argcount"))
#else
  if (PyObject_HasAttrString(tmp_fun,"func_code")) {
    if (PyObject_HasAttrString(tmp = PyObject_GetAttrString(tmp_fun,"func_code"),"co_argcount"))
#endif
      tot = PyInt_AsLong(PyObject_GetAttrString(tmp,"co_argcount")) - di;
    Py_XDECREF(tmp);
  }
  /* Get the number of optional arguments */
#if PY_VERSION_HEX >= 0x03000000
  if (PyObject_HasAttrString(tmp_fun,"__defaults__")) {
    if (PyTuple_Check(tmp = PyObject_GetAttrString(tmp_fun,"__defaults__")))
#else
  if (PyObject_HasAttrString(tmp_fun,"func_defaults")) {
    if (PyTuple_Check(tmp = PyObject_GetAttrString(tmp_fun,"func_defaults")))
#endif
      opt = PyTuple_Size(tmp);
    Py_XDECREF(tmp);
  }
  /* Get the number of extra arguments */
  if (xa != NULL)
    ext = PyTuple_Size((PyObject *)xa);
  /* Calculate the size of call-backs argument list */
  siz = MIN(maxnofargs+ext,tot);
  *nofargs = MAX(0,siz-ext);
#ifdef DEBUGCFUNCS
  fprintf(stderr,"debug-capi:create_cb_arglist:maxnofargs(-nofoptargs),tot,opt,ext,siz,nofargs=%d(-%d),%d,%d,%d,%d,%d\n",maxnofargs,nofoptargs,tot,opt,ext,siz,*nofargs);
#endif
  if (siz<tot-opt) {
    fprintf(stderr,"create_cb_arglist: Failed to build argument list (siz) with enough arguments (tot-opt) required by user-supplied function (siz,tot,opt=%d,%d,%d).\n",siz,tot,opt);
    goto capi_fail;
  }
  /* Initialize argument list */
  *args = (PyTupleObject *)PyTuple_New(siz);
  for (i=0;i<*nofargs;i++) {
    Py_INCREF(Py_None);
    PyTuple_SET_ITEM((PyObject *)(*args),i,Py_None);
  }
  if (xa != NULL)
    for (i=(*nofargs);i<siz;i++) {
      tmp = PyTuple_GetItem((PyObject *)xa,i-(*nofargs));
      Py_INCREF(tmp);
      PyTuple_SET_ITEM(*args,i,tmp);
    }
  CFUNCSMESS("create_cb_arglist-end\n");
  return 1;
capi_fail:
  if ((PyErr_Occurred())==NULL)
    PyErr_SetString(linalg_utils_error,errmess);
  return 0;
}

static int int_from_pyobj(int* v,PyObject *obj,const char *errmess) {
  PyObject* tmp = NULL;
  if (PyInt_Check(obj)) {
    *v = (int)PyInt_AS_LONG(obj);
    return 1;
  }
  tmp = PyNumber_Int(obj);
  if (tmp) {
    *v = PyInt_AS_LONG(tmp);
    Py_DECREF(tmp);
    return 1;
  }
  if (PyComplex_Check(obj))
    tmp = PyObject_GetAttrString(obj,"real");
  else if (PyString_Check(obj) || PyUnicode_Check(obj))
    /*pass*/;
  else if (PySequence_Check(obj))
    tmp = PySequence_GetItem(obj,0);
  if (tmp) {
    PyErr_Clear();
    if (int_from_pyobj(v,tmp,errmess)) {Py_DECREF(tmp); return 1;}
    Py_DECREF(tmp);
  }
  {
    PyObject* err = PyErr_Occurred();
    if (err==NULL) err = linalg_utils_error;
    PyErr_SetString(err,errmess);
  }
  return 0;
}

static int string_from_pyobj(string *str,int *len,const string inistr,PyObject *obj,const char *errmess) {
  PyArrayObject *arr = NULL;
  PyObject *tmp = NULL;
#ifdef DEBUGCFUNCS
fprintf(stderr,"string_from_pyobj(str='%s',len=%d,inistr='%s',obj=%p)\n",(char*)str,*len,(char *)inistr,obj);
#endif
  if (obj == Py_None) {
    if (*len == -1)
      *len = strlen(inistr); /* Will this cause problems? */
    STRINGMALLOC(*str,*len);
    STRINGCOPYN(*str,inistr,*len+1);
    return 1;
  }
  if (PyArray_Check(obj)) {
    if ((arr = (PyArrayObject *)obj) == NULL)
      goto capi_fail;
    if (!ISCONTIGUOUS(arr)) {
      PyErr_SetString(PyExc_ValueError,"array object is non-contiguous.");
      goto capi_fail;
    }
    if (*len == -1)
      *len = (arr->descr->elsize)*PyArray_SIZE(arr);
    STRINGMALLOC(*str,*len);
    STRINGCOPYN(*str,arr->data,*len+1);
    return 1;
  }
  if (PyString_Check(obj)) {
    tmp = obj;
    Py_INCREF(tmp);
  }
#if PY_VERSION_HEX >= 0x03000000
  else if (PyUnicode_Check(obj)) {
    tmp = PyUnicode_AsASCIIString(obj);
  }
  else {
    PyObject *tmp2;
    tmp2 = PyObject_Str(obj);
    if (tmp2) {
      tmp = PyUnicode_AsASCIIString(tmp2);
      Py_DECREF(tmp2);
    }
    else {
      tmp = NULL;
    }
  }
#else
  else {
    tmp = PyObject_Str(obj);
  }
#endif
  if (tmp == NULL) goto capi_fail;
  if (*len == -1)
    *len = PyString_GET_SIZE(tmp);
  STRINGMALLOC(*str,*len);
  STRINGCOPYN(*str,PyString_AS_STRING(tmp),*len+1);
  Py_DECREF(tmp);
  return 1;
capi_fail:
  Py_XDECREF(tmp);
  {
    PyObject* err = PyErr_Occurred();
    if (err==NULL) err = linalg_utils_error;
    PyErr_SetString(err,errmess);
  }
  return 0;
}

static int complex_double_from_pyobj(complex_double* v,PyObject *obj,const char *errmess) {
  Py_complex c;
  if (PyComplex_Check(obj)) {
    c=PyComplex_AsCComplex(obj);
    (*v).r=c.real, (*v).i=c.imag;
    return 1;
  }
  if (PyArray_IsScalar(obj, ComplexFloating)) {
    if (PyArray_IsScalar(obj, CFloat)) {
      npy_cfloat new;
      PyArray_ScalarAsCtype(obj, &new);
      (*v).r = (double)new.real;
      (*v).i = (double)new.imag;
    }
    else if (PyArray_IsScalar(obj, CLongDouble)) {
      npy_clongdouble new;
      PyArray_ScalarAsCtype(obj, &new);
      (*v).r = (double)new.real;
      (*v).i = (double)new.imag;
    }
    else { /* if (PyArray_IsScalar(obj, CDouble)) */
      PyArray_ScalarAsCtype(obj, v);
    }
    return 1;
  }
  if (PyArray_CheckScalar(obj)) { /* 0-dim array or still array scalar */
    PyObject *arr;
    if (PyArray_Check(obj)) {
      arr = PyArray_Cast((PyArrayObject *)obj, NPY_CDOUBLE);
    }
    else {
      arr = PyArray_FromScalar(obj, PyArray_DescrFromType(NPY_CDOUBLE));
    }
    if (arr==NULL) return 0;
    (*v).r = ((npy_cdouble *)PyArray_DATA(arr))->real;
    (*v).i = ((npy_cdouble *)PyArray_DATA(arr))->imag;
    return 1;
  }
  /* Python does not provide PyNumber_Complex function :-( */
  (*v).i=0.0;
  if (PyFloat_Check(obj)) {
#ifdef __sgi
    (*v).r = PyFloat_AsDouble(obj);
#else
    (*v).r = PyFloat_AS_DOUBLE(obj);
#endif
    return 1;
  }
  if (PyInt_Check(obj)) {
    (*v).r = (double)PyInt_AS_LONG(obj);
    return 1;
  }
  if (PyLong_Check(obj)) {
    (*v).r = PyLong_AsDouble(obj);
    return (!PyErr_Occurred());
  }
  if (PySequence_Check(obj) && !(PyString_Check(obj) || PyUnicode_Check(obj))) {
    PyObject *tmp = PySequence_GetItem(obj,0);
    if (tmp) {
      if (complex_double_from_pyobj(v,tmp,errmess)) {
        Py_DECREF(tmp);
        return 1;
      }
      Py_DECREF(tmp);
    }
  }
  {
    PyObject* err = PyErr_Occurred();
    if (err==NULL)
      err = PyExc_TypeError;
    PyErr_SetString(err,errmess);
  }
  return 0;
}

static int float_from_pyobj(float* v,PyObject *obj,const char *errmess) {
  double d=0.0;
  if (double_from_pyobj(&d,obj,errmess)) {
    *v = (float)d;
    return 1;
  }
  return 0;
}


/********************* See f2py2e/cfuncs.py: userincludes *********************/
/*need_userincludes*/

/********************* See f2py2e/capi_rules.py: usercode *********************/


/* See f2py2e/rules.py */
extern void F_FUNC_US(remove_duplicates,REMOVE_DUPLICATES)(double*,int*,int*,int*,int*,int*,int*,double*,int*);
extern void F_FUNC_US(check_repeats,CHECK_REPEATS)(double*,double*,double*,int*,int*,int*,double*,int*,int*);
extern void F_FUNC_US(diag_call,DIAG_CALL)(double*,int*,int*,double*,cb_cov_fun_in_diag_call__user__routines_typedef);
extern void F_FUNC_US(basis_diag_call,BASIS_DIAG_CALL)(double*,double*,int*,int*);
extern void F_FUNC_US(gp_array_logp,GP_ARRAY_LOGP)(double*,double*,double*,int*,double*,int*);
extern void F_FUNC(asqs,ASQS)(double*,double*,int*,int*,int*,int*);
extern void F_FUNC_US(dcopy_wrap,DCOPY_WRAP)(double*,double*,int*);
extern void F_FUNC_US(dtrmm_wrap,DTRMM_WRAP)(int*,int*,double*,double*,string,string,string,double*,size_t,size_t,size_t);
extern void F_FUNC_US(dtrsm_wrap,DTRSM_WRAP)(int*,int*,double*,double*,string,string,string,double*,size_t,size_t,size_t);
extern void F_FUNC_US(dpotrf_wrap,DPOTRF_WRAP)(double*,int*,int*);
extern void F_FUNC_US(dchdc_wrap,DCHDC_WRAP)(double*,int*,double*,int*,int*);
extern void F_FUNC_US(dpotrs_wrap,DPOTRS_WRAP)(double*,double*,int*,int*,int*,string,size_t);
extern void F_FUNC(xerbla,XERBLA)(string,int*,size_t);
extern void F_WRAPPEDFUNC(lsame,LSAME)(int*,string,string,size_t,size_t);
extern void F_WRAPPEDFUNC(idamax,IDAMAX)(int*,int*,double*,int*);
extern void F_WRAPPEDFUNC(dznrm2,DZNRM2)(double*,int*,complex_double*,int*);
extern void F_WRAPPEDFUNC(dzasum,DZASUM)(double*,int*,complex_double*,int*);
extern void F_FUNC(dtrsv,DTRSV)(string,string,string,int*,double*,int*,double*,int*,size_t,size_t,size_t);
extern void F_FUNC(dtrsm,DTRSM)(string,string,string,string,int*,int*,double*,double*,int*,double*,int*,size_t,size_t,size_t,size_t);
extern void F_FUNC(dtrmv,DTRMV)(string,string,string,int*,double*,int*,double*,int*,size_t,size_t,size_t);
extern void F_FUNC(dtrmm,DTRMM)(string,string,string,string,int*,int*,double*,double*,int*,double*,int*,size_t,size_t,size_t,size_t);
extern void F_FUNC(dtpsv,DTPSV)(string,string,string,int*,double*,double*,int*,size_t,size_t,size_t);
extern void F_FUNC(dtpmv,DTPMV)(string,string,string,int*,double*,double*,int*,size_t,size_t,size_t);
extern void F_FUNC(dtbsv,DTBSV)(string,string,string,int*,int*,double*,int*,double*,int*,size_t,size_t,size_t);
extern void F_FUNC(dtbmv,DTBMV)(string,string,string,int*,int*,double*,int*,double*,int*,size_t,size_t,size_t);
extern void F_FUNC(dsyrk,DSYRK)(string,string,int*,int*,double*,double*,int*,double*,double*,int*,size_t,size_t);
extern void F_FUNC(dsyr2k,DSYR2K)(string,string,int*,int*,double*,double*,int*,double*,int*,double*,double*,int*,size_t,size_t);
extern void F_FUNC(dsyr2,DSYR2)(string,int*,double*,double*,int*,double*,int*,double*,int*,size_t);
extern void F_FUNC(dsyr,DSYR)(string,int*,double*,double*,int*,double*,int*,size_t);
extern void F_FUNC(dsymv,DSYMV)(string,int*,double*,double*,int*,double*,int*,double*,double*,int*,size_t);
extern void F_FUNC(dsymm,DSYMM)(string,string,int*,int*,double*,double*,int*,double*,int*,double*,double*,int*,size_t,size_t);
extern void F_FUNC(dswap,DSWAP)(int*,double*,int*,double*,int*);
extern void F_FUNC(dspr2,DSPR2)(string,int*,double*,double*,int*,double*,int*,double*,size_t);
extern void F_FUNC(dspr,DSPR)(string,int*,double*,double*,int*,double*,size_t);
extern void F_FUNC(dspmv,DSPMV)(string,int*,double*,double*,double*,int*,double*,double*,int*,size_t);
extern void F_WRAPPEDFUNC(dsdot,DSDOT)(double*,int*,float*,int*,float*,int*);
extern void F_FUNC(dscal,DSCAL)(int*,double*,double*,int*);
extern void F_FUNC(dsbmv,DSBMV)(string,int*,int*,double*,double*,int*,double*,int*,double*,double*,int*,size_t);
extern void F_FUNC(drotmg,DROTMG)(double*,double*,double*,double*,double*);
extern void F_FUNC(drotm,DROTM)(int*,double*,int*,double*,int*,double*);
extern void F_FUNC(drotg,DROTG)(double*,double*,double*,double*);
extern void F_FUNC(drot,DROT)(int*,double*,int*,double*,int*,double*,double*);
extern void F_WRAPPEDFUNC(dnrm2,DNRM2)(double*,int*,double*,int*);
extern void F_FUNC(dger,DGER)(int*,int*,double*,double*,int*,double*,int*,double*,int*);
extern void F_FUNC(dgemv,DGEMV)(string,int*,int*,double*,double*,int*,double*,int*,double*,double*,int*,size_t);
extern void F_FUNC(dgemm,DGEMM)(string,string,int*,int*,int*,double*,double*,int*,double*,int*,double*,double*,int*,size_t,size_t);
extern void F_FUNC(dgbmv,DGBMV)(string,int*,int*,int*,int*,double*,double*,int*,double*,int*,double*,double*,int*,size_t);
extern void F_WRAPPEDFUNC(ddot,DDOT)(double*,int*,double*,int*,double*,int*);
extern void F_FUNC(dcopy,DCOPY)(int*,double*,int*,double*,int*);
extern void F_WRAPPEDFUNC(dcabs1,DCABS1)(double*,complex_double*);
extern void F_FUNC(daxpy,DAXPY)(int*,double*,double*,int*,double*,int*);
extern void F_WRAPPEDFUNC(dasum,DASUM)(double*,int*,double*,int*);
extern void F_FUNC(dpotrs,DPOTRS)(string,int*,int*,double*,int*,double*,int*,int*,size_t);
extern void F_FUNC(dpotrf,DPOTRF)(string,int*,double*,int*,int*,size_t);
extern void F_FUNC(dpotf2,DPOTF2)(string,int*,double*,int*,int*,size_t);
extern void F_WRAPPEDFUNC(ilaenv,ILAENV)(int*,int*,string,string,int*,int*,int*,int*,size_t,size_t);
extern void F_WRAPPEDFUNC(dlamch,DLAMCH)(double*,string,size_t);
extern void F_FUNC(dlamc1,DLAMC1)(int*,int*,int*,int*);
extern void F_FUNC(dlamc2,DLAMC2)(int*,int*,int*,double*,int*,double*,int*,double*);
extern void F_WRAPPEDFUNC(dlamc3,DLAMC3)(double*,double*,double*);
extern void F_FUNC(dlamc4,DLAMC4)(int*,double*,int*);
extern void F_FUNC(dlamc5,DLAMC5)(int*,int*,int*,int*,int*,double*);
extern void F_FUNC(ilaver,ILAVER)(int*,int*,int*);
extern void F_WRAPPEDFUNC(ieeeck,IEEECK)(int*,int*,float*,float*);
extern void F_WRAPPEDFUNC(iparmq,IPARMQ)(int*,int*,string,string,int*,int*,int*,int*,size_t,size_t);
/*eof externroutines*/

/******************** See f2py2e/capi_rules.py: usercode1 ********************/


/******************* See f2py2e/cb_rules.py: buildcallback *******************/

/****************** cb_cov_fun_in_diag_call__user__routines ******************/
PyObject *cb_cov_fun_in_diag_call__user__routines_capi = NULL;/*was Py_None*/
PyTupleObject *cb_cov_fun_in_diag_call__user__routines_args_capi = NULL;
int cb_cov_fun_in_diag_call__user__routines_nofargs = 0;
jmp_buf cb_cov_fun_in_diag_call__user__routines_jmpbuf;
/*typedef double(*cb_cov_fun_in_diag_call__user__routines_typedef)(double *,int *);*/
static double cb_cov_fun_in_diag_call__user__routines (double *xe,int *ndim_cb_capi) {
  PyTupleObject *capi_arglist = cb_cov_fun_in_diag_call__user__routines_args_capi;
  PyObject *capi_return = NULL;
  PyObject *capi_tmp = NULL;
  int capi_j,capi_i = 0;
  int capi_longjmp_ok = 1;
/*decl*/
  double return_value;
  int ndim=(*ndim_cb_capi);
  npy_intp xe_Dims[2] = {-1, -1};
#ifdef F2PY_REPORT_ATEXIT
f2py_cb_start_clock();
#endif
  CFUNCSMESS("cb:Call-back function cb_cov_fun_in_diag_call__user__routines (maxnofargs=1(-0))\n");
  CFUNCSMESSPY("cb:cb_cov_fun_in_diag_call__user__routines_capi=",cb_cov_fun_in_diag_call__user__routines_capi);
  if (cb_cov_fun_in_diag_call__user__routines_capi==NULL) {
    capi_longjmp_ok = 0;
    cb_cov_fun_in_diag_call__user__routines_capi = PyObject_GetAttrString(linalg_utils_module,"cov_fun");
  }
  if (cb_cov_fun_in_diag_call__user__routines_capi==NULL) {
    PyErr_SetString(linalg_utils_error,"cb: Callback cov_fun not defined (as an argument or module linalg_utils attribute).\n");
    goto capi_fail;
  }
  if (F2PyCapsule_Check(cb_cov_fun_in_diag_call__user__routines_capi)) {
  cb_cov_fun_in_diag_call__user__routines_typedef cb_cov_fun_in_diag_call__user__routines_cptr;
  cb_cov_fun_in_diag_call__user__routines_cptr = F2PyCapsule_AsVoidPtr(cb_cov_fun_in_diag_call__user__routines_capi);
  return_value=(*cb_cov_fun_in_diag_call__user__routines_cptr)(xe,ndim_cb_capi);
    return return_value;
  }
  if (capi_arglist==NULL) {
    capi_longjmp_ok = 0;
    capi_tmp = PyObject_GetAttrString(linalg_utils_module,"cov_fun_extra_args");
    if (capi_tmp) {
      capi_arglist = (PyTupleObject *)PySequence_Tuple(capi_tmp);
      if (capi_arglist==NULL) {
        PyErr_SetString(linalg_utils_error,"Failed to convert linalg_utils.cov_fun_extra_args to tuple.\n");
        goto capi_fail;
      }
    } else {
      PyErr_Clear();
      capi_arglist = (PyTupleObject *)Py_BuildValue("()");
    }
  }
  if (capi_arglist == NULL) {
    PyErr_SetString(linalg_utils_error,"Callback cov_fun argument list is not set.\n");
    goto capi_fail;
  }
/*setdims*/
  xe_Dims[0]=1,xe_Dims[1]=ndim;
/*pyobjfrom*/
  if (cb_cov_fun_in_diag_call__user__routines_nofargs>capi_i) {
    PyArrayObject *tmp_arr = (PyArrayObject *)PyArray_New(&PyArray_Type,2,xe_Dims,NPY_DOUBLE,NULL,(char*)xe,0,NPY_FARRAY,NULL); /*XXX: Hmm, what will destroy this array??? */


    if (tmp_arr==NULL)
      goto capi_fail;
    if (PyTuple_SetItem((PyObject *)capi_arglist,capi_i++,(PyObject *)tmp_arr))
      goto capi_fail;
}
  CFUNCSMESSPY("cb:capi_arglist=",capi_arglist);
  CFUNCSMESS("cb:Call-back calling Python function cov_fun.\n");
#ifdef F2PY_REPORT_ATEXIT
f2py_cb_start_call_clock();
#endif
  capi_return = PyObject_CallObject(cb_cov_fun_in_diag_call__user__routines_capi,(PyObject *)capi_arglist);
#ifdef F2PY_REPORT_ATEXIT
f2py_cb_stop_call_clock();
#endif
  CFUNCSMESSPY("cb:capi_return=",capi_return);
  if (capi_return == NULL) {
    fprintf(stderr,"capi_return is NULL\n");
    goto capi_fail;
  }
  if (capi_return == Py_None) {
    Py_DECREF(capi_return);
    capi_return = Py_BuildValue("()");
  }
  else if (!PyTuple_Check(capi_return)) {
    capi_return = Py_BuildValue("(N)",capi_return);
  }
  capi_j = PyTuple_Size(capi_return);
  capi_i = 0;
/*frompyobj*/
  if (capi_j>capi_i)
    GETSCALARFROMPYTUPLE(capi_return,capi_i++,&return_value,double,"double_from_pyobj failed in converting return_value of call-back function cb_cov_fun_in_diag_call__user__routines to C double\n");
  CFUNCSMESS("cb:cb_cov_fun_in_diag_call__user__routines:successful\n");
  Py_DECREF(capi_return);
#ifdef F2PY_REPORT_ATEXIT
f2py_cb_stop_clock();
#endif
  goto capi_return_pt;
capi_fail:
  fprintf(stderr,"Call-back cb_cov_fun_in_diag_call__user__routines failed.\n");
  Py_XDECREF(capi_return);
  if (capi_longjmp_ok)
    longjmp(cb_cov_fun_in_diag_call__user__routines_jmpbuf,-1);
capi_return_pt:
  ;
  return return_value;
}
/*************** end of cb_cov_fun_in_diag_call__user__routines ***************/


/*********************** See f2py2e/rules.py: buildapi ***********************/

/***************************** remove_duplicates *****************************/
static char doc_f2py_rout_linalg_utils_remove_duplicates[] = "\
nr,rf,rt,nu,xu,ui = remove_duplicates(x)\n\nWrapper for ``remove_duplicates``.\
\n\nParameters\n----------\n"
"x : input rank-2 array('d') with bounds (n,nd)\n"
"\nReturns\n-------\n"
"nr : int\n"
"rf : rank-1 array('i') with bounds (n)\n"
"rt : rank-1 array('i') with bounds (n)\n"
"nu : int\n"
"xu : rank-2 array('d') with bounds (n,nd)\n"
"ui : rank-1 array('i') with bounds (n)";
/* extern void F_FUNC_US(remove_duplicates,REMOVE_DUPLICATES)(double*,int*,int*,int*,int*,int*,int*,double*,int*); */
static PyObject *f2py_rout_linalg_utils_remove_duplicates(const PyObject *capi_self,
                           PyObject *capi_args,
                           PyObject *capi_keywds,
                           void (*f2py_func)(double*,int*,int*,int*,int*,int*,int*,double*,int*)) {
  PyObject * volatile capi_buildvalue = NULL;
  volatile int f2py_success = 1;
/*decl*/

  double *x = NULL;
  npy_intp x_Dims[2] = {-1, -1};
  const int x_Rank = 2;
  PyArrayObject *capi_x_tmp = NULL;
  int capi_x_intent = 0;
  PyObject *x_capi = Py_None;
  int n = 0;
  int nd = 0;
  int nr = 0;
  int *rf = NULL;
  npy_intp rf_Dims[1] = {-1};
  const int rf_Rank = 1;
  PyArrayObject *capi_rf_tmp = NULL;
  int capi_rf_intent = 0;
  int *rt = NULL;
  npy_intp rt_Dims[1] = {-1};
  const int rt_Rank = 1;
  PyArrayObject *capi_rt_tmp = NULL;
  int capi_rt_intent = 0;
  int nu = 0;
  double *xu = NULL;
  npy_intp xu_Dims[2] = {-1, -1};
  const int xu_Rank = 2;
  PyArrayObject *capi_xu_tmp = NULL;
  int capi_xu_intent = 0;
  int *ui = NULL;
  npy_intp ui_Dims[1] = {-1};
  const int ui_Rank = 1;
  PyArrayObject *capi_ui_tmp = NULL;
  int capi_ui_intent = 0;
  static char *capi_kwlist[] = {"x",NULL};

/*routdebugenter*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_clock();
#endif
  if (!PyArg_ParseTupleAndKeywords(capi_args,capi_keywds,\
    "O:linalg_utils.remove_duplicates",\
    capi_kwlist,&x_capi))
    return NULL;
/*frompyobj*/
  /* Processing variable x */
  ;
  capi_x_intent |= F2PY_INTENT_IN;
  capi_x_tmp = array_from_pyobj(NPY_DOUBLE,x_Dims,x_Rank,capi_x_intent,x_capi);
  if (capi_x_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 1st argument `x' of linalg_utils.remove_duplicates to C/Fortran array" );
  } else {
    x = (double *)(capi_x_tmp->data);

  /* Processing variable nr */
  /* Processing variable nu */
  /* Processing variable nd */
  nd = shape(x,1);
  CHECKSCALAR(shape(x,1)==nd,"shape(x,1)==nd","hidden nd","remove_duplicates:nd=%d",nd) {
  /* Processing variable n */
  n = shape(x,0);
  CHECKSCALAR(shape(x,0)==n,"shape(x,0)==n","hidden n","remove_duplicates:n=%d",n) {
  /* Processing variable rf */
  rf_Dims[0]=n;
  capi_rf_intent |= F2PY_INTENT_OUT|F2PY_INTENT_HIDE;
  capi_rf_tmp = array_from_pyobj(NPY_INT,rf_Dims,rf_Rank,capi_rf_intent,Py_None);
  if (capi_rf_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting hidden `rf' of linalg_utils.remove_duplicates to C/Fortran array" );
  } else {
    rf = (int *)(capi_rf_tmp->data);

  /* Processing variable ui */
  ui_Dims[0]=n;
  capi_ui_intent |= F2PY_INTENT_OUT|F2PY_INTENT_HIDE;
  capi_ui_tmp = array_from_pyobj(NPY_INT,ui_Dims,ui_Rank,capi_ui_intent,Py_None);
  if (capi_ui_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting hidden `ui' of linalg_utils.remove_duplicates to C/Fortran array" );
  } else {
    ui = (int *)(capi_ui_tmp->data);

  /* Processing variable xu */
  xu_Dims[0]=n,xu_Dims[1]=nd;
  capi_xu_intent |= F2PY_INTENT_OUT|F2PY_INTENT_HIDE;
  capi_xu_tmp = array_from_pyobj(NPY_DOUBLE,xu_Dims,xu_Rank,capi_xu_intent,Py_None);
  if (capi_xu_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting hidden `xu' of linalg_utils.remove_duplicates to C/Fortran array" );
  } else {
    xu = (double *)(capi_xu_tmp->data);

  /* Processing variable rt */
  rt_Dims[0]=n;
  capi_rt_intent |= F2PY_INTENT_OUT|F2PY_INTENT_HIDE;
  capi_rt_tmp = array_from_pyobj(NPY_INT,rt_Dims,rt_Rank,capi_rt_intent,Py_None);
  if (capi_rt_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting hidden `rt' of linalg_utils.remove_duplicates to C/Fortran array" );
  } else {
    rt = (int *)(capi_rt_tmp->data);

/*end of frompyobj*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_call_clock();
#endif
/*callfortranroutine*/
      Py_BEGIN_ALLOW_THREADS
        (*f2py_func)(x,&n,&nd,&nr,rf,rt,&nu,xu,ui);
      Py_END_ALLOW_THREADS
if (PyErr_Occurred())
  f2py_success = 0;
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_call_clock();
#endif
/*end of callfortranroutine*/
    if (f2py_success) {
/*pyobjfrom*/
/*end of pyobjfrom*/
    CFUNCSMESS("Building return value.\n");
    capi_buildvalue = Py_BuildValue("iNNiNN",nr,capi_rf_tmp,capi_rt_tmp,nu,capi_xu_tmp,capi_ui_tmp);
/*closepyobjfrom*/
/*end of closepyobjfrom*/
    } /*if (f2py_success) after callfortranroutine*/
/*cleanupfrompyobj*/
  }  /*if (capi_rt_tmp == NULL) ... else of rt*/
  /* End of cleaning variable rt */
  }  /*if (capi_xu_tmp == NULL) ... else of xu*/
  /* End of cleaning variable xu */
  }  /*if (capi_ui_tmp == NULL) ... else of ui*/
  /* End of cleaning variable ui */
  }  /*if (capi_rf_tmp == NULL) ... else of rf*/
  /* End of cleaning variable rf */
  } /*CHECKSCALAR(shape(x,0)==n)*/
  /* End of cleaning variable n */
  } /*CHECKSCALAR(shape(x,1)==nd)*/
  /* End of cleaning variable nd */
  /* End of cleaning variable nu */
  /* End of cleaning variable nr */
  if((PyObject *)capi_x_tmp!=x_capi) {
    Py_XDECREF(capi_x_tmp); }
  }  /*if (capi_x_tmp == NULL) ... else of x*/
  /* End of cleaning variable x */
/*end of cleanupfrompyobj*/
  if (capi_buildvalue == NULL) {
/*routdebugfailure*/
  } else {
/*routdebugleave*/
  }
  CFUNCSMESS("Freeing memory.\n");
/*freemem*/
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_clock();
#endif
  return capi_buildvalue;
}
/************************** end of remove_duplicates **************************/

/******************************* check_repeats *******************************/
static char doc_f2py_rout_linalg_utils_check_repeats[] = "\
f,new_indices,n_new_indices = check_repeats(x,x_sofar,f_sofar)\n\nWrapper for ``check_repeats``.\
\n\nParameters\n----------\n"
"x : input rank-2 array('d') with bounds (n,n_dim)\n"
"x_sofar : input rank-2 array('d') with bounds (n_sofar,n_dim)\n"
"f_sofar : input rank-1 array('d') with bounds (n_sofar)\n"
"\nReturns\n-------\n"
"f : rank-1 array('d') with bounds (n)\n"
"new_indices : rank-1 array('i') with bounds (n)\n"
"n_new_indices : int";
/* extern void F_FUNC_US(check_repeats,CHECK_REPEATS)(double*,double*,double*,int*,int*,int*,double*,int*,int*); */
static PyObject *f2py_rout_linalg_utils_check_repeats(const PyObject *capi_self,
                           PyObject *capi_args,
                           PyObject *capi_keywds,
                           void (*f2py_func)(double*,double*,double*,int*,int*,int*,double*,int*,int*)) {
  PyObject * volatile capi_buildvalue = NULL;
  volatile int f2py_success = 1;
/*decl*/

  double *x = NULL;
  npy_intp x_Dims[2] = {-1, -1};
  const int x_Rank = 2;
  PyArrayObject *capi_x_tmp = NULL;
  int capi_x_intent = 0;
  PyObject *x_capi = Py_None;
  double *x_sofar = NULL;
  npy_intp x_sofar_Dims[2] = {-1, -1};
  const int x_sofar_Rank = 2;
  PyArrayObject *capi_x_sofar_tmp = NULL;
  int capi_x_sofar_intent = 0;
  PyObject *x_sofar_capi = Py_None;
  double *f_sofar = NULL;
  npy_intp f_sofar_Dims[1] = {-1};
  const int f_sofar_Rank = 1;
  PyArrayObject *capi_f_sofar_tmp = NULL;
  int capi_f_sofar_intent = 0;
  PyObject *f_sofar_capi = Py_None;
  int n = 0;
  int n_dim = 0;
  int n_sofar = 0;
  double *f = NULL;
  npy_intp f_Dims[1] = {-1};
  const int f_Rank = 1;
  PyArrayObject *capi_f_tmp = NULL;
  int capi_f_intent = 0;
  int *new_indices = NULL;
  npy_intp new_indices_Dims[1] = {-1};
  const int new_indices_Rank = 1;
  PyArrayObject *capi_new_indices_tmp = NULL;
  int capi_new_indices_intent = 0;
  int n_new_indices = 0;
  static char *capi_kwlist[] = {"x","x_sofar","f_sofar",NULL};

/*routdebugenter*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_clock();
#endif
  if (!PyArg_ParseTupleAndKeywords(capi_args,capi_keywds,\
    "OOO:linalg_utils.check_repeats",\
    capi_kwlist,&x_capi,&x_sofar_capi,&f_sofar_capi))
    return NULL;
/*frompyobj*/
  /* Processing variable n_new_indices */
  /* Processing variable x */
  ;
  capi_x_intent |= F2PY_INTENT_IN;
  capi_x_tmp = array_from_pyobj(NPY_DOUBLE,x_Dims,x_Rank,capi_x_intent,x_capi);
  if (capi_x_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 1st argument `x' of linalg_utils.check_repeats to C/Fortran array" );
  } else {
    x = (double *)(capi_x_tmp->data);

  /* Processing variable n_dim */
  n_dim = shape(x,1);
  /* Processing variable n */
  n = shape(x,0);
  /* Processing variable x_sofar */
  x_sofar_Dims[1]=n_dim;
  capi_x_sofar_intent |= F2PY_INTENT_IN;
  capi_x_sofar_tmp = array_from_pyobj(NPY_DOUBLE,x_sofar_Dims,x_sofar_Rank,capi_x_sofar_intent,x_sofar_capi);
  if (capi_x_sofar_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 2nd argument `x_sofar' of linalg_utils.check_repeats to C/Fortran array" );
  } else {
    x_sofar = (double *)(capi_x_sofar_tmp->data);

  /* Processing variable new_indices */
  new_indices_Dims[0]=n;
  capi_new_indices_intent |= F2PY_INTENT_OUT|F2PY_INTENT_HIDE;
  capi_new_indices_tmp = array_from_pyobj(NPY_INT,new_indices_Dims,new_indices_Rank,capi_new_indices_intent,Py_None);
  if (capi_new_indices_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting hidden `new_indices' of linalg_utils.check_repeats to C/Fortran array" );
  } else {
    new_indices = (int *)(capi_new_indices_tmp->data);

  /* Processing variable f */
  f_Dims[0]=n;
  capi_f_intent |= F2PY_INTENT_OUT|F2PY_INTENT_HIDE;
  capi_f_tmp = array_from_pyobj(NPY_DOUBLE,f_Dims,f_Rank,capi_f_intent,Py_None);
  if (capi_f_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting hidden `f' of linalg_utils.check_repeats to C/Fortran array" );
  } else {
    f = (double *)(capi_f_tmp->data);

  /* Processing variable n_sofar */
  n_sofar = shape(x_sofar,0);
  /* Processing variable f_sofar */
  f_sofar_Dims[0]=n_sofar;
  capi_f_sofar_intent |= F2PY_INTENT_IN;
  capi_f_sofar_tmp = array_from_pyobj(NPY_DOUBLE,f_sofar_Dims,f_sofar_Rank,capi_f_sofar_intent,f_sofar_capi);
  if (capi_f_sofar_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 3rd argument `f_sofar' of linalg_utils.check_repeats to C/Fortran array" );
  } else {
    f_sofar = (double *)(capi_f_sofar_tmp->data);

/*end of frompyobj*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_call_clock();
#endif
/*callfortranroutine*/
      Py_BEGIN_ALLOW_THREADS
        (*f2py_func)(x,x_sofar,f_sofar,&n,&n_dim,&n_sofar,f,new_indices,&n_new_indices);
      Py_END_ALLOW_THREADS
if (PyErr_Occurred())
  f2py_success = 0;
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_call_clock();
#endif
/*end of callfortranroutine*/
    if (f2py_success) {
/*pyobjfrom*/
/*end of pyobjfrom*/
    CFUNCSMESS("Building return value.\n");
    capi_buildvalue = Py_BuildValue("NNi",capi_f_tmp,capi_new_indices_tmp,n_new_indices);
/*closepyobjfrom*/
/*end of closepyobjfrom*/
    } /*if (f2py_success) after callfortranroutine*/
/*cleanupfrompyobj*/
  if((PyObject *)capi_f_sofar_tmp!=f_sofar_capi) {
    Py_XDECREF(capi_f_sofar_tmp); }
  }  /*if (capi_f_sofar_tmp == NULL) ... else of f_sofar*/
  /* End of cleaning variable f_sofar */
  /* End of cleaning variable n_sofar */
  }  /*if (capi_f_tmp == NULL) ... else of f*/
  /* End of cleaning variable f */
  }  /*if (capi_new_indices_tmp == NULL) ... else of new_indices*/
  /* End of cleaning variable new_indices */
  if((PyObject *)capi_x_sofar_tmp!=x_sofar_capi) {
    Py_XDECREF(capi_x_sofar_tmp); }
  }  /*if (capi_x_sofar_tmp == NULL) ... else of x_sofar*/
  /* End of cleaning variable x_sofar */
  /* End of cleaning variable n */
  /* End of cleaning variable n_dim */
  if((PyObject *)capi_x_tmp!=x_capi) {
    Py_XDECREF(capi_x_tmp); }
  }  /*if (capi_x_tmp == NULL) ... else of x*/
  /* End of cleaning variable x */
  /* End of cleaning variable n_new_indices */
/*end of cleanupfrompyobj*/
  if (capi_buildvalue == NULL) {
/*routdebugfailure*/
  } else {
/*routdebugleave*/
  }
  CFUNCSMESS("Freeing memory.\n");
/*freemem*/
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_clock();
#endif
  return capi_buildvalue;
}
/**************************** end of check_repeats ****************************/

/********************************* diag_call *********************************/
static char doc_f2py_rout_linalg_utils_diag_call[] = "\
v = diag_call(x,cov_fun,[cov_fun_extra_args])\n\nWrapper for ``diag_call``.\
\n\nParameters\n----------\n"
"x : input rank-2 array('d') with bounds (n,ndim)\n"
"cov_fun : call-back function\n"
"\nOther Parameters\n----------------\n"
"cov_fun_extra_args : input tuple, optional\n    Default: ()\n"
"\nReturns\n-------\n"
"v : rank-1 array('d') with bounds (n)\n"
"\nNotes\n-----\nCall-back functions::\n\n"
"  def cov_fun(xe): return q\n\
  Required arguments:\n"
"    xe : input rank-2 array('d') with bounds (1,ndim)\n"
"  Return objects:\n"
"    q : float";
/* extern void F_FUNC_US(diag_call,DIAG_CALL)(double*,int*,int*,double*,cb_cov_fun_in_diag_call__user__routines_typedef); */
static PyObject *f2py_rout_linalg_utils_diag_call(const PyObject *capi_self,
                           PyObject *capi_args,
                           PyObject *capi_keywds,
                           void (*f2py_func)(double*,int*,int*,double*,cb_cov_fun_in_diag_call__user__routines_typedef)) {
  PyObject * volatile capi_buildvalue = NULL;
  volatile int f2py_success = 1;
/*decl*/

  double *x = NULL;
  npy_intp x_Dims[2] = {-1, -1};
  const int x_Rank = 2;
  PyArrayObject *capi_x_tmp = NULL;
  int capi_x_intent = 0;
  PyObject *x_capi = Py_None;
  int n = 0;
  int ndim = 0;
  double *v = NULL;
  npy_intp v_Dims[1] = {-1};
  const int v_Rank = 1;
  PyArrayObject *capi_v_tmp = NULL;
  int capi_v_intent = 0;
  PyObject *cov_fun_capi = Py_None;
  PyTupleObject *cov_fun_xa_capi = NULL;
  PyTupleObject *cov_fun_args_capi = NULL;
  int cov_fun_nofargs_capi = 0;
  cb_cov_fun_in_diag_call__user__routines_typedef cov_fun_cptr;
  static char *capi_kwlist[] = {"x","cov_fun","cov_fun_extra_args",NULL};

/*routdebugenter*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_clock();
#endif
  if (!PyArg_ParseTupleAndKeywords(capi_args,capi_keywds,\
    "OO|O!:linalg_utils.diag_call",\
    capi_kwlist,&x_capi,&cov_fun_capi,&PyTuple_Type,&cov_fun_xa_capi))
    return NULL;
/*frompyobj*/
  /* Processing variable cov_fun */
if(F2PyCapsule_Check(cov_fun_capi)) {
  cov_fun_cptr = F2PyCapsule_AsVoidPtr(cov_fun_capi);
} else {
  cov_fun_cptr = cb_cov_fun_in_diag_call__user__routines;
}

  cov_fun_nofargs_capi = cb_cov_fun_in_diag_call__user__routines_nofargs;
  if (create_cb_arglist(cov_fun_capi,cov_fun_xa_capi,1,0,&cb_cov_fun_in_diag_call__user__routines_nofargs,&cov_fun_args_capi,"failed in processing argument list for call-back cov_fun.")) {
    jmp_buf cov_fun_jmpbuf;
    CFUNCSMESS("Saving jmpbuf for `cov_fun`.\n");
    SWAP(cov_fun_capi,cb_cov_fun_in_diag_call__user__routines_capi,PyObject);
    SWAP(cov_fun_args_capi,cb_cov_fun_in_diag_call__user__routines_args_capi,PyTupleObject);
    memcpy(&cov_fun_jmpbuf,&cb_cov_fun_in_diag_call__user__routines_jmpbuf,sizeof(jmp_buf));
  /* Processing variable x */
  ;
  capi_x_intent |= F2PY_INTENT_IN;
  capi_x_tmp = array_from_pyobj(NPY_DOUBLE,x_Dims,x_Rank,capi_x_intent,x_capi);
  if (capi_x_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 1st argument `x' of linalg_utils.diag_call to C/Fortran array" );
  } else {
    x = (double *)(capi_x_tmp->data);

  /* Processing variable ndim */
  ndim = shape(x,1);
  CHECKSCALAR(shape(x,1)==ndim,"shape(x,1)==ndim","hidden ndim","diag_call:ndim=%d",ndim) {
  /* Processing variable n */
  n = shape(x,0);
  CHECKSCALAR(shape(x,0)==n,"shape(x,0)==n","hidden n","diag_call:n=%d",n) {
  /* Processing variable v */
  v_Dims[0]=n;
  capi_v_intent |= F2PY_INTENT_OUT|F2PY_INTENT_HIDE;
  capi_v_tmp = array_from_pyobj(NPY_DOUBLE,v_Dims,v_Rank,capi_v_intent,Py_None);
  if (capi_v_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting hidden `v' of linalg_utils.diag_call to C/Fortran array" );
  } else {
    v = (double *)(capi_v_tmp->data);

/*end of frompyobj*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_call_clock();
#endif
/*callfortranroutine*/
    if ((setjmp(cb_cov_fun_in_diag_call__user__routines_jmpbuf))) {
      f2py_success = 0;
    } else {
        (*f2py_func)(x,&n,&ndim,v,cov_fun_cptr);
    }
if (PyErr_Occurred())
  f2py_success = 0;
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_call_clock();
#endif
/*end of callfortranroutine*/
    if (f2py_success) {
/*pyobjfrom*/
/*end of pyobjfrom*/
    CFUNCSMESS("Building return value.\n");
    capi_buildvalue = Py_BuildValue("N",capi_v_tmp);
/*closepyobjfrom*/
/*end of closepyobjfrom*/
    } /*if (f2py_success) after callfortranroutine*/
/*cleanupfrompyobj*/
  }  /*if (capi_v_tmp == NULL) ... else of v*/
  /* End of cleaning variable v */
  } /*CHECKSCALAR(shape(x,0)==n)*/
  /* End of cleaning variable n */
  } /*CHECKSCALAR(shape(x,1)==ndim)*/
  /* End of cleaning variable ndim */
  if((PyObject *)capi_x_tmp!=x_capi) {
    Py_XDECREF(capi_x_tmp); }
  }  /*if (capi_x_tmp == NULL) ... else of x*/
  /* End of cleaning variable x */
    CFUNCSMESS("Restoring jmpbuf for `cov_fun`.\n");
    cb_cov_fun_in_diag_call__user__routines_capi = cov_fun_capi;
    Py_DECREF(cb_cov_fun_in_diag_call__user__routines_args_capi);
    cb_cov_fun_in_diag_call__user__routines_args_capi = cov_fun_args_capi;
    cb_cov_fun_in_diag_call__user__routines_nofargs = cov_fun_nofargs_capi;
    memcpy(&cb_cov_fun_in_diag_call__user__routines_jmpbuf,&cov_fun_jmpbuf,sizeof(jmp_buf));
  }
  /* End of cleaning variable cov_fun */
/*end of cleanupfrompyobj*/
  if (capi_buildvalue == NULL) {
/*routdebugfailure*/
  } else {
/*routdebugleave*/
  }
  CFUNCSMESS("Freeing memory.\n");
/*freemem*/
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_clock();
#endif
  return capi_buildvalue;
}
/****************************** end of diag_call ******************************/

/****************************** basis_diag_call ******************************/
static char doc_f2py_rout_linalg_utils_basis_diag_call[] = "\
v = basis_diag_call(basis_x)\n\nWrapper for ``basis_diag_call``.\
\n\nParameters\n----------\n"
"basis_x : input rank-2 array('d') with bounds (nbas,n)\n"
"\nReturns\n-------\n"
"v : rank-1 array('d') with bounds (n)";
/* extern void F_FUNC_US(basis_diag_call,BASIS_DIAG_CALL)(double*,double*,int*,int*); */
static PyObject *f2py_rout_linalg_utils_basis_diag_call(const PyObject *capi_self,
                           PyObject *capi_args,
                           PyObject *capi_keywds,
                           void (*f2py_func)(double*,double*,int*,int*)) {
  PyObject * volatile capi_buildvalue = NULL;
  volatile int f2py_success = 1;
/*decl*/

  double *basis_x = NULL;
  npy_intp basis_x_Dims[2] = {-1, -1};
  const int basis_x_Rank = 2;
  PyArrayObject *capi_basis_x_tmp = NULL;
  int capi_basis_x_intent = 0;
  PyObject *basis_x_capi = Py_None;
  double *v = NULL;
  npy_intp v_Dims[1] = {-1};
  const int v_Rank = 1;
  PyArrayObject *capi_v_tmp = NULL;
  int capi_v_intent = 0;
  int n = 0;
  int nbas = 0;
  static char *capi_kwlist[] = {"basis_x",NULL};

/*routdebugenter*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_clock();
#endif
  if (!PyArg_ParseTupleAndKeywords(capi_args,capi_keywds,\
    "O:linalg_utils.basis_diag_call",\
    capi_kwlist,&basis_x_capi))
    return NULL;
/*frompyobj*/
  /* Processing variable basis_x */
  ;
  capi_basis_x_intent |= F2PY_INTENT_IN;
  capi_basis_x_tmp = array_from_pyobj(NPY_DOUBLE,basis_x_Dims,basis_x_Rank,capi_basis_x_intent,basis_x_capi);
  if (capi_basis_x_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 1st argument `basis_x' of linalg_utils.basis_diag_call to C/Fortran array" );
  } else {
    basis_x = (double *)(capi_basis_x_tmp->data);

  /* Processing variable nbas */
  nbas = shape(basis_x,0);
  CHECKSCALAR(shape(basis_x,0)==nbas,"shape(basis_x,0)==nbas","hidden nbas","basis_diag_call:nbas=%d",nbas) {
  /* Processing variable n */
  n = shape(basis_x,1);
  CHECKSCALAR(shape(basis_x,1)==n,"shape(basis_x,1)==n","hidden n","basis_diag_call:n=%d",n) {
  /* Processing variable v */
  v_Dims[0]=n;
  capi_v_intent |= F2PY_INTENT_OUT|F2PY_INTENT_HIDE;
  capi_v_tmp = array_from_pyobj(NPY_DOUBLE,v_Dims,v_Rank,capi_v_intent,Py_None);
  if (capi_v_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting hidden `v' of linalg_utils.basis_diag_call to C/Fortran array" );
  } else {
    v = (double *)(capi_v_tmp->data);

/*end of frompyobj*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_call_clock();
#endif
/*callfortranroutine*/
        (*f2py_func)(basis_x,v,&n,&nbas);
if (PyErr_Occurred())
  f2py_success = 0;
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_call_clock();
#endif
/*end of callfortranroutine*/
    if (f2py_success) {
/*pyobjfrom*/
/*end of pyobjfrom*/
    CFUNCSMESS("Building return value.\n");
    capi_buildvalue = Py_BuildValue("N",capi_v_tmp);
/*closepyobjfrom*/
/*end of closepyobjfrom*/
    } /*if (f2py_success) after callfortranroutine*/
/*cleanupfrompyobj*/
  }  /*if (capi_v_tmp == NULL) ... else of v*/
  /* End of cleaning variable v */
  } /*CHECKSCALAR(shape(basis_x,1)==n)*/
  /* End of cleaning variable n */
  } /*CHECKSCALAR(shape(basis_x,0)==nbas)*/
  /* End of cleaning variable nbas */
  if((PyObject *)capi_basis_x_tmp!=basis_x_capi) {
    Py_XDECREF(capi_basis_x_tmp); }
  }  /*if (capi_basis_x_tmp == NULL) ... else of basis_x*/
  /* End of cleaning variable basis_x */
/*end of cleanupfrompyobj*/
  if (capi_buildvalue == NULL) {
/*routdebugfailure*/
  } else {
/*routdebugleave*/
  }
  CFUNCSMESS("Freeing memory.\n");
/*freemem*/
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_clock();
#endif
  return capi_buildvalue;
}
/*************************** end of basis_diag_call ***************************/

/******************************* gp_array_logp *******************************/
static char doc_f2py_rout_linalg_utils_gp_array_logp[] = "\
like = gp_array_logp(x,mu,sig,[overwrite_x,overwrite_mu])\n\nWrapper for ``gp_array_logp``.\
\n\nParameters\n----------\n"
"x : input rank-1 array('d') with bounds (n)\n"
"mu : input rank-1 array('d') with bounds (n)\n"
"sig : input rank-2 array('d') with bounds (n,n)\n"
"\nOther Parameters\n----------------\n"
"overwrite_x : input int, optional\n    Default: 0\n"
"overwrite_mu : input int, optional\n    Default: 0\n"
"\nReturns\n-------\n"
"like : float";
/* extern void F_FUNC_US(gp_array_logp,GP_ARRAY_LOGP)(double*,double*,double*,int*,double*,int*); */
static PyObject *f2py_rout_linalg_utils_gp_array_logp(const PyObject *capi_self,
                           PyObject *capi_args,
                           PyObject *capi_keywds,
                           void (*f2py_func)(double*,double*,double*,int*,double*,int*)) {
  PyObject * volatile capi_buildvalue = NULL;
  volatile int f2py_success = 1;
/*decl*/

  double *x = NULL;
  npy_intp x_Dims[1] = {-1};
  const int x_Rank = 1;
  PyArrayObject *capi_x_tmp = NULL;
  int capi_x_intent = 0;
  int capi_overwrite_x = 0;
  PyObject *x_capi = Py_None;
  double *mu = NULL;
  npy_intp mu_Dims[1] = {-1};
  const int mu_Rank = 1;
  PyArrayObject *capi_mu_tmp = NULL;
  int capi_mu_intent = 0;
  int capi_overwrite_mu = 0;
  PyObject *mu_capi = Py_None;
  double *sig = NULL;
  npy_intp sig_Dims[2] = {-1, -1};
  const int sig_Rank = 2;
  PyArrayObject *capi_sig_tmp = NULL;
  int capi_sig_intent = 0;
  PyObject *sig_capi = Py_None;
  int n = 0;
  double like = 0;
  int info = 0;
  static char *capi_kwlist[] = {"x","mu","sig","overwrite_x","overwrite_mu",NULL};

/*routdebugenter*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_clock();
#endif
  if (!PyArg_ParseTupleAndKeywords(capi_args,capi_keywds,\
    "OOO|ii:linalg_utils.gp_array_logp",\
    capi_kwlist,&x_capi,&mu_capi,&sig_capi,&capi_overwrite_x,&capi_overwrite_mu))
    return NULL;
/*frompyobj*/
  /* Processing variable info */
  /* Processing variable like */
  /* Processing variable x */
  capi_x_intent |= (capi_overwrite_x?0:F2PY_INTENT_COPY);
  ;
  capi_x_intent |= F2PY_INTENT_IN;
  capi_x_tmp = array_from_pyobj(NPY_DOUBLE,x_Dims,x_Rank,capi_x_intent,x_capi);
  if (capi_x_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 1st argument `x' of linalg_utils.gp_array_logp to C/Fortran array" );
  } else {
    x = (double *)(capi_x_tmp->data);

  /* Processing variable n */
  n = len(x);
  CHECKSCALAR(len(x)>=n,"len(x)>=n","hidden n","gp_array_logp:n=%d",n) {
  /* Processing variable mu */
  capi_mu_intent |= (capi_overwrite_mu?0:F2PY_INTENT_COPY);
  mu_Dims[0]=n;
  capi_mu_intent |= F2PY_INTENT_IN;
  capi_mu_tmp = array_from_pyobj(NPY_DOUBLE,mu_Dims,mu_Rank,capi_mu_intent,mu_capi);
  if (capi_mu_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 2nd argument `mu' of linalg_utils.gp_array_logp to C/Fortran array" );
  } else {
    mu = (double *)(capi_mu_tmp->data);

  /* Processing variable sig */
  sig_Dims[0]=n,sig_Dims[1]=n;
  capi_sig_intent |= F2PY_INTENT_IN;
  capi_sig_tmp = array_from_pyobj(NPY_DOUBLE,sig_Dims,sig_Rank,capi_sig_intent,sig_capi);
  if (capi_sig_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 3rd argument `sig' of linalg_utils.gp_array_logp to C/Fortran array" );
  } else {
    sig = (double *)(capi_sig_tmp->data);

/*end of frompyobj*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_call_clock();
#endif
/*callfortranroutine*/
      Py_BEGIN_ALLOW_THREADS
        (*f2py_func)(x,mu,sig,&n,&like,&info);
      Py_END_ALLOW_THREADS
if (PyErr_Occurred())
  f2py_success = 0;
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_call_clock();
#endif
/*end of callfortranroutine*/
    if (f2py_success) {
/*pyobjfrom*/
/*end of pyobjfrom*/
    CFUNCSMESS("Building return value.\n");
    capi_buildvalue = Py_BuildValue("d",like);
/*closepyobjfrom*/
/*end of closepyobjfrom*/
    } /*if (f2py_success) after callfortranroutine*/
/*cleanupfrompyobj*/
  if((PyObject *)capi_sig_tmp!=sig_capi) {
    Py_XDECREF(capi_sig_tmp); }
  }  /*if (capi_sig_tmp == NULL) ... else of sig*/
  /* End of cleaning variable sig */
  if((PyObject *)capi_mu_tmp!=mu_capi) {
    Py_XDECREF(capi_mu_tmp); }
  }  /*if (capi_mu_tmp == NULL) ... else of mu*/
  /* End of cleaning variable mu */
  } /*CHECKSCALAR(len(x)>=n)*/
  /* End of cleaning variable n */
  if((PyObject *)capi_x_tmp!=x_capi) {
    Py_XDECREF(capi_x_tmp); }
  }  /*if (capi_x_tmp == NULL) ... else of x*/
  /* End of cleaning variable x */
  /* End of cleaning variable like */
  /* End of cleaning variable info */
/*end of cleanupfrompyobj*/
  if (capi_buildvalue == NULL) {
/*routdebugfailure*/
  } else {
/*routdebugleave*/
  }
  CFUNCSMESS("Freeing memory.\n");
/*freemem*/
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_clock();
#endif
  return capi_buildvalue;
}
/**************************** end of gp_array_logp ****************************/

/************************************ asqs ************************************/
static char doc_f2py_rout_linalg_utils_asqs[] = "\
asqs(c,s,[cmin,cmax])\n\nWrapper for ``asqs``.\
\n\nParameters\n----------\n"
"c : input rank-2 array('d') with bounds (nx,ny)\n"
"s :  rank-1 array('d') with bounds (ny)\n"
"\nOther Parameters\n----------------\n"
"cmin : input int, optional\n    Default: 0\n"
"cmax : input int, optional\n    Default: -1";
/* extern void F_FUNC(asqs,ASQS)(double*,double*,int*,int*,int*,int*); */
static PyObject *f2py_rout_linalg_utils_asqs(const PyObject *capi_self,
                           PyObject *capi_args,
                           PyObject *capi_keywds,
                           void (*f2py_func)(double*,double*,int*,int*,int*,int*)) {
  PyObject * volatile capi_buildvalue = NULL;
  volatile int f2py_success = 1;
/*decl*/

  double *c = NULL;
  npy_intp c_Dims[2] = {-1, -1};
  const int c_Rank = 2;
  PyArrayObject *capi_c_tmp = NULL;
  int capi_c_intent = 0;
  PyObject *c_capi = Py_None;
  double *s = NULL;
  npy_intp s_Dims[1] = {-1};
  const int s_Rank = 1;
  PyArrayObject *capi_s_tmp = NULL;
  int capi_s_intent = 0;
  PyObject *s_capi = Py_None;
  int nx = 0;
  int ny = 0;
  int cmin = 0;
  PyObject *cmin_capi = Py_None;
  int cmax = 0;
  PyObject *cmax_capi = Py_None;
  static char *capi_kwlist[] = {"c","s","cmin","cmax",NULL};

/*routdebugenter*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_clock();
#endif
  if (!PyArg_ParseTupleAndKeywords(capi_args,capi_keywds,\
    "OO|OO:linalg_utils.asqs",\
    capi_kwlist,&c_capi,&s_capi,&cmin_capi,&cmax_capi))
    return NULL;
/*frompyobj*/
  /* Processing variable c */
  ;
  capi_c_intent |= F2PY_INTENT_IN;
  capi_c_tmp = array_from_pyobj(NPY_DOUBLE,c_Dims,c_Rank,capi_c_intent,c_capi);
  if (capi_c_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 1st argument `c' of linalg_utils.asqs to C/Fortran array" );
  } else {
    c = (double *)(capi_c_tmp->data);

  /* Processing variable cmin */
  if (cmin_capi == Py_None) cmin = 0; else
    f2py_success = int_from_pyobj(&cmin,cmin_capi,"linalg_utils.asqs() 1st keyword (cmin) can't be converted to int");
  if (f2py_success) {
  /* Processing variable cmax */
  if (cmax_capi == Py_None) cmax = -1; else
    f2py_success = int_from_pyobj(&cmax,cmax_capi,"linalg_utils.asqs() 2nd keyword (cmax) can't be converted to int");
  if (f2py_success) {
  /* Processing variable nx */
  nx = shape(c,0);
  CHECKSCALAR(shape(c,0)==nx,"shape(c,0)==nx","hidden nx","asqs:nx=%d",nx) {
  /* Processing variable ny */
  ny = shape(c,1);
  CHECKSCALAR(shape(c,1)==ny,"shape(c,1)==ny","hidden ny","asqs:ny=%d",ny) {
  /* Processing variable s */
  s_Dims[0]=ny;
  capi_s_intent |= F2PY_INTENT_INPLACE;
  capi_s_tmp = array_from_pyobj(NPY_DOUBLE,s_Dims,s_Rank,capi_s_intent,s_capi);
  if (capi_s_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 2nd argument `s' of linalg_utils.asqs to C/Fortran array" );
  } else {
    s = (double *)(capi_s_tmp->data);

/*end of frompyobj*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_call_clock();
#endif
/*callfortranroutine*/
      Py_BEGIN_ALLOW_THREADS
        (*f2py_func)(c,s,&nx,&ny,&cmin,&cmax);
      Py_END_ALLOW_THREADS
if (PyErr_Occurred())
  f2py_success = 0;
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_call_clock();
#endif
/*end of callfortranroutine*/
    if (f2py_success) {
/*pyobjfrom*/
/*end of pyobjfrom*/
    CFUNCSMESS("Building return value.\n");
    capi_buildvalue = Py_BuildValue("");
/*closepyobjfrom*/
/*end of closepyobjfrom*/
    } /*if (f2py_success) after callfortranroutine*/
/*cleanupfrompyobj*/
  if((PyObject *)capi_s_tmp!=s_capi) {
    Py_XDECREF(capi_s_tmp); }
  }  /*if (capi_s_tmp == NULL) ... else of s*/
  /* End of cleaning variable s */
  } /*CHECKSCALAR(shape(c,1)==ny)*/
  /* End of cleaning variable ny */
  } /*CHECKSCALAR(shape(c,0)==nx)*/
  /* End of cleaning variable nx */
  } /*if (f2py_success) of cmax*/
  /* End of cleaning variable cmax */
  } /*if (f2py_success) of cmin*/
  /* End of cleaning variable cmin */
  if((PyObject *)capi_c_tmp!=c_capi) {
    Py_XDECREF(capi_c_tmp); }
  }  /*if (capi_c_tmp == NULL) ... else of c*/
  /* End of cleaning variable c */
/*end of cleanupfrompyobj*/
  if (capi_buildvalue == NULL) {
/*routdebugfailure*/
  } else {
/*routdebugleave*/
  }
  CFUNCSMESS("Freeing memory.\n");
/*freemem*/
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_clock();
#endif
  return capi_buildvalue;
}
/******************************** end of asqs ********************************/

/********************************* dcopy_wrap *********************************/
static char doc_f2py_rout_linalg_utils_dcopy_wrap[] = "\
dcopy_wrap(x,y)\n\nWrapper for ``dcopy_wrap``.\
\n\nParameters\n----------\n"
"x : input rank-1 array('d') with bounds (nx)\n"
"y :  rank-1 array('d') with bounds (nx)";
/* extern void F_FUNC_US(dcopy_wrap,DCOPY_WRAP)(double*,double*,int*); */
static PyObject *f2py_rout_linalg_utils_dcopy_wrap(const PyObject *capi_self,
                           PyObject *capi_args,
                           PyObject *capi_keywds,
                           void (*f2py_func)(double*,double*,int*)) {
  PyObject * volatile capi_buildvalue = NULL;
  volatile int f2py_success = 1;
/*decl*/

  double *x = NULL;
  npy_intp x_Dims[1] = {-1};
  const int x_Rank = 1;
  PyArrayObject *capi_x_tmp = NULL;
  int capi_x_intent = 0;
  PyObject *x_capi = Py_None;
  double *y = NULL;
  npy_intp y_Dims[1] = {-1};
  const int y_Rank = 1;
  PyArrayObject *capi_y_tmp = NULL;
  int capi_y_intent = 0;
  PyObject *y_capi = Py_None;
  int nx = 0;
  static char *capi_kwlist[] = {"x","y",NULL};

/*routdebugenter*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_clock();
#endif
  if (!PyArg_ParseTupleAndKeywords(capi_args,capi_keywds,\
    "OO:linalg_utils.dcopy_wrap",\
    capi_kwlist,&x_capi,&y_capi))
    return NULL;
/*frompyobj*/
  /* Processing variable x */
  ;
  capi_x_intent |= F2PY_INTENT_IN;
  capi_x_tmp = array_from_pyobj(NPY_DOUBLE,x_Dims,x_Rank,capi_x_intent,x_capi);
  if (capi_x_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 1st argument `x' of linalg_utils.dcopy_wrap to C/Fortran array" );
  } else {
    x = (double *)(capi_x_tmp->data);

  /* Processing variable nx */
  nx = len(x);
  CHECKSCALAR(len(x)>=nx,"len(x)>=nx","hidden nx","dcopy_wrap:nx=%d",nx) {
  /* Processing variable y */
  y_Dims[0]=nx;
  capi_y_intent |= F2PY_INTENT_INPLACE;
  capi_y_tmp = array_from_pyobj(NPY_DOUBLE,y_Dims,y_Rank,capi_y_intent,y_capi);
  if (capi_y_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 2nd argument `y' of linalg_utils.dcopy_wrap to C/Fortran array" );
  } else {
    y = (double *)(capi_y_tmp->data);

/*end of frompyobj*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_call_clock();
#endif
/*callfortranroutine*/
      Py_BEGIN_ALLOW_THREADS
        (*f2py_func)(x,y,&nx);
      Py_END_ALLOW_THREADS
if (PyErr_Occurred())
  f2py_success = 0;
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_call_clock();
#endif
/*end of callfortranroutine*/
    if (f2py_success) {
/*pyobjfrom*/
/*end of pyobjfrom*/
    CFUNCSMESS("Building return value.\n");
    capi_buildvalue = Py_BuildValue("");
/*closepyobjfrom*/
/*end of closepyobjfrom*/
    } /*if (f2py_success) after callfortranroutine*/
/*cleanupfrompyobj*/
  if((PyObject *)capi_y_tmp!=y_capi) {
    Py_XDECREF(capi_y_tmp); }
  }  /*if (capi_y_tmp == NULL) ... else of y*/
  /* End of cleaning variable y */
  } /*CHECKSCALAR(len(x)>=nx)*/
  /* End of cleaning variable nx */
  if((PyObject *)capi_x_tmp!=x_capi) {
    Py_XDECREF(capi_x_tmp); }
  }  /*if (capi_x_tmp == NULL) ... else of x*/
  /* End of cleaning variable x */
/*end of cleanupfrompyobj*/
  if (capi_buildvalue == NULL) {
/*routdebugfailure*/
  } else {
/*routdebugleave*/
  }
  CFUNCSMESS("Freeing memory.\n");
/*freemem*/
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_clock();
#endif
  return capi_buildvalue;
}
/***************************** end of dcopy_wrap *****************************/

/********************************* dtrmm_wrap *********************************/
static char doc_f2py_rout_linalg_utils_dtrmm_wrap[] = "\
dtrmm_wrap(a,b,side,transa,uplo,alpha)\n\nWrapper for ``dtrmm_wrap``.\
\n\nParameters\n----------\n"
"a : input rank-2 array('d') with bounds (m,m)\n"
"b :  rank-2 array('d') with bounds (m,n)\n"
"side : input string(len=1)\n"
"transa : input string(len=1)\n"
"uplo : input string(len=1)\n"
"alpha : input float";
/* extern void F_FUNC_US(dtrmm_wrap,DTRMM_WRAP)(int*,int*,double*,double*,string,string,string,double*,size_t,size_t,size_t); */
static PyObject *f2py_rout_linalg_utils_dtrmm_wrap(const PyObject *capi_self,
                           PyObject *capi_args,
                           PyObject *capi_keywds,
                           void (*f2py_func)(int*,int*,double*,double*,string,string,string,double*,size_t,size_t,size_t)) {
  PyObject * volatile capi_buildvalue = NULL;
  volatile int f2py_success = 1;
/*decl*/

  int m = 0;
  int n = 0;
  double *a = NULL;
  npy_intp a_Dims[2] = {-1, -1};
  const int a_Rank = 2;
  PyArrayObject *capi_a_tmp = NULL;
  int capi_a_intent = 0;
  PyObject *a_capi = Py_None;
  double *b = NULL;
  npy_intp b_Dims[2] = {-1, -1};
  const int b_Rank = 2;
  PyArrayObject *capi_b_tmp = NULL;
  int capi_b_intent = 0;
  PyObject *b_capi = Py_None;
  string side = NULL;
  int slen(side);
  PyObject *side_capi = Py_None;
  string transa = NULL;
  int slen(transa);
  PyObject *transa_capi = Py_None;
  string uplo = NULL;
  int slen(uplo);
  PyObject *uplo_capi = Py_None;
  double alpha = 0;
  PyObject *alpha_capi = Py_None;
  static char *capi_kwlist[] = {"a","b","side","transa","uplo","alpha",NULL};

/*routdebugenter*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_clock();
#endif
  if (!PyArg_ParseTupleAndKeywords(capi_args,capi_keywds,\
    "OOOOOO:linalg_utils.dtrmm_wrap",\
    capi_kwlist,&a_capi,&b_capi,&side_capi,&transa_capi,&uplo_capi,&alpha_capi))
    return NULL;
/*frompyobj*/
  /* Processing variable a */
  ;
  capi_a_intent |= F2PY_INTENT_IN;
  capi_a_tmp = array_from_pyobj(NPY_DOUBLE,a_Dims,a_Rank,capi_a_intent,a_capi);
  if (capi_a_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 1st argument `a' of linalg_utils.dtrmm_wrap to C/Fortran array" );
  } else {
    a = (double *)(capi_a_tmp->data);

  /* Processing variable uplo */
  slen(uplo) = 1;
  f2py_success = string_from_pyobj(&uplo,&slen(uplo),"",uplo_capi,"string_from_pyobj failed in converting 5th argument `uplo' of linalg_utils.dtrmm_wrap to C string");
  if (f2py_success) {
  /* Processing variable alpha */
    f2py_success = double_from_pyobj(&alpha,alpha_capi,"linalg_utils.dtrmm_wrap() 6th argument (alpha) can't be converted to double");
  if (f2py_success) {
  /* Processing variable transa */
  slen(transa) = 1;
  f2py_success = string_from_pyobj(&transa,&slen(transa),"",transa_capi,"string_from_pyobj failed in converting 4th argument `transa' of linalg_utils.dtrmm_wrap to C string");
  if (f2py_success) {
  /* Processing variable side */
  slen(side) = 1;
  f2py_success = string_from_pyobj(&side,&slen(side),"",side_capi,"string_from_pyobj failed in converting 3rd argument `side' of linalg_utils.dtrmm_wrap to C string");
  if (f2py_success) {
  /* Processing variable m */
  m = shape(a,0);
  CHECKSCALAR(shape(a,0)==m,"shape(a,0)==m","hidden m","dtrmm_wrap:m=%d",m) {
  /* Processing variable b */
  b_Dims[0]=m;
  capi_b_intent |= F2PY_INTENT_INPLACE;
  capi_b_tmp = array_from_pyobj(NPY_DOUBLE,b_Dims,b_Rank,capi_b_intent,b_capi);
  if (capi_b_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 2nd argument `b' of linalg_utils.dtrmm_wrap to C/Fortran array" );
  } else {
    b = (double *)(capi_b_tmp->data);

  /* Processing variable n */
  n = shape(b,1);
  CHECKSCALAR(shape(b,1)==n,"shape(b,1)==n","hidden n","dtrmm_wrap:n=%d",n) {
/*end of frompyobj*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_call_clock();
#endif
/*callfortranroutine*/
      Py_BEGIN_ALLOW_THREADS
        (*f2py_func)(&m,&n,a,b,side,transa,uplo,&alpha,slen(side),slen(transa),slen(uplo));
      Py_END_ALLOW_THREADS
if (PyErr_Occurred())
  f2py_success = 0;
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_call_clock();
#endif
/*end of callfortranroutine*/
    if (f2py_success) {
/*pyobjfrom*/
/*end of pyobjfrom*/
    CFUNCSMESS("Building return value.\n");
    capi_buildvalue = Py_BuildValue("");
/*closepyobjfrom*/
/*end of closepyobjfrom*/
    } /*if (f2py_success) after callfortranroutine*/
/*cleanupfrompyobj*/
  } /*CHECKSCALAR(shape(b,1)==n)*/
  /* End of cleaning variable n */
  if((PyObject *)capi_b_tmp!=b_capi) {
    Py_XDECREF(capi_b_tmp); }
  }  /*if (capi_b_tmp == NULL) ... else of b*/
  /* End of cleaning variable b */
  } /*CHECKSCALAR(shape(a,0)==m)*/
  /* End of cleaning variable m */
    STRINGFREE(side);
  }  /*if (f2py_success) of side*/
  /* End of cleaning variable side */
    STRINGFREE(transa);
  }  /*if (f2py_success) of transa*/
  /* End of cleaning variable transa */
  } /*if (f2py_success) of alpha*/
  /* End of cleaning variable alpha */
    STRINGFREE(uplo);
  }  /*if (f2py_success) of uplo*/
  /* End of cleaning variable uplo */
  if((PyObject *)capi_a_tmp!=a_capi) {
    Py_XDECREF(capi_a_tmp); }
  }  /*if (capi_a_tmp == NULL) ... else of a*/
  /* End of cleaning variable a */
/*end of cleanupfrompyobj*/
  if (capi_buildvalue == NULL) {
/*routdebugfailure*/
  } else {
/*routdebugleave*/
  }
  CFUNCSMESS("Freeing memory.\n");
/*freemem*/
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_clock();
#endif
  return capi_buildvalue;
}
/***************************** end of dtrmm_wrap *****************************/

/********************************* dtrsm_wrap *********************************/
static char doc_f2py_rout_linalg_utils_dtrsm_wrap[] = "\
dtrsm_wrap(a,b,side,transa,uplo,alpha)\n\nWrapper for ``dtrsm_wrap``.\
\n\nParameters\n----------\n"
"a : input rank-2 array('d') with bounds (m,m)\n"
"b :  rank-2 array('d') with bounds (m,n)\n"
"side : input string(len=1)\n"
"transa : input string(len=1)\n"
"uplo : input string(len=1)\n"
"alpha : input float";
/* extern void F_FUNC_US(dtrsm_wrap,DTRSM_WRAP)(int*,int*,double*,double*,string,string,string,double*,size_t,size_t,size_t); */
static PyObject *f2py_rout_linalg_utils_dtrsm_wrap(const PyObject *capi_self,
                           PyObject *capi_args,
                           PyObject *capi_keywds,
                           void (*f2py_func)(int*,int*,double*,double*,string,string,string,double*,size_t,size_t,size_t)) {
  PyObject * volatile capi_buildvalue = NULL;
  volatile int f2py_success = 1;
/*decl*/

  int m = 0;
  int n = 0;
  double *a = NULL;
  npy_intp a_Dims[2] = {-1, -1};
  const int a_Rank = 2;
  PyArrayObject *capi_a_tmp = NULL;
  int capi_a_intent = 0;
  PyObject *a_capi = Py_None;
  double *b = NULL;
  npy_intp b_Dims[2] = {-1, -1};
  const int b_Rank = 2;
  PyArrayObject *capi_b_tmp = NULL;
  int capi_b_intent = 0;
  PyObject *b_capi = Py_None;
  string side = NULL;
  int slen(side);
  PyObject *side_capi = Py_None;
  string transa = NULL;
  int slen(transa);
  PyObject *transa_capi = Py_None;
  string uplo = NULL;
  int slen(uplo);
  PyObject *uplo_capi = Py_None;
  double alpha = 0;
  PyObject *alpha_capi = Py_None;
  static char *capi_kwlist[] = {"a","b","side","transa","uplo","alpha",NULL};

/*routdebugenter*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_clock();
#endif
  if (!PyArg_ParseTupleAndKeywords(capi_args,capi_keywds,\
    "OOOOOO:linalg_utils.dtrsm_wrap",\
    capi_kwlist,&a_capi,&b_capi,&side_capi,&transa_capi,&uplo_capi,&alpha_capi))
    return NULL;
/*frompyobj*/
  /* Processing variable a */
  ;
  capi_a_intent |= F2PY_INTENT_IN;
  capi_a_tmp = array_from_pyobj(NPY_DOUBLE,a_Dims,a_Rank,capi_a_intent,a_capi);
  if (capi_a_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 1st argument `a' of linalg_utils.dtrsm_wrap to C/Fortran array" );
  } else {
    a = (double *)(capi_a_tmp->data);

  /* Processing variable uplo */
  slen(uplo) = 1;
  f2py_success = string_from_pyobj(&uplo,&slen(uplo),"",uplo_capi,"string_from_pyobj failed in converting 5th argument `uplo' of linalg_utils.dtrsm_wrap to C string");
  if (f2py_success) {
  /* Processing variable alpha */
    f2py_success = double_from_pyobj(&alpha,alpha_capi,"linalg_utils.dtrsm_wrap() 6th argument (alpha) can't be converted to double");
  if (f2py_success) {
  /* Processing variable transa */
  slen(transa) = 1;
  f2py_success = string_from_pyobj(&transa,&slen(transa),"",transa_capi,"string_from_pyobj failed in converting 4th argument `transa' of linalg_utils.dtrsm_wrap to C string");
  if (f2py_success) {
  /* Processing variable side */
  slen(side) = 1;
  f2py_success = string_from_pyobj(&side,&slen(side),"",side_capi,"string_from_pyobj failed in converting 3rd argument `side' of linalg_utils.dtrsm_wrap to C string");
  if (f2py_success) {
  /* Processing variable m */
  m = shape(a,0);
  CHECKSCALAR(shape(a,0)==m,"shape(a,0)==m","hidden m","dtrsm_wrap:m=%d",m) {
  /* Processing variable b */
  b_Dims[0]=m;
  capi_b_intent |= F2PY_INTENT_INPLACE;
  capi_b_tmp = array_from_pyobj(NPY_DOUBLE,b_Dims,b_Rank,capi_b_intent,b_capi);
  if (capi_b_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 2nd argument `b' of linalg_utils.dtrsm_wrap to C/Fortran array" );
  } else {
    b = (double *)(capi_b_tmp->data);

  /* Processing variable n */
  n = shape(b,1);
  CHECKSCALAR(shape(b,1)==n,"shape(b,1)==n","hidden n","dtrsm_wrap:n=%d",n) {
/*end of frompyobj*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_call_clock();
#endif
/*callfortranroutine*/
      Py_BEGIN_ALLOW_THREADS
        (*f2py_func)(&m,&n,a,b,side,transa,uplo,&alpha,slen(side),slen(transa),slen(uplo));
      Py_END_ALLOW_THREADS
if (PyErr_Occurred())
  f2py_success = 0;
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_call_clock();
#endif
/*end of callfortranroutine*/
    if (f2py_success) {
/*pyobjfrom*/
/*end of pyobjfrom*/
    CFUNCSMESS("Building return value.\n");
    capi_buildvalue = Py_BuildValue("");
/*closepyobjfrom*/
/*end of closepyobjfrom*/
    } /*if (f2py_success) after callfortranroutine*/
/*cleanupfrompyobj*/
  } /*CHECKSCALAR(shape(b,1)==n)*/
  /* End of cleaning variable n */
  if((PyObject *)capi_b_tmp!=b_capi) {
    Py_XDECREF(capi_b_tmp); }
  }  /*if (capi_b_tmp == NULL) ... else of b*/
  /* End of cleaning variable b */
  } /*CHECKSCALAR(shape(a,0)==m)*/
  /* End of cleaning variable m */
    STRINGFREE(side);
  }  /*if (f2py_success) of side*/
  /* End of cleaning variable side */
    STRINGFREE(transa);
  }  /*if (f2py_success) of transa*/
  /* End of cleaning variable transa */
  } /*if (f2py_success) of alpha*/
  /* End of cleaning variable alpha */
    STRINGFREE(uplo);
  }  /*if (f2py_success) of uplo*/
  /* End of cleaning variable uplo */
  if((PyObject *)capi_a_tmp!=a_capi) {
    Py_XDECREF(capi_a_tmp); }
  }  /*if (capi_a_tmp == NULL) ... else of a*/
  /* End of cleaning variable a */
/*end of cleanupfrompyobj*/
  if (capi_buildvalue == NULL) {
/*routdebugfailure*/
  } else {
/*routdebugleave*/
  }
  CFUNCSMESS("Freeing memory.\n");
/*freemem*/
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_clock();
#endif
  return capi_buildvalue;
}
/***************************** end of dtrsm_wrap *****************************/

/******************************** dpotrf_wrap ********************************/
static char doc_f2py_rout_linalg_utils_dpotrf_wrap[] = "\
info = dpotrf_wrap(a)\n\nWrapper for ``dpotrf_wrap``.\
\n\nParameters\n----------\n"
"a :  rank-2 array('d') with bounds (n,n)\n"
"\nReturns\n-------\n"
"info : int";
/* extern void F_FUNC_US(dpotrf_wrap,DPOTRF_WRAP)(double*,int*,int*); */
static PyObject *f2py_rout_linalg_utils_dpotrf_wrap(const PyObject *capi_self,
                           PyObject *capi_args,
                           PyObject *capi_keywds,
                           void (*f2py_func)(double*,int*,int*)) {
  PyObject * volatile capi_buildvalue = NULL;
  volatile int f2py_success = 1;
/*decl*/

  double *a = NULL;
  npy_intp a_Dims[2] = {-1, -1};
  const int a_Rank = 2;
  PyArrayObject *capi_a_tmp = NULL;
  int capi_a_intent = 0;
  PyObject *a_capi = Py_None;
  int n = 0;
  int info = 0;
  static char *capi_kwlist[] = {"a",NULL};

/*routdebugenter*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_clock();
#endif
  if (!PyArg_ParseTupleAndKeywords(capi_args,capi_keywds,\
    "O:linalg_utils.dpotrf_wrap",\
    capi_kwlist,&a_capi))
    return NULL;
/*frompyobj*/
  /* Processing variable a */
  ;
  capi_a_intent |= F2PY_INTENT_INPLACE;
  capi_a_tmp = array_from_pyobj(NPY_DOUBLE,a_Dims,a_Rank,capi_a_intent,a_capi);
  if (capi_a_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 1st argument `a' of linalg_utils.dpotrf_wrap to C/Fortran array" );
  } else {
    a = (double *)(capi_a_tmp->data);

  /* Processing variable info */
  /* Processing variable n */
  n = shape(a,0);
/*end of frompyobj*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_call_clock();
#endif
/*callfortranroutine*/
      Py_BEGIN_ALLOW_THREADS
        (*f2py_func)(a,&n,&info);
      Py_END_ALLOW_THREADS
if (PyErr_Occurred())
  f2py_success = 0;
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_call_clock();
#endif
/*end of callfortranroutine*/
    if (f2py_success) {
/*pyobjfrom*/
/*end of pyobjfrom*/
    CFUNCSMESS("Building return value.\n");
    capi_buildvalue = Py_BuildValue("i",info);
/*closepyobjfrom*/
/*end of closepyobjfrom*/
    } /*if (f2py_success) after callfortranroutine*/
/*cleanupfrompyobj*/
  /* End of cleaning variable n */
  /* End of cleaning variable info */
  if((PyObject *)capi_a_tmp!=a_capi) {
    Py_XDECREF(capi_a_tmp); }
  }  /*if (capi_a_tmp == NULL) ... else of a*/
  /* End of cleaning variable a */
/*end of cleanupfrompyobj*/
  if (capi_buildvalue == NULL) {
/*routdebugfailure*/
  } else {
/*routdebugleave*/
  }
  CFUNCSMESS("Freeing memory.\n");
/*freemem*/
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_clock();
#endif
  return capi_buildvalue;
}
/***************************** end of dpotrf_wrap *****************************/

/********************************* dchdc_wrap *********************************/
static char doc_f2py_rout_linalg_utils_dchdc_wrap[] = "\
piv,info = dchdc_wrap(a)\n\nWrapper for ``dchdc_wrap``.\
\n\nParameters\n----------\n"
"a :  rank-2 array('d') with bounds (p,p)\n"
"\nReturns\n-------\n"
"piv : rank-1 array('i') with bounds (p)\n"
"info : int";
/* extern void F_FUNC_US(dchdc_wrap,DCHDC_WRAP)(double*,int*,double*,int*,int*); */
static PyObject *f2py_rout_linalg_utils_dchdc_wrap(const PyObject *capi_self,
                           PyObject *capi_args,
                           PyObject *capi_keywds,
                           void (*f2py_func)(double*,int*,double*,int*,int*)) {
  PyObject * volatile capi_buildvalue = NULL;
  volatile int f2py_success = 1;
/*decl*/

  double *a = NULL;
  npy_intp a_Dims[2] = {-1, -1};
  const int a_Rank = 2;
  PyArrayObject *capi_a_tmp = NULL;
  int capi_a_intent = 0;
  PyObject *a_capi = Py_None;
  int p = 0;
  double *work = NULL;
  npy_intp work_Dims[1] = {-1};
  const int work_Rank = 1;
  PyArrayObject *capi_work_tmp = NULL;
  int capi_work_intent = 0;
  int *piv = NULL;
  npy_intp piv_Dims[1] = {-1};
  const int piv_Rank = 1;
  PyArrayObject *capi_piv_tmp = NULL;
  int capi_piv_intent = 0;
  int info = 0;
  static char *capi_kwlist[] = {"a",NULL};

/*routdebugenter*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_clock();
#endif
  if (!PyArg_ParseTupleAndKeywords(capi_args,capi_keywds,\
    "O:linalg_utils.dchdc_wrap",\
    capi_kwlist,&a_capi))
    return NULL;
/*frompyobj*/
  /* Processing variable a */
  ;
  capi_a_intent |= F2PY_INTENT_INPLACE;
  capi_a_tmp = array_from_pyobj(NPY_DOUBLE,a_Dims,a_Rank,capi_a_intent,a_capi);
  if (capi_a_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 1st argument `a' of linalg_utils.dchdc_wrap to C/Fortran array" );
  } else {
    a = (double *)(capi_a_tmp->data);

  /* Processing variable info */
  /* Processing variable p */
  p = shape(a,0);
  CHECKSCALAR(shape(a,0)==p,"shape(a,0)==p","hidden p","dchdc_wrap:p=%d",p) {
  /* Processing variable piv */
  piv_Dims[0]=p;
  capi_piv_intent |= F2PY_INTENT_OUT|F2PY_INTENT_HIDE;
  capi_piv_tmp = array_from_pyobj(NPY_INT,piv_Dims,piv_Rank,capi_piv_intent,Py_None);
  if (capi_piv_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting hidden `piv' of linalg_utils.dchdc_wrap to C/Fortran array" );
  } else {
    piv = (int *)(capi_piv_tmp->data);

  /* Processing variable work */
  work_Dims[0]=p;
  capi_work_intent |= F2PY_INTENT_HIDE;
  capi_work_tmp = array_from_pyobj(NPY_DOUBLE,work_Dims,work_Rank,capi_work_intent,Py_None);
  if (capi_work_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting hidden `work' of linalg_utils.dchdc_wrap to C/Fortran array" );
  } else {
    work = (double *)(capi_work_tmp->data);

/*end of frompyobj*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_call_clock();
#endif
/*callfortranroutine*/
      Py_BEGIN_ALLOW_THREADS
        (*f2py_func)(a,&p,work,piv,&info);
      Py_END_ALLOW_THREADS
if (PyErr_Occurred())
  f2py_success = 0;
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_call_clock();
#endif
/*end of callfortranroutine*/
    if (f2py_success) {
/*pyobjfrom*/
/*end of pyobjfrom*/
    CFUNCSMESS("Building return value.\n");
    capi_buildvalue = Py_BuildValue("Ni",capi_piv_tmp,info);
/*closepyobjfrom*/
/*end of closepyobjfrom*/
    } /*if (f2py_success) after callfortranroutine*/
/*cleanupfrompyobj*/
    Py_XDECREF(capi_work_tmp);
  }  /*if (capi_work_tmp == NULL) ... else of work*/
  /* End of cleaning variable work */
  }  /*if (capi_piv_tmp == NULL) ... else of piv*/
  /* End of cleaning variable piv */
  } /*CHECKSCALAR(shape(a,0)==p)*/
  /* End of cleaning variable p */
  /* End of cleaning variable info */
  if((PyObject *)capi_a_tmp!=a_capi) {
    Py_XDECREF(capi_a_tmp); }
  }  /*if (capi_a_tmp == NULL) ... else of a*/
  /* End of cleaning variable a */
/*end of cleanupfrompyobj*/
  if (capi_buildvalue == NULL) {
/*routdebugfailure*/
  } else {
/*routdebugleave*/
  }
  CFUNCSMESS("Freeing memory.\n");
/*freemem*/
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_clock();
#endif
  return capi_buildvalue;
}
/***************************** end of dchdc_wrap *****************************/

/******************************** dpotrs_wrap ********************************/
static char doc_f2py_rout_linalg_utils_dpotrs_wrap[] = "\
info = dpotrs_wrap(chol_fac,b,[uplo])\n\nWrapper for ``dpotrs_wrap``.\
\n\nParameters\n----------\n"
"chol_fac : input rank-2 array('d') with bounds (n,n)\n"
"b :  rank-2 array('d') with bounds (n,m)\n"
"\nOther Parameters\n----------------\n"
"uplo : input string(len=1)\n"
"\nReturns\n-------\n"
"info : int";
/* extern void F_FUNC_US(dpotrs_wrap,DPOTRS_WRAP)(double*,double*,int*,int*,int*,string,size_t); */
static PyObject *f2py_rout_linalg_utils_dpotrs_wrap(const PyObject *capi_self,
                           PyObject *capi_args,
                           PyObject *capi_keywds,
                           void (*f2py_func)(double*,double*,int*,int*,int*,string,size_t)) {
  PyObject * volatile capi_buildvalue = NULL;
  volatile int f2py_success = 1;
/*decl*/

  double *chol_fac = NULL;
  npy_intp chol_fac_Dims[2] = {-1, -1};
  const int chol_fac_Rank = 2;
  PyArrayObject *capi_chol_fac_tmp = NULL;
  int capi_chol_fac_intent = 0;
  PyObject *chol_fac_capi = Py_None;
  double *b = NULL;
  npy_intp b_Dims[2] = {-1, -1};
  const int b_Rank = 2;
  PyArrayObject *capi_b_tmp = NULL;
  int capi_b_intent = 0;
  PyObject *b_capi = Py_None;
  int info = 0;
  int n = 0;
  int m = 0;
  string uplo = NULL;
  int slen(uplo);
  PyObject *uplo_capi = Py_None;
  static char *capi_kwlist[] = {"chol_fac","b","uplo",NULL};

/*routdebugenter*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_clock();
#endif
  if (!PyArg_ParseTupleAndKeywords(capi_args,capi_keywds,\
    "OO|O:linalg_utils.dpotrs_wrap",\
    capi_kwlist,&chol_fac_capi,&b_capi,&uplo_capi))
    return NULL;
/*frompyobj*/
  /* Processing variable info */
  /* Processing variable uplo */
  slen(uplo) = 1;
  f2py_success = string_from_pyobj(&uplo,&slen(uplo),"",uplo_capi,"string_from_pyobj failed in converting 1st keyword `uplo' of linalg_utils.dpotrs_wrap to C string");
  if (f2py_success) {
  /* Processing variable chol_fac */
  ;
  capi_chol_fac_intent |= F2PY_INTENT_IN;
  capi_chol_fac_tmp = array_from_pyobj(NPY_DOUBLE,chol_fac_Dims,chol_fac_Rank,capi_chol_fac_intent,chol_fac_capi);
  if (capi_chol_fac_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 1st argument `chol_fac' of linalg_utils.dpotrs_wrap to C/Fortran array" );
  } else {
    chol_fac = (double *)(capi_chol_fac_tmp->data);

  /* Processing variable n */
  n = shape(chol_fac,0);
  /* Processing variable b */
  b_Dims[0]=n;
  capi_b_intent |= F2PY_INTENT_INPLACE;
  capi_b_tmp = array_from_pyobj(NPY_DOUBLE,b_Dims,b_Rank,capi_b_intent,b_capi);
  if (capi_b_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 2nd argument `b' of linalg_utils.dpotrs_wrap to C/Fortran array" );
  } else {
    b = (double *)(capi_b_tmp->data);

  /* Processing variable m */
  m = shape(b,1);
/*end of frompyobj*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_call_clock();
#endif
/*callfortranroutine*/
      Py_BEGIN_ALLOW_THREADS
        (*f2py_func)(chol_fac,b,&info,&n,&m,uplo,slen(uplo));
      Py_END_ALLOW_THREADS
if (PyErr_Occurred())
  f2py_success = 0;
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_call_clock();
#endif
/*end of callfortranroutine*/
    if (f2py_success) {
/*pyobjfrom*/
/*end of pyobjfrom*/
    CFUNCSMESS("Building return value.\n");
    capi_buildvalue = Py_BuildValue("i",info);
/*closepyobjfrom*/
/*end of closepyobjfrom*/
    } /*if (f2py_success) after callfortranroutine*/
/*cleanupfrompyobj*/
  /* End of cleaning variable m */
  if((PyObject *)capi_b_tmp!=b_capi) {
    Py_XDECREF(capi_b_tmp); }
  }  /*if (capi_b_tmp == NULL) ... else of b*/
  /* End of cleaning variable b */
  /* End of cleaning variable n */
  if((PyObject *)capi_chol_fac_tmp!=chol_fac_capi) {
    Py_XDECREF(capi_chol_fac_tmp); }
  }  /*if (capi_chol_fac_tmp == NULL) ... else of chol_fac*/
  /* End of cleaning variable chol_fac */
    STRINGFREE(uplo);
  }  /*if (f2py_success) of uplo*/
  /* End of cleaning variable uplo */
  /* End of cleaning variable info */
/*end of cleanupfrompyobj*/
  if (capi_buildvalue == NULL) {
/*routdebugfailure*/
  } else {
/*routdebugleave*/
  }
  CFUNCSMESS("Freeing memory.\n");
/*freemem*/
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_clock();
#endif
  return capi_buildvalue;
}
/***************************** end of dpotrs_wrap *****************************/

/*********************************** xerbla ***********************************/
static char doc_f2py_rout_linalg_utils_xerbla[] = "\
xerbla(srname,info)\n\nWrapper for ``xerbla``.\
\n\nParameters\n----------\n"
"srname : input string(len=6)\n"
"info : input int";
/* extern void F_FUNC(xerbla,XERBLA)(string,int*,size_t); */
static PyObject *f2py_rout_linalg_utils_xerbla(const PyObject *capi_self,
                           PyObject *capi_args,
                           PyObject *capi_keywds,
                           void (*f2py_func)(string,int*,size_t)) {
  PyObject * volatile capi_buildvalue = NULL;
  volatile int f2py_success = 1;
/*decl*/

  string srname = NULL;
  int slen(srname);
  PyObject *srname_capi = Py_None;
  int info = 0;
  PyObject *info_capi = Py_None;
  static char *capi_kwlist[] = {"srname","info",NULL};

/*routdebugenter*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_clock();
#endif
  if (!PyArg_ParseTupleAndKeywords(capi_args,capi_keywds,\
    "OO:linalg_utils.xerbla",\
    capi_kwlist,&srname_capi,&info_capi))
    return NULL;
/*frompyobj*/
  /* Processing variable info */
    f2py_success = int_from_pyobj(&info,info_capi,"linalg_utils.xerbla() 2nd argument (info) can't be converted to int");
  if (f2py_success) {
  /* Processing variable srname */
  slen(srname) = 6;
  f2py_success = string_from_pyobj(&srname,&slen(srname),"",srname_capi,"string_from_pyobj failed in converting 1st argument `srname' of linalg_utils.xerbla to C string");
  if (f2py_success) {
/*end of frompyobj*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_call_clock();
#endif
/*callfortranroutine*/
        (*f2py_func)(srname,&info,slen(srname));
if (PyErr_Occurred())
  f2py_success = 0;
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_call_clock();
#endif
/*end of callfortranroutine*/
    if (f2py_success) {
/*pyobjfrom*/
/*end of pyobjfrom*/
    CFUNCSMESS("Building return value.\n");
    capi_buildvalue = Py_BuildValue("");
/*closepyobjfrom*/
/*end of closepyobjfrom*/
    } /*if (f2py_success) after callfortranroutine*/
/*cleanupfrompyobj*/
    STRINGFREE(srname);
  }  /*if (f2py_success) of srname*/
  /* End of cleaning variable srname */
  } /*if (f2py_success) of info*/
  /* End of cleaning variable info */
/*end of cleanupfrompyobj*/
  if (capi_buildvalue == NULL) {
/*routdebugfailure*/
  } else {
/*routdebugleave*/
  }
  CFUNCSMESS("Freeing memory.\n");
/*freemem*/
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_clock();
#endif
  return capi_buildvalue;
}
/******************************* end of xerbla *******************************/

/*********************************** lsame ***********************************/
static char doc_f2py_rout_linalg_utils_lsame[] = "\
lsame = lsame(ca,cb)\n\nWrapper for ``lsame``.\
\n\nParameters\n----------\n"
"ca : input string(len=1)\n"
"cb : input string(len=1)\n"
"\nReturns\n-------\n"
"lsame : int";
/* extern void F_WRAPPEDFUNC(lsame,LSAME)(int*,string,string,size_t,size_t); */
static PyObject *f2py_rout_linalg_utils_lsame(const PyObject *capi_self,
                           PyObject *capi_args,
                           PyObject *capi_keywds,
                           void (*f2py_func)(int*,string,string,size_t,size_t)) {
  PyObject * volatile capi_buildvalue = NULL;
  volatile int f2py_success = 1;
/*decl*/

  int lsame = 0;
  string ca = NULL;
  int slen(ca);
  PyObject *ca_capi = Py_None;
  string cb = NULL;
  int slen(cb);
  PyObject *cb_capi = Py_None;
  static char *capi_kwlist[] = {"ca","cb",NULL};

/*routdebugenter*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_clock();
#endif
  if (!PyArg_ParseTupleAndKeywords(capi_args,capi_keywds,\
    "OO:linalg_utils.lsame",\
    capi_kwlist,&ca_capi,&cb_capi))
    return NULL;
/*frompyobj*/
  /* Processing variable lsame */
  /* Processing variable cb */
  slen(cb) = 1;
  f2py_success = string_from_pyobj(&cb,&slen(cb),"",cb_capi,"string_from_pyobj failed in converting 2nd argument `cb' of linalg_utils.lsame to C string");
  if (f2py_success) {
  /* Processing variable ca */
  slen(ca) = 1;
  f2py_success = string_from_pyobj(&ca,&slen(ca),"",ca_capi,"string_from_pyobj failed in converting 1st argument `ca' of linalg_utils.lsame to C string");
  if (f2py_success) {
/*end of frompyobj*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_call_clock();
#endif
/*callfortranroutine*/
  (*f2py_func)(&lsame,ca,cb,slen(ca),slen(cb));
if (PyErr_Occurred())
  f2py_success = 0;
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_call_clock();
#endif
/*end of callfortranroutine*/
    if (f2py_success) {
/*pyobjfrom*/
/*end of pyobjfrom*/
    CFUNCSMESS("Building return value.\n");
    capi_buildvalue = Py_BuildValue("i",lsame);
/*closepyobjfrom*/
/*end of closepyobjfrom*/
    } /*if (f2py_success) after callfortranroutine*/
/*cleanupfrompyobj*/
    STRINGFREE(ca);
  }  /*if (f2py_success) of ca*/
  /* End of cleaning variable ca */
    STRINGFREE(cb);
  }  /*if (f2py_success) of cb*/
  /* End of cleaning variable cb */
  /* End of cleaning variable lsame */
/*end of cleanupfrompyobj*/
  if (capi_buildvalue == NULL) {
/*routdebugfailure*/
  } else {
/*routdebugleave*/
  }
  CFUNCSMESS("Freeing memory.\n");
/*freemem*/
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_clock();
#endif
  return capi_buildvalue;
}
/******************************** end of lsame ********************************/

/*********************************** idamax ***********************************/
static char doc_f2py_rout_linalg_utils_idamax[] = "\
idamax = idamax(n,dx,incx)\n\nWrapper for ``idamax``.\
\n\nParameters\n----------\n"
"n : input int\n"
"dx : input rank-1 array('d') with bounds (*)\n"
"incx : input int\n"
"\nReturns\n-------\n"
"idamax : int";
/* extern void F_WRAPPEDFUNC(idamax,IDAMAX)(int*,int*,double*,int*); */
static PyObject *f2py_rout_linalg_utils_idamax(const PyObject *capi_self,
                           PyObject *capi_args,
                           PyObject *capi_keywds,
                           void (*f2py_func)(int*,int*,double*,int*)) {
  PyObject * volatile capi_buildvalue = NULL;
  volatile int f2py_success = 1;
/*decl*/

  int idamax = 0;
  int n = 0;
  PyObject *n_capi = Py_None;
  double *dx = NULL;
  npy_intp dx_Dims[1] = {-1};
  const int dx_Rank = 1;
  PyArrayObject *capi_dx_tmp = NULL;
  int capi_dx_intent = 0;
  PyObject *dx_capi = Py_None;
  int incx = 0;
  PyObject *incx_capi = Py_None;
  static char *capi_kwlist[] = {"n","dx","incx",NULL};

/*routdebugenter*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_clock();
#endif
  if (!PyArg_ParseTupleAndKeywords(capi_args,capi_keywds,\
    "OOO:linalg_utils.idamax",\
    capi_kwlist,&n_capi,&dx_capi,&incx_capi))
    return NULL;
/*frompyobj*/
  /* Processing variable idamax */
  /* Processing variable dx */
  ;
  capi_dx_intent |= F2PY_INTENT_IN;
  capi_dx_tmp = array_from_pyobj(NPY_DOUBLE,dx_Dims,dx_Rank,capi_dx_intent,dx_capi);
  if (capi_dx_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 2nd argument `dx' of linalg_utils.idamax to C/Fortran array" );
  } else {
    dx = (double *)(capi_dx_tmp->data);

  /* Processing variable incx */
    f2py_success = int_from_pyobj(&incx,incx_capi,"linalg_utils.idamax() 3rd argument (incx) can't be converted to int");
  if (f2py_success) {
  /* Processing variable n */
    f2py_success = int_from_pyobj(&n,n_capi,"linalg_utils.idamax() 1st argument (n) can't be converted to int");
  if (f2py_success) {
/*end of frompyobj*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_call_clock();
#endif
/*callfortranroutine*/
  (*f2py_func)(&idamax,&n,dx,&incx);
if (PyErr_Occurred())
  f2py_success = 0;
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_call_clock();
#endif
/*end of callfortranroutine*/
    if (f2py_success) {
/*pyobjfrom*/
/*end of pyobjfrom*/
    CFUNCSMESS("Building return value.\n");
    capi_buildvalue = Py_BuildValue("i",idamax);
/*closepyobjfrom*/
/*end of closepyobjfrom*/
    } /*if (f2py_success) after callfortranroutine*/
/*cleanupfrompyobj*/
  } /*if (f2py_success) of n*/
  /* End of cleaning variable n */
  } /*if (f2py_success) of incx*/
  /* End of cleaning variable incx */
  if((PyObject *)capi_dx_tmp!=dx_capi) {
    Py_XDECREF(capi_dx_tmp); }
  }  /*if (capi_dx_tmp == NULL) ... else of dx*/
  /* End of cleaning variable dx */
  /* End of cleaning variable idamax */
/*end of cleanupfrompyobj*/
  if (capi_buildvalue == NULL) {
/*routdebugfailure*/
  } else {
/*routdebugleave*/
  }
  CFUNCSMESS("Freeing memory.\n");
/*freemem*/
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_clock();
#endif
  return capi_buildvalue;
}
/******************************* end of idamax *******************************/

/*********************************** dznrm2 ***********************************/
static char doc_f2py_rout_linalg_utils_dznrm2[] = "\
dznrm2 = dznrm2(n,x,incx)\n\nWrapper for ``dznrm2``.\
\n\nParameters\n----------\n"
"n : input int\n"
"x : input rank-1 array('D') with bounds (*)\n"
"incx : input int\n"
"\nReturns\n-------\n"
"dznrm2 : float";
/* extern void F_WRAPPEDFUNC(dznrm2,DZNRM2)(double*,int*,complex_double*,int*); */
static PyObject *f2py_rout_linalg_utils_dznrm2(const PyObject *capi_self,
                           PyObject *capi_args,
                           PyObject *capi_keywds,
                           void (*f2py_func)(double*,int*,complex_double*,int*)) {
  PyObject * volatile capi_buildvalue = NULL;
  volatile int f2py_success = 1;
/*decl*/

  double dznrm2 = 0;
  int n = 0;
  PyObject *n_capi = Py_None;
  complex_double *x = NULL;
  npy_intp x_Dims[1] = {-1};
  const int x_Rank = 1;
  PyArrayObject *capi_x_tmp = NULL;
  int capi_x_intent = 0;
  PyObject *x_capi = Py_None;
  int incx = 0;
  PyObject *incx_capi = Py_None;
  static char *capi_kwlist[] = {"n","x","incx",NULL};

/*routdebugenter*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_clock();
#endif
  if (!PyArg_ParseTupleAndKeywords(capi_args,capi_keywds,\
    "OOO:linalg_utils.dznrm2",\
    capi_kwlist,&n_capi,&x_capi,&incx_capi))
    return NULL;
/*frompyobj*/
  /* Processing variable incx */
    f2py_success = int_from_pyobj(&incx,incx_capi,"linalg_utils.dznrm2() 3rd argument (incx) can't be converted to int");
  if (f2py_success) {
  /* Processing variable dznrm2 */
  /* Processing variable x */
  ;
  capi_x_intent |= F2PY_INTENT_IN;
  capi_x_tmp = array_from_pyobj(NPY_CDOUBLE,x_Dims,x_Rank,capi_x_intent,x_capi);
  if (capi_x_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 2nd argument `x' of linalg_utils.dznrm2 to C/Fortran array" );
  } else {
    x = (complex_double *)(capi_x_tmp->data);

  /* Processing variable n */
    f2py_success = int_from_pyobj(&n,n_capi,"linalg_utils.dznrm2() 1st argument (n) can't be converted to int");
  if (f2py_success) {
/*end of frompyobj*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_call_clock();
#endif
/*callfortranroutine*/
  (*f2py_func)(&dznrm2,&n,x,&incx);
if (PyErr_Occurred())
  f2py_success = 0;
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_call_clock();
#endif
/*end of callfortranroutine*/
    if (f2py_success) {
/*pyobjfrom*/
/*end of pyobjfrom*/
    CFUNCSMESS("Building return value.\n");
    capi_buildvalue = Py_BuildValue("d",dznrm2);
/*closepyobjfrom*/
/*end of closepyobjfrom*/
    } /*if (f2py_success) after callfortranroutine*/
/*cleanupfrompyobj*/
  } /*if (f2py_success) of n*/
  /* End of cleaning variable n */
  if((PyObject *)capi_x_tmp!=x_capi) {
    Py_XDECREF(capi_x_tmp); }
  }  /*if (capi_x_tmp == NULL) ... else of x*/
  /* End of cleaning variable x */
  /* End of cleaning variable dznrm2 */
  } /*if (f2py_success) of incx*/
  /* End of cleaning variable incx */
/*end of cleanupfrompyobj*/
  if (capi_buildvalue == NULL) {
/*routdebugfailure*/
  } else {
/*routdebugleave*/
  }
  CFUNCSMESS("Freeing memory.\n");
/*freemem*/
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_clock();
#endif
  return capi_buildvalue;
}
/******************************* end of dznrm2 *******************************/

/*********************************** dzasum ***********************************/
static char doc_f2py_rout_linalg_utils_dzasum[] = "\
dzasum = dzasum(n,zx,incx)\n\nWrapper for ``dzasum``.\
\n\nParameters\n----------\n"
"n : input int\n"
"zx : input rank-1 array('D') with bounds (*)\n"
"incx : input int\n"
"\nReturns\n-------\n"
"dzasum : float";
/* extern void F_WRAPPEDFUNC(dzasum,DZASUM)(double*,int*,complex_double*,int*); */
static PyObject *f2py_rout_linalg_utils_dzasum(const PyObject *capi_self,
                           PyObject *capi_args,
                           PyObject *capi_keywds,
                           void (*f2py_func)(double*,int*,complex_double*,int*)) {
  PyObject * volatile capi_buildvalue = NULL;
  volatile int f2py_success = 1;
/*decl*/

  double dzasum = 0;
  int n = 0;
  PyObject *n_capi = Py_None;
  complex_double *zx = NULL;
  npy_intp zx_Dims[1] = {-1};
  const int zx_Rank = 1;
  PyArrayObject *capi_zx_tmp = NULL;
  int capi_zx_intent = 0;
  PyObject *zx_capi = Py_None;
  int incx = 0;
  PyObject *incx_capi = Py_None;
  static char *capi_kwlist[] = {"n","zx","incx",NULL};

/*routdebugenter*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_clock();
#endif
  if (!PyArg_ParseTupleAndKeywords(capi_args,capi_keywds,\
    "OOO:linalg_utils.dzasum",\
    capi_kwlist,&n_capi,&zx_capi,&incx_capi))
    return NULL;
/*frompyobj*/
  /* Processing variable zx */
  ;
  capi_zx_intent |= F2PY_INTENT_IN;
  capi_zx_tmp = array_from_pyobj(NPY_CDOUBLE,zx_Dims,zx_Rank,capi_zx_intent,zx_capi);
  if (capi_zx_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 2nd argument `zx' of linalg_utils.dzasum to C/Fortran array" );
  } else {
    zx = (complex_double *)(capi_zx_tmp->data);

  /* Processing variable incx */
    f2py_success = int_from_pyobj(&incx,incx_capi,"linalg_utils.dzasum() 3rd argument (incx) can't be converted to int");
  if (f2py_success) {
  /* Processing variable n */
    f2py_success = int_from_pyobj(&n,n_capi,"linalg_utils.dzasum() 1st argument (n) can't be converted to int");
  if (f2py_success) {
  /* Processing variable dzasum */
/*end of frompyobj*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_call_clock();
#endif
/*callfortranroutine*/
  (*f2py_func)(&dzasum,&n,zx,&incx);
if (PyErr_Occurred())
  f2py_success = 0;
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_call_clock();
#endif
/*end of callfortranroutine*/
    if (f2py_success) {
/*pyobjfrom*/
/*end of pyobjfrom*/
    CFUNCSMESS("Building return value.\n");
    capi_buildvalue = Py_BuildValue("d",dzasum);
/*closepyobjfrom*/
/*end of closepyobjfrom*/
    } /*if (f2py_success) after callfortranroutine*/
/*cleanupfrompyobj*/
  /* End of cleaning variable dzasum */
  } /*if (f2py_success) of n*/
  /* End of cleaning variable n */
  } /*if (f2py_success) of incx*/
  /* End of cleaning variable incx */
  if((PyObject *)capi_zx_tmp!=zx_capi) {
    Py_XDECREF(capi_zx_tmp); }
  }  /*if (capi_zx_tmp == NULL) ... else of zx*/
  /* End of cleaning variable zx */
/*end of cleanupfrompyobj*/
  if (capi_buildvalue == NULL) {
/*routdebugfailure*/
  } else {
/*routdebugleave*/
  }
  CFUNCSMESS("Freeing memory.\n");
/*freemem*/
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_clock();
#endif
  return capi_buildvalue;
}
/******************************* end of dzasum *******************************/

/*********************************** dtrsv ***********************************/
static char doc_f2py_rout_linalg_utils_dtrsv[] = "\
dtrsv(uplo,trans,diag,n,a,x,incx,[lda])\n\nWrapper for ``dtrsv``.\
\n\nParameters\n----------\n"
"uplo : input string(len=1)\n"
"trans : input string(len=1)\n"
"diag : input string(len=1)\n"
"n : input int\n"
"a : input rank-2 array('d') with bounds (lda,*)\n"
"x : input rank-1 array('d') with bounds (*)\n"
"incx : input int\n"
"\nOther Parameters\n----------------\n"
"lda : input int, optional\n    Default: shape(a,0)";
/* extern void F_FUNC(dtrsv,DTRSV)(string,string,string,int*,double*,int*,double*,int*,size_t,size_t,size_t); */
static PyObject *f2py_rout_linalg_utils_dtrsv(const PyObject *capi_self,
                           PyObject *capi_args,
                           PyObject *capi_keywds,
                           void (*f2py_func)(string,string,string,int*,double*,int*,double*,int*,size_t,size_t,size_t)) {
  PyObject * volatile capi_buildvalue = NULL;
  volatile int f2py_success = 1;
/*decl*/

  string uplo = NULL;
  int slen(uplo);
  PyObject *uplo_capi = Py_None;
  string trans = NULL;
  int slen(trans);
  PyObject *trans_capi = Py_None;
  string diag = NULL;
  int slen(diag);
  PyObject *diag_capi = Py_None;
  int n = 0;
  PyObject *n_capi = Py_None;
  double *a = NULL;
  npy_intp a_Dims[2] = {-1, -1};
  const int a_Rank = 2;
  PyArrayObject *capi_a_tmp = NULL;
  int capi_a_intent = 0;
  PyObject *a_capi = Py_None;
  int lda = 0;
  PyObject *lda_capi = Py_None;
  double *x = NULL;
  npy_intp x_Dims[1] = {-1};
  const int x_Rank = 1;
  PyArrayObject *capi_x_tmp = NULL;
  int capi_x_intent = 0;
  PyObject *x_capi = Py_None;
  int incx = 0;
  PyObject *incx_capi = Py_None;
  static char *capi_kwlist[] = {"uplo","trans","diag","n","a","x","incx","lda",NULL};

/*routdebugenter*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_clock();
#endif
  if (!PyArg_ParseTupleAndKeywords(capi_args,capi_keywds,\
    "OOOOOOO|O:linalg_utils.dtrsv",\
    capi_kwlist,&uplo_capi,&trans_capi,&diag_capi,&n_capi,&a_capi,&x_capi,&incx_capi,&lda_capi))
    return NULL;
/*frompyobj*/
  /* Processing variable uplo */
  slen(uplo) = 1;
  f2py_success = string_from_pyobj(&uplo,&slen(uplo),"",uplo_capi,"string_from_pyobj failed in converting 1st argument `uplo' of linalg_utils.dtrsv to C string");
  if (f2py_success) {
  /* Processing variable a */
  ;
  capi_a_intent |= F2PY_INTENT_IN;
  capi_a_tmp = array_from_pyobj(NPY_DOUBLE,a_Dims,a_Rank,capi_a_intent,a_capi);
  if (capi_a_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 5th argument `a' of linalg_utils.dtrsv to C/Fortran array" );
  } else {
    a = (double *)(capi_a_tmp->data);

  /* Processing variable trans */
  slen(trans) = 1;
  f2py_success = string_from_pyobj(&trans,&slen(trans),"",trans_capi,"string_from_pyobj failed in converting 2nd argument `trans' of linalg_utils.dtrsv to C string");
  if (f2py_success) {
  /* Processing variable diag */
  slen(diag) = 1;
  f2py_success = string_from_pyobj(&diag,&slen(diag),"",diag_capi,"string_from_pyobj failed in converting 3rd argument `diag' of linalg_utils.dtrsv to C string");
  if (f2py_success) {
  /* Processing variable n */
    f2py_success = int_from_pyobj(&n,n_capi,"linalg_utils.dtrsv() 4th argument (n) can't be converted to int");
  if (f2py_success) {
  /* Processing variable incx */
    f2py_success = int_from_pyobj(&incx,incx_capi,"linalg_utils.dtrsv() 7th argument (incx) can't be converted to int");
  if (f2py_success) {
  /* Processing variable x */
  ;
  capi_x_intent |= F2PY_INTENT_IN;
  capi_x_tmp = array_from_pyobj(NPY_DOUBLE,x_Dims,x_Rank,capi_x_intent,x_capi);
  if (capi_x_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 6th argument `x' of linalg_utils.dtrsv to C/Fortran array" );
  } else {
    x = (double *)(capi_x_tmp->data);

  /* Processing variable lda */
  if (lda_capi == Py_None) lda = shape(a,0); else
    f2py_success = int_from_pyobj(&lda,lda_capi,"linalg_utils.dtrsv() 1st keyword (lda) can't be converted to int");
  if (f2py_success) {
  CHECKSCALAR(shape(a,0)==lda,"shape(a,0)==lda","1st keyword lda","dtrsv:lda=%d",lda) {
/*end of frompyobj*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_call_clock();
#endif
/*callfortranroutine*/
        (*f2py_func)(uplo,trans,diag,&n,a,&lda,x,&incx,slen(uplo),slen(trans),slen(diag));
if (PyErr_Occurred())
  f2py_success = 0;
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_call_clock();
#endif
/*end of callfortranroutine*/
    if (f2py_success) {
/*pyobjfrom*/
/*end of pyobjfrom*/
    CFUNCSMESS("Building return value.\n");
    capi_buildvalue = Py_BuildValue("");
/*closepyobjfrom*/
/*end of closepyobjfrom*/
    } /*if (f2py_success) after callfortranroutine*/
/*cleanupfrompyobj*/
  } /*CHECKSCALAR(shape(a,0)==lda)*/
  } /*if (f2py_success) of lda*/
  /* End of cleaning variable lda */
  if((PyObject *)capi_x_tmp!=x_capi) {
    Py_XDECREF(capi_x_tmp); }
  }  /*if (capi_x_tmp == NULL) ... else of x*/
  /* End of cleaning variable x */
  } /*if (f2py_success) of incx*/
  /* End of cleaning variable incx */
  } /*if (f2py_success) of n*/
  /* End of cleaning variable n */
    STRINGFREE(diag);
  }  /*if (f2py_success) of diag*/
  /* End of cleaning variable diag */
    STRINGFREE(trans);
  }  /*if (f2py_success) of trans*/
  /* End of cleaning variable trans */
  if((PyObject *)capi_a_tmp!=a_capi) {
    Py_XDECREF(capi_a_tmp); }
  }  /*if (capi_a_tmp == NULL) ... else of a*/
  /* End of cleaning variable a */
    STRINGFREE(uplo);
  }  /*if (f2py_success) of uplo*/
  /* End of cleaning variable uplo */
/*end of cleanupfrompyobj*/
  if (capi_buildvalue == NULL) {
/*routdebugfailure*/
  } else {
/*routdebugleave*/
  }
  CFUNCSMESS("Freeing memory.\n");
/*freemem*/
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_clock();
#endif
  return capi_buildvalue;
}
/******************************** end of dtrsv ********************************/

/*********************************** dtrsm ***********************************/
static char doc_f2py_rout_linalg_utils_dtrsm[] = "\
dtrsm(side,uplo,transa,diag,m,n,alpha,a,b,[lda,ldb])\n\nWrapper for ``dtrsm``.\
\n\nParameters\n----------\n"
"side : input string(len=1)\n"
"uplo : input string(len=1)\n"
"transa : input string(len=1)\n"
"diag : input string(len=1)\n"
"m : input int\n"
"n : input int\n"
"alpha : input float\n"
"a : input rank-2 array('d') with bounds (lda,*)\n"
"b : input rank-2 array('d') with bounds (ldb,*)\n"
"\nOther Parameters\n----------------\n"
"lda : input int, optional\n    Default: shape(a,0)\n"
"ldb : input int, optional\n    Default: shape(b,0)";
/* extern void F_FUNC(dtrsm,DTRSM)(string,string,string,string,int*,int*,double*,double*,int*,double*,int*,size_t,size_t,size_t,size_t); */
static PyObject *f2py_rout_linalg_utils_dtrsm(const PyObject *capi_self,
                           PyObject *capi_args,
                           PyObject *capi_keywds,
                           void (*f2py_func)(string,string,string,string,int*,int*,double*,double*,int*,double*,int*,size_t,size_t,size_t,size_t)) {
  PyObject * volatile capi_buildvalue = NULL;
  volatile int f2py_success = 1;
/*decl*/

  string side = NULL;
  int slen(side);
  PyObject *side_capi = Py_None;
  string uplo = NULL;
  int slen(uplo);
  PyObject *uplo_capi = Py_None;
  string transa = NULL;
  int slen(transa);
  PyObject *transa_capi = Py_None;
  string diag = NULL;
  int slen(diag);
  PyObject *diag_capi = Py_None;
  int m = 0;
  PyObject *m_capi = Py_None;
  int n = 0;
  PyObject *n_capi = Py_None;
  double alpha = 0;
  PyObject *alpha_capi = Py_None;
  double *a = NULL;
  npy_intp a_Dims[2] = {-1, -1};
  const int a_Rank = 2;
  PyArrayObject *capi_a_tmp = NULL;
  int capi_a_intent = 0;
  PyObject *a_capi = Py_None;
  int lda = 0;
  PyObject *lda_capi = Py_None;
  double *b = NULL;
  npy_intp b_Dims[2] = {-1, -1};
  const int b_Rank = 2;
  PyArrayObject *capi_b_tmp = NULL;
  int capi_b_intent = 0;
  PyObject *b_capi = Py_None;
  int ldb = 0;
  PyObject *ldb_capi = Py_None;
  static char *capi_kwlist[] = {"side","uplo","transa","diag","m","n","alpha","a","b","lda","ldb",NULL};

/*routdebugenter*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_clock();
#endif
  if (!PyArg_ParseTupleAndKeywords(capi_args,capi_keywds,\
    "OOOOOOOOO|OO:linalg_utils.dtrsm",\
    capi_kwlist,&side_capi,&uplo_capi,&transa_capi,&diag_capi,&m_capi,&n_capi,&alpha_capi,&a_capi,&b_capi,&lda_capi,&ldb_capi))
    return NULL;
/*frompyobj*/
  /* Processing variable uplo */
  slen(uplo) = 1;
  f2py_success = string_from_pyobj(&uplo,&slen(uplo),"",uplo_capi,"string_from_pyobj failed in converting 2nd argument `uplo' of linalg_utils.dtrsm to C string");
  if (f2py_success) {
  /* Processing variable a */
  ;
  capi_a_intent |= F2PY_INTENT_IN;
  capi_a_tmp = array_from_pyobj(NPY_DOUBLE,a_Dims,a_Rank,capi_a_intent,a_capi);
  if (capi_a_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 8th argument `a' of linalg_utils.dtrsm to C/Fortran array" );
  } else {
    a = (double *)(capi_a_tmp->data);

  /* Processing variable alpha */
    f2py_success = double_from_pyobj(&alpha,alpha_capi,"linalg_utils.dtrsm() 7th argument (alpha) can't be converted to double");
  if (f2py_success) {
  /* Processing variable transa */
  slen(transa) = 1;
  f2py_success = string_from_pyobj(&transa,&slen(transa),"",transa_capi,"string_from_pyobj failed in converting 3rd argument `transa' of linalg_utils.dtrsm to C string");
  if (f2py_success) {
  /* Processing variable b */
  ;
  capi_b_intent |= F2PY_INTENT_IN;
  capi_b_tmp = array_from_pyobj(NPY_DOUBLE,b_Dims,b_Rank,capi_b_intent,b_capi);
  if (capi_b_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 9th argument `b' of linalg_utils.dtrsm to C/Fortran array" );
  } else {
    b = (double *)(capi_b_tmp->data);

  /* Processing variable diag */
  slen(diag) = 1;
  f2py_success = string_from_pyobj(&diag,&slen(diag),"",diag_capi,"string_from_pyobj failed in converting 4th argument `diag' of linalg_utils.dtrsm to C string");
  if (f2py_success) {
  /* Processing variable m */
    f2py_success = int_from_pyobj(&m,m_capi,"linalg_utils.dtrsm() 5th argument (m) can't be converted to int");
  if (f2py_success) {
  /* Processing variable n */
    f2py_success = int_from_pyobj(&n,n_capi,"linalg_utils.dtrsm() 6th argument (n) can't be converted to int");
  if (f2py_success) {
  /* Processing variable side */
  slen(side) = 1;
  f2py_success = string_from_pyobj(&side,&slen(side),"",side_capi,"string_from_pyobj failed in converting 1st argument `side' of linalg_utils.dtrsm to C string");
  if (f2py_success) {
  /* Processing variable ldb */
  if (ldb_capi == Py_None) ldb = shape(b,0); else
    f2py_success = int_from_pyobj(&ldb,ldb_capi,"linalg_utils.dtrsm() 2nd keyword (ldb) can't be converted to int");
  if (f2py_success) {
  CHECKSCALAR(shape(b,0)==ldb,"shape(b,0)==ldb","2nd keyword ldb","dtrsm:ldb=%d",ldb) {
  /* Processing variable lda */
  if (lda_capi == Py_None) lda = shape(a,0); else
    f2py_success = int_from_pyobj(&lda,lda_capi,"linalg_utils.dtrsm() 1st keyword (lda) can't be converted to int");
  if (f2py_success) {
  CHECKSCALAR(shape(a,0)==lda,"shape(a,0)==lda","1st keyword lda","dtrsm:lda=%d",lda) {
/*end of frompyobj*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_call_clock();
#endif
/*callfortranroutine*/
        (*f2py_func)(side,uplo,transa,diag,&m,&n,&alpha,a,&lda,b,&ldb,slen(side),slen(uplo),slen(transa),slen(diag));
if (PyErr_Occurred())
  f2py_success = 0;
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_call_clock();
#endif
/*end of callfortranroutine*/
    if (f2py_success) {
/*pyobjfrom*/
/*end of pyobjfrom*/
    CFUNCSMESS("Building return value.\n");
    capi_buildvalue = Py_BuildValue("");
/*closepyobjfrom*/
/*end of closepyobjfrom*/
    } /*if (f2py_success) after callfortranroutine*/
/*cleanupfrompyobj*/
  } /*CHECKSCALAR(shape(a,0)==lda)*/
  } /*if (f2py_success) of lda*/
  /* End of cleaning variable lda */
  } /*CHECKSCALAR(shape(b,0)==ldb)*/
  } /*if (f2py_success) of ldb*/
  /* End of cleaning variable ldb */
    STRINGFREE(side);
  }  /*if (f2py_success) of side*/
  /* End of cleaning variable side */
  } /*if (f2py_success) of n*/
  /* End of cleaning variable n */
  } /*if (f2py_success) of m*/
  /* End of cleaning variable m */
    STRINGFREE(diag);
  }  /*if (f2py_success) of diag*/
  /* End of cleaning variable diag */
  if((PyObject *)capi_b_tmp!=b_capi) {
    Py_XDECREF(capi_b_tmp); }
  }  /*if (capi_b_tmp == NULL) ... else of b*/
  /* End of cleaning variable b */
    STRINGFREE(transa);
  }  /*if (f2py_success) of transa*/
  /* End of cleaning variable transa */
  } /*if (f2py_success) of alpha*/
  /* End of cleaning variable alpha */
  if((PyObject *)capi_a_tmp!=a_capi) {
    Py_XDECREF(capi_a_tmp); }
  }  /*if (capi_a_tmp == NULL) ... else of a*/
  /* End of cleaning variable a */
    STRINGFREE(uplo);
  }  /*if (f2py_success) of uplo*/
  /* End of cleaning variable uplo */
/*end of cleanupfrompyobj*/
  if (capi_buildvalue == NULL) {
/*routdebugfailure*/
  } else {
/*routdebugleave*/
  }
  CFUNCSMESS("Freeing memory.\n");
/*freemem*/
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_clock();
#endif
  return capi_buildvalue;
}
/******************************** end of dtrsm ********************************/

/*********************************** dtrmv ***********************************/
static char doc_f2py_rout_linalg_utils_dtrmv[] = "\
dtrmv(uplo,trans,diag,n,a,x,incx,[lda])\n\nWrapper for ``dtrmv``.\
\n\nParameters\n----------\n"
"uplo : input string(len=1)\n"
"trans : input string(len=1)\n"
"diag : input string(len=1)\n"
"n : input int\n"
"a : input rank-2 array('d') with bounds (lda,*)\n"
"x : input rank-1 array('d') with bounds (*)\n"
"incx : input int\n"
"\nOther Parameters\n----------------\n"
"lda : input int, optional\n    Default: shape(a,0)";
/* extern void F_FUNC(dtrmv,DTRMV)(string,string,string,int*,double*,int*,double*,int*,size_t,size_t,size_t); */
static PyObject *f2py_rout_linalg_utils_dtrmv(const PyObject *capi_self,
                           PyObject *capi_args,
                           PyObject *capi_keywds,
                           void (*f2py_func)(string,string,string,int*,double*,int*,double*,int*,size_t,size_t,size_t)) {
  PyObject * volatile capi_buildvalue = NULL;
  volatile int f2py_success = 1;
/*decl*/

  string uplo = NULL;
  int slen(uplo);
  PyObject *uplo_capi = Py_None;
  string trans = NULL;
  int slen(trans);
  PyObject *trans_capi = Py_None;
  string diag = NULL;
  int slen(diag);
  PyObject *diag_capi = Py_None;
  int n = 0;
  PyObject *n_capi = Py_None;
  double *a = NULL;
  npy_intp a_Dims[2] = {-1, -1};
  const int a_Rank = 2;
  PyArrayObject *capi_a_tmp = NULL;
  int capi_a_intent = 0;
  PyObject *a_capi = Py_None;
  int lda = 0;
  PyObject *lda_capi = Py_None;
  double *x = NULL;
  npy_intp x_Dims[1] = {-1};
  const int x_Rank = 1;
  PyArrayObject *capi_x_tmp = NULL;
  int capi_x_intent = 0;
  PyObject *x_capi = Py_None;
  int incx = 0;
  PyObject *incx_capi = Py_None;
  static char *capi_kwlist[] = {"uplo","trans","diag","n","a","x","incx","lda",NULL};

/*routdebugenter*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_clock();
#endif
  if (!PyArg_ParseTupleAndKeywords(capi_args,capi_keywds,\
    "OOOOOOO|O:linalg_utils.dtrmv",\
    capi_kwlist,&uplo_capi,&trans_capi,&diag_capi,&n_capi,&a_capi,&x_capi,&incx_capi,&lda_capi))
    return NULL;
/*frompyobj*/
  /* Processing variable uplo */
  slen(uplo) = 1;
  f2py_success = string_from_pyobj(&uplo,&slen(uplo),"",uplo_capi,"string_from_pyobj failed in converting 1st argument `uplo' of linalg_utils.dtrmv to C string");
  if (f2py_success) {
  /* Processing variable a */
  ;
  capi_a_intent |= F2PY_INTENT_IN;
  capi_a_tmp = array_from_pyobj(NPY_DOUBLE,a_Dims,a_Rank,capi_a_intent,a_capi);
  if (capi_a_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 5th argument `a' of linalg_utils.dtrmv to C/Fortran array" );
  } else {
    a = (double *)(capi_a_tmp->data);

  /* Processing variable trans */
  slen(trans) = 1;
  f2py_success = string_from_pyobj(&trans,&slen(trans),"",trans_capi,"string_from_pyobj failed in converting 2nd argument `trans' of linalg_utils.dtrmv to C string");
  if (f2py_success) {
  /* Processing variable diag */
  slen(diag) = 1;
  f2py_success = string_from_pyobj(&diag,&slen(diag),"",diag_capi,"string_from_pyobj failed in converting 3rd argument `diag' of linalg_utils.dtrmv to C string");
  if (f2py_success) {
  /* Processing variable n */
    f2py_success = int_from_pyobj(&n,n_capi,"linalg_utils.dtrmv() 4th argument (n) can't be converted to int");
  if (f2py_success) {
  /* Processing variable incx */
    f2py_success = int_from_pyobj(&incx,incx_capi,"linalg_utils.dtrmv() 7th argument (incx) can't be converted to int");
  if (f2py_success) {
  /* Processing variable x */
  ;
  capi_x_intent |= F2PY_INTENT_IN;
  capi_x_tmp = array_from_pyobj(NPY_DOUBLE,x_Dims,x_Rank,capi_x_intent,x_capi);
  if (capi_x_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 6th argument `x' of linalg_utils.dtrmv to C/Fortran array" );
  } else {
    x = (double *)(capi_x_tmp->data);

  /* Processing variable lda */
  if (lda_capi == Py_None) lda = shape(a,0); else
    f2py_success = int_from_pyobj(&lda,lda_capi,"linalg_utils.dtrmv() 1st keyword (lda) can't be converted to int");
  if (f2py_success) {
  CHECKSCALAR(shape(a,0)==lda,"shape(a,0)==lda","1st keyword lda","dtrmv:lda=%d",lda) {
/*end of frompyobj*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_call_clock();
#endif
/*callfortranroutine*/
        (*f2py_func)(uplo,trans,diag,&n,a,&lda,x,&incx,slen(uplo),slen(trans),slen(diag));
if (PyErr_Occurred())
  f2py_success = 0;
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_call_clock();
#endif
/*end of callfortranroutine*/
    if (f2py_success) {
/*pyobjfrom*/
/*end of pyobjfrom*/
    CFUNCSMESS("Building return value.\n");
    capi_buildvalue = Py_BuildValue("");
/*closepyobjfrom*/
/*end of closepyobjfrom*/
    } /*if (f2py_success) after callfortranroutine*/
/*cleanupfrompyobj*/
  } /*CHECKSCALAR(shape(a,0)==lda)*/
  } /*if (f2py_success) of lda*/
  /* End of cleaning variable lda */
  if((PyObject *)capi_x_tmp!=x_capi) {
    Py_XDECREF(capi_x_tmp); }
  }  /*if (capi_x_tmp == NULL) ... else of x*/
  /* End of cleaning variable x */
  } /*if (f2py_success) of incx*/
  /* End of cleaning variable incx */
  } /*if (f2py_success) of n*/
  /* End of cleaning variable n */
    STRINGFREE(diag);
  }  /*if (f2py_success) of diag*/
  /* End of cleaning variable diag */
    STRINGFREE(trans);
  }  /*if (f2py_success) of trans*/
  /* End of cleaning variable trans */
  if((PyObject *)capi_a_tmp!=a_capi) {
    Py_XDECREF(capi_a_tmp); }
  }  /*if (capi_a_tmp == NULL) ... else of a*/
  /* End of cleaning variable a */
    STRINGFREE(uplo);
  }  /*if (f2py_success) of uplo*/
  /* End of cleaning variable uplo */
/*end of cleanupfrompyobj*/
  if (capi_buildvalue == NULL) {
/*routdebugfailure*/
  } else {
/*routdebugleave*/
  }
  CFUNCSMESS("Freeing memory.\n");
/*freemem*/
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_clock();
#endif
  return capi_buildvalue;
}
/******************************** end of dtrmv ********************************/

/*********************************** dtrmm ***********************************/
static char doc_f2py_rout_linalg_utils_dtrmm[] = "\
dtrmm(side,uplo,transa,diag,m,n,alpha,a,b,[lda,ldb])\n\nWrapper for ``dtrmm``.\
\n\nParameters\n----------\n"
"side : input string(len=1)\n"
"uplo : input string(len=1)\n"
"transa : input string(len=1)\n"
"diag : input string(len=1)\n"
"m : input int\n"
"n : input int\n"
"alpha : input float\n"
"a : input rank-2 array('d') with bounds (lda,*)\n"
"b : input rank-2 array('d') with bounds (ldb,*)\n"
"\nOther Parameters\n----------------\n"
"lda : input int, optional\n    Default: shape(a,0)\n"
"ldb : input int, optional\n    Default: shape(b,0)";
/* extern void F_FUNC(dtrmm,DTRMM)(string,string,string,string,int*,int*,double*,double*,int*,double*,int*,size_t,size_t,size_t,size_t); */
static PyObject *f2py_rout_linalg_utils_dtrmm(const PyObject *capi_self,
                           PyObject *capi_args,
                           PyObject *capi_keywds,
                           void (*f2py_func)(string,string,string,string,int*,int*,double*,double*,int*,double*,int*,size_t,size_t,size_t,size_t)) {
  PyObject * volatile capi_buildvalue = NULL;
  volatile int f2py_success = 1;
/*decl*/

  string side = NULL;
  int slen(side);
  PyObject *side_capi = Py_None;
  string uplo = NULL;
  int slen(uplo);
  PyObject *uplo_capi = Py_None;
  string transa = NULL;
  int slen(transa);
  PyObject *transa_capi = Py_None;
  string diag = NULL;
  int slen(diag);
  PyObject *diag_capi = Py_None;
  int m = 0;
  PyObject *m_capi = Py_None;
  int n = 0;
  PyObject *n_capi = Py_None;
  double alpha = 0;
  PyObject *alpha_capi = Py_None;
  double *a = NULL;
  npy_intp a_Dims[2] = {-1, -1};
  const int a_Rank = 2;
  PyArrayObject *capi_a_tmp = NULL;
  int capi_a_intent = 0;
  PyObject *a_capi = Py_None;
  int lda = 0;
  PyObject *lda_capi = Py_None;
  double *b = NULL;
  npy_intp b_Dims[2] = {-1, -1};
  const int b_Rank = 2;
  PyArrayObject *capi_b_tmp = NULL;
  int capi_b_intent = 0;
  PyObject *b_capi = Py_None;
  int ldb = 0;
  PyObject *ldb_capi = Py_None;
  static char *capi_kwlist[] = {"side","uplo","transa","diag","m","n","alpha","a","b","lda","ldb",NULL};

/*routdebugenter*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_clock();
#endif
  if (!PyArg_ParseTupleAndKeywords(capi_args,capi_keywds,\
    "OOOOOOOOO|OO:linalg_utils.dtrmm",\
    capi_kwlist,&side_capi,&uplo_capi,&transa_capi,&diag_capi,&m_capi,&n_capi,&alpha_capi,&a_capi,&b_capi,&lda_capi,&ldb_capi))
    return NULL;
/*frompyobj*/
  /* Processing variable uplo */
  slen(uplo) = 1;
  f2py_success = string_from_pyobj(&uplo,&slen(uplo),"",uplo_capi,"string_from_pyobj failed in converting 2nd argument `uplo' of linalg_utils.dtrmm to C string");
  if (f2py_success) {
  /* Processing variable a */
  ;
  capi_a_intent |= F2PY_INTENT_IN;
  capi_a_tmp = array_from_pyobj(NPY_DOUBLE,a_Dims,a_Rank,capi_a_intent,a_capi);
  if (capi_a_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 8th argument `a' of linalg_utils.dtrmm to C/Fortran array" );
  } else {
    a = (double *)(capi_a_tmp->data);

  /* Processing variable alpha */
    f2py_success = double_from_pyobj(&alpha,alpha_capi,"linalg_utils.dtrmm() 7th argument (alpha) can't be converted to double");
  if (f2py_success) {
  /* Processing variable transa */
  slen(transa) = 1;
  f2py_success = string_from_pyobj(&transa,&slen(transa),"",transa_capi,"string_from_pyobj failed in converting 3rd argument `transa' of linalg_utils.dtrmm to C string");
  if (f2py_success) {
  /* Processing variable b */
  ;
  capi_b_intent |= F2PY_INTENT_IN;
  capi_b_tmp = array_from_pyobj(NPY_DOUBLE,b_Dims,b_Rank,capi_b_intent,b_capi);
  if (capi_b_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 9th argument `b' of linalg_utils.dtrmm to C/Fortran array" );
  } else {
    b = (double *)(capi_b_tmp->data);

  /* Processing variable diag */
  slen(diag) = 1;
  f2py_success = string_from_pyobj(&diag,&slen(diag),"",diag_capi,"string_from_pyobj failed in converting 4th argument `diag' of linalg_utils.dtrmm to C string");
  if (f2py_success) {
  /* Processing variable m */
    f2py_success = int_from_pyobj(&m,m_capi,"linalg_utils.dtrmm() 5th argument (m) can't be converted to int");
  if (f2py_success) {
  /* Processing variable n */
    f2py_success = int_from_pyobj(&n,n_capi,"linalg_utils.dtrmm() 6th argument (n) can't be converted to int");
  if (f2py_success) {
  /* Processing variable side */
  slen(side) = 1;
  f2py_success = string_from_pyobj(&side,&slen(side),"",side_capi,"string_from_pyobj failed in converting 1st argument `side' of linalg_utils.dtrmm to C string");
  if (f2py_success) {
  /* Processing variable ldb */
  if (ldb_capi == Py_None) ldb = shape(b,0); else
    f2py_success = int_from_pyobj(&ldb,ldb_capi,"linalg_utils.dtrmm() 2nd keyword (ldb) can't be converted to int");
  if (f2py_success) {
  CHECKSCALAR(shape(b,0)==ldb,"shape(b,0)==ldb","2nd keyword ldb","dtrmm:ldb=%d",ldb) {
  /* Processing variable lda */
  if (lda_capi == Py_None) lda = shape(a,0); else
    f2py_success = int_from_pyobj(&lda,lda_capi,"linalg_utils.dtrmm() 1st keyword (lda) can't be converted to int");
  if (f2py_success) {
  CHECKSCALAR(shape(a,0)==lda,"shape(a,0)==lda","1st keyword lda","dtrmm:lda=%d",lda) {
/*end of frompyobj*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_call_clock();
#endif
/*callfortranroutine*/
        (*f2py_func)(side,uplo,transa,diag,&m,&n,&alpha,a,&lda,b,&ldb,slen(side),slen(uplo),slen(transa),slen(diag));
if (PyErr_Occurred())
  f2py_success = 0;
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_call_clock();
#endif
/*end of callfortranroutine*/
    if (f2py_success) {
/*pyobjfrom*/
/*end of pyobjfrom*/
    CFUNCSMESS("Building return value.\n");
    capi_buildvalue = Py_BuildValue("");
/*closepyobjfrom*/
/*end of closepyobjfrom*/
    } /*if (f2py_success) after callfortranroutine*/
/*cleanupfrompyobj*/
  } /*CHECKSCALAR(shape(a,0)==lda)*/
  } /*if (f2py_success) of lda*/
  /* End of cleaning variable lda */
  } /*CHECKSCALAR(shape(b,0)==ldb)*/
  } /*if (f2py_success) of ldb*/
  /* End of cleaning variable ldb */
    STRINGFREE(side);
  }  /*if (f2py_success) of side*/
  /* End of cleaning variable side */
  } /*if (f2py_success) of n*/
  /* End of cleaning variable n */
  } /*if (f2py_success) of m*/
  /* End of cleaning variable m */
    STRINGFREE(diag);
  }  /*if (f2py_success) of diag*/
  /* End of cleaning variable diag */
  if((PyObject *)capi_b_tmp!=b_capi) {
    Py_XDECREF(capi_b_tmp); }
  }  /*if (capi_b_tmp == NULL) ... else of b*/
  /* End of cleaning variable b */
    STRINGFREE(transa);
  }  /*if (f2py_success) of transa*/
  /* End of cleaning variable transa */
  } /*if (f2py_success) of alpha*/
  /* End of cleaning variable alpha */
  if((PyObject *)capi_a_tmp!=a_capi) {
    Py_XDECREF(capi_a_tmp); }
  }  /*if (capi_a_tmp == NULL) ... else of a*/
  /* End of cleaning variable a */
    STRINGFREE(uplo);
  }  /*if (f2py_success) of uplo*/
  /* End of cleaning variable uplo */
/*end of cleanupfrompyobj*/
  if (capi_buildvalue == NULL) {
/*routdebugfailure*/
  } else {
/*routdebugleave*/
  }
  CFUNCSMESS("Freeing memory.\n");
/*freemem*/
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_clock();
#endif
  return capi_buildvalue;
}
/******************************** end of dtrmm ********************************/

/*********************************** dtpsv ***********************************/
static char doc_f2py_rout_linalg_utils_dtpsv[] = "\
dtpsv(uplo,trans,diag,n,ap,x,incx)\n\nWrapper for ``dtpsv``.\
\n\nParameters\n----------\n"
"uplo : input string(len=1)\n"
"trans : input string(len=1)\n"
"diag : input string(len=1)\n"
"n : input int\n"
"ap : input rank-1 array('d') with bounds (*)\n"
"x : input rank-1 array('d') with bounds (*)\n"
"incx : input int";
/* extern void F_FUNC(dtpsv,DTPSV)(string,string,string,int*,double*,double*,int*,size_t,size_t,size_t); */
static PyObject *f2py_rout_linalg_utils_dtpsv(const PyObject *capi_self,
                           PyObject *capi_args,
                           PyObject *capi_keywds,
                           void (*f2py_func)(string,string,string,int*,double*,double*,int*,size_t,size_t,size_t)) {
  PyObject * volatile capi_buildvalue = NULL;
  volatile int f2py_success = 1;
/*decl*/

  string uplo = NULL;
  int slen(uplo);
  PyObject *uplo_capi = Py_None;
  string trans = NULL;
  int slen(trans);
  PyObject *trans_capi = Py_None;
  string diag = NULL;
  int slen(diag);
  PyObject *diag_capi = Py_None;
  int n = 0;
  PyObject *n_capi = Py_None;
  double *ap = NULL;
  npy_intp ap_Dims[1] = {-1};
  const int ap_Rank = 1;
  PyArrayObject *capi_ap_tmp = NULL;
  int capi_ap_intent = 0;
  PyObject *ap_capi = Py_None;
  double *x = NULL;
  npy_intp x_Dims[1] = {-1};
  const int x_Rank = 1;
  PyArrayObject *capi_x_tmp = NULL;
  int capi_x_intent = 0;
  PyObject *x_capi = Py_None;
  int incx = 0;
  PyObject *incx_capi = Py_None;
  static char *capi_kwlist[] = {"uplo","trans","diag","n","ap","x","incx",NULL};

/*routdebugenter*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_clock();
#endif
  if (!PyArg_ParseTupleAndKeywords(capi_args,capi_keywds,\
    "OOOOOOO:linalg_utils.dtpsv",\
    capi_kwlist,&uplo_capi,&trans_capi,&diag_capi,&n_capi,&ap_capi,&x_capi,&incx_capi))
    return NULL;
/*frompyobj*/
  /* Processing variable uplo */
  slen(uplo) = 1;
  f2py_success = string_from_pyobj(&uplo,&slen(uplo),"",uplo_capi,"string_from_pyobj failed in converting 1st argument `uplo' of linalg_utils.dtpsv to C string");
  if (f2py_success) {
  /* Processing variable ap */
  ;
  capi_ap_intent |= F2PY_INTENT_IN;
  capi_ap_tmp = array_from_pyobj(NPY_DOUBLE,ap_Dims,ap_Rank,capi_ap_intent,ap_capi);
  if (capi_ap_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 5th argument `ap' of linalg_utils.dtpsv to C/Fortran array" );
  } else {
    ap = (double *)(capi_ap_tmp->data);

  /* Processing variable trans */
  slen(trans) = 1;
  f2py_success = string_from_pyobj(&trans,&slen(trans),"",trans_capi,"string_from_pyobj failed in converting 2nd argument `trans' of linalg_utils.dtpsv to C string");
  if (f2py_success) {
  /* Processing variable diag */
  slen(diag) = 1;
  f2py_success = string_from_pyobj(&diag,&slen(diag),"",diag_capi,"string_from_pyobj failed in converting 3rd argument `diag' of linalg_utils.dtpsv to C string");
  if (f2py_success) {
  /* Processing variable n */
    f2py_success = int_from_pyobj(&n,n_capi,"linalg_utils.dtpsv() 4th argument (n) can't be converted to int");
  if (f2py_success) {
  /* Processing variable incx */
    f2py_success = int_from_pyobj(&incx,incx_capi,"linalg_utils.dtpsv() 7th argument (incx) can't be converted to int");
  if (f2py_success) {
  /* Processing variable x */
  ;
  capi_x_intent |= F2PY_INTENT_IN;
  capi_x_tmp = array_from_pyobj(NPY_DOUBLE,x_Dims,x_Rank,capi_x_intent,x_capi);
  if (capi_x_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 6th argument `x' of linalg_utils.dtpsv to C/Fortran array" );
  } else {
    x = (double *)(capi_x_tmp->data);

/*end of frompyobj*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_call_clock();
#endif
/*callfortranroutine*/
        (*f2py_func)(uplo,trans,diag,&n,ap,x,&incx,slen(uplo),slen(trans),slen(diag));
if (PyErr_Occurred())
  f2py_success = 0;
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_call_clock();
#endif
/*end of callfortranroutine*/
    if (f2py_success) {
/*pyobjfrom*/
/*end of pyobjfrom*/
    CFUNCSMESS("Building return value.\n");
    capi_buildvalue = Py_BuildValue("");
/*closepyobjfrom*/
/*end of closepyobjfrom*/
    } /*if (f2py_success) after callfortranroutine*/
/*cleanupfrompyobj*/
  if((PyObject *)capi_x_tmp!=x_capi) {
    Py_XDECREF(capi_x_tmp); }
  }  /*if (capi_x_tmp == NULL) ... else of x*/
  /* End of cleaning variable x */
  } /*if (f2py_success) of incx*/
  /* End of cleaning variable incx */
  } /*if (f2py_success) of n*/
  /* End of cleaning variable n */
    STRINGFREE(diag);
  }  /*if (f2py_success) of diag*/
  /* End of cleaning variable diag */
    STRINGFREE(trans);
  }  /*if (f2py_success) of trans*/
  /* End of cleaning variable trans */
  if((PyObject *)capi_ap_tmp!=ap_capi) {
    Py_XDECREF(capi_ap_tmp); }
  }  /*if (capi_ap_tmp == NULL) ... else of ap*/
  /* End of cleaning variable ap */
    STRINGFREE(uplo);
  }  /*if (f2py_success) of uplo*/
  /* End of cleaning variable uplo */
/*end of cleanupfrompyobj*/
  if (capi_buildvalue == NULL) {
/*routdebugfailure*/
  } else {
/*routdebugleave*/
  }
  CFUNCSMESS("Freeing memory.\n");
/*freemem*/
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_clock();
#endif
  return capi_buildvalue;
}
/******************************** end of dtpsv ********************************/

/*********************************** dtpmv ***********************************/
static char doc_f2py_rout_linalg_utils_dtpmv[] = "\
dtpmv(uplo,trans,diag,n,ap,x,incx)\n\nWrapper for ``dtpmv``.\
\n\nParameters\n----------\n"
"uplo : input string(len=1)\n"
"trans : input string(len=1)\n"
"diag : input string(len=1)\n"
"n : input int\n"
"ap : input rank-1 array('d') with bounds (*)\n"
"x : input rank-1 array('d') with bounds (*)\n"
"incx : input int";
/* extern void F_FUNC(dtpmv,DTPMV)(string,string,string,int*,double*,double*,int*,size_t,size_t,size_t); */
static PyObject *f2py_rout_linalg_utils_dtpmv(const PyObject *capi_self,
                           PyObject *capi_args,
                           PyObject *capi_keywds,
                           void (*f2py_func)(string,string,string,int*,double*,double*,int*,size_t,size_t,size_t)) {
  PyObject * volatile capi_buildvalue = NULL;
  volatile int f2py_success = 1;
/*decl*/

  string uplo = NULL;
  int slen(uplo);
  PyObject *uplo_capi = Py_None;
  string trans = NULL;
  int slen(trans);
  PyObject *trans_capi = Py_None;
  string diag = NULL;
  int slen(diag);
  PyObject *diag_capi = Py_None;
  int n = 0;
  PyObject *n_capi = Py_None;
  double *ap = NULL;
  npy_intp ap_Dims[1] = {-1};
  const int ap_Rank = 1;
  PyArrayObject *capi_ap_tmp = NULL;
  int capi_ap_intent = 0;
  PyObject *ap_capi = Py_None;
  double *x = NULL;
  npy_intp x_Dims[1] = {-1};
  const int x_Rank = 1;
  PyArrayObject *capi_x_tmp = NULL;
  int capi_x_intent = 0;
  PyObject *x_capi = Py_None;
  int incx = 0;
  PyObject *incx_capi = Py_None;
  static char *capi_kwlist[] = {"uplo","trans","diag","n","ap","x","incx",NULL};

/*routdebugenter*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_clock();
#endif
  if (!PyArg_ParseTupleAndKeywords(capi_args,capi_keywds,\
    "OOOOOOO:linalg_utils.dtpmv",\
    capi_kwlist,&uplo_capi,&trans_capi,&diag_capi,&n_capi,&ap_capi,&x_capi,&incx_capi))
    return NULL;
/*frompyobj*/
  /* Processing variable uplo */
  slen(uplo) = 1;
  f2py_success = string_from_pyobj(&uplo,&slen(uplo),"",uplo_capi,"string_from_pyobj failed in converting 1st argument `uplo' of linalg_utils.dtpmv to C string");
  if (f2py_success) {
  /* Processing variable ap */
  ;
  capi_ap_intent |= F2PY_INTENT_IN;
  capi_ap_tmp = array_from_pyobj(NPY_DOUBLE,ap_Dims,ap_Rank,capi_ap_intent,ap_capi);
  if (capi_ap_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 5th argument `ap' of linalg_utils.dtpmv to C/Fortran array" );
  } else {
    ap = (double *)(capi_ap_tmp->data);

  /* Processing variable trans */
  slen(trans) = 1;
  f2py_success = string_from_pyobj(&trans,&slen(trans),"",trans_capi,"string_from_pyobj failed in converting 2nd argument `trans' of linalg_utils.dtpmv to C string");
  if (f2py_success) {
  /* Processing variable diag */
  slen(diag) = 1;
  f2py_success = string_from_pyobj(&diag,&slen(diag),"",diag_capi,"string_from_pyobj failed in converting 3rd argument `diag' of linalg_utils.dtpmv to C string");
  if (f2py_success) {
  /* Processing variable n */
    f2py_success = int_from_pyobj(&n,n_capi,"linalg_utils.dtpmv() 4th argument (n) can't be converted to int");
  if (f2py_success) {
  /* Processing variable incx */
    f2py_success = int_from_pyobj(&incx,incx_capi,"linalg_utils.dtpmv() 7th argument (incx) can't be converted to int");
  if (f2py_success) {
  /* Processing variable x */
  ;
  capi_x_intent |= F2PY_INTENT_IN;
  capi_x_tmp = array_from_pyobj(NPY_DOUBLE,x_Dims,x_Rank,capi_x_intent,x_capi);
  if (capi_x_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 6th argument `x' of linalg_utils.dtpmv to C/Fortran array" );
  } else {
    x = (double *)(capi_x_tmp->data);

/*end of frompyobj*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_call_clock();
#endif
/*callfortranroutine*/
        (*f2py_func)(uplo,trans,diag,&n,ap,x,&incx,slen(uplo),slen(trans),slen(diag));
if (PyErr_Occurred())
  f2py_success = 0;
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_call_clock();
#endif
/*end of callfortranroutine*/
    if (f2py_success) {
/*pyobjfrom*/
/*end of pyobjfrom*/
    CFUNCSMESS("Building return value.\n");
    capi_buildvalue = Py_BuildValue("");
/*closepyobjfrom*/
/*end of closepyobjfrom*/
    } /*if (f2py_success) after callfortranroutine*/
/*cleanupfrompyobj*/
  if((PyObject *)capi_x_tmp!=x_capi) {
    Py_XDECREF(capi_x_tmp); }
  }  /*if (capi_x_tmp == NULL) ... else of x*/
  /* End of cleaning variable x */
  } /*if (f2py_success) of incx*/
  /* End of cleaning variable incx */
  } /*if (f2py_success) of n*/
  /* End of cleaning variable n */
    STRINGFREE(diag);
  }  /*if (f2py_success) of diag*/
  /* End of cleaning variable diag */
    STRINGFREE(trans);
  }  /*if (f2py_success) of trans*/
  /* End of cleaning variable trans */
  if((PyObject *)capi_ap_tmp!=ap_capi) {
    Py_XDECREF(capi_ap_tmp); }
  }  /*if (capi_ap_tmp == NULL) ... else of ap*/
  /* End of cleaning variable ap */
    STRINGFREE(uplo);
  }  /*if (f2py_success) of uplo*/
  /* End of cleaning variable uplo */
/*end of cleanupfrompyobj*/
  if (capi_buildvalue == NULL) {
/*routdebugfailure*/
  } else {
/*routdebugleave*/
  }
  CFUNCSMESS("Freeing memory.\n");
/*freemem*/
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_clock();
#endif
  return capi_buildvalue;
}
/******************************** end of dtpmv ********************************/

/*********************************** dtbsv ***********************************/
static char doc_f2py_rout_linalg_utils_dtbsv[] = "\
dtbsv(uplo,trans,diag,n,k,a,x,incx,[lda])\n\nWrapper for ``dtbsv``.\
\n\nParameters\n----------\n"
"uplo : input string(len=1)\n"
"trans : input string(len=1)\n"
"diag : input string(len=1)\n"
"n : input int\n"
"k : input int\n"
"a : input rank-2 array('d') with bounds (lda,*)\n"
"x : input rank-1 array('d') with bounds (*)\n"
"incx : input int\n"
"\nOther Parameters\n----------------\n"
"lda : input int, optional\n    Default: shape(a,0)";
/* extern void F_FUNC(dtbsv,DTBSV)(string,string,string,int*,int*,double*,int*,double*,int*,size_t,size_t,size_t); */
static PyObject *f2py_rout_linalg_utils_dtbsv(const PyObject *capi_self,
                           PyObject *capi_args,
                           PyObject *capi_keywds,
                           void (*f2py_func)(string,string,string,int*,int*,double*,int*,double*,int*,size_t,size_t,size_t)) {
  PyObject * volatile capi_buildvalue = NULL;
  volatile int f2py_success = 1;
/*decl*/

  string uplo = NULL;
  int slen(uplo);
  PyObject *uplo_capi = Py_None;
  string trans = NULL;
  int slen(trans);
  PyObject *trans_capi = Py_None;
  string diag = NULL;
  int slen(diag);
  PyObject *diag_capi = Py_None;
  int n = 0;
  PyObject *n_capi = Py_None;
  int k = 0;
  PyObject *k_capi = Py_None;
  double *a = NULL;
  npy_intp a_Dims[2] = {-1, -1};
  const int a_Rank = 2;
  PyArrayObject *capi_a_tmp = NULL;
  int capi_a_intent = 0;
  PyObject *a_capi = Py_None;
  int lda = 0;
  PyObject *lda_capi = Py_None;
  double *x = NULL;
  npy_intp x_Dims[1] = {-1};
  const int x_Rank = 1;
  PyArrayObject *capi_x_tmp = NULL;
  int capi_x_intent = 0;
  PyObject *x_capi = Py_None;
  int incx = 0;
  PyObject *incx_capi = Py_None;
  static char *capi_kwlist[] = {"uplo","trans","diag","n","k","a","x","incx","lda",NULL};

/*routdebugenter*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_clock();
#endif
  if (!PyArg_ParseTupleAndKeywords(capi_args,capi_keywds,\
    "OOOOOOOO|O:linalg_utils.dtbsv",\
    capi_kwlist,&uplo_capi,&trans_capi,&diag_capi,&n_capi,&k_capi,&a_capi,&x_capi,&incx_capi,&lda_capi))
    return NULL;
/*frompyobj*/
  /* Processing variable uplo */
  slen(uplo) = 1;
  f2py_success = string_from_pyobj(&uplo,&slen(uplo),"",uplo_capi,"string_from_pyobj failed in converting 1st argument `uplo' of linalg_utils.dtbsv to C string");
  if (f2py_success) {
  /* Processing variable a */
  ;
  capi_a_intent |= F2PY_INTENT_IN;
  capi_a_tmp = array_from_pyobj(NPY_DOUBLE,a_Dims,a_Rank,capi_a_intent,a_capi);
  if (capi_a_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 6th argument `a' of linalg_utils.dtbsv to C/Fortran array" );
  } else {
    a = (double *)(capi_a_tmp->data);

  /* Processing variable incx */
    f2py_success = int_from_pyobj(&incx,incx_capi,"linalg_utils.dtbsv() 8th argument (incx) can't be converted to int");
  if (f2py_success) {
  /* Processing variable diag */
  slen(diag) = 1;
  f2py_success = string_from_pyobj(&diag,&slen(diag),"",diag_capi,"string_from_pyobj failed in converting 3rd argument `diag' of linalg_utils.dtbsv to C string");
  if (f2py_success) {
  /* Processing variable k */
    f2py_success = int_from_pyobj(&k,k_capi,"linalg_utils.dtbsv() 5th argument (k) can't be converted to int");
  if (f2py_success) {
  /* Processing variable n */
    f2py_success = int_from_pyobj(&n,n_capi,"linalg_utils.dtbsv() 4th argument (n) can't be converted to int");
  if (f2py_success) {
  /* Processing variable x */
  ;
  capi_x_intent |= F2PY_INTENT_IN;
  capi_x_tmp = array_from_pyobj(NPY_DOUBLE,x_Dims,x_Rank,capi_x_intent,x_capi);
  if (capi_x_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 7th argument `x' of linalg_utils.dtbsv to C/Fortran array" );
  } else {
    x = (double *)(capi_x_tmp->data);

  /* Processing variable trans */
  slen(trans) = 1;
  f2py_success = string_from_pyobj(&trans,&slen(trans),"",trans_capi,"string_from_pyobj failed in converting 2nd argument `trans' of linalg_utils.dtbsv to C string");
  if (f2py_success) {
  /* Processing variable lda */
  if (lda_capi == Py_None) lda = shape(a,0); else
    f2py_success = int_from_pyobj(&lda,lda_capi,"linalg_utils.dtbsv() 1st keyword (lda) can't be converted to int");
  if (f2py_success) {
  CHECKSCALAR(shape(a,0)==lda,"shape(a,0)==lda","1st keyword lda","dtbsv:lda=%d",lda) {
/*end of frompyobj*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_call_clock();
#endif
/*callfortranroutine*/
        (*f2py_func)(uplo,trans,diag,&n,&k,a,&lda,x,&incx,slen(uplo),slen(trans),slen(diag));
if (PyErr_Occurred())
  f2py_success = 0;
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_call_clock();
#endif
/*end of callfortranroutine*/
    if (f2py_success) {
/*pyobjfrom*/
/*end of pyobjfrom*/
    CFUNCSMESS("Building return value.\n");
    capi_buildvalue = Py_BuildValue("");
/*closepyobjfrom*/
/*end of closepyobjfrom*/
    } /*if (f2py_success) after callfortranroutine*/
/*cleanupfrompyobj*/
  } /*CHECKSCALAR(shape(a,0)==lda)*/
  } /*if (f2py_success) of lda*/
  /* End of cleaning variable lda */
    STRINGFREE(trans);
  }  /*if (f2py_success) of trans*/
  /* End of cleaning variable trans */
  if((PyObject *)capi_x_tmp!=x_capi) {
    Py_XDECREF(capi_x_tmp); }
  }  /*if (capi_x_tmp == NULL) ... else of x*/
  /* End of cleaning variable x */
  } /*if (f2py_success) of n*/
  /* End of cleaning variable n */
  } /*if (f2py_success) of k*/
  /* End of cleaning variable k */
    STRINGFREE(diag);
  }  /*if (f2py_success) of diag*/
  /* End of cleaning variable diag */
  } /*if (f2py_success) of incx*/
  /* End of cleaning variable incx */
  if((PyObject *)capi_a_tmp!=a_capi) {
    Py_XDECREF(capi_a_tmp); }
  }  /*if (capi_a_tmp == NULL) ... else of a*/
  /* End of cleaning variable a */
    STRINGFREE(uplo);
  }  /*if (f2py_success) of uplo*/
  /* End of cleaning variable uplo */
/*end of cleanupfrompyobj*/
  if (capi_buildvalue == NULL) {
/*routdebugfailure*/
  } else {
/*routdebugleave*/
  }
  CFUNCSMESS("Freeing memory.\n");
/*freemem*/
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_clock();
#endif
  return capi_buildvalue;
}
/******************************** end of dtbsv ********************************/

/*********************************** dtbmv ***********************************/
static char doc_f2py_rout_linalg_utils_dtbmv[] = "\
dtbmv(uplo,trans,diag,n,k,a,x,incx,[lda])\n\nWrapper for ``dtbmv``.\
\n\nParameters\n----------\n"
"uplo : input string(len=1)\n"
"trans : input string(len=1)\n"
"diag : input string(len=1)\n"
"n : input int\n"
"k : input int\n"
"a : input rank-2 array('d') with bounds (lda,*)\n"
"x : input rank-1 array('d') with bounds (*)\n"
"incx : input int\n"
"\nOther Parameters\n----------------\n"
"lda : input int, optional\n    Default: shape(a,0)";
/* extern void F_FUNC(dtbmv,DTBMV)(string,string,string,int*,int*,double*,int*,double*,int*,size_t,size_t,size_t); */
static PyObject *f2py_rout_linalg_utils_dtbmv(const PyObject *capi_self,
                           PyObject *capi_args,
                           PyObject *capi_keywds,
                           void (*f2py_func)(string,string,string,int*,int*,double*,int*,double*,int*,size_t,size_t,size_t)) {
  PyObject * volatile capi_buildvalue = NULL;
  volatile int f2py_success = 1;
/*decl*/

  string uplo = NULL;
  int slen(uplo);
  PyObject *uplo_capi = Py_None;
  string trans = NULL;
  int slen(trans);
  PyObject *trans_capi = Py_None;
  string diag = NULL;
  int slen(diag);
  PyObject *diag_capi = Py_None;
  int n = 0;
  PyObject *n_capi = Py_None;
  int k = 0;
  PyObject *k_capi = Py_None;
  double *a = NULL;
  npy_intp a_Dims[2] = {-1, -1};
  const int a_Rank = 2;
  PyArrayObject *capi_a_tmp = NULL;
  int capi_a_intent = 0;
  PyObject *a_capi = Py_None;
  int lda = 0;
  PyObject *lda_capi = Py_None;
  double *x = NULL;
  npy_intp x_Dims[1] = {-1};
  const int x_Rank = 1;
  PyArrayObject *capi_x_tmp = NULL;
  int capi_x_intent = 0;
  PyObject *x_capi = Py_None;
  int incx = 0;
  PyObject *incx_capi = Py_None;
  static char *capi_kwlist[] = {"uplo","trans","diag","n","k","a","x","incx","lda",NULL};

/*routdebugenter*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_clock();
#endif
  if (!PyArg_ParseTupleAndKeywords(capi_args,capi_keywds,\
    "OOOOOOOO|O:linalg_utils.dtbmv",\
    capi_kwlist,&uplo_capi,&trans_capi,&diag_capi,&n_capi,&k_capi,&a_capi,&x_capi,&incx_capi,&lda_capi))
    return NULL;
/*frompyobj*/
  /* Processing variable uplo */
  slen(uplo) = 1;
  f2py_success = string_from_pyobj(&uplo,&slen(uplo),"",uplo_capi,"string_from_pyobj failed in converting 1st argument `uplo' of linalg_utils.dtbmv to C string");
  if (f2py_success) {
  /* Processing variable a */
  ;
  capi_a_intent |= F2PY_INTENT_IN;
  capi_a_tmp = array_from_pyobj(NPY_DOUBLE,a_Dims,a_Rank,capi_a_intent,a_capi);
  if (capi_a_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 6th argument `a' of linalg_utils.dtbmv to C/Fortran array" );
  } else {
    a = (double *)(capi_a_tmp->data);

  /* Processing variable incx */
    f2py_success = int_from_pyobj(&incx,incx_capi,"linalg_utils.dtbmv() 8th argument (incx) can't be converted to int");
  if (f2py_success) {
  /* Processing variable diag */
  slen(diag) = 1;
  f2py_success = string_from_pyobj(&diag,&slen(diag),"",diag_capi,"string_from_pyobj failed in converting 3rd argument `diag' of linalg_utils.dtbmv to C string");
  if (f2py_success) {
  /* Processing variable k */
    f2py_success = int_from_pyobj(&k,k_capi,"linalg_utils.dtbmv() 5th argument (k) can't be converted to int");
  if (f2py_success) {
  /* Processing variable n */
    f2py_success = int_from_pyobj(&n,n_capi,"linalg_utils.dtbmv() 4th argument (n) can't be converted to int");
  if (f2py_success) {
  /* Processing variable x */
  ;
  capi_x_intent |= F2PY_INTENT_IN;
  capi_x_tmp = array_from_pyobj(NPY_DOUBLE,x_Dims,x_Rank,capi_x_intent,x_capi);
  if (capi_x_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 7th argument `x' of linalg_utils.dtbmv to C/Fortran array" );
  } else {
    x = (double *)(capi_x_tmp->data);

  /* Processing variable trans */
  slen(trans) = 1;
  f2py_success = string_from_pyobj(&trans,&slen(trans),"",trans_capi,"string_from_pyobj failed in converting 2nd argument `trans' of linalg_utils.dtbmv to C string");
  if (f2py_success) {
  /* Processing variable lda */
  if (lda_capi == Py_None) lda = shape(a,0); else
    f2py_success = int_from_pyobj(&lda,lda_capi,"linalg_utils.dtbmv() 1st keyword (lda) can't be converted to int");
  if (f2py_success) {
  CHECKSCALAR(shape(a,0)==lda,"shape(a,0)==lda","1st keyword lda","dtbmv:lda=%d",lda) {
/*end of frompyobj*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_call_clock();
#endif
/*callfortranroutine*/
        (*f2py_func)(uplo,trans,diag,&n,&k,a,&lda,x,&incx,slen(uplo),slen(trans),slen(diag));
if (PyErr_Occurred())
  f2py_success = 0;
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_call_clock();
#endif
/*end of callfortranroutine*/
    if (f2py_success) {
/*pyobjfrom*/
/*end of pyobjfrom*/
    CFUNCSMESS("Building return value.\n");
    capi_buildvalue = Py_BuildValue("");
/*closepyobjfrom*/
/*end of closepyobjfrom*/
    } /*if (f2py_success) after callfortranroutine*/
/*cleanupfrompyobj*/
  } /*CHECKSCALAR(shape(a,0)==lda)*/
  } /*if (f2py_success) of lda*/
  /* End of cleaning variable lda */
    STRINGFREE(trans);
  }  /*if (f2py_success) of trans*/
  /* End of cleaning variable trans */
  if((PyObject *)capi_x_tmp!=x_capi) {
    Py_XDECREF(capi_x_tmp); }
  }  /*if (capi_x_tmp == NULL) ... else of x*/
  /* End of cleaning variable x */
  } /*if (f2py_success) of n*/
  /* End of cleaning variable n */
  } /*if (f2py_success) of k*/
  /* End of cleaning variable k */
    STRINGFREE(diag);
  }  /*if (f2py_success) of diag*/
  /* End of cleaning variable diag */
  } /*if (f2py_success) of incx*/
  /* End of cleaning variable incx */
  if((PyObject *)capi_a_tmp!=a_capi) {
    Py_XDECREF(capi_a_tmp); }
  }  /*if (capi_a_tmp == NULL) ... else of a*/
  /* End of cleaning variable a */
    STRINGFREE(uplo);
  }  /*if (f2py_success) of uplo*/
  /* End of cleaning variable uplo */
/*end of cleanupfrompyobj*/
  if (capi_buildvalue == NULL) {
/*routdebugfailure*/
  } else {
/*routdebugleave*/
  }
  CFUNCSMESS("Freeing memory.\n");
/*freemem*/
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_clock();
#endif
  return capi_buildvalue;
}
/******************************** end of dtbmv ********************************/

/*********************************** dsyrk ***********************************/
static char doc_f2py_rout_linalg_utils_dsyrk[] = "\
dsyrk(uplo,trans,n,k,alpha,a,beta,c,[lda,ldc])\n\nWrapper for ``dsyrk``.\
\n\nParameters\n----------\n"
"uplo : input string(len=1)\n"
"trans : input string(len=1)\n"
"n : input int\n"
"k : input int\n"
"alpha : input float\n"
"a : input rank-2 array('d') with bounds (lda,*)\n"
"beta : input float\n"
"c : input rank-2 array('d') with bounds (ldc,*)\n"
"\nOther Parameters\n----------------\n"
"lda : input int, optional\n    Default: shape(a,0)\n"
"ldc : input int, optional\n    Default: shape(c,0)";
/* extern void F_FUNC(dsyrk,DSYRK)(string,string,int*,int*,double*,double*,int*,double*,double*,int*,size_t,size_t); */
static PyObject *f2py_rout_linalg_utils_dsyrk(const PyObject *capi_self,
                           PyObject *capi_args,
                           PyObject *capi_keywds,
                           void (*f2py_func)(string,string,int*,int*,double*,double*,int*,double*,double*,int*,size_t,size_t)) {
  PyObject * volatile capi_buildvalue = NULL;
  volatile int f2py_success = 1;
/*decl*/

  string uplo = NULL;
  int slen(uplo);
  PyObject *uplo_capi = Py_None;
  string trans = NULL;
  int slen(trans);
  PyObject *trans_capi = Py_None;
  int n = 0;
  PyObject *n_capi = Py_None;
  int k = 0;
  PyObject *k_capi = Py_None;
  double alpha = 0;
  PyObject *alpha_capi = Py_None;
  double *a = NULL;
  npy_intp a_Dims[2] = {-1, -1};
  const int a_Rank = 2;
  PyArrayObject *capi_a_tmp = NULL;
  int capi_a_intent = 0;
  PyObject *a_capi = Py_None;
  int lda = 0;
  PyObject *lda_capi = Py_None;
  double beta = 0;
  PyObject *beta_capi = Py_None;
  double *c = NULL;
  npy_intp c_Dims[2] = {-1, -1};
  const int c_Rank = 2;
  PyArrayObject *capi_c_tmp = NULL;
  int capi_c_intent = 0;
  PyObject *c_capi = Py_None;
  int ldc = 0;
  PyObject *ldc_capi = Py_None;
  static char *capi_kwlist[] = {"uplo","trans","n","k","alpha","a","beta","c","lda","ldc",NULL};

/*routdebugenter*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_clock();
#endif
  if (!PyArg_ParseTupleAndKeywords(capi_args,capi_keywds,\
    "OOOOOOOO|OO:linalg_utils.dsyrk",\
    capi_kwlist,&uplo_capi,&trans_capi,&n_capi,&k_capi,&alpha_capi,&a_capi,&beta_capi,&c_capi,&lda_capi,&ldc_capi))
    return NULL;
/*frompyobj*/
  /* Processing variable uplo */
  slen(uplo) = 1;
  f2py_success = string_from_pyobj(&uplo,&slen(uplo),"",uplo_capi,"string_from_pyobj failed in converting 1st argument `uplo' of linalg_utils.dsyrk to C string");
  if (f2py_success) {
  /* Processing variable beta */
    f2py_success = double_from_pyobj(&beta,beta_capi,"linalg_utils.dsyrk() 7th argument (beta) can't be converted to double");
  if (f2py_success) {
  /* Processing variable alpha */
    f2py_success = double_from_pyobj(&alpha,alpha_capi,"linalg_utils.dsyrk() 5th argument (alpha) can't be converted to double");
  if (f2py_success) {
  /* Processing variable a */
  ;
  capi_a_intent |= F2PY_INTENT_IN;
  capi_a_tmp = array_from_pyobj(NPY_DOUBLE,a_Dims,a_Rank,capi_a_intent,a_capi);
  if (capi_a_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 6th argument `a' of linalg_utils.dsyrk to C/Fortran array" );
  } else {
    a = (double *)(capi_a_tmp->data);

  /* Processing variable c */
  ;
  capi_c_intent |= F2PY_INTENT_IN;
  capi_c_tmp = array_from_pyobj(NPY_DOUBLE,c_Dims,c_Rank,capi_c_intent,c_capi);
  if (capi_c_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 8th argument `c' of linalg_utils.dsyrk to C/Fortran array" );
  } else {
    c = (double *)(capi_c_tmp->data);

  /* Processing variable k */
    f2py_success = int_from_pyobj(&k,k_capi,"linalg_utils.dsyrk() 4th argument (k) can't be converted to int");
  if (f2py_success) {
  /* Processing variable n */
    f2py_success = int_from_pyobj(&n,n_capi,"linalg_utils.dsyrk() 3rd argument (n) can't be converted to int");
  if (f2py_success) {
  /* Processing variable trans */
  slen(trans) = 1;
  f2py_success = string_from_pyobj(&trans,&slen(trans),"",trans_capi,"string_from_pyobj failed in converting 2nd argument `trans' of linalg_utils.dsyrk to C string");
  if (f2py_success) {
  /* Processing variable ldc */
  if (ldc_capi == Py_None) ldc = shape(c,0); else
    f2py_success = int_from_pyobj(&ldc,ldc_capi,"linalg_utils.dsyrk() 2nd keyword (ldc) can't be converted to int");
  if (f2py_success) {
  CHECKSCALAR(shape(c,0)==ldc,"shape(c,0)==ldc","2nd keyword ldc","dsyrk:ldc=%d",ldc) {
  /* Processing variable lda */
  if (lda_capi == Py_None) lda = shape(a,0); else
    f2py_success = int_from_pyobj(&lda,lda_capi,"linalg_utils.dsyrk() 1st keyword (lda) can't be converted to int");
  if (f2py_success) {
  CHECKSCALAR(shape(a,0)==lda,"shape(a,0)==lda","1st keyword lda","dsyrk:lda=%d",lda) {
/*end of frompyobj*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_call_clock();
#endif
/*callfortranroutine*/
        (*f2py_func)(uplo,trans,&n,&k,&alpha,a,&lda,&beta,c,&ldc,slen(uplo),slen(trans));
if (PyErr_Occurred())
  f2py_success = 0;
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_call_clock();
#endif
/*end of callfortranroutine*/
    if (f2py_success) {
/*pyobjfrom*/
/*end of pyobjfrom*/
    CFUNCSMESS("Building return value.\n");
    capi_buildvalue = Py_BuildValue("");
/*closepyobjfrom*/
/*end of closepyobjfrom*/
    } /*if (f2py_success) after callfortranroutine*/
/*cleanupfrompyobj*/
  } /*CHECKSCALAR(shape(a,0)==lda)*/
  } /*if (f2py_success) of lda*/
  /* End of cleaning variable lda */
  } /*CHECKSCALAR(shape(c,0)==ldc)*/
  } /*if (f2py_success) of ldc*/
  /* End of cleaning variable ldc */
    STRINGFREE(trans);
  }  /*if (f2py_success) of trans*/
  /* End of cleaning variable trans */
  } /*if (f2py_success) of n*/
  /* End of cleaning variable n */
  } /*if (f2py_success) of k*/
  /* End of cleaning variable k */
  if((PyObject *)capi_c_tmp!=c_capi) {
    Py_XDECREF(capi_c_tmp); }
  }  /*if (capi_c_tmp == NULL) ... else of c*/
  /* End of cleaning variable c */
  if((PyObject *)capi_a_tmp!=a_capi) {
    Py_XDECREF(capi_a_tmp); }
  }  /*if (capi_a_tmp == NULL) ... else of a*/
  /* End of cleaning variable a */
  } /*if (f2py_success) of alpha*/
  /* End of cleaning variable alpha */
  } /*if (f2py_success) of beta*/
  /* End of cleaning variable beta */
    STRINGFREE(uplo);
  }  /*if (f2py_success) of uplo*/
  /* End of cleaning variable uplo */
/*end of cleanupfrompyobj*/
  if (capi_buildvalue == NULL) {
/*routdebugfailure*/
  } else {
/*routdebugleave*/
  }
  CFUNCSMESS("Freeing memory.\n");
/*freemem*/
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_clock();
#endif
  return capi_buildvalue;
}
/******************************** end of dsyrk ********************************/

/*********************************** dsyr2k ***********************************/
static char doc_f2py_rout_linalg_utils_dsyr2k[] = "\
dsyr2k(uplo,trans,n,k,alpha,a,b,beta,c,[lda,ldb,ldc])\n\nWrapper for ``dsyr2k``.\
\n\nParameters\n----------\n"
"uplo : input string(len=1)\n"
"trans : input string(len=1)\n"
"n : input int\n"
"k : input int\n"
"alpha : input float\n"
"a : input rank-2 array('d') with bounds (lda,*)\n"
"b : input rank-2 array('d') with bounds (ldb,*)\n"
"beta : input float\n"
"c : input rank-2 array('d') with bounds (ldc,*)\n"
"\nOther Parameters\n----------------\n"
"lda : input int, optional\n    Default: shape(a,0)\n"
"ldb : input int, optional\n    Default: shape(b,0)\n"
"ldc : input int, optional\n    Default: shape(c,0)";
/* extern void F_FUNC(dsyr2k,DSYR2K)(string,string,int*,int*,double*,double*,int*,double*,int*,double*,double*,int*,size_t,size_t); */
static PyObject *f2py_rout_linalg_utils_dsyr2k(const PyObject *capi_self,
                           PyObject *capi_args,
                           PyObject *capi_keywds,
                           void (*f2py_func)(string,string,int*,int*,double*,double*,int*,double*,int*,double*,double*,int*,size_t,size_t)) {
  PyObject * volatile capi_buildvalue = NULL;
  volatile int f2py_success = 1;
/*decl*/

  string uplo = NULL;
  int slen(uplo);
  PyObject *uplo_capi = Py_None;
  string trans = NULL;
  int slen(trans);
  PyObject *trans_capi = Py_None;
  int n = 0;
  PyObject *n_capi = Py_None;
  int k = 0;
  PyObject *k_capi = Py_None;
  double alpha = 0;
  PyObject *alpha_capi = Py_None;
  double *a = NULL;
  npy_intp a_Dims[2] = {-1, -1};
  const int a_Rank = 2;
  PyArrayObject *capi_a_tmp = NULL;
  int capi_a_intent = 0;
  PyObject *a_capi = Py_None;
  int lda = 0;
  PyObject *lda_capi = Py_None;
  double *b = NULL;
  npy_intp b_Dims[2] = {-1, -1};
  const int b_Rank = 2;
  PyArrayObject *capi_b_tmp = NULL;
  int capi_b_intent = 0;
  PyObject *b_capi = Py_None;
  int ldb = 0;
  PyObject *ldb_capi = Py_None;
  double beta = 0;
  PyObject *beta_capi = Py_None;
  double *c = NULL;
  npy_intp c_Dims[2] = {-1, -1};
  const int c_Rank = 2;
  PyArrayObject *capi_c_tmp = NULL;
  int capi_c_intent = 0;
  PyObject *c_capi = Py_None;
  int ldc = 0;
  PyObject *ldc_capi = Py_None;
  static char *capi_kwlist[] = {"uplo","trans","n","k","alpha","a","b","beta","c","lda","ldb","ldc",NULL};

/*routdebugenter*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_clock();
#endif
  if (!PyArg_ParseTupleAndKeywords(capi_args,capi_keywds,\
    "OOOOOOOOO|OOO:linalg_utils.dsyr2k",\
    capi_kwlist,&uplo_capi,&trans_capi,&n_capi,&k_capi,&alpha_capi,&a_capi,&b_capi,&beta_capi,&c_capi,&lda_capi,&ldb_capi,&ldc_capi))
    return NULL;
/*frompyobj*/
  /* Processing variable uplo */
  slen(uplo) = 1;
  f2py_success = string_from_pyobj(&uplo,&slen(uplo),"",uplo_capi,"string_from_pyobj failed in converting 1st argument `uplo' of linalg_utils.dsyr2k to C string");
  if (f2py_success) {
  /* Processing variable beta */
    f2py_success = double_from_pyobj(&beta,beta_capi,"linalg_utils.dsyr2k() 8th argument (beta) can't be converted to double");
  if (f2py_success) {
  /* Processing variable alpha */
    f2py_success = double_from_pyobj(&alpha,alpha_capi,"linalg_utils.dsyr2k() 5th argument (alpha) can't be converted to double");
  if (f2py_success) {
  /* Processing variable a */
  ;
  capi_a_intent |= F2PY_INTENT_IN;
  capi_a_tmp = array_from_pyobj(NPY_DOUBLE,a_Dims,a_Rank,capi_a_intent,a_capi);
  if (capi_a_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 6th argument `a' of linalg_utils.dsyr2k to C/Fortran array" );
  } else {
    a = (double *)(capi_a_tmp->data);

  /* Processing variable c */
  ;
  capi_c_intent |= F2PY_INTENT_IN;
  capi_c_tmp = array_from_pyobj(NPY_DOUBLE,c_Dims,c_Rank,capi_c_intent,c_capi);
  if (capi_c_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 9th argument `c' of linalg_utils.dsyr2k to C/Fortran array" );
  } else {
    c = (double *)(capi_c_tmp->data);

  /* Processing variable b */
  ;
  capi_b_intent |= F2PY_INTENT_IN;
  capi_b_tmp = array_from_pyobj(NPY_DOUBLE,b_Dims,b_Rank,capi_b_intent,b_capi);
  if (capi_b_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 7th argument `b' of linalg_utils.dsyr2k to C/Fortran array" );
  } else {
    b = (double *)(capi_b_tmp->data);

  /* Processing variable k */
    f2py_success = int_from_pyobj(&k,k_capi,"linalg_utils.dsyr2k() 4th argument (k) can't be converted to int");
  if (f2py_success) {
  /* Processing variable n */
    f2py_success = int_from_pyobj(&n,n_capi,"linalg_utils.dsyr2k() 3rd argument (n) can't be converted to int");
  if (f2py_success) {
  /* Processing variable trans */
  slen(trans) = 1;
  f2py_success = string_from_pyobj(&trans,&slen(trans),"",trans_capi,"string_from_pyobj failed in converting 2nd argument `trans' of linalg_utils.dsyr2k to C string");
  if (f2py_success) {
  /* Processing variable ldc */
  if (ldc_capi == Py_None) ldc = shape(c,0); else
    f2py_success = int_from_pyobj(&ldc,ldc_capi,"linalg_utils.dsyr2k() 3rd keyword (ldc) can't be converted to int");
  if (f2py_success) {
  CHECKSCALAR(shape(c,0)==ldc,"shape(c,0)==ldc","3rd keyword ldc","dsyr2k:ldc=%d",ldc) {
  /* Processing variable ldb */
  if (ldb_capi == Py_None) ldb = shape(b,0); else
    f2py_success = int_from_pyobj(&ldb,ldb_capi,"linalg_utils.dsyr2k() 2nd keyword (ldb) can't be converted to int");
  if (f2py_success) {
  CHECKSCALAR(shape(b,0)==ldb,"shape(b,0)==ldb","2nd keyword ldb","dsyr2k:ldb=%d",ldb) {
  /* Processing variable lda */
  if (lda_capi == Py_None) lda = shape(a,0); else
    f2py_success = int_from_pyobj(&lda,lda_capi,"linalg_utils.dsyr2k() 1st keyword (lda) can't be converted to int");
  if (f2py_success) {
  CHECKSCALAR(shape(a,0)==lda,"shape(a,0)==lda","1st keyword lda","dsyr2k:lda=%d",lda) {
/*end of frompyobj*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_call_clock();
#endif
/*callfortranroutine*/
        (*f2py_func)(uplo,trans,&n,&k,&alpha,a,&lda,b,&ldb,&beta,c,&ldc,slen(uplo),slen(trans));
if (PyErr_Occurred())
  f2py_success = 0;
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_call_clock();
#endif
/*end of callfortranroutine*/
    if (f2py_success) {
/*pyobjfrom*/
/*end of pyobjfrom*/
    CFUNCSMESS("Building return value.\n");
    capi_buildvalue = Py_BuildValue("");
/*closepyobjfrom*/
/*end of closepyobjfrom*/
    } /*if (f2py_success) after callfortranroutine*/
/*cleanupfrompyobj*/
  } /*CHECKSCALAR(shape(a,0)==lda)*/
  } /*if (f2py_success) of lda*/
  /* End of cleaning variable lda */
  } /*CHECKSCALAR(shape(b,0)==ldb)*/
  } /*if (f2py_success) of ldb*/
  /* End of cleaning variable ldb */
  } /*CHECKSCALAR(shape(c,0)==ldc)*/
  } /*if (f2py_success) of ldc*/
  /* End of cleaning variable ldc */
    STRINGFREE(trans);
  }  /*if (f2py_success) of trans*/
  /* End of cleaning variable trans */
  } /*if (f2py_success) of n*/
  /* End of cleaning variable n */
  } /*if (f2py_success) of k*/
  /* End of cleaning variable k */
  if((PyObject *)capi_b_tmp!=b_capi) {
    Py_XDECREF(capi_b_tmp); }
  }  /*if (capi_b_tmp == NULL) ... else of b*/
  /* End of cleaning variable b */
  if((PyObject *)capi_c_tmp!=c_capi) {
    Py_XDECREF(capi_c_tmp); }
  }  /*if (capi_c_tmp == NULL) ... else of c*/
  /* End of cleaning variable c */
  if((PyObject *)capi_a_tmp!=a_capi) {
    Py_XDECREF(capi_a_tmp); }
  }  /*if (capi_a_tmp == NULL) ... else of a*/
  /* End of cleaning variable a */
  } /*if (f2py_success) of alpha*/
  /* End of cleaning variable alpha */
  } /*if (f2py_success) of beta*/
  /* End of cleaning variable beta */
    STRINGFREE(uplo);
  }  /*if (f2py_success) of uplo*/
  /* End of cleaning variable uplo */
/*end of cleanupfrompyobj*/
  if (capi_buildvalue == NULL) {
/*routdebugfailure*/
  } else {
/*routdebugleave*/
  }
  CFUNCSMESS("Freeing memory.\n");
/*freemem*/
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_clock();
#endif
  return capi_buildvalue;
}
/******************************* end of dsyr2k *******************************/

/*********************************** dsyr2 ***********************************/
static char doc_f2py_rout_linalg_utils_dsyr2[] = "\
dsyr2(uplo,n,alpha,x,incx,y,incy,a,[lda])\n\nWrapper for ``dsyr2``.\
\n\nParameters\n----------\n"
"uplo : input string(len=1)\n"
"n : input int\n"
"alpha : input float\n"
"x : input rank-1 array('d') with bounds (*)\n"
"incx : input int\n"
"y : input rank-1 array('d') with bounds (*)\n"
"incy : input int\n"
"a : input rank-2 array('d') with bounds (lda,*)\n"
"\nOther Parameters\n----------------\n"
"lda : input int, optional\n    Default: shape(a,0)";
/* extern void F_FUNC(dsyr2,DSYR2)(string,int*,double*,double*,int*,double*,int*,double*,int*,size_t); */
static PyObject *f2py_rout_linalg_utils_dsyr2(const PyObject *capi_self,
                           PyObject *capi_args,
                           PyObject *capi_keywds,
                           void (*f2py_func)(string,int*,double*,double*,int*,double*,int*,double*,int*,size_t)) {
  PyObject * volatile capi_buildvalue = NULL;
  volatile int f2py_success = 1;
/*decl*/

  string uplo = NULL;
  int slen(uplo);
  PyObject *uplo_capi = Py_None;
  int n = 0;
  PyObject *n_capi = Py_None;
  double alpha = 0;
  PyObject *alpha_capi = Py_None;
  double *x = NULL;
  npy_intp x_Dims[1] = {-1};
  const int x_Rank = 1;
  PyArrayObject *capi_x_tmp = NULL;
  int capi_x_intent = 0;
  PyObject *x_capi = Py_None;
  int incx = 0;
  PyObject *incx_capi = Py_None;
  double *y = NULL;
  npy_intp y_Dims[1] = {-1};
  const int y_Rank = 1;
  PyArrayObject *capi_y_tmp = NULL;
  int capi_y_intent = 0;
  PyObject *y_capi = Py_None;
  int incy = 0;
  PyObject *incy_capi = Py_None;
  double *a = NULL;
  npy_intp a_Dims[2] = {-1, -1};
  const int a_Rank = 2;
  PyArrayObject *capi_a_tmp = NULL;
  int capi_a_intent = 0;
  PyObject *a_capi = Py_None;
  int lda = 0;
  PyObject *lda_capi = Py_None;
  static char *capi_kwlist[] = {"uplo","n","alpha","x","incx","y","incy","a","lda",NULL};

/*routdebugenter*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_clock();
#endif
  if (!PyArg_ParseTupleAndKeywords(capi_args,capi_keywds,\
    "OOOOOOOO|O:linalg_utils.dsyr2",\
    capi_kwlist,&uplo_capi,&n_capi,&alpha_capi,&x_capi,&incx_capi,&y_capi,&incy_capi,&a_capi,&lda_capi))
    return NULL;
/*frompyobj*/
  /* Processing variable uplo */
  slen(uplo) = 1;
  f2py_success = string_from_pyobj(&uplo,&slen(uplo),"",uplo_capi,"string_from_pyobj failed in converting 1st argument `uplo' of linalg_utils.dsyr2 to C string");
  if (f2py_success) {
  /* Processing variable a */
  ;
  capi_a_intent |= F2PY_INTENT_IN;
  capi_a_tmp = array_from_pyobj(NPY_DOUBLE,a_Dims,a_Rank,capi_a_intent,a_capi);
  if (capi_a_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 8th argument `a' of linalg_utils.dsyr2 to C/Fortran array" );
  } else {
    a = (double *)(capi_a_tmp->data);

  /* Processing variable alpha */
    f2py_success = double_from_pyobj(&alpha,alpha_capi,"linalg_utils.dsyr2() 3rd argument (alpha) can't be converted to double");
  if (f2py_success) {
  /* Processing variable incx */
    f2py_success = int_from_pyobj(&incx,incx_capi,"linalg_utils.dsyr2() 5th argument (incx) can't be converted to int");
  if (f2py_success) {
  /* Processing variable incy */
    f2py_success = int_from_pyobj(&incy,incy_capi,"linalg_utils.dsyr2() 7th argument (incy) can't be converted to int");
  if (f2py_success) {
  /* Processing variable n */
    f2py_success = int_from_pyobj(&n,n_capi,"linalg_utils.dsyr2() 2nd argument (n) can't be converted to int");
  if (f2py_success) {
  /* Processing variable y */
  ;
  capi_y_intent |= F2PY_INTENT_IN;
  capi_y_tmp = array_from_pyobj(NPY_DOUBLE,y_Dims,y_Rank,capi_y_intent,y_capi);
  if (capi_y_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 6th argument `y' of linalg_utils.dsyr2 to C/Fortran array" );
  } else {
    y = (double *)(capi_y_tmp->data);

  /* Processing variable x */
  ;
  capi_x_intent |= F2PY_INTENT_IN;
  capi_x_tmp = array_from_pyobj(NPY_DOUBLE,x_Dims,x_Rank,capi_x_intent,x_capi);
  if (capi_x_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 4th argument `x' of linalg_utils.dsyr2 to C/Fortran array" );
  } else {
    x = (double *)(capi_x_tmp->data);

  /* Processing variable lda */
  if (lda_capi == Py_None) lda = shape(a,0); else
    f2py_success = int_from_pyobj(&lda,lda_capi,"linalg_utils.dsyr2() 1st keyword (lda) can't be converted to int");
  if (f2py_success) {
  CHECKSCALAR(shape(a,0)==lda,"shape(a,0)==lda","1st keyword lda","dsyr2:lda=%d",lda) {
/*end of frompyobj*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_call_clock();
#endif
/*callfortranroutine*/
        (*f2py_func)(uplo,&n,&alpha,x,&incx,y,&incy,a,&lda,slen(uplo));
if (PyErr_Occurred())
  f2py_success = 0;
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_call_clock();
#endif
/*end of callfortranroutine*/
    if (f2py_success) {
/*pyobjfrom*/
/*end of pyobjfrom*/
    CFUNCSMESS("Building return value.\n");
    capi_buildvalue = Py_BuildValue("");
/*closepyobjfrom*/
/*end of closepyobjfrom*/
    } /*if (f2py_success) after callfortranroutine*/
/*cleanupfrompyobj*/
  } /*CHECKSCALAR(shape(a,0)==lda)*/
  } /*if (f2py_success) of lda*/
  /* End of cleaning variable lda */
  if((PyObject *)capi_x_tmp!=x_capi) {
    Py_XDECREF(capi_x_tmp); }
  }  /*if (capi_x_tmp == NULL) ... else of x*/
  /* End of cleaning variable x */
  if((PyObject *)capi_y_tmp!=y_capi) {
    Py_XDECREF(capi_y_tmp); }
  }  /*if (capi_y_tmp == NULL) ... else of y*/
  /* End of cleaning variable y */
  } /*if (f2py_success) of n*/
  /* End of cleaning variable n */
  } /*if (f2py_success) of incy*/
  /* End of cleaning variable incy */
  } /*if (f2py_success) of incx*/
  /* End of cleaning variable incx */
  } /*if (f2py_success) of alpha*/
  /* End of cleaning variable alpha */
  if((PyObject *)capi_a_tmp!=a_capi) {
    Py_XDECREF(capi_a_tmp); }
  }  /*if (capi_a_tmp == NULL) ... else of a*/
  /* End of cleaning variable a */
    STRINGFREE(uplo);
  }  /*if (f2py_success) of uplo*/
  /* End of cleaning variable uplo */
/*end of cleanupfrompyobj*/
  if (capi_buildvalue == NULL) {
/*routdebugfailure*/
  } else {
/*routdebugleave*/
  }
  CFUNCSMESS("Freeing memory.\n");
/*freemem*/
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_clock();
#endif
  return capi_buildvalue;
}
/******************************** end of dsyr2 ********************************/

/************************************ dsyr ************************************/
static char doc_f2py_rout_linalg_utils_dsyr[] = "\
dsyr(uplo,n,alpha,x,incx,a,[lda])\n\nWrapper for ``dsyr``.\
\n\nParameters\n----------\n"
"uplo : input string(len=1)\n"
"n : input int\n"
"alpha : input float\n"
"x : input rank-1 array('d') with bounds (*)\n"
"incx : input int\n"
"a : input rank-2 array('d') with bounds (lda,*)\n"
"\nOther Parameters\n----------------\n"
"lda : input int, optional\n    Default: shape(a,0)";
/* extern void F_FUNC(dsyr,DSYR)(string,int*,double*,double*,int*,double*,int*,size_t); */
static PyObject *f2py_rout_linalg_utils_dsyr(const PyObject *capi_self,
                           PyObject *capi_args,
                           PyObject *capi_keywds,
                           void (*f2py_func)(string,int*,double*,double*,int*,double*,int*,size_t)) {
  PyObject * volatile capi_buildvalue = NULL;
  volatile int f2py_success = 1;
/*decl*/

  string uplo = NULL;
  int slen(uplo);
  PyObject *uplo_capi = Py_None;
  int n = 0;
  PyObject *n_capi = Py_None;
  double alpha = 0;
  PyObject *alpha_capi = Py_None;
  double *x = NULL;
  npy_intp x_Dims[1] = {-1};
  const int x_Rank = 1;
  PyArrayObject *capi_x_tmp = NULL;
  int capi_x_intent = 0;
  PyObject *x_capi = Py_None;
  int incx = 0;
  PyObject *incx_capi = Py_None;
  double *a = NULL;
  npy_intp a_Dims[2] = {-1, -1};
  const int a_Rank = 2;
  PyArrayObject *capi_a_tmp = NULL;
  int capi_a_intent = 0;
  PyObject *a_capi = Py_None;
  int lda = 0;
  PyObject *lda_capi = Py_None;
  static char *capi_kwlist[] = {"uplo","n","alpha","x","incx","a","lda",NULL};

/*routdebugenter*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_clock();
#endif
  if (!PyArg_ParseTupleAndKeywords(capi_args,capi_keywds,\
    "OOOOOO|O:linalg_utils.dsyr",\
    capi_kwlist,&uplo_capi,&n_capi,&alpha_capi,&x_capi,&incx_capi,&a_capi,&lda_capi))
    return NULL;
/*frompyobj*/
  /* Processing variable uplo */
  slen(uplo) = 1;
  f2py_success = string_from_pyobj(&uplo,&slen(uplo),"",uplo_capi,"string_from_pyobj failed in converting 1st argument `uplo' of linalg_utils.dsyr to C string");
  if (f2py_success) {
  /* Processing variable alpha */
    f2py_success = double_from_pyobj(&alpha,alpha_capi,"linalg_utils.dsyr() 3rd argument (alpha) can't be converted to double");
  if (f2py_success) {
  /* Processing variable a */
  ;
  capi_a_intent |= F2PY_INTENT_IN;
  capi_a_tmp = array_from_pyobj(NPY_DOUBLE,a_Dims,a_Rank,capi_a_intent,a_capi);
  if (capi_a_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 6th argument `a' of linalg_utils.dsyr to C/Fortran array" );
  } else {
    a = (double *)(capi_a_tmp->data);

  /* Processing variable n */
    f2py_success = int_from_pyobj(&n,n_capi,"linalg_utils.dsyr() 2nd argument (n) can't be converted to int");
  if (f2py_success) {
  /* Processing variable incx */
    f2py_success = int_from_pyobj(&incx,incx_capi,"linalg_utils.dsyr() 5th argument (incx) can't be converted to int");
  if (f2py_success) {
  /* Processing variable x */
  ;
  capi_x_intent |= F2PY_INTENT_IN;
  capi_x_tmp = array_from_pyobj(NPY_DOUBLE,x_Dims,x_Rank,capi_x_intent,x_capi);
  if (capi_x_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 4th argument `x' of linalg_utils.dsyr to C/Fortran array" );
  } else {
    x = (double *)(capi_x_tmp->data);

  /* Processing variable lda */
  if (lda_capi == Py_None) lda = shape(a,0); else
    f2py_success = int_from_pyobj(&lda,lda_capi,"linalg_utils.dsyr() 1st keyword (lda) can't be converted to int");
  if (f2py_success) {
  CHECKSCALAR(shape(a,0)==lda,"shape(a,0)==lda","1st keyword lda","dsyr:lda=%d",lda) {
/*end of frompyobj*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_call_clock();
#endif
/*callfortranroutine*/
        (*f2py_func)(uplo,&n,&alpha,x,&incx,a,&lda,slen(uplo));
if (PyErr_Occurred())
  f2py_success = 0;
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_call_clock();
#endif
/*end of callfortranroutine*/
    if (f2py_success) {
/*pyobjfrom*/
/*end of pyobjfrom*/
    CFUNCSMESS("Building return value.\n");
    capi_buildvalue = Py_BuildValue("");
/*closepyobjfrom*/
/*end of closepyobjfrom*/
    } /*if (f2py_success) after callfortranroutine*/
/*cleanupfrompyobj*/
  } /*CHECKSCALAR(shape(a,0)==lda)*/
  } /*if (f2py_success) of lda*/
  /* End of cleaning variable lda */
  if((PyObject *)capi_x_tmp!=x_capi) {
    Py_XDECREF(capi_x_tmp); }
  }  /*if (capi_x_tmp == NULL) ... else of x*/
  /* End of cleaning variable x */
  } /*if (f2py_success) of incx*/
  /* End of cleaning variable incx */
  } /*if (f2py_success) of n*/
  /* End of cleaning variable n */
  if((PyObject *)capi_a_tmp!=a_capi) {
    Py_XDECREF(capi_a_tmp); }
  }  /*if (capi_a_tmp == NULL) ... else of a*/
  /* End of cleaning variable a */
  } /*if (f2py_success) of alpha*/
  /* End of cleaning variable alpha */
    STRINGFREE(uplo);
  }  /*if (f2py_success) of uplo*/
  /* End of cleaning variable uplo */
/*end of cleanupfrompyobj*/
  if (capi_buildvalue == NULL) {
/*routdebugfailure*/
  } else {
/*routdebugleave*/
  }
  CFUNCSMESS("Freeing memory.\n");
/*freemem*/
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_clock();
#endif
  return capi_buildvalue;
}
/******************************** end of dsyr ********************************/

/*********************************** dsymv ***********************************/
static char doc_f2py_rout_linalg_utils_dsymv[] = "\
dsymv(uplo,n,alpha,a,x,incx,beta,y,incy,[lda])\n\nWrapper for ``dsymv``.\
\n\nParameters\n----------\n"
"uplo : input string(len=1)\n"
"n : input int\n"
"alpha : input float\n"
"a : input rank-2 array('d') with bounds (lda,*)\n"
"x : input rank-1 array('d') with bounds (*)\n"
"incx : input int\n"
"beta : input float\n"
"y : input rank-1 array('d') with bounds (*)\n"
"incy : input int\n"
"\nOther Parameters\n----------------\n"
"lda : input int, optional\n    Default: shape(a,0)";
/* extern void F_FUNC(dsymv,DSYMV)(string,int*,double*,double*,int*,double*,int*,double*,double*,int*,size_t); */
static PyObject *f2py_rout_linalg_utils_dsymv(const PyObject *capi_self,
                           PyObject *capi_args,
                           PyObject *capi_keywds,
                           void (*f2py_func)(string,int*,double*,double*,int*,double*,int*,double*,double*,int*,size_t)) {
  PyObject * volatile capi_buildvalue = NULL;
  volatile int f2py_success = 1;
/*decl*/

  string uplo = NULL;
  int slen(uplo);
  PyObject *uplo_capi = Py_None;
  int n = 0;
  PyObject *n_capi = Py_None;
  double alpha = 0;
  PyObject *alpha_capi = Py_None;
  double *a = NULL;
  npy_intp a_Dims[2] = {-1, -1};
  const int a_Rank = 2;
  PyArrayObject *capi_a_tmp = NULL;
  int capi_a_intent = 0;
  PyObject *a_capi = Py_None;
  int lda = 0;
  PyObject *lda_capi = Py_None;
  double *x = NULL;
  npy_intp x_Dims[1] = {-1};
  const int x_Rank = 1;
  PyArrayObject *capi_x_tmp = NULL;
  int capi_x_intent = 0;
  PyObject *x_capi = Py_None;
  int incx = 0;
  PyObject *incx_capi = Py_None;
  double beta = 0;
  PyObject *beta_capi = Py_None;
  double *y = NULL;
  npy_intp y_Dims[1] = {-1};
  const int y_Rank = 1;
  PyArrayObject *capi_y_tmp = NULL;
  int capi_y_intent = 0;
  PyObject *y_capi = Py_None;
  int incy = 0;
  PyObject *incy_capi = Py_None;
  static char *capi_kwlist[] = {"uplo","n","alpha","a","x","incx","beta","y","incy","lda",NULL};

/*routdebugenter*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_clock();
#endif
  if (!PyArg_ParseTupleAndKeywords(capi_args,capi_keywds,\
    "OOOOOOOOO|O:linalg_utils.dsymv",\
    capi_kwlist,&uplo_capi,&n_capi,&alpha_capi,&a_capi,&x_capi,&incx_capi,&beta_capi,&y_capi,&incy_capi,&lda_capi))
    return NULL;
/*frompyobj*/
  /* Processing variable uplo */
  slen(uplo) = 1;
  f2py_success = string_from_pyobj(&uplo,&slen(uplo),"",uplo_capi,"string_from_pyobj failed in converting 1st argument `uplo' of linalg_utils.dsymv to C string");
  if (f2py_success) {
  /* Processing variable a */
  ;
  capi_a_intent |= F2PY_INTENT_IN;
  capi_a_tmp = array_from_pyobj(NPY_DOUBLE,a_Dims,a_Rank,capi_a_intent,a_capi);
  if (capi_a_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 4th argument `a' of linalg_utils.dsymv to C/Fortran array" );
  } else {
    a = (double *)(capi_a_tmp->data);

  /* Processing variable alpha */
    f2py_success = double_from_pyobj(&alpha,alpha_capi,"linalg_utils.dsymv() 3rd argument (alpha) can't be converted to double");
  if (f2py_success) {
  /* Processing variable incx */
    f2py_success = int_from_pyobj(&incx,incx_capi,"linalg_utils.dsymv() 6th argument (incx) can't be converted to int");
  if (f2py_success) {
  /* Processing variable incy */
    f2py_success = int_from_pyobj(&incy,incy_capi,"linalg_utils.dsymv() 9th argument (incy) can't be converted to int");
  if (f2py_success) {
  /* Processing variable beta */
    f2py_success = double_from_pyobj(&beta,beta_capi,"linalg_utils.dsymv() 7th argument (beta) can't be converted to double");
  if (f2py_success) {
  /* Processing variable n */
    f2py_success = int_from_pyobj(&n,n_capi,"linalg_utils.dsymv() 2nd argument (n) can't be converted to int");
  if (f2py_success) {
  /* Processing variable y */
  ;
  capi_y_intent |= F2PY_INTENT_IN;
  capi_y_tmp = array_from_pyobj(NPY_DOUBLE,y_Dims,y_Rank,capi_y_intent,y_capi);
  if (capi_y_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 8th argument `y' of linalg_utils.dsymv to C/Fortran array" );
  } else {
    y = (double *)(capi_y_tmp->data);

  /* Processing variable x */
  ;
  capi_x_intent |= F2PY_INTENT_IN;
  capi_x_tmp = array_from_pyobj(NPY_DOUBLE,x_Dims,x_Rank,capi_x_intent,x_capi);
  if (capi_x_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 5th argument `x' of linalg_utils.dsymv to C/Fortran array" );
  } else {
    x = (double *)(capi_x_tmp->data);

  /* Processing variable lda */
  if (lda_capi == Py_None) lda = shape(a,0); else
    f2py_success = int_from_pyobj(&lda,lda_capi,"linalg_utils.dsymv() 1st keyword (lda) can't be converted to int");
  if (f2py_success) {
  CHECKSCALAR(shape(a,0)==lda,"shape(a,0)==lda","1st keyword lda","dsymv:lda=%d",lda) {
/*end of frompyobj*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_call_clock();
#endif
/*callfortranroutine*/
        (*f2py_func)(uplo,&n,&alpha,a,&lda,x,&incx,&beta,y,&incy,slen(uplo));
if (PyErr_Occurred())
  f2py_success = 0;
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_call_clock();
#endif
/*end of callfortranroutine*/
    if (f2py_success) {
/*pyobjfrom*/
/*end of pyobjfrom*/
    CFUNCSMESS("Building return value.\n");
    capi_buildvalue = Py_BuildValue("");
/*closepyobjfrom*/
/*end of closepyobjfrom*/
    } /*if (f2py_success) after callfortranroutine*/
/*cleanupfrompyobj*/
  } /*CHECKSCALAR(shape(a,0)==lda)*/
  } /*if (f2py_success) of lda*/
  /* End of cleaning variable lda */
  if((PyObject *)capi_x_tmp!=x_capi) {
    Py_XDECREF(capi_x_tmp); }
  }  /*if (capi_x_tmp == NULL) ... else of x*/
  /* End of cleaning variable x */
  if((PyObject *)capi_y_tmp!=y_capi) {
    Py_XDECREF(capi_y_tmp); }
  }  /*if (capi_y_tmp == NULL) ... else of y*/
  /* End of cleaning variable y */
  } /*if (f2py_success) of n*/
  /* End of cleaning variable n */
  } /*if (f2py_success) of beta*/
  /* End of cleaning variable beta */
  } /*if (f2py_success) of incy*/
  /* End of cleaning variable incy */
  } /*if (f2py_success) of incx*/
  /* End of cleaning variable incx */
  } /*if (f2py_success) of alpha*/
  /* End of cleaning variable alpha */
  if((PyObject *)capi_a_tmp!=a_capi) {
    Py_XDECREF(capi_a_tmp); }
  }  /*if (capi_a_tmp == NULL) ... else of a*/
  /* End of cleaning variable a */
    STRINGFREE(uplo);
  }  /*if (f2py_success) of uplo*/
  /* End of cleaning variable uplo */
/*end of cleanupfrompyobj*/
  if (capi_buildvalue == NULL) {
/*routdebugfailure*/
  } else {
/*routdebugleave*/
  }
  CFUNCSMESS("Freeing memory.\n");
/*freemem*/
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_clock();
#endif
  return capi_buildvalue;
}
/******************************** end of dsymv ********************************/

/*********************************** dsymm ***********************************/
static char doc_f2py_rout_linalg_utils_dsymm[] = "\
dsymm(side,uplo,m,n,alpha,a,b,beta,c,[lda,ldb,ldc])\n\nWrapper for ``dsymm``.\
\n\nParameters\n----------\n"
"side : input string(len=1)\n"
"uplo : input string(len=1)\n"
"m : input int\n"
"n : input int\n"
"alpha : input float\n"
"a : input rank-2 array('d') with bounds (lda,*)\n"
"b : input rank-2 array('d') with bounds (ldb,*)\n"
"beta : input float\n"
"c : input rank-2 array('d') with bounds (ldc,*)\n"
"\nOther Parameters\n----------------\n"
"lda : input int, optional\n    Default: shape(a,0)\n"
"ldb : input int, optional\n    Default: shape(b,0)\n"
"ldc : input int, optional\n    Default: shape(c,0)";
/* extern void F_FUNC(dsymm,DSYMM)(string,string,int*,int*,double*,double*,int*,double*,int*,double*,double*,int*,size_t,size_t); */
static PyObject *f2py_rout_linalg_utils_dsymm(const PyObject *capi_self,
                           PyObject *capi_args,
                           PyObject *capi_keywds,
                           void (*f2py_func)(string,string,int*,int*,double*,double*,int*,double*,int*,double*,double*,int*,size_t,size_t)) {
  PyObject * volatile capi_buildvalue = NULL;
  volatile int f2py_success = 1;
/*decl*/

  string side = NULL;
  int slen(side);
  PyObject *side_capi = Py_None;
  string uplo = NULL;
  int slen(uplo);
  PyObject *uplo_capi = Py_None;
  int m = 0;
  PyObject *m_capi = Py_None;
  int n = 0;
  PyObject *n_capi = Py_None;
  double alpha = 0;
  PyObject *alpha_capi = Py_None;
  double *a = NULL;
  npy_intp a_Dims[2] = {-1, -1};
  const int a_Rank = 2;
  PyArrayObject *capi_a_tmp = NULL;
  int capi_a_intent = 0;
  PyObject *a_capi = Py_None;
  int lda = 0;
  PyObject *lda_capi = Py_None;
  double *b = NULL;
  npy_intp b_Dims[2] = {-1, -1};
  const int b_Rank = 2;
  PyArrayObject *capi_b_tmp = NULL;
  int capi_b_intent = 0;
  PyObject *b_capi = Py_None;
  int ldb = 0;
  PyObject *ldb_capi = Py_None;
  double beta = 0;
  PyObject *beta_capi = Py_None;
  double *c = NULL;
  npy_intp c_Dims[2] = {-1, -1};
  const int c_Rank = 2;
  PyArrayObject *capi_c_tmp = NULL;
  int capi_c_intent = 0;
  PyObject *c_capi = Py_None;
  int ldc = 0;
  PyObject *ldc_capi = Py_None;
  static char *capi_kwlist[] = {"side","uplo","m","n","alpha","a","b","beta","c","lda","ldb","ldc",NULL};

/*routdebugenter*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_clock();
#endif
  if (!PyArg_ParseTupleAndKeywords(capi_args,capi_keywds,\
    "OOOOOOOOO|OOO:linalg_utils.dsymm",\
    capi_kwlist,&side_capi,&uplo_capi,&m_capi,&n_capi,&alpha_capi,&a_capi,&b_capi,&beta_capi,&c_capi,&lda_capi,&ldb_capi,&ldc_capi))
    return NULL;
/*frompyobj*/
  /* Processing variable uplo */
  slen(uplo) = 1;
  f2py_success = string_from_pyobj(&uplo,&slen(uplo),"",uplo_capi,"string_from_pyobj failed in converting 2nd argument `uplo' of linalg_utils.dsymm to C string");
  if (f2py_success) {
  /* Processing variable alpha */
    f2py_success = double_from_pyobj(&alpha,alpha_capi,"linalg_utils.dsymm() 5th argument (alpha) can't be converted to double");
  if (f2py_success) {
  /* Processing variable a */
  ;
  capi_a_intent |= F2PY_INTENT_IN;
  capi_a_tmp = array_from_pyobj(NPY_DOUBLE,a_Dims,a_Rank,capi_a_intent,a_capi);
  if (capi_a_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 6th argument `a' of linalg_utils.dsymm to C/Fortran array" );
  } else {
    a = (double *)(capi_a_tmp->data);

  /* Processing variable c */
  ;
  capi_c_intent |= F2PY_INTENT_IN;
  capi_c_tmp = array_from_pyobj(NPY_DOUBLE,c_Dims,c_Rank,capi_c_intent,c_capi);
  if (capi_c_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 9th argument `c' of linalg_utils.dsymm to C/Fortran array" );
  } else {
    c = (double *)(capi_c_tmp->data);

  /* Processing variable b */
  ;
  capi_b_intent |= F2PY_INTENT_IN;
  capi_b_tmp = array_from_pyobj(NPY_DOUBLE,b_Dims,b_Rank,capi_b_intent,b_capi);
  if (capi_b_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 7th argument `b' of linalg_utils.dsymm to C/Fortran array" );
  } else {
    b = (double *)(capi_b_tmp->data);

  /* Processing variable m */
    f2py_success = int_from_pyobj(&m,m_capi,"linalg_utils.dsymm() 3rd argument (m) can't be converted to int");
  if (f2py_success) {
  /* Processing variable beta */
    f2py_success = double_from_pyobj(&beta,beta_capi,"linalg_utils.dsymm() 8th argument (beta) can't be converted to double");
  if (f2py_success) {
  /* Processing variable n */
    f2py_success = int_from_pyobj(&n,n_capi,"linalg_utils.dsymm() 4th argument (n) can't be converted to int");
  if (f2py_success) {
  /* Processing variable side */
  slen(side) = 1;
  f2py_success = string_from_pyobj(&side,&slen(side),"",side_capi,"string_from_pyobj failed in converting 1st argument `side' of linalg_utils.dsymm to C string");
  if (f2py_success) {
  /* Processing variable ldc */
  if (ldc_capi == Py_None) ldc = shape(c,0); else
    f2py_success = int_from_pyobj(&ldc,ldc_capi,"linalg_utils.dsymm() 3rd keyword (ldc) can't be converted to int");
  if (f2py_success) {
  CHECKSCALAR(shape(c,0)==ldc,"shape(c,0)==ldc","3rd keyword ldc","dsymm:ldc=%d",ldc) {
  /* Processing variable ldb */
  if (ldb_capi == Py_None) ldb = shape(b,0); else
    f2py_success = int_from_pyobj(&ldb,ldb_capi,"linalg_utils.dsymm() 2nd keyword (ldb) can't be converted to int");
  if (f2py_success) {
  CHECKSCALAR(shape(b,0)==ldb,"shape(b,0)==ldb","2nd keyword ldb","dsymm:ldb=%d",ldb) {
  /* Processing variable lda */
  if (lda_capi == Py_None) lda = shape(a,0); else
    f2py_success = int_from_pyobj(&lda,lda_capi,"linalg_utils.dsymm() 1st keyword (lda) can't be converted to int");
  if (f2py_success) {
  CHECKSCALAR(shape(a,0)==lda,"shape(a,0)==lda","1st keyword lda","dsymm:lda=%d",lda) {
/*end of frompyobj*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_call_clock();
#endif
/*callfortranroutine*/
        (*f2py_func)(side,uplo,&m,&n,&alpha,a,&lda,b,&ldb,&beta,c,&ldc,slen(side),slen(uplo));
if (PyErr_Occurred())
  f2py_success = 0;
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_call_clock();
#endif
/*end of callfortranroutine*/
    if (f2py_success) {
/*pyobjfrom*/
/*end of pyobjfrom*/
    CFUNCSMESS("Building return value.\n");
    capi_buildvalue = Py_BuildValue("");
/*closepyobjfrom*/
/*end of closepyobjfrom*/
    } /*if (f2py_success) after callfortranroutine*/
/*cleanupfrompyobj*/
  } /*CHECKSCALAR(shape(a,0)==lda)*/
  } /*if (f2py_success) of lda*/
  /* End of cleaning variable lda */
  } /*CHECKSCALAR(shape(b,0)==ldb)*/
  } /*if (f2py_success) of ldb*/
  /* End of cleaning variable ldb */
  } /*CHECKSCALAR(shape(c,0)==ldc)*/
  } /*if (f2py_success) of ldc*/
  /* End of cleaning variable ldc */
    STRINGFREE(side);
  }  /*if (f2py_success) of side*/
  /* End of cleaning variable side */
  } /*if (f2py_success) of n*/
  /* End of cleaning variable n */
  } /*if (f2py_success) of beta*/
  /* End of cleaning variable beta */
  } /*if (f2py_success) of m*/
  /* End of cleaning variable m */
  if((PyObject *)capi_b_tmp!=b_capi) {
    Py_XDECREF(capi_b_tmp); }
  }  /*if (capi_b_tmp == NULL) ... else of b*/
  /* End of cleaning variable b */
  if((PyObject *)capi_c_tmp!=c_capi) {
    Py_XDECREF(capi_c_tmp); }
  }  /*if (capi_c_tmp == NULL) ... else of c*/
  /* End of cleaning variable c */
  if((PyObject *)capi_a_tmp!=a_capi) {
    Py_XDECREF(capi_a_tmp); }
  }  /*if (capi_a_tmp == NULL) ... else of a*/
  /* End of cleaning variable a */
  } /*if (f2py_success) of alpha*/
  /* End of cleaning variable alpha */
    STRINGFREE(uplo);
  }  /*if (f2py_success) of uplo*/
  /* End of cleaning variable uplo */
/*end of cleanupfrompyobj*/
  if (capi_buildvalue == NULL) {
/*routdebugfailure*/
  } else {
/*routdebugleave*/
  }
  CFUNCSMESS("Freeing memory.\n");
/*freemem*/
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_clock();
#endif
  return capi_buildvalue;
}
/******************************** end of dsymm ********************************/

/*********************************** dswap ***********************************/
static char doc_f2py_rout_linalg_utils_dswap[] = "\
dswap(n,dx,incx,dy,incy)\n\nWrapper for ``dswap``.\
\n\nParameters\n----------\n"
"n : input int\n"
"dx : input rank-1 array('d') with bounds (*)\n"
"incx : input int\n"
"dy : input rank-1 array('d') with bounds (*)\n"
"incy : input int";
/* extern void F_FUNC(dswap,DSWAP)(int*,double*,int*,double*,int*); */
static PyObject *f2py_rout_linalg_utils_dswap(const PyObject *capi_self,
                           PyObject *capi_args,
                           PyObject *capi_keywds,
                           void (*f2py_func)(int*,double*,int*,double*,int*)) {
  PyObject * volatile capi_buildvalue = NULL;
  volatile int f2py_success = 1;
/*decl*/

  int n = 0;
  PyObject *n_capi = Py_None;
  double *dx = NULL;
  npy_intp dx_Dims[1] = {-1};
  const int dx_Rank = 1;
  PyArrayObject *capi_dx_tmp = NULL;
  int capi_dx_intent = 0;
  PyObject *dx_capi = Py_None;
  int incx = 0;
  PyObject *incx_capi = Py_None;
  double *dy = NULL;
  npy_intp dy_Dims[1] = {-1};
  const int dy_Rank = 1;
  PyArrayObject *capi_dy_tmp = NULL;
  int capi_dy_intent = 0;
  PyObject *dy_capi = Py_None;
  int incy = 0;
  PyObject *incy_capi = Py_None;
  static char *capi_kwlist[] = {"n","dx","incx","dy","incy",NULL};

/*routdebugenter*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_clock();
#endif
  if (!PyArg_ParseTupleAndKeywords(capi_args,capi_keywds,\
    "OOOOO:linalg_utils.dswap",\
    capi_kwlist,&n_capi,&dx_capi,&incx_capi,&dy_capi,&incy_capi))
    return NULL;
/*frompyobj*/
  /* Processing variable incx */
    f2py_success = int_from_pyobj(&incx,incx_capi,"linalg_utils.dswap() 3rd argument (incx) can't be converted to int");
  if (f2py_success) {
  /* Processing variable incy */
    f2py_success = int_from_pyobj(&incy,incy_capi,"linalg_utils.dswap() 5th argument (incy) can't be converted to int");
  if (f2py_success) {
  /* Processing variable n */
    f2py_success = int_from_pyobj(&n,n_capi,"linalg_utils.dswap() 1st argument (n) can't be converted to int");
  if (f2py_success) {
  /* Processing variable dx */
  ;
  capi_dx_intent |= F2PY_INTENT_IN;
  capi_dx_tmp = array_from_pyobj(NPY_DOUBLE,dx_Dims,dx_Rank,capi_dx_intent,dx_capi);
  if (capi_dx_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 2nd argument `dx' of linalg_utils.dswap to C/Fortran array" );
  } else {
    dx = (double *)(capi_dx_tmp->data);

  /* Processing variable dy */
  ;
  capi_dy_intent |= F2PY_INTENT_IN;
  capi_dy_tmp = array_from_pyobj(NPY_DOUBLE,dy_Dims,dy_Rank,capi_dy_intent,dy_capi);
  if (capi_dy_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 4th argument `dy' of linalg_utils.dswap to C/Fortran array" );
  } else {
    dy = (double *)(capi_dy_tmp->data);

/*end of frompyobj*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_call_clock();
#endif
/*callfortranroutine*/
        (*f2py_func)(&n,dx,&incx,dy,&incy);
if (PyErr_Occurred())
  f2py_success = 0;
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_call_clock();
#endif
/*end of callfortranroutine*/
    if (f2py_success) {
/*pyobjfrom*/
/*end of pyobjfrom*/
    CFUNCSMESS("Building return value.\n");
    capi_buildvalue = Py_BuildValue("");
/*closepyobjfrom*/
/*end of closepyobjfrom*/
    } /*if (f2py_success) after callfortranroutine*/
/*cleanupfrompyobj*/
  if((PyObject *)capi_dy_tmp!=dy_capi) {
    Py_XDECREF(capi_dy_tmp); }
  }  /*if (capi_dy_tmp == NULL) ... else of dy*/
  /* End of cleaning variable dy */
  if((PyObject *)capi_dx_tmp!=dx_capi) {
    Py_XDECREF(capi_dx_tmp); }
  }  /*if (capi_dx_tmp == NULL) ... else of dx*/
  /* End of cleaning variable dx */
  } /*if (f2py_success) of n*/
  /* End of cleaning variable n */
  } /*if (f2py_success) of incy*/
  /* End of cleaning variable incy */
  } /*if (f2py_success) of incx*/
  /* End of cleaning variable incx */
/*end of cleanupfrompyobj*/
  if (capi_buildvalue == NULL) {
/*routdebugfailure*/
  } else {
/*routdebugleave*/
  }
  CFUNCSMESS("Freeing memory.\n");
/*freemem*/
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_clock();
#endif
  return capi_buildvalue;
}
/******************************** end of dswap ********************************/

/*********************************** dspr2 ***********************************/
static char doc_f2py_rout_linalg_utils_dspr2[] = "\
dspr2(uplo,n,alpha,x,incx,y,incy,ap)\n\nWrapper for ``dspr2``.\
\n\nParameters\n----------\n"
"uplo : input string(len=1)\n"
"n : input int\n"
"alpha : input float\n"
"x : input rank-1 array('d') with bounds (*)\n"
"incx : input int\n"
"y : input rank-1 array('d') with bounds (*)\n"
"incy : input int\n"
"ap : input rank-1 array('d') with bounds (*)";
/* extern void F_FUNC(dspr2,DSPR2)(string,int*,double*,double*,int*,double*,int*,double*,size_t); */
static PyObject *f2py_rout_linalg_utils_dspr2(const PyObject *capi_self,
                           PyObject *capi_args,
                           PyObject *capi_keywds,
                           void (*f2py_func)(string,int*,double*,double*,int*,double*,int*,double*,size_t)) {
  PyObject * volatile capi_buildvalue = NULL;
  volatile int f2py_success = 1;
/*decl*/

  string uplo = NULL;
  int slen(uplo);
  PyObject *uplo_capi = Py_None;
  int n = 0;
  PyObject *n_capi = Py_None;
  double alpha = 0;
  PyObject *alpha_capi = Py_None;
  double *x = NULL;
  npy_intp x_Dims[1] = {-1};
  const int x_Rank = 1;
  PyArrayObject *capi_x_tmp = NULL;
  int capi_x_intent = 0;
  PyObject *x_capi = Py_None;
  int incx = 0;
  PyObject *incx_capi = Py_None;
  double *y = NULL;
  npy_intp y_Dims[1] = {-1};
  const int y_Rank = 1;
  PyArrayObject *capi_y_tmp = NULL;
  int capi_y_intent = 0;
  PyObject *y_capi = Py_None;
  int incy = 0;
  PyObject *incy_capi = Py_None;
  double *ap = NULL;
  npy_intp ap_Dims[1] = {-1};
  const int ap_Rank = 1;
  PyArrayObject *capi_ap_tmp = NULL;
  int capi_ap_intent = 0;
  PyObject *ap_capi = Py_None;
  static char *capi_kwlist[] = {"uplo","n","alpha","x","incx","y","incy","ap",NULL};

/*routdebugenter*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_clock();
#endif
  if (!PyArg_ParseTupleAndKeywords(capi_args,capi_keywds,\
    "OOOOOOOO:linalg_utils.dspr2",\
    capi_kwlist,&uplo_capi,&n_capi,&alpha_capi,&x_capi,&incx_capi,&y_capi,&incy_capi,&ap_capi))
    return NULL;
/*frompyobj*/
  /* Processing variable uplo */
  slen(uplo) = 1;
  f2py_success = string_from_pyobj(&uplo,&slen(uplo),"",uplo_capi,"string_from_pyobj failed in converting 1st argument `uplo' of linalg_utils.dspr2 to C string");
  if (f2py_success) {
  /* Processing variable alpha */
    f2py_success = double_from_pyobj(&alpha,alpha_capi,"linalg_utils.dspr2() 3rd argument (alpha) can't be converted to double");
  if (f2py_success) {
  /* Processing variable ap */
  ;
  capi_ap_intent |= F2PY_INTENT_IN;
  capi_ap_tmp = array_from_pyobj(NPY_DOUBLE,ap_Dims,ap_Rank,capi_ap_intent,ap_capi);
  if (capi_ap_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 8th argument `ap' of linalg_utils.dspr2 to C/Fortran array" );
  } else {
    ap = (double *)(capi_ap_tmp->data);

  /* Processing variable incx */
    f2py_success = int_from_pyobj(&incx,incx_capi,"linalg_utils.dspr2() 5th argument (incx) can't be converted to int");
  if (f2py_success) {
  /* Processing variable incy */
    f2py_success = int_from_pyobj(&incy,incy_capi,"linalg_utils.dspr2() 7th argument (incy) can't be converted to int");
  if (f2py_success) {
  /* Processing variable n */
    f2py_success = int_from_pyobj(&n,n_capi,"linalg_utils.dspr2() 2nd argument (n) can't be converted to int");
  if (f2py_success) {
  /* Processing variable y */
  ;
  capi_y_intent |= F2PY_INTENT_IN;
  capi_y_tmp = array_from_pyobj(NPY_DOUBLE,y_Dims,y_Rank,capi_y_intent,y_capi);
  if (capi_y_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 6th argument `y' of linalg_utils.dspr2 to C/Fortran array" );
  } else {
    y = (double *)(capi_y_tmp->data);

  /* Processing variable x */
  ;
  capi_x_intent |= F2PY_INTENT_IN;
  capi_x_tmp = array_from_pyobj(NPY_DOUBLE,x_Dims,x_Rank,capi_x_intent,x_capi);
  if (capi_x_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 4th argument `x' of linalg_utils.dspr2 to C/Fortran array" );
  } else {
    x = (double *)(capi_x_tmp->data);

/*end of frompyobj*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_call_clock();
#endif
/*callfortranroutine*/
        (*f2py_func)(uplo,&n,&alpha,x,&incx,y,&incy,ap,slen(uplo));
if (PyErr_Occurred())
  f2py_success = 0;
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_call_clock();
#endif
/*end of callfortranroutine*/
    if (f2py_success) {
/*pyobjfrom*/
/*end of pyobjfrom*/
    CFUNCSMESS("Building return value.\n");
    capi_buildvalue = Py_BuildValue("");
/*closepyobjfrom*/
/*end of closepyobjfrom*/
    } /*if (f2py_success) after callfortranroutine*/
/*cleanupfrompyobj*/
  if((PyObject *)capi_x_tmp!=x_capi) {
    Py_XDECREF(capi_x_tmp); }
  }  /*if (capi_x_tmp == NULL) ... else of x*/
  /* End of cleaning variable x */
  if((PyObject *)capi_y_tmp!=y_capi) {
    Py_XDECREF(capi_y_tmp); }
  }  /*if (capi_y_tmp == NULL) ... else of y*/
  /* End of cleaning variable y */
  } /*if (f2py_success) of n*/
  /* End of cleaning variable n */
  } /*if (f2py_success) of incy*/
  /* End of cleaning variable incy */
  } /*if (f2py_success) of incx*/
  /* End of cleaning variable incx */
  if((PyObject *)capi_ap_tmp!=ap_capi) {
    Py_XDECREF(capi_ap_tmp); }
  }  /*if (capi_ap_tmp == NULL) ... else of ap*/
  /* End of cleaning variable ap */
  } /*if (f2py_success) of alpha*/
  /* End of cleaning variable alpha */
    STRINGFREE(uplo);
  }  /*if (f2py_success) of uplo*/
  /* End of cleaning variable uplo */
/*end of cleanupfrompyobj*/
  if (capi_buildvalue == NULL) {
/*routdebugfailure*/
  } else {
/*routdebugleave*/
  }
  CFUNCSMESS("Freeing memory.\n");
/*freemem*/
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_clock();
#endif
  return capi_buildvalue;
}
/******************************** end of dspr2 ********************************/

/************************************ dspr ************************************/
static char doc_f2py_rout_linalg_utils_dspr[] = "\
dspr(uplo,n,alpha,x,incx,ap)\n\nWrapper for ``dspr``.\
\n\nParameters\n----------\n"
"uplo : input string(len=1)\n"
"n : input int\n"
"alpha : input float\n"
"x : input rank-1 array('d') with bounds (*)\n"
"incx : input int\n"
"ap : input rank-1 array('d') with bounds (*)";
/* extern void F_FUNC(dspr,DSPR)(string,int*,double*,double*,int*,double*,size_t); */
static PyObject *f2py_rout_linalg_utils_dspr(const PyObject *capi_self,
                           PyObject *capi_args,
                           PyObject *capi_keywds,
                           void (*f2py_func)(string,int*,double*,double*,int*,double*,size_t)) {
  PyObject * volatile capi_buildvalue = NULL;
  volatile int f2py_success = 1;
/*decl*/

  string uplo = NULL;
  int slen(uplo);
  PyObject *uplo_capi = Py_None;
  int n = 0;
  PyObject *n_capi = Py_None;
  double alpha = 0;
  PyObject *alpha_capi = Py_None;
  double *x = NULL;
  npy_intp x_Dims[1] = {-1};
  const int x_Rank = 1;
  PyArrayObject *capi_x_tmp = NULL;
  int capi_x_intent = 0;
  PyObject *x_capi = Py_None;
  int incx = 0;
  PyObject *incx_capi = Py_None;
  double *ap = NULL;
  npy_intp ap_Dims[1] = {-1};
  const int ap_Rank = 1;
  PyArrayObject *capi_ap_tmp = NULL;
  int capi_ap_intent = 0;
  PyObject *ap_capi = Py_None;
  static char *capi_kwlist[] = {"uplo","n","alpha","x","incx","ap",NULL};

/*routdebugenter*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_clock();
#endif
  if (!PyArg_ParseTupleAndKeywords(capi_args,capi_keywds,\
    "OOOOOO:linalg_utils.dspr",\
    capi_kwlist,&uplo_capi,&n_capi,&alpha_capi,&x_capi,&incx_capi,&ap_capi))
    return NULL;
/*frompyobj*/
  /* Processing variable uplo */
  slen(uplo) = 1;
  f2py_success = string_from_pyobj(&uplo,&slen(uplo),"",uplo_capi,"string_from_pyobj failed in converting 1st argument `uplo' of linalg_utils.dspr to C string");
  if (f2py_success) {
  /* Processing variable ap */
  ;
  capi_ap_intent |= F2PY_INTENT_IN;
  capi_ap_tmp = array_from_pyobj(NPY_DOUBLE,ap_Dims,ap_Rank,capi_ap_intent,ap_capi);
  if (capi_ap_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 6th argument `ap' of linalg_utils.dspr to C/Fortran array" );
  } else {
    ap = (double *)(capi_ap_tmp->data);

  /* Processing variable alpha */
    f2py_success = double_from_pyobj(&alpha,alpha_capi,"linalg_utils.dspr() 3rd argument (alpha) can't be converted to double");
  if (f2py_success) {
  /* Processing variable n */
    f2py_success = int_from_pyobj(&n,n_capi,"linalg_utils.dspr() 2nd argument (n) can't be converted to int");
  if (f2py_success) {
  /* Processing variable incx */
    f2py_success = int_from_pyobj(&incx,incx_capi,"linalg_utils.dspr() 5th argument (incx) can't be converted to int");
  if (f2py_success) {
  /* Processing variable x */
  ;
  capi_x_intent |= F2PY_INTENT_IN;
  capi_x_tmp = array_from_pyobj(NPY_DOUBLE,x_Dims,x_Rank,capi_x_intent,x_capi);
  if (capi_x_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 4th argument `x' of linalg_utils.dspr to C/Fortran array" );
  } else {
    x = (double *)(capi_x_tmp->data);

/*end of frompyobj*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_call_clock();
#endif
/*callfortranroutine*/
        (*f2py_func)(uplo,&n,&alpha,x,&incx,ap,slen(uplo));
if (PyErr_Occurred())
  f2py_success = 0;
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_call_clock();
#endif
/*end of callfortranroutine*/
    if (f2py_success) {
/*pyobjfrom*/
/*end of pyobjfrom*/
    CFUNCSMESS("Building return value.\n");
    capi_buildvalue = Py_BuildValue("");
/*closepyobjfrom*/
/*end of closepyobjfrom*/
    } /*if (f2py_success) after callfortranroutine*/
/*cleanupfrompyobj*/
  if((PyObject *)capi_x_tmp!=x_capi) {
    Py_XDECREF(capi_x_tmp); }
  }  /*if (capi_x_tmp == NULL) ... else of x*/
  /* End of cleaning variable x */
  } /*if (f2py_success) of incx*/
  /* End of cleaning variable incx */
  } /*if (f2py_success) of n*/
  /* End of cleaning variable n */
  } /*if (f2py_success) of alpha*/
  /* End of cleaning variable alpha */
  if((PyObject *)capi_ap_tmp!=ap_capi) {
    Py_XDECREF(capi_ap_tmp); }
  }  /*if (capi_ap_tmp == NULL) ... else of ap*/
  /* End of cleaning variable ap */
    STRINGFREE(uplo);
  }  /*if (f2py_success) of uplo*/
  /* End of cleaning variable uplo */
/*end of cleanupfrompyobj*/
  if (capi_buildvalue == NULL) {
/*routdebugfailure*/
  } else {
/*routdebugleave*/
  }
  CFUNCSMESS("Freeing memory.\n");
/*freemem*/
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_clock();
#endif
  return capi_buildvalue;
}
/******************************** end of dspr ********************************/

/*********************************** dspmv ***********************************/
static char doc_f2py_rout_linalg_utils_dspmv[] = "\
dspmv(uplo,n,alpha,ap,x,incx,beta,y,incy)\n\nWrapper for ``dspmv``.\
\n\nParameters\n----------\n"
"uplo : input string(len=1)\n"
"n : input int\n"
"alpha : input float\n"
"ap : input rank-1 array('d') with bounds (*)\n"
"x : input rank-1 array('d') with bounds (*)\n"
"incx : input int\n"
"beta : input float\n"
"y : input rank-1 array('d') with bounds (*)\n"
"incy : input int";
/* extern void F_FUNC(dspmv,DSPMV)(string,int*,double*,double*,double*,int*,double*,double*,int*,size_t); */
static PyObject *f2py_rout_linalg_utils_dspmv(const PyObject *capi_self,
                           PyObject *capi_args,
                           PyObject *capi_keywds,
                           void (*f2py_func)(string,int*,double*,double*,double*,int*,double*,double*,int*,size_t)) {
  PyObject * volatile capi_buildvalue = NULL;
  volatile int f2py_success = 1;
/*decl*/

  string uplo = NULL;
  int slen(uplo);
  PyObject *uplo_capi = Py_None;
  int n = 0;
  PyObject *n_capi = Py_None;
  double alpha = 0;
  PyObject *alpha_capi = Py_None;
  double *ap = NULL;
  npy_intp ap_Dims[1] = {-1};
  const int ap_Rank = 1;
  PyArrayObject *capi_ap_tmp = NULL;
  int capi_ap_intent = 0;
  PyObject *ap_capi = Py_None;
  double *x = NULL;
  npy_intp x_Dims[1] = {-1};
  const int x_Rank = 1;
  PyArrayObject *capi_x_tmp = NULL;
  int capi_x_intent = 0;
  PyObject *x_capi = Py_None;
  int incx = 0;
  PyObject *incx_capi = Py_None;
  double beta = 0;
  PyObject *beta_capi = Py_None;
  double *y = NULL;
  npy_intp y_Dims[1] = {-1};
  const int y_Rank = 1;
  PyArrayObject *capi_y_tmp = NULL;
  int capi_y_intent = 0;
  PyObject *y_capi = Py_None;
  int incy = 0;
  PyObject *incy_capi = Py_None;
  static char *capi_kwlist[] = {"uplo","n","alpha","ap","x","incx","beta","y","incy",NULL};

/*routdebugenter*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_clock();
#endif
  if (!PyArg_ParseTupleAndKeywords(capi_args,capi_keywds,\
    "OOOOOOOOO:linalg_utils.dspmv",\
    capi_kwlist,&uplo_capi,&n_capi,&alpha_capi,&ap_capi,&x_capi,&incx_capi,&beta_capi,&y_capi,&incy_capi))
    return NULL;
/*frompyobj*/
  /* Processing variable uplo */
  slen(uplo) = 1;
  f2py_success = string_from_pyobj(&uplo,&slen(uplo),"",uplo_capi,"string_from_pyobj failed in converting 1st argument `uplo' of linalg_utils.dspmv to C string");
  if (f2py_success) {
  /* Processing variable ap */
  ;
  capi_ap_intent |= F2PY_INTENT_IN;
  capi_ap_tmp = array_from_pyobj(NPY_DOUBLE,ap_Dims,ap_Rank,capi_ap_intent,ap_capi);
  if (capi_ap_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 4th argument `ap' of linalg_utils.dspmv to C/Fortran array" );
  } else {
    ap = (double *)(capi_ap_tmp->data);

  /* Processing variable alpha */
    f2py_success = double_from_pyobj(&alpha,alpha_capi,"linalg_utils.dspmv() 3rd argument (alpha) can't be converted to double");
  if (f2py_success) {
  /* Processing variable incx */
    f2py_success = int_from_pyobj(&incx,incx_capi,"linalg_utils.dspmv() 6th argument (incx) can't be converted to int");
  if (f2py_success) {
  /* Processing variable incy */
    f2py_success = int_from_pyobj(&incy,incy_capi,"linalg_utils.dspmv() 9th argument (incy) can't be converted to int");
  if (f2py_success) {
  /* Processing variable beta */
    f2py_success = double_from_pyobj(&beta,beta_capi,"linalg_utils.dspmv() 7th argument (beta) can't be converted to double");
  if (f2py_success) {
  /* Processing variable n */
    f2py_success = int_from_pyobj(&n,n_capi,"linalg_utils.dspmv() 2nd argument (n) can't be converted to int");
  if (f2py_success) {
  /* Processing variable y */
  ;
  capi_y_intent |= F2PY_INTENT_IN;
  capi_y_tmp = array_from_pyobj(NPY_DOUBLE,y_Dims,y_Rank,capi_y_intent,y_capi);
  if (capi_y_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 8th argument `y' of linalg_utils.dspmv to C/Fortran array" );
  } else {
    y = (double *)(capi_y_tmp->data);

  /* Processing variable x */
  ;
  capi_x_intent |= F2PY_INTENT_IN;
  capi_x_tmp = array_from_pyobj(NPY_DOUBLE,x_Dims,x_Rank,capi_x_intent,x_capi);
  if (capi_x_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 5th argument `x' of linalg_utils.dspmv to C/Fortran array" );
  } else {
    x = (double *)(capi_x_tmp->data);

/*end of frompyobj*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_call_clock();
#endif
/*callfortranroutine*/
        (*f2py_func)(uplo,&n,&alpha,ap,x,&incx,&beta,y,&incy,slen(uplo));
if (PyErr_Occurred())
  f2py_success = 0;
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_call_clock();
#endif
/*end of callfortranroutine*/
    if (f2py_success) {
/*pyobjfrom*/
/*end of pyobjfrom*/
    CFUNCSMESS("Building return value.\n");
    capi_buildvalue = Py_BuildValue("");
/*closepyobjfrom*/
/*end of closepyobjfrom*/
    } /*if (f2py_success) after callfortranroutine*/
/*cleanupfrompyobj*/
  if((PyObject *)capi_x_tmp!=x_capi) {
    Py_XDECREF(capi_x_tmp); }
  }  /*if (capi_x_tmp == NULL) ... else of x*/
  /* End of cleaning variable x */
  if((PyObject *)capi_y_tmp!=y_capi) {
    Py_XDECREF(capi_y_tmp); }
  }  /*if (capi_y_tmp == NULL) ... else of y*/
  /* End of cleaning variable y */
  } /*if (f2py_success) of n*/
  /* End of cleaning variable n */
  } /*if (f2py_success) of beta*/
  /* End of cleaning variable beta */
  } /*if (f2py_success) of incy*/
  /* End of cleaning variable incy */
  } /*if (f2py_success) of incx*/
  /* End of cleaning variable incx */
  } /*if (f2py_success) of alpha*/
  /* End of cleaning variable alpha */
  if((PyObject *)capi_ap_tmp!=ap_capi) {
    Py_XDECREF(capi_ap_tmp); }
  }  /*if (capi_ap_tmp == NULL) ... else of ap*/
  /* End of cleaning variable ap */
    STRINGFREE(uplo);
  }  /*if (f2py_success) of uplo*/
  /* End of cleaning variable uplo */
/*end of cleanupfrompyobj*/
  if (capi_buildvalue == NULL) {
/*routdebugfailure*/
  } else {
/*routdebugleave*/
  }
  CFUNCSMESS("Freeing memory.\n");
/*freemem*/
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_clock();
#endif
  return capi_buildvalue;
}
/******************************** end of dspmv ********************************/

/*********************************** dsdot ***********************************/
static char doc_f2py_rout_linalg_utils_dsdot[] = "\
dsdot = dsdot(n,sx,incx,sy,incy)\n\nWrapper for ``dsdot``.\
\n\nParameters\n----------\n"
"n : input int\n"
"sx : input rank-1 array('f') with bounds (*)\n"
"incx : input int\n"
"sy : input rank-1 array('f') with bounds (*)\n"
"incy : input int\n"
"\nReturns\n-------\n"
"dsdot : float";
/* extern void F_WRAPPEDFUNC(dsdot,DSDOT)(double*,int*,float*,int*,float*,int*); */
static PyObject *f2py_rout_linalg_utils_dsdot(const PyObject *capi_self,
                           PyObject *capi_args,
                           PyObject *capi_keywds,
                           void (*f2py_func)(double*,int*,float*,int*,float*,int*)) {
  PyObject * volatile capi_buildvalue = NULL;
  volatile int f2py_success = 1;
/*decl*/

  double dsdot = 0;
  int n = 0;
  PyObject *n_capi = Py_None;
  float *sx = NULL;
  npy_intp sx_Dims[1] = {-1};
  const int sx_Rank = 1;
  PyArrayObject *capi_sx_tmp = NULL;
  int capi_sx_intent = 0;
  PyObject *sx_capi = Py_None;
  int incx = 0;
  PyObject *incx_capi = Py_None;
  float *sy = NULL;
  npy_intp sy_Dims[1] = {-1};
  const int sy_Rank = 1;
  PyArrayObject *capi_sy_tmp = NULL;
  int capi_sy_intent = 0;
  PyObject *sy_capi = Py_None;
  int incy = 0;
  PyObject *incy_capi = Py_None;
  static char *capi_kwlist[] = {"n","sx","incx","sy","incy",NULL};

/*routdebugenter*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_clock();
#endif
  if (!PyArg_ParseTupleAndKeywords(capi_args,capi_keywds,\
    "OOOOO:linalg_utils.dsdot",\
    capi_kwlist,&n_capi,&sx_capi,&incx_capi,&sy_capi,&incy_capi))
    return NULL;
/*frompyobj*/
  /* Processing variable sy */
  ;
  capi_sy_intent |= F2PY_INTENT_IN;
  capi_sy_tmp = array_from_pyobj(NPY_FLOAT,sy_Dims,sy_Rank,capi_sy_intent,sy_capi);
  if (capi_sy_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 4th argument `sy' of linalg_utils.dsdot to C/Fortran array" );
  } else {
    sy = (float *)(capi_sy_tmp->data);

  /* Processing variable sx */
  ;
  capi_sx_intent |= F2PY_INTENT_IN;
  capi_sx_tmp = array_from_pyobj(NPY_FLOAT,sx_Dims,sx_Rank,capi_sx_intent,sx_capi);
  if (capi_sx_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 2nd argument `sx' of linalg_utils.dsdot to C/Fortran array" );
  } else {
    sx = (float *)(capi_sx_tmp->data);

  /* Processing variable incx */
    f2py_success = int_from_pyobj(&incx,incx_capi,"linalg_utils.dsdot() 3rd argument (incx) can't be converted to int");
  if (f2py_success) {
  /* Processing variable incy */
    f2py_success = int_from_pyobj(&incy,incy_capi,"linalg_utils.dsdot() 5th argument (incy) can't be converted to int");
  if (f2py_success) {
  /* Processing variable n */
    f2py_success = int_from_pyobj(&n,n_capi,"linalg_utils.dsdot() 1st argument (n) can't be converted to int");
  if (f2py_success) {
  /* Processing variable dsdot */
/*end of frompyobj*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_call_clock();
#endif
/*callfortranroutine*/
  (*f2py_func)(&dsdot,&n,sx,&incx,sy,&incy);
if (PyErr_Occurred())
  f2py_success = 0;
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_call_clock();
#endif
/*end of callfortranroutine*/
    if (f2py_success) {
/*pyobjfrom*/
/*end of pyobjfrom*/
    CFUNCSMESS("Building return value.\n");
    capi_buildvalue = Py_BuildValue("d",dsdot);
/*closepyobjfrom*/
/*end of closepyobjfrom*/
    } /*if (f2py_success) after callfortranroutine*/
/*cleanupfrompyobj*/
  /* End of cleaning variable dsdot */
  } /*if (f2py_success) of n*/
  /* End of cleaning variable n */
  } /*if (f2py_success) of incy*/
  /* End of cleaning variable incy */
  } /*if (f2py_success) of incx*/
  /* End of cleaning variable incx */
  if((PyObject *)capi_sx_tmp!=sx_capi) {
    Py_XDECREF(capi_sx_tmp); }
  }  /*if (capi_sx_tmp == NULL) ... else of sx*/
  /* End of cleaning variable sx */
  if((PyObject *)capi_sy_tmp!=sy_capi) {
    Py_XDECREF(capi_sy_tmp); }
  }  /*if (capi_sy_tmp == NULL) ... else of sy*/
  /* End of cleaning variable sy */
/*end of cleanupfrompyobj*/
  if (capi_buildvalue == NULL) {
/*routdebugfailure*/
  } else {
/*routdebugleave*/
  }
  CFUNCSMESS("Freeing memory.\n");
/*freemem*/
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_clock();
#endif
  return capi_buildvalue;
}
/******************************** end of dsdot ********************************/

/*********************************** dscal ***********************************/
static char doc_f2py_rout_linalg_utils_dscal[] = "\
dscal(n,da,dx,incx)\n\nWrapper for ``dscal``.\
\n\nParameters\n----------\n"
"n : input int\n"
"da : input float\n"
"dx : input rank-1 array('d') with bounds (*)\n"
"incx : input int";
/* extern void F_FUNC(dscal,DSCAL)(int*,double*,double*,int*); */
static PyObject *f2py_rout_linalg_utils_dscal(const PyObject *capi_self,
                           PyObject *capi_args,
                           PyObject *capi_keywds,
                           void (*f2py_func)(int*,double*,double*,int*)) {
  PyObject * volatile capi_buildvalue = NULL;
  volatile int f2py_success = 1;
/*decl*/

  int n = 0;
  PyObject *n_capi = Py_None;
  double da = 0;
  PyObject *da_capi = Py_None;
  double *dx = NULL;
  npy_intp dx_Dims[1] = {-1};
  const int dx_Rank = 1;
  PyArrayObject *capi_dx_tmp = NULL;
  int capi_dx_intent = 0;
  PyObject *dx_capi = Py_None;
  int incx = 0;
  PyObject *incx_capi = Py_None;
  static char *capi_kwlist[] = {"n","da","dx","incx",NULL};

/*routdebugenter*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_clock();
#endif
  if (!PyArg_ParseTupleAndKeywords(capi_args,capi_keywds,\
    "OOOO:linalg_utils.dscal",\
    capi_kwlist,&n_capi,&da_capi,&dx_capi,&incx_capi))
    return NULL;
/*frompyobj*/
  /* Processing variable incx */
    f2py_success = int_from_pyobj(&incx,incx_capi,"linalg_utils.dscal() 4th argument (incx) can't be converted to int");
  if (f2py_success) {
  /* Processing variable n */
    f2py_success = int_from_pyobj(&n,n_capi,"linalg_utils.dscal() 1st argument (n) can't be converted to int");
  if (f2py_success) {
  /* Processing variable dx */
  ;
  capi_dx_intent |= F2PY_INTENT_IN;
  capi_dx_tmp = array_from_pyobj(NPY_DOUBLE,dx_Dims,dx_Rank,capi_dx_intent,dx_capi);
  if (capi_dx_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 3rd argument `dx' of linalg_utils.dscal to C/Fortran array" );
  } else {
    dx = (double *)(capi_dx_tmp->data);

  /* Processing variable da */
    f2py_success = double_from_pyobj(&da,da_capi,"linalg_utils.dscal() 2nd argument (da) can't be converted to double");
  if (f2py_success) {
/*end of frompyobj*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_call_clock();
#endif
/*callfortranroutine*/
        (*f2py_func)(&n,&da,dx,&incx);
if (PyErr_Occurred())
  f2py_success = 0;
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_call_clock();
#endif
/*end of callfortranroutine*/
    if (f2py_success) {
/*pyobjfrom*/
/*end of pyobjfrom*/
    CFUNCSMESS("Building return value.\n");
    capi_buildvalue = Py_BuildValue("");
/*closepyobjfrom*/
/*end of closepyobjfrom*/
    } /*if (f2py_success) after callfortranroutine*/
/*cleanupfrompyobj*/
  } /*if (f2py_success) of da*/
  /* End of cleaning variable da */
  if((PyObject *)capi_dx_tmp!=dx_capi) {
    Py_XDECREF(capi_dx_tmp); }
  }  /*if (capi_dx_tmp == NULL) ... else of dx*/
  /* End of cleaning variable dx */
  } /*if (f2py_success) of n*/
  /* End of cleaning variable n */
  } /*if (f2py_success) of incx*/
  /* End of cleaning variable incx */
/*end of cleanupfrompyobj*/
  if (capi_buildvalue == NULL) {
/*routdebugfailure*/
  } else {
/*routdebugleave*/
  }
  CFUNCSMESS("Freeing memory.\n");
/*freemem*/
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_clock();
#endif
  return capi_buildvalue;
}
/******************************** end of dscal ********************************/

/*********************************** dsbmv ***********************************/
static char doc_f2py_rout_linalg_utils_dsbmv[] = "\
dsbmv(uplo,n,k,alpha,a,x,incx,beta,y,incy,[lda])\n\nWrapper for ``dsbmv``.\
\n\nParameters\n----------\n"
"uplo : input string(len=1)\n"
"n : input int\n"
"k : input int\n"
"alpha : input float\n"
"a : input rank-2 array('d') with bounds (lda,*)\n"
"x : input rank-1 array('d') with bounds (*)\n"
"incx : input int\n"
"beta : input float\n"
"y : input rank-1 array('d') with bounds (*)\n"
"incy : input int\n"
"\nOther Parameters\n----------------\n"
"lda : input int, optional\n    Default: shape(a,0)";
/* extern void F_FUNC(dsbmv,DSBMV)(string,int*,int*,double*,double*,int*,double*,int*,double*,double*,int*,size_t); */
static PyObject *f2py_rout_linalg_utils_dsbmv(const PyObject *capi_self,
                           PyObject *capi_args,
                           PyObject *capi_keywds,
                           void (*f2py_func)(string,int*,int*,double*,double*,int*,double*,int*,double*,double*,int*,size_t)) {
  PyObject * volatile capi_buildvalue = NULL;
  volatile int f2py_success = 1;
/*decl*/

  string uplo = NULL;
  int slen(uplo);
  PyObject *uplo_capi = Py_None;
  int n = 0;
  PyObject *n_capi = Py_None;
  int k = 0;
  PyObject *k_capi = Py_None;
  double alpha = 0;
  PyObject *alpha_capi = Py_None;
  double *a = NULL;
  npy_intp a_Dims[2] = {-1, -1};
  const int a_Rank = 2;
  PyArrayObject *capi_a_tmp = NULL;
  int capi_a_intent = 0;
  PyObject *a_capi = Py_None;
  int lda = 0;
  PyObject *lda_capi = Py_None;
  double *x = NULL;
  npy_intp x_Dims[1] = {-1};
  const int x_Rank = 1;
  PyArrayObject *capi_x_tmp = NULL;
  int capi_x_intent = 0;
  PyObject *x_capi = Py_None;
  int incx = 0;
  PyObject *incx_capi = Py_None;
  double beta = 0;
  PyObject *beta_capi = Py_None;
  double *y = NULL;
  npy_intp y_Dims[1] = {-1};
  const int y_Rank = 1;
  PyArrayObject *capi_y_tmp = NULL;
  int capi_y_intent = 0;
  PyObject *y_capi = Py_None;
  int incy = 0;
  PyObject *incy_capi = Py_None;
  static char *capi_kwlist[] = {"uplo","n","k","alpha","a","x","incx","beta","y","incy","lda",NULL};

/*routdebugenter*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_clock();
#endif
  if (!PyArg_ParseTupleAndKeywords(capi_args,capi_keywds,\
    "OOOOOOOOOO|O:linalg_utils.dsbmv",\
    capi_kwlist,&uplo_capi,&n_capi,&k_capi,&alpha_capi,&a_capi,&x_capi,&incx_capi,&beta_capi,&y_capi,&incy_capi,&lda_capi))
    return NULL;
/*frompyobj*/
  /* Processing variable uplo */
  slen(uplo) = 1;
  f2py_success = string_from_pyobj(&uplo,&slen(uplo),"",uplo_capi,"string_from_pyobj failed in converting 1st argument `uplo' of linalg_utils.dsbmv to C string");
  if (f2py_success) {
  /* Processing variable a */
  ;
  capi_a_intent |= F2PY_INTENT_IN;
  capi_a_tmp = array_from_pyobj(NPY_DOUBLE,a_Dims,a_Rank,capi_a_intent,a_capi);
  if (capi_a_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 5th argument `a' of linalg_utils.dsbmv to C/Fortran array" );
  } else {
    a = (double *)(capi_a_tmp->data);

  /* Processing variable alpha */
    f2py_success = double_from_pyobj(&alpha,alpha_capi,"linalg_utils.dsbmv() 4th argument (alpha) can't be converted to double");
  if (f2py_success) {
  /* Processing variable incx */
    f2py_success = int_from_pyobj(&incx,incx_capi,"linalg_utils.dsbmv() 7th argument (incx) can't be converted to int");
  if (f2py_success) {
  /* Processing variable incy */
    f2py_success = int_from_pyobj(&incy,incy_capi,"linalg_utils.dsbmv() 10th argument (incy) can't be converted to int");
  if (f2py_success) {
  /* Processing variable k */
    f2py_success = int_from_pyobj(&k,k_capi,"linalg_utils.dsbmv() 3rd argument (k) can't be converted to int");
  if (f2py_success) {
  /* Processing variable beta */
    f2py_success = double_from_pyobj(&beta,beta_capi,"linalg_utils.dsbmv() 8th argument (beta) can't be converted to double");
  if (f2py_success) {
  /* Processing variable n */
    f2py_success = int_from_pyobj(&n,n_capi,"linalg_utils.dsbmv() 2nd argument (n) can't be converted to int");
  if (f2py_success) {
  /* Processing variable y */
  ;
  capi_y_intent |= F2PY_INTENT_IN;
  capi_y_tmp = array_from_pyobj(NPY_DOUBLE,y_Dims,y_Rank,capi_y_intent,y_capi);
  if (capi_y_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 9th argument `y' of linalg_utils.dsbmv to C/Fortran array" );
  } else {
    y = (double *)(capi_y_tmp->data);

  /* Processing variable x */
  ;
  capi_x_intent |= F2PY_INTENT_IN;
  capi_x_tmp = array_from_pyobj(NPY_DOUBLE,x_Dims,x_Rank,capi_x_intent,x_capi);
  if (capi_x_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 6th argument `x' of linalg_utils.dsbmv to C/Fortran array" );
  } else {
    x = (double *)(capi_x_tmp->data);

  /* Processing variable lda */
  if (lda_capi == Py_None) lda = shape(a,0); else
    f2py_success = int_from_pyobj(&lda,lda_capi,"linalg_utils.dsbmv() 1st keyword (lda) can't be converted to int");
  if (f2py_success) {
  CHECKSCALAR(shape(a,0)==lda,"shape(a,0)==lda","1st keyword lda","dsbmv:lda=%d",lda) {
/*end of frompyobj*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_call_clock();
#endif
/*callfortranroutine*/
        (*f2py_func)(uplo,&n,&k,&alpha,a,&lda,x,&incx,&beta,y,&incy,slen(uplo));
if (PyErr_Occurred())
  f2py_success = 0;
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_call_clock();
#endif
/*end of callfortranroutine*/
    if (f2py_success) {
/*pyobjfrom*/
/*end of pyobjfrom*/
    CFUNCSMESS("Building return value.\n");
    capi_buildvalue = Py_BuildValue("");
/*closepyobjfrom*/
/*end of closepyobjfrom*/
    } /*if (f2py_success) after callfortranroutine*/
/*cleanupfrompyobj*/
  } /*CHECKSCALAR(shape(a,0)==lda)*/
  } /*if (f2py_success) of lda*/
  /* End of cleaning variable lda */
  if((PyObject *)capi_x_tmp!=x_capi) {
    Py_XDECREF(capi_x_tmp); }
  }  /*if (capi_x_tmp == NULL) ... else of x*/
  /* End of cleaning variable x */
  if((PyObject *)capi_y_tmp!=y_capi) {
    Py_XDECREF(capi_y_tmp); }
  }  /*if (capi_y_tmp == NULL) ... else of y*/
  /* End of cleaning variable y */
  } /*if (f2py_success) of n*/
  /* End of cleaning variable n */
  } /*if (f2py_success) of beta*/
  /* End of cleaning variable beta */
  } /*if (f2py_success) of k*/
  /* End of cleaning variable k */
  } /*if (f2py_success) of incy*/
  /* End of cleaning variable incy */
  } /*if (f2py_success) of incx*/
  /* End of cleaning variable incx */
  } /*if (f2py_success) of alpha*/
  /* End of cleaning variable alpha */
  if((PyObject *)capi_a_tmp!=a_capi) {
    Py_XDECREF(capi_a_tmp); }
  }  /*if (capi_a_tmp == NULL) ... else of a*/
  /* End of cleaning variable a */
    STRINGFREE(uplo);
  }  /*if (f2py_success) of uplo*/
  /* End of cleaning variable uplo */
/*end of cleanupfrompyobj*/
  if (capi_buildvalue == NULL) {
/*routdebugfailure*/
  } else {
/*routdebugleave*/
  }
  CFUNCSMESS("Freeing memory.\n");
/*freemem*/
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_clock();
#endif
  return capi_buildvalue;
}
/******************************** end of dsbmv ********************************/

/*********************************** drotmg ***********************************/
static char doc_f2py_rout_linalg_utils_drotmg[] = "\
drotmg(dd1,dd2,dx1,dy1,dparam)\n\nWrapper for ``drotmg``.\
\n\nParameters\n----------\n"
"dd1 : input float\n"
"dd2 : input float\n"
"dx1 : input float\n"
"dy1 : input float\n"
"dparam : input rank-1 array('d') with bounds (5)";
/* extern void F_FUNC(drotmg,DROTMG)(double*,double*,double*,double*,double*); */
static PyObject *f2py_rout_linalg_utils_drotmg(const PyObject *capi_self,
                           PyObject *capi_args,
                           PyObject *capi_keywds,
                           void (*f2py_func)(double*,double*,double*,double*,double*)) {
  PyObject * volatile capi_buildvalue = NULL;
  volatile int f2py_success = 1;
/*decl*/

  double dd1 = 0;
  PyObject *dd1_capi = Py_None;
  double dd2 = 0;
  PyObject *dd2_capi = Py_None;
  double dx1 = 0;
  PyObject *dx1_capi = Py_None;
  double dy1 = 0;
  PyObject *dy1_capi = Py_None;
  double *dparam = NULL;
  npy_intp dparam_Dims[1] = {-1};
  const int dparam_Rank = 1;
  PyArrayObject *capi_dparam_tmp = NULL;
  int capi_dparam_intent = 0;
  PyObject *dparam_capi = Py_None;
  static char *capi_kwlist[] = {"dd1","dd2","dx1","dy1","dparam",NULL};

/*routdebugenter*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_clock();
#endif
  if (!PyArg_ParseTupleAndKeywords(capi_args,capi_keywds,\
    "OOOOO:linalg_utils.drotmg",\
    capi_kwlist,&dd1_capi,&dd2_capi,&dx1_capi,&dy1_capi,&dparam_capi))
    return NULL;
/*frompyobj*/
  /* Processing variable dy1 */
    f2py_success = double_from_pyobj(&dy1,dy1_capi,"linalg_utils.drotmg() 4th argument (dy1) can't be converted to double");
  if (f2py_success) {
  /* Processing variable dx1 */
    f2py_success = double_from_pyobj(&dx1,dx1_capi,"linalg_utils.drotmg() 3rd argument (dx1) can't be converted to double");
  if (f2py_success) {
  /* Processing variable dparam */
  dparam_Dims[0]=5;
  capi_dparam_intent |= F2PY_INTENT_IN;
  capi_dparam_tmp = array_from_pyobj(NPY_DOUBLE,dparam_Dims,dparam_Rank,capi_dparam_intent,dparam_capi);
  if (capi_dparam_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 5th argument `dparam' of linalg_utils.drotmg to C/Fortran array" );
  } else {
    dparam = (double *)(capi_dparam_tmp->data);

  /* Processing variable dd2 */
    f2py_success = double_from_pyobj(&dd2,dd2_capi,"linalg_utils.drotmg() 2nd argument (dd2) can't be converted to double");
  if (f2py_success) {
  /* Processing variable dd1 */
    f2py_success = double_from_pyobj(&dd1,dd1_capi,"linalg_utils.drotmg() 1st argument (dd1) can't be converted to double");
  if (f2py_success) {
/*end of frompyobj*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_call_clock();
#endif
/*callfortranroutine*/
        (*f2py_func)(&dd1,&dd2,&dx1,&dy1,dparam);
if (PyErr_Occurred())
  f2py_success = 0;
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_call_clock();
#endif
/*end of callfortranroutine*/
    if (f2py_success) {
/*pyobjfrom*/
/*end of pyobjfrom*/
    CFUNCSMESS("Building return value.\n");
    capi_buildvalue = Py_BuildValue("");
/*closepyobjfrom*/
/*end of closepyobjfrom*/
    } /*if (f2py_success) after callfortranroutine*/
/*cleanupfrompyobj*/
  } /*if (f2py_success) of dd1*/
  /* End of cleaning variable dd1 */
  } /*if (f2py_success) of dd2*/
  /* End of cleaning variable dd2 */
  if((PyObject *)capi_dparam_tmp!=dparam_capi) {
    Py_XDECREF(capi_dparam_tmp); }
  }  /*if (capi_dparam_tmp == NULL) ... else of dparam*/
  /* End of cleaning variable dparam */
  } /*if (f2py_success) of dx1*/
  /* End of cleaning variable dx1 */
  } /*if (f2py_success) of dy1*/
  /* End of cleaning variable dy1 */
/*end of cleanupfrompyobj*/
  if (capi_buildvalue == NULL) {
/*routdebugfailure*/
  } else {
/*routdebugleave*/
  }
  CFUNCSMESS("Freeing memory.\n");
/*freemem*/
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_clock();
#endif
  return capi_buildvalue;
}
/******************************* end of drotmg *******************************/

/*********************************** drotm ***********************************/
static char doc_f2py_rout_linalg_utils_drotm[] = "\
drotm(n,dx,incx,dy,incy,dparam)\n\nWrapper for ``drotm``.\
\n\nParameters\n----------\n"
"n : input int\n"
"dx : input rank-1 array('d') with bounds (1)\n"
"incx : input int\n"
"dy : input rank-1 array('d') with bounds (1)\n"
"incy : input int\n"
"dparam : input rank-1 array('d') with bounds (5)";
/* extern void F_FUNC(drotm,DROTM)(int*,double*,int*,double*,int*,double*); */
static PyObject *f2py_rout_linalg_utils_drotm(const PyObject *capi_self,
                           PyObject *capi_args,
                           PyObject *capi_keywds,
                           void (*f2py_func)(int*,double*,int*,double*,int*,double*)) {
  PyObject * volatile capi_buildvalue = NULL;
  volatile int f2py_success = 1;
/*decl*/

  int n = 0;
  PyObject *n_capi = Py_None;
  double *dx = NULL;
  npy_intp dx_Dims[1] = {-1};
  const int dx_Rank = 1;
  PyArrayObject *capi_dx_tmp = NULL;
  int capi_dx_intent = 0;
  PyObject *dx_capi = Py_None;
  int incx = 0;
  PyObject *incx_capi = Py_None;
  double *dy = NULL;
  npy_intp dy_Dims[1] = {-1};
  const int dy_Rank = 1;
  PyArrayObject *capi_dy_tmp = NULL;
  int capi_dy_intent = 0;
  PyObject *dy_capi = Py_None;
  int incy = 0;
  PyObject *incy_capi = Py_None;
  double *dparam = NULL;
  npy_intp dparam_Dims[1] = {-1};
  const int dparam_Rank = 1;
  PyArrayObject *capi_dparam_tmp = NULL;
  int capi_dparam_intent = 0;
  PyObject *dparam_capi = Py_None;
  static char *capi_kwlist[] = {"n","dx","incx","dy","incy","dparam",NULL};

/*routdebugenter*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_clock();
#endif
  if (!PyArg_ParseTupleAndKeywords(capi_args,capi_keywds,\
    "OOOOOO:linalg_utils.drotm",\
    capi_kwlist,&n_capi,&dx_capi,&incx_capi,&dy_capi,&incy_capi,&dparam_capi))
    return NULL;
/*frompyobj*/
  /* Processing variable dx */
  dx_Dims[0]=1;
  capi_dx_intent |= F2PY_INTENT_IN;
  capi_dx_tmp = array_from_pyobj(NPY_DOUBLE,dx_Dims,dx_Rank,capi_dx_intent,dx_capi);
  if (capi_dx_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 2nd argument `dx' of linalg_utils.drotm to C/Fortran array" );
  } else {
    dx = (double *)(capi_dx_tmp->data);

  /* Processing variable dy */
  dy_Dims[0]=1;
  capi_dy_intent |= F2PY_INTENT_IN;
  capi_dy_tmp = array_from_pyobj(NPY_DOUBLE,dy_Dims,dy_Rank,capi_dy_intent,dy_capi);
  if (capi_dy_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 4th argument `dy' of linalg_utils.drotm to C/Fortran array" );
  } else {
    dy = (double *)(capi_dy_tmp->data);

  /* Processing variable dparam */
  dparam_Dims[0]=5;
  capi_dparam_intent |= F2PY_INTENT_IN;
  capi_dparam_tmp = array_from_pyobj(NPY_DOUBLE,dparam_Dims,dparam_Rank,capi_dparam_intent,dparam_capi);
  if (capi_dparam_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 6th argument `dparam' of linalg_utils.drotm to C/Fortran array" );
  } else {
    dparam = (double *)(capi_dparam_tmp->data);

  /* Processing variable incx */
    f2py_success = int_from_pyobj(&incx,incx_capi,"linalg_utils.drotm() 3rd argument (incx) can't be converted to int");
  if (f2py_success) {
  /* Processing variable incy */
    f2py_success = int_from_pyobj(&incy,incy_capi,"linalg_utils.drotm() 5th argument (incy) can't be converted to int");
  if (f2py_success) {
  /* Processing variable n */
    f2py_success = int_from_pyobj(&n,n_capi,"linalg_utils.drotm() 1st argument (n) can't be converted to int");
  if (f2py_success) {
/*end of frompyobj*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_call_clock();
#endif
/*callfortranroutine*/
        (*f2py_func)(&n,dx,&incx,dy,&incy,dparam);
if (PyErr_Occurred())
  f2py_success = 0;
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_call_clock();
#endif
/*end of callfortranroutine*/
    if (f2py_success) {
/*pyobjfrom*/
/*end of pyobjfrom*/
    CFUNCSMESS("Building return value.\n");
    capi_buildvalue = Py_BuildValue("");
/*closepyobjfrom*/
/*end of closepyobjfrom*/
    } /*if (f2py_success) after callfortranroutine*/
/*cleanupfrompyobj*/
  } /*if (f2py_success) of n*/
  /* End of cleaning variable n */
  } /*if (f2py_success) of incy*/
  /* End of cleaning variable incy */
  } /*if (f2py_success) of incx*/
  /* End of cleaning variable incx */
  if((PyObject *)capi_dparam_tmp!=dparam_capi) {
    Py_XDECREF(capi_dparam_tmp); }
  }  /*if (capi_dparam_tmp == NULL) ... else of dparam*/
  /* End of cleaning variable dparam */
  if((PyObject *)capi_dy_tmp!=dy_capi) {
    Py_XDECREF(capi_dy_tmp); }
  }  /*if (capi_dy_tmp == NULL) ... else of dy*/
  /* End of cleaning variable dy */
  if((PyObject *)capi_dx_tmp!=dx_capi) {
    Py_XDECREF(capi_dx_tmp); }
  }  /*if (capi_dx_tmp == NULL) ... else of dx*/
  /* End of cleaning variable dx */
/*end of cleanupfrompyobj*/
  if (capi_buildvalue == NULL) {
/*routdebugfailure*/
  } else {
/*routdebugleave*/
  }
  CFUNCSMESS("Freeing memory.\n");
/*freemem*/
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_clock();
#endif
  return capi_buildvalue;
}
/******************************** end of drotm ********************************/

/*********************************** drotg ***********************************/
static char doc_f2py_rout_linalg_utils_drotg[] = "\
drotg(da,db,c,s)\n\nWrapper for ``drotg``.\
\n\nParameters\n----------\n"
"da : input float\n"
"db : input float\n"
"c : input float\n"
"s : input float";
/* extern void F_FUNC(drotg,DROTG)(double*,double*,double*,double*); */
static PyObject *f2py_rout_linalg_utils_drotg(const PyObject *capi_self,
                           PyObject *capi_args,
                           PyObject *capi_keywds,
                           void (*f2py_func)(double*,double*,double*,double*)) {
  PyObject * volatile capi_buildvalue = NULL;
  volatile int f2py_success = 1;
/*decl*/

  double da = 0;
  PyObject *da_capi = Py_None;
  double db = 0;
  PyObject *db_capi = Py_None;
  double c = 0;
  PyObject *c_capi = Py_None;
  double s = 0;
  PyObject *s_capi = Py_None;
  static char *capi_kwlist[] = {"da","db","c","s",NULL};

/*routdebugenter*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_clock();
#endif
  if (!PyArg_ParseTupleAndKeywords(capi_args,capi_keywds,\
    "OOOO:linalg_utils.drotg",\
    capi_kwlist,&da_capi,&db_capi,&c_capi,&s_capi))
    return NULL;
/*frompyobj*/
  /* Processing variable c */
    f2py_success = double_from_pyobj(&c,c_capi,"linalg_utils.drotg() 3rd argument (c) can't be converted to double");
  if (f2py_success) {
  /* Processing variable db */
    f2py_success = double_from_pyobj(&db,db_capi,"linalg_utils.drotg() 2nd argument (db) can't be converted to double");
  if (f2py_success) {
  /* Processing variable da */
    f2py_success = double_from_pyobj(&da,da_capi,"linalg_utils.drotg() 1st argument (da) can't be converted to double");
  if (f2py_success) {
  /* Processing variable s */
    f2py_success = double_from_pyobj(&s,s_capi,"linalg_utils.drotg() 4th argument (s) can't be converted to double");
  if (f2py_success) {
/*end of frompyobj*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_call_clock();
#endif
/*callfortranroutine*/
        (*f2py_func)(&da,&db,&c,&s);
if (PyErr_Occurred())
  f2py_success = 0;
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_call_clock();
#endif
/*end of callfortranroutine*/
    if (f2py_success) {
/*pyobjfrom*/
/*end of pyobjfrom*/
    CFUNCSMESS("Building return value.\n");
    capi_buildvalue = Py_BuildValue("");
/*closepyobjfrom*/
/*end of closepyobjfrom*/
    } /*if (f2py_success) after callfortranroutine*/
/*cleanupfrompyobj*/
  } /*if (f2py_success) of s*/
  /* End of cleaning variable s */
  } /*if (f2py_success) of da*/
  /* End of cleaning variable da */
  } /*if (f2py_success) of db*/
  /* End of cleaning variable db */
  } /*if (f2py_success) of c*/
  /* End of cleaning variable c */
/*end of cleanupfrompyobj*/
  if (capi_buildvalue == NULL) {
/*routdebugfailure*/
  } else {
/*routdebugleave*/
  }
  CFUNCSMESS("Freeing memory.\n");
/*freemem*/
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_clock();
#endif
  return capi_buildvalue;
}
/******************************** end of drotg ********************************/

/************************************ drot ************************************/
static char doc_f2py_rout_linalg_utils_drot[] = "\
drot(n,dx,incx,dy,incy,c,s)\n\nWrapper for ``drot``.\
\n\nParameters\n----------\n"
"n : input int\n"
"dx : input rank-1 array('d') with bounds (*)\n"
"incx : input int\n"
"dy : input rank-1 array('d') with bounds (*)\n"
"incy : input int\n"
"c : input float\n"
"s : input float";
/* extern void F_FUNC(drot,DROT)(int*,double*,int*,double*,int*,double*,double*); */
static PyObject *f2py_rout_linalg_utils_drot(const PyObject *capi_self,
                           PyObject *capi_args,
                           PyObject *capi_keywds,
                           void (*f2py_func)(int*,double*,int*,double*,int*,double*,double*)) {
  PyObject * volatile capi_buildvalue = NULL;
  volatile int f2py_success = 1;
/*decl*/

  int n = 0;
  PyObject *n_capi = Py_None;
  double *dx = NULL;
  npy_intp dx_Dims[1] = {-1};
  const int dx_Rank = 1;
  PyArrayObject *capi_dx_tmp = NULL;
  int capi_dx_intent = 0;
  PyObject *dx_capi = Py_None;
  int incx = 0;
  PyObject *incx_capi = Py_None;
  double *dy = NULL;
  npy_intp dy_Dims[1] = {-1};
  const int dy_Rank = 1;
  PyArrayObject *capi_dy_tmp = NULL;
  int capi_dy_intent = 0;
  PyObject *dy_capi = Py_None;
  int incy = 0;
  PyObject *incy_capi = Py_None;
  double c = 0;
  PyObject *c_capi = Py_None;
  double s = 0;
  PyObject *s_capi = Py_None;
  static char *capi_kwlist[] = {"n","dx","incx","dy","incy","c","s",NULL};

/*routdebugenter*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_clock();
#endif
  if (!PyArg_ParseTupleAndKeywords(capi_args,capi_keywds,\
    "OOOOOOO:linalg_utils.drot",\
    capi_kwlist,&n_capi,&dx_capi,&incx_capi,&dy_capi,&incy_capi,&c_capi,&s_capi))
    return NULL;
/*frompyobj*/
  /* Processing variable c */
    f2py_success = double_from_pyobj(&c,c_capi,"linalg_utils.drot() 6th argument (c) can't be converted to double");
  if (f2py_success) {
  /* Processing variable incx */
    f2py_success = int_from_pyobj(&incx,incx_capi,"linalg_utils.drot() 3rd argument (incx) can't be converted to int");
  if (f2py_success) {
  /* Processing variable incy */
    f2py_success = int_from_pyobj(&incy,incy_capi,"linalg_utils.drot() 5th argument (incy) can't be converted to int");
  if (f2py_success) {
  /* Processing variable n */
    f2py_success = int_from_pyobj(&n,n_capi,"linalg_utils.drot() 1st argument (n) can't be converted to int");
  if (f2py_success) {
  /* Processing variable s */
    f2py_success = double_from_pyobj(&s,s_capi,"linalg_utils.drot() 7th argument (s) can't be converted to double");
  if (f2py_success) {
  /* Processing variable dx */
  ;
  capi_dx_intent |= F2PY_INTENT_IN;
  capi_dx_tmp = array_from_pyobj(NPY_DOUBLE,dx_Dims,dx_Rank,capi_dx_intent,dx_capi);
  if (capi_dx_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 2nd argument `dx' of linalg_utils.drot to C/Fortran array" );
  } else {
    dx = (double *)(capi_dx_tmp->data);

  /* Processing variable dy */
  ;
  capi_dy_intent |= F2PY_INTENT_IN;
  capi_dy_tmp = array_from_pyobj(NPY_DOUBLE,dy_Dims,dy_Rank,capi_dy_intent,dy_capi);
  if (capi_dy_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 4th argument `dy' of linalg_utils.drot to C/Fortran array" );
  } else {
    dy = (double *)(capi_dy_tmp->data);

/*end of frompyobj*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_call_clock();
#endif
/*callfortranroutine*/
        (*f2py_func)(&n,dx,&incx,dy,&incy,&c,&s);
if (PyErr_Occurred())
  f2py_success = 0;
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_call_clock();
#endif
/*end of callfortranroutine*/
    if (f2py_success) {
/*pyobjfrom*/
/*end of pyobjfrom*/
    CFUNCSMESS("Building return value.\n");
    capi_buildvalue = Py_BuildValue("");
/*closepyobjfrom*/
/*end of closepyobjfrom*/
    } /*if (f2py_success) after callfortranroutine*/
/*cleanupfrompyobj*/
  if((PyObject *)capi_dy_tmp!=dy_capi) {
    Py_XDECREF(capi_dy_tmp); }
  }  /*if (capi_dy_tmp == NULL) ... else of dy*/
  /* End of cleaning variable dy */
  if((PyObject *)capi_dx_tmp!=dx_capi) {
    Py_XDECREF(capi_dx_tmp); }
  }  /*if (capi_dx_tmp == NULL) ... else of dx*/
  /* End of cleaning variable dx */
  } /*if (f2py_success) of s*/
  /* End of cleaning variable s */
  } /*if (f2py_success) of n*/
  /* End of cleaning variable n */
  } /*if (f2py_success) of incy*/
  /* End of cleaning variable incy */
  } /*if (f2py_success) of incx*/
  /* End of cleaning variable incx */
  } /*if (f2py_success) of c*/
  /* End of cleaning variable c */
/*end of cleanupfrompyobj*/
  if (capi_buildvalue == NULL) {
/*routdebugfailure*/
  } else {
/*routdebugleave*/
  }
  CFUNCSMESS("Freeing memory.\n");
/*freemem*/
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_clock();
#endif
  return capi_buildvalue;
}
/******************************** end of drot ********************************/

/*********************************** dnrm2 ***********************************/
static char doc_f2py_rout_linalg_utils_dnrm2[] = "\
dnrm2 = dnrm2(n,x,incx)\n\nWrapper for ``dnrm2``.\
\n\nParameters\n----------\n"
"n : input int\n"
"x : input rank-1 array('d') with bounds (*)\n"
"incx : input int\n"
"\nReturns\n-------\n"
"dnrm2 : float";
/* extern void F_WRAPPEDFUNC(dnrm2,DNRM2)(double*,int*,double*,int*); */
static PyObject *f2py_rout_linalg_utils_dnrm2(const PyObject *capi_self,
                           PyObject *capi_args,
                           PyObject *capi_keywds,
                           void (*f2py_func)(double*,int*,double*,int*)) {
  PyObject * volatile capi_buildvalue = NULL;
  volatile int f2py_success = 1;
/*decl*/

  double dnrm2 = 0;
  int n = 0;
  PyObject *n_capi = Py_None;
  double *x = NULL;
  npy_intp x_Dims[1] = {-1};
  const int x_Rank = 1;
  PyArrayObject *capi_x_tmp = NULL;
  int capi_x_intent = 0;
  PyObject *x_capi = Py_None;
  int incx = 0;
  PyObject *incx_capi = Py_None;
  static char *capi_kwlist[] = {"n","x","incx",NULL};

/*routdebugenter*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_clock();
#endif
  if (!PyArg_ParseTupleAndKeywords(capi_args,capi_keywds,\
    "OOO:linalg_utils.dnrm2",\
    capi_kwlist,&n_capi,&x_capi,&incx_capi))
    return NULL;
/*frompyobj*/
  /* Processing variable dnrm2 */
  /* Processing variable incx */
    f2py_success = int_from_pyobj(&incx,incx_capi,"linalg_utils.dnrm2() 3rd argument (incx) can't be converted to int");
  if (f2py_success) {
  /* Processing variable x */
  ;
  capi_x_intent |= F2PY_INTENT_IN;
  capi_x_tmp = array_from_pyobj(NPY_DOUBLE,x_Dims,x_Rank,capi_x_intent,x_capi);
  if (capi_x_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 2nd argument `x' of linalg_utils.dnrm2 to C/Fortran array" );
  } else {
    x = (double *)(capi_x_tmp->data);

  /* Processing variable n */
    f2py_success = int_from_pyobj(&n,n_capi,"linalg_utils.dnrm2() 1st argument (n) can't be converted to int");
  if (f2py_success) {
/*end of frompyobj*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_call_clock();
#endif
/*callfortranroutine*/
  (*f2py_func)(&dnrm2,&n,x,&incx);
if (PyErr_Occurred())
  f2py_success = 0;
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_call_clock();
#endif
/*end of callfortranroutine*/
    if (f2py_success) {
/*pyobjfrom*/
/*end of pyobjfrom*/
    CFUNCSMESS("Building return value.\n");
    capi_buildvalue = Py_BuildValue("d",dnrm2);
/*closepyobjfrom*/
/*end of closepyobjfrom*/
    } /*if (f2py_success) after callfortranroutine*/
/*cleanupfrompyobj*/
  } /*if (f2py_success) of n*/
  /* End of cleaning variable n */
  if((PyObject *)capi_x_tmp!=x_capi) {
    Py_XDECREF(capi_x_tmp); }
  }  /*if (capi_x_tmp == NULL) ... else of x*/
  /* End of cleaning variable x */
  } /*if (f2py_success) of incx*/
  /* End of cleaning variable incx */
  /* End of cleaning variable dnrm2 */
/*end of cleanupfrompyobj*/
  if (capi_buildvalue == NULL) {
/*routdebugfailure*/
  } else {
/*routdebugleave*/
  }
  CFUNCSMESS("Freeing memory.\n");
/*freemem*/
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_clock();
#endif
  return capi_buildvalue;
}
/******************************** end of dnrm2 ********************************/

/************************************ dger ************************************/
static char doc_f2py_rout_linalg_utils_dger[] = "\
dger(m,n,alpha,x,incx,y,incy,a,[lda])\n\nWrapper for ``dger``.\
\n\nParameters\n----------\n"
"m : input int\n"
"n : input int\n"
"alpha : input float\n"
"x : input rank-1 array('d') with bounds (*)\n"
"incx : input int\n"
"y : input rank-1 array('d') with bounds (*)\n"
"incy : input int\n"
"a : input rank-2 array('d') with bounds (lda,*)\n"
"\nOther Parameters\n----------------\n"
"lda : input int, optional\n    Default: shape(a,0)";
/* extern void F_FUNC(dger,DGER)(int*,int*,double*,double*,int*,double*,int*,double*,int*); */
static PyObject *f2py_rout_linalg_utils_dger(const PyObject *capi_self,
                           PyObject *capi_args,
                           PyObject *capi_keywds,
                           void (*f2py_func)(int*,int*,double*,double*,int*,double*,int*,double*,int*)) {
  PyObject * volatile capi_buildvalue = NULL;
  volatile int f2py_success = 1;
/*decl*/

  int m = 0;
  PyObject *m_capi = Py_None;
  int n = 0;
  PyObject *n_capi = Py_None;
  double alpha = 0;
  PyObject *alpha_capi = Py_None;
  double *x = NULL;
  npy_intp x_Dims[1] = {-1};
  const int x_Rank = 1;
  PyArrayObject *capi_x_tmp = NULL;
  int capi_x_intent = 0;
  PyObject *x_capi = Py_None;
  int incx = 0;
  PyObject *incx_capi = Py_None;
  double *y = NULL;
  npy_intp y_Dims[1] = {-1};
  const int y_Rank = 1;
  PyArrayObject *capi_y_tmp = NULL;
  int capi_y_intent = 0;
  PyObject *y_capi = Py_None;
  int incy = 0;
  PyObject *incy_capi = Py_None;
  double *a = NULL;
  npy_intp a_Dims[2] = {-1, -1};
  const int a_Rank = 2;
  PyArrayObject *capi_a_tmp = NULL;
  int capi_a_intent = 0;
  PyObject *a_capi = Py_None;
  int lda = 0;
  PyObject *lda_capi = Py_None;
  static char *capi_kwlist[] = {"m","n","alpha","x","incx","y","incy","a","lda",NULL};

/*routdebugenter*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_clock();
#endif
  if (!PyArg_ParseTupleAndKeywords(capi_args,capi_keywds,\
    "OOOOOOOO|O:linalg_utils.dger",\
    capi_kwlist,&m_capi,&n_capi,&alpha_capi,&x_capi,&incx_capi,&y_capi,&incy_capi,&a_capi,&lda_capi))
    return NULL;
/*frompyobj*/
  /* Processing variable alpha */
    f2py_success = double_from_pyobj(&alpha,alpha_capi,"linalg_utils.dger() 3rd argument (alpha) can't be converted to double");
  if (f2py_success) {
  /* Processing variable a */
  ;
  capi_a_intent |= F2PY_INTENT_IN;
  capi_a_tmp = array_from_pyobj(NPY_DOUBLE,a_Dims,a_Rank,capi_a_intent,a_capi);
  if (capi_a_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 8th argument `a' of linalg_utils.dger to C/Fortran array" );
  } else {
    a = (double *)(capi_a_tmp->data);

  /* Processing variable incx */
    f2py_success = int_from_pyobj(&incx,incx_capi,"linalg_utils.dger() 5th argument (incx) can't be converted to int");
  if (f2py_success) {
  /* Processing variable incy */
    f2py_success = int_from_pyobj(&incy,incy_capi,"linalg_utils.dger() 7th argument (incy) can't be converted to int");
  if (f2py_success) {
  /* Processing variable m */
    f2py_success = int_from_pyobj(&m,m_capi,"linalg_utils.dger() 1st argument (m) can't be converted to int");
  if (f2py_success) {
  /* Processing variable n */
    f2py_success = int_from_pyobj(&n,n_capi,"linalg_utils.dger() 2nd argument (n) can't be converted to int");
  if (f2py_success) {
  /* Processing variable y */
  ;
  capi_y_intent |= F2PY_INTENT_IN;
  capi_y_tmp = array_from_pyobj(NPY_DOUBLE,y_Dims,y_Rank,capi_y_intent,y_capi);
  if (capi_y_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 6th argument `y' of linalg_utils.dger to C/Fortran array" );
  } else {
    y = (double *)(capi_y_tmp->data);

  /* Processing variable x */
  ;
  capi_x_intent |= F2PY_INTENT_IN;
  capi_x_tmp = array_from_pyobj(NPY_DOUBLE,x_Dims,x_Rank,capi_x_intent,x_capi);
  if (capi_x_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 4th argument `x' of linalg_utils.dger to C/Fortran array" );
  } else {
    x = (double *)(capi_x_tmp->data);

  /* Processing variable lda */
  if (lda_capi == Py_None) lda = shape(a,0); else
    f2py_success = int_from_pyobj(&lda,lda_capi,"linalg_utils.dger() 1st keyword (lda) can't be converted to int");
  if (f2py_success) {
  CHECKSCALAR(shape(a,0)==lda,"shape(a,0)==lda","1st keyword lda","dger:lda=%d",lda) {
/*end of frompyobj*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_call_clock();
#endif
/*callfortranroutine*/
        (*f2py_func)(&m,&n,&alpha,x,&incx,y,&incy,a,&lda);
if (PyErr_Occurred())
  f2py_success = 0;
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_call_clock();
#endif
/*end of callfortranroutine*/
    if (f2py_success) {
/*pyobjfrom*/
/*end of pyobjfrom*/
    CFUNCSMESS("Building return value.\n");
    capi_buildvalue = Py_BuildValue("");
/*closepyobjfrom*/
/*end of closepyobjfrom*/
    } /*if (f2py_success) after callfortranroutine*/
/*cleanupfrompyobj*/
  } /*CHECKSCALAR(shape(a,0)==lda)*/
  } /*if (f2py_success) of lda*/
  /* End of cleaning variable lda */
  if((PyObject *)capi_x_tmp!=x_capi) {
    Py_XDECREF(capi_x_tmp); }
  }  /*if (capi_x_tmp == NULL) ... else of x*/
  /* End of cleaning variable x */
  if((PyObject *)capi_y_tmp!=y_capi) {
    Py_XDECREF(capi_y_tmp); }
  }  /*if (capi_y_tmp == NULL) ... else of y*/
  /* End of cleaning variable y */
  } /*if (f2py_success) of n*/
  /* End of cleaning variable n */
  } /*if (f2py_success) of m*/
  /* End of cleaning variable m */
  } /*if (f2py_success) of incy*/
  /* End of cleaning variable incy */
  } /*if (f2py_success) of incx*/
  /* End of cleaning variable incx */
  if((PyObject *)capi_a_tmp!=a_capi) {
    Py_XDECREF(capi_a_tmp); }
  }  /*if (capi_a_tmp == NULL) ... else of a*/
  /* End of cleaning variable a */
  } /*if (f2py_success) of alpha*/
  /* End of cleaning variable alpha */
/*end of cleanupfrompyobj*/
  if (capi_buildvalue == NULL) {
/*routdebugfailure*/
  } else {
/*routdebugleave*/
  }
  CFUNCSMESS("Freeing memory.\n");
/*freemem*/
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_clock();
#endif
  return capi_buildvalue;
}
/******************************** end of dger ********************************/

/*********************************** dgemv ***********************************/
static char doc_f2py_rout_linalg_utils_dgemv[] = "\
dgemv(trans,m,n,alpha,a,x,incx,beta,y,incy,[lda])\n\nWrapper for ``dgemv``.\
\n\nParameters\n----------\n"
"trans : input string(len=1)\n"
"m : input int\n"
"n : input int\n"
"alpha : input float\n"
"a : input rank-2 array('d') with bounds (lda,*)\n"
"x : input rank-1 array('d') with bounds (*)\n"
"incx : input int\n"
"beta : input float\n"
"y : input rank-1 array('d') with bounds (*)\n"
"incy : input int\n"
"\nOther Parameters\n----------------\n"
"lda : input int, optional\n    Default: shape(a,0)";
/* extern void F_FUNC(dgemv,DGEMV)(string,int*,int*,double*,double*,int*,double*,int*,double*,double*,int*,size_t); */
static PyObject *f2py_rout_linalg_utils_dgemv(const PyObject *capi_self,
                           PyObject *capi_args,
                           PyObject *capi_keywds,
                           void (*f2py_func)(string,int*,int*,double*,double*,int*,double*,int*,double*,double*,int*,size_t)) {
  PyObject * volatile capi_buildvalue = NULL;
  volatile int f2py_success = 1;
/*decl*/

  string trans = NULL;
  int slen(trans);
  PyObject *trans_capi = Py_None;
  int m = 0;
  PyObject *m_capi = Py_None;
  int n = 0;
  PyObject *n_capi = Py_None;
  double alpha = 0;
  PyObject *alpha_capi = Py_None;
  double *a = NULL;
  npy_intp a_Dims[2] = {-1, -1};
  const int a_Rank = 2;
  PyArrayObject *capi_a_tmp = NULL;
  int capi_a_intent = 0;
  PyObject *a_capi = Py_None;
  int lda = 0;
  PyObject *lda_capi = Py_None;
  double *x = NULL;
  npy_intp x_Dims[1] = {-1};
  const int x_Rank = 1;
  PyArrayObject *capi_x_tmp = NULL;
  int capi_x_intent = 0;
  PyObject *x_capi = Py_None;
  int incx = 0;
  PyObject *incx_capi = Py_None;
  double beta = 0;
  PyObject *beta_capi = Py_None;
  double *y = NULL;
  npy_intp y_Dims[1] = {-1};
  const int y_Rank = 1;
  PyArrayObject *capi_y_tmp = NULL;
  int capi_y_intent = 0;
  PyObject *y_capi = Py_None;
  int incy = 0;
  PyObject *incy_capi = Py_None;
  static char *capi_kwlist[] = {"trans","m","n","alpha","a","x","incx","beta","y","incy","lda",NULL};

/*routdebugenter*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_clock();
#endif
  if (!PyArg_ParseTupleAndKeywords(capi_args,capi_keywds,\
    "OOOOOOOOOO|O:linalg_utils.dgemv",\
    capi_kwlist,&trans_capi,&m_capi,&n_capi,&alpha_capi,&a_capi,&x_capi,&incx_capi,&beta_capi,&y_capi,&incy_capi,&lda_capi))
    return NULL;
/*frompyobj*/
  /* Processing variable a */
  ;
  capi_a_intent |= F2PY_INTENT_IN;
  capi_a_tmp = array_from_pyobj(NPY_DOUBLE,a_Dims,a_Rank,capi_a_intent,a_capi);
  if (capi_a_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 5th argument `a' of linalg_utils.dgemv to C/Fortran array" );
  } else {
    a = (double *)(capi_a_tmp->data);

  /* Processing variable alpha */
    f2py_success = double_from_pyobj(&alpha,alpha_capi,"linalg_utils.dgemv() 4th argument (alpha) can't be converted to double");
  if (f2py_success) {
  /* Processing variable incx */
    f2py_success = int_from_pyobj(&incx,incx_capi,"linalg_utils.dgemv() 7th argument (incx) can't be converted to int");
  if (f2py_success) {
  /* Processing variable incy */
    f2py_success = int_from_pyobj(&incy,incy_capi,"linalg_utils.dgemv() 10th argument (incy) can't be converted to int");
  if (f2py_success) {
  /* Processing variable m */
    f2py_success = int_from_pyobj(&m,m_capi,"linalg_utils.dgemv() 2nd argument (m) can't be converted to int");
  if (f2py_success) {
  /* Processing variable beta */
    f2py_success = double_from_pyobj(&beta,beta_capi,"linalg_utils.dgemv() 8th argument (beta) can't be converted to double");
  if (f2py_success) {
  /* Processing variable n */
    f2py_success = int_from_pyobj(&n,n_capi,"linalg_utils.dgemv() 3rd argument (n) can't be converted to int");
  if (f2py_success) {
  /* Processing variable y */
  ;
  capi_y_intent |= F2PY_INTENT_IN;
  capi_y_tmp = array_from_pyobj(NPY_DOUBLE,y_Dims,y_Rank,capi_y_intent,y_capi);
  if (capi_y_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 9th argument `y' of linalg_utils.dgemv to C/Fortran array" );
  } else {
    y = (double *)(capi_y_tmp->data);

  /* Processing variable x */
  ;
  capi_x_intent |= F2PY_INTENT_IN;
  capi_x_tmp = array_from_pyobj(NPY_DOUBLE,x_Dims,x_Rank,capi_x_intent,x_capi);
  if (capi_x_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 6th argument `x' of linalg_utils.dgemv to C/Fortran array" );
  } else {
    x = (double *)(capi_x_tmp->data);

  /* Processing variable trans */
  slen(trans) = 1;
  f2py_success = string_from_pyobj(&trans,&slen(trans),"",trans_capi,"string_from_pyobj failed in converting 1st argument `trans' of linalg_utils.dgemv to C string");
  if (f2py_success) {
  /* Processing variable lda */
  if (lda_capi == Py_None) lda = shape(a,0); else
    f2py_success = int_from_pyobj(&lda,lda_capi,"linalg_utils.dgemv() 1st keyword (lda) can't be converted to int");
  if (f2py_success) {
  CHECKSCALAR(shape(a,0)==lda,"shape(a,0)==lda","1st keyword lda","dgemv:lda=%d",lda) {
/*end of frompyobj*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_call_clock();
#endif
/*callfortranroutine*/
        (*f2py_func)(trans,&m,&n,&alpha,a,&lda,x,&incx,&beta,y,&incy,slen(trans));
if (PyErr_Occurred())
  f2py_success = 0;
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_call_clock();
#endif
/*end of callfortranroutine*/
    if (f2py_success) {
/*pyobjfrom*/
/*end of pyobjfrom*/
    CFUNCSMESS("Building return value.\n");
    capi_buildvalue = Py_BuildValue("");
/*closepyobjfrom*/
/*end of closepyobjfrom*/
    } /*if (f2py_success) after callfortranroutine*/
/*cleanupfrompyobj*/
  } /*CHECKSCALAR(shape(a,0)==lda)*/
  } /*if (f2py_success) of lda*/
  /* End of cleaning variable lda */
    STRINGFREE(trans);
  }  /*if (f2py_success) of trans*/
  /* End of cleaning variable trans */
  if((PyObject *)capi_x_tmp!=x_capi) {
    Py_XDECREF(capi_x_tmp); }
  }  /*if (capi_x_tmp == NULL) ... else of x*/
  /* End of cleaning variable x */
  if((PyObject *)capi_y_tmp!=y_capi) {
    Py_XDECREF(capi_y_tmp); }
  }  /*if (capi_y_tmp == NULL) ... else of y*/
  /* End of cleaning variable y */
  } /*if (f2py_success) of n*/
  /* End of cleaning variable n */
  } /*if (f2py_success) of beta*/
  /* End of cleaning variable beta */
  } /*if (f2py_success) of m*/
  /* End of cleaning variable m */
  } /*if (f2py_success) of incy*/
  /* End of cleaning variable incy */
  } /*if (f2py_success) of incx*/
  /* End of cleaning variable incx */
  } /*if (f2py_success) of alpha*/
  /* End of cleaning variable alpha */
  if((PyObject *)capi_a_tmp!=a_capi) {
    Py_XDECREF(capi_a_tmp); }
  }  /*if (capi_a_tmp == NULL) ... else of a*/
  /* End of cleaning variable a */
/*end of cleanupfrompyobj*/
  if (capi_buildvalue == NULL) {
/*routdebugfailure*/
  } else {
/*routdebugleave*/
  }
  CFUNCSMESS("Freeing memory.\n");
/*freemem*/
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_clock();
#endif
  return capi_buildvalue;
}
/******************************** end of dgemv ********************************/

/*********************************** dgemm ***********************************/
static char doc_f2py_rout_linalg_utils_dgemm[] = "\
dgemm(transa,transb,m,n,k,alpha,a,b,beta,c,[lda,ldb,ldc])\n\nWrapper for ``dgemm``.\
\n\nParameters\n----------\n"
"transa : input string(len=1)\n"
"transb : input string(len=1)\n"
"m : input int\n"
"n : input int\n"
"k : input int\n"
"alpha : input float\n"
"a : input rank-2 array('d') with bounds (lda,*)\n"
"b : input rank-2 array('d') with bounds (ldb,*)\n"
"beta : input float\n"
"c : input rank-2 array('d') with bounds (ldc,*)\n"
"\nOther Parameters\n----------------\n"
"lda : input int, optional\n    Default: shape(a,0)\n"
"ldb : input int, optional\n    Default: shape(b,0)\n"
"ldc : input int, optional\n    Default: shape(c,0)";
/* extern void F_FUNC(dgemm,DGEMM)(string,string,int*,int*,int*,double*,double*,int*,double*,int*,double*,double*,int*,size_t,size_t); */
static PyObject *f2py_rout_linalg_utils_dgemm(const PyObject *capi_self,
                           PyObject *capi_args,
                           PyObject *capi_keywds,
                           void (*f2py_func)(string,string,int*,int*,int*,double*,double*,int*,double*,int*,double*,double*,int*,size_t,size_t)) {
  PyObject * volatile capi_buildvalue = NULL;
  volatile int f2py_success = 1;
/*decl*/

  string transa = NULL;
  int slen(transa);
  PyObject *transa_capi = Py_None;
  string transb = NULL;
  int slen(transb);
  PyObject *transb_capi = Py_None;
  int m = 0;
  PyObject *m_capi = Py_None;
  int n = 0;
  PyObject *n_capi = Py_None;
  int k = 0;
  PyObject *k_capi = Py_None;
  double alpha = 0;
  PyObject *alpha_capi = Py_None;
  double *a = NULL;
  npy_intp a_Dims[2] = {-1, -1};
  const int a_Rank = 2;
  PyArrayObject *capi_a_tmp = NULL;
  int capi_a_intent = 0;
  PyObject *a_capi = Py_None;
  int lda = 0;
  PyObject *lda_capi = Py_None;
  double *b = NULL;
  npy_intp b_Dims[2] = {-1, -1};
  const int b_Rank = 2;
  PyArrayObject *capi_b_tmp = NULL;
  int capi_b_intent = 0;
  PyObject *b_capi = Py_None;
  int ldb = 0;
  PyObject *ldb_capi = Py_None;
  double beta = 0;
  PyObject *beta_capi = Py_None;
  double *c = NULL;
  npy_intp c_Dims[2] = {-1, -1};
  const int c_Rank = 2;
  PyArrayObject *capi_c_tmp = NULL;
  int capi_c_intent = 0;
  PyObject *c_capi = Py_None;
  int ldc = 0;
  PyObject *ldc_capi = Py_None;
  static char *capi_kwlist[] = {"transa","transb","m","n","k","alpha","a","b","beta","c","lda","ldb","ldc",NULL};

/*routdebugenter*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_clock();
#endif
  if (!PyArg_ParseTupleAndKeywords(capi_args,capi_keywds,\
    "OOOOOOOOOO|OOO:linalg_utils.dgemm",\
    capi_kwlist,&transa_capi,&transb_capi,&m_capi,&n_capi,&k_capi,&alpha_capi,&a_capi,&b_capi,&beta_capi,&c_capi,&lda_capi,&ldb_capi,&ldc_capi))
    return NULL;
/*frompyobj*/
  /* Processing variable alpha */
    f2py_success = double_from_pyobj(&alpha,alpha_capi,"linalg_utils.dgemm() 6th argument (alpha) can't be converted to double");
  if (f2py_success) {
  /* Processing variable transa */
  slen(transa) = 1;
  f2py_success = string_from_pyobj(&transa,&slen(transa),"",transa_capi,"string_from_pyobj failed in converting 1st argument `transa' of linalg_utils.dgemm to C string");
  if (f2py_success) {
  /* Processing variable transb */
  slen(transb) = 1;
  f2py_success = string_from_pyobj(&transb,&slen(transb),"",transb_capi,"string_from_pyobj failed in converting 2nd argument `transb' of linalg_utils.dgemm to C string");
  if (f2py_success) {
  /* Processing variable a */
  ;
  capi_a_intent |= F2PY_INTENT_IN;
  capi_a_tmp = array_from_pyobj(NPY_DOUBLE,a_Dims,a_Rank,capi_a_intent,a_capi);
  if (capi_a_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 7th argument `a' of linalg_utils.dgemm to C/Fortran array" );
  } else {
    a = (double *)(capi_a_tmp->data);

  /* Processing variable c */
  ;
  capi_c_intent |= F2PY_INTENT_IN;
  capi_c_tmp = array_from_pyobj(NPY_DOUBLE,c_Dims,c_Rank,capi_c_intent,c_capi);
  if (capi_c_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 10th argument `c' of linalg_utils.dgemm to C/Fortran array" );
  } else {
    c = (double *)(capi_c_tmp->data);

  /* Processing variable b */
  ;
  capi_b_intent |= F2PY_INTENT_IN;
  capi_b_tmp = array_from_pyobj(NPY_DOUBLE,b_Dims,b_Rank,capi_b_intent,b_capi);
  if (capi_b_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 8th argument `b' of linalg_utils.dgemm to C/Fortran array" );
  } else {
    b = (double *)(capi_b_tmp->data);

  /* Processing variable k */
    f2py_success = int_from_pyobj(&k,k_capi,"linalg_utils.dgemm() 5th argument (k) can't be converted to int");
  if (f2py_success) {
  /* Processing variable m */
    f2py_success = int_from_pyobj(&m,m_capi,"linalg_utils.dgemm() 3rd argument (m) can't be converted to int");
  if (f2py_success) {
  /* Processing variable beta */
    f2py_success = double_from_pyobj(&beta,beta_capi,"linalg_utils.dgemm() 9th argument (beta) can't be converted to double");
  if (f2py_success) {
  /* Processing variable n */
    f2py_success = int_from_pyobj(&n,n_capi,"linalg_utils.dgemm() 4th argument (n) can't be converted to int");
  if (f2py_success) {
  /* Processing variable ldc */
  if (ldc_capi == Py_None) ldc = shape(c,0); else
    f2py_success = int_from_pyobj(&ldc,ldc_capi,"linalg_utils.dgemm() 3rd keyword (ldc) can't be converted to int");
  if (f2py_success) {
  CHECKSCALAR(shape(c,0)==ldc,"shape(c,0)==ldc","3rd keyword ldc","dgemm:ldc=%d",ldc) {
  /* Processing variable ldb */
  if (ldb_capi == Py_None) ldb = shape(b,0); else
    f2py_success = int_from_pyobj(&ldb,ldb_capi,"linalg_utils.dgemm() 2nd keyword (ldb) can't be converted to int");
  if (f2py_success) {
  CHECKSCALAR(shape(b,0)==ldb,"shape(b,0)==ldb","2nd keyword ldb","dgemm:ldb=%d",ldb) {
  /* Processing variable lda */
  if (lda_capi == Py_None) lda = shape(a,0); else
    f2py_success = int_from_pyobj(&lda,lda_capi,"linalg_utils.dgemm() 1st keyword (lda) can't be converted to int");
  if (f2py_success) {
  CHECKSCALAR(shape(a,0)==lda,"shape(a,0)==lda","1st keyword lda","dgemm:lda=%d",lda) {
/*end of frompyobj*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_call_clock();
#endif
/*callfortranroutine*/
        (*f2py_func)(transa,transb,&m,&n,&k,&alpha,a,&lda,b,&ldb,&beta,c,&ldc,slen(transa),slen(transb));
if (PyErr_Occurred())
  f2py_success = 0;
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_call_clock();
#endif
/*end of callfortranroutine*/
    if (f2py_success) {
/*pyobjfrom*/
/*end of pyobjfrom*/
    CFUNCSMESS("Building return value.\n");
    capi_buildvalue = Py_BuildValue("");
/*closepyobjfrom*/
/*end of closepyobjfrom*/
    } /*if (f2py_success) after callfortranroutine*/
/*cleanupfrompyobj*/
  } /*CHECKSCALAR(shape(a,0)==lda)*/
  } /*if (f2py_success) of lda*/
  /* End of cleaning variable lda */
  } /*CHECKSCALAR(shape(b,0)==ldb)*/
  } /*if (f2py_success) of ldb*/
  /* End of cleaning variable ldb */
  } /*CHECKSCALAR(shape(c,0)==ldc)*/
  } /*if (f2py_success) of ldc*/
  /* End of cleaning variable ldc */
  } /*if (f2py_success) of n*/
  /* End of cleaning variable n */
  } /*if (f2py_success) of beta*/
  /* End of cleaning variable beta */
  } /*if (f2py_success) of m*/
  /* End of cleaning variable m */
  } /*if (f2py_success) of k*/
  /* End of cleaning variable k */
  if((PyObject *)capi_b_tmp!=b_capi) {
    Py_XDECREF(capi_b_tmp); }
  }  /*if (capi_b_tmp == NULL) ... else of b*/
  /* End of cleaning variable b */
  if((PyObject *)capi_c_tmp!=c_capi) {
    Py_XDECREF(capi_c_tmp); }
  }  /*if (capi_c_tmp == NULL) ... else of c*/
  /* End of cleaning variable c */
  if((PyObject *)capi_a_tmp!=a_capi) {
    Py_XDECREF(capi_a_tmp); }
  }  /*if (capi_a_tmp == NULL) ... else of a*/
  /* End of cleaning variable a */
    STRINGFREE(transb);
  }  /*if (f2py_success) of transb*/
  /* End of cleaning variable transb */
    STRINGFREE(transa);
  }  /*if (f2py_success) of transa*/
  /* End of cleaning variable transa */
  } /*if (f2py_success) of alpha*/
  /* End of cleaning variable alpha */
/*end of cleanupfrompyobj*/
  if (capi_buildvalue == NULL) {
/*routdebugfailure*/
  } else {
/*routdebugleave*/
  }
  CFUNCSMESS("Freeing memory.\n");
/*freemem*/
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_clock();
#endif
  return capi_buildvalue;
}
/******************************** end of dgemm ********************************/

/*********************************** dgbmv ***********************************/
static char doc_f2py_rout_linalg_utils_dgbmv[] = "\
dgbmv(trans,m,n,kl,ku,alpha,a,x,incx,beta,y,incy,[lda])\n\nWrapper for ``dgbmv``.\
\n\nParameters\n----------\n"
"trans : input string(len=1)\n"
"m : input int\n"
"n : input int\n"
"kl : input int\n"
"ku : input int\n"
"alpha : input float\n"
"a : input rank-2 array('d') with bounds (lda,*)\n"
"x : input rank-1 array('d') with bounds (*)\n"
"incx : input int\n"
"beta : input float\n"
"y : input rank-1 array('d') with bounds (*)\n"
"incy : input int\n"
"\nOther Parameters\n----------------\n"
"lda : input int, optional\n    Default: shape(a,0)";
/* extern void F_FUNC(dgbmv,DGBMV)(string,int*,int*,int*,int*,double*,double*,int*,double*,int*,double*,double*,int*,size_t); */
static PyObject *f2py_rout_linalg_utils_dgbmv(const PyObject *capi_self,
                           PyObject *capi_args,
                           PyObject *capi_keywds,
                           void (*f2py_func)(string,int*,int*,int*,int*,double*,double*,int*,double*,int*,double*,double*,int*,size_t)) {
  PyObject * volatile capi_buildvalue = NULL;
  volatile int f2py_success = 1;
/*decl*/

  string trans = NULL;
  int slen(trans);
  PyObject *trans_capi = Py_None;
  int m = 0;
  PyObject *m_capi = Py_None;
  int n = 0;
  PyObject *n_capi = Py_None;
  int kl = 0;
  PyObject *kl_capi = Py_None;
  int ku = 0;
  PyObject *ku_capi = Py_None;
  double alpha = 0;
  PyObject *alpha_capi = Py_None;
  double *a = NULL;
  npy_intp a_Dims[2] = {-1, -1};
  const int a_Rank = 2;
  PyArrayObject *capi_a_tmp = NULL;
  int capi_a_intent = 0;
  PyObject *a_capi = Py_None;
  int lda = 0;
  PyObject *lda_capi = Py_None;
  double *x = NULL;
  npy_intp x_Dims[1] = {-1};
  const int x_Rank = 1;
  PyArrayObject *capi_x_tmp = NULL;
  int capi_x_intent = 0;
  PyObject *x_capi = Py_None;
  int incx = 0;
  PyObject *incx_capi = Py_None;
  double beta = 0;
  PyObject *beta_capi = Py_None;
  double *y = NULL;
  npy_intp y_Dims[1] = {-1};
  const int y_Rank = 1;
  PyArrayObject *capi_y_tmp = NULL;
  int capi_y_intent = 0;
  PyObject *y_capi = Py_None;
  int incy = 0;
  PyObject *incy_capi = Py_None;
  static char *capi_kwlist[] = {"trans","m","n","kl","ku","alpha","a","x","incx","beta","y","incy","lda",NULL};

/*routdebugenter*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_clock();
#endif
  if (!PyArg_ParseTupleAndKeywords(capi_args,capi_keywds,\
    "OOOOOOOOOOOO|O:linalg_utils.dgbmv",\
    capi_kwlist,&trans_capi,&m_capi,&n_capi,&kl_capi,&ku_capi,&alpha_capi,&a_capi,&x_capi,&incx_capi,&beta_capi,&y_capi,&incy_capi,&lda_capi))
    return NULL;
/*frompyobj*/
  /* Processing variable a */
  ;
  capi_a_intent |= F2PY_INTENT_IN;
  capi_a_tmp = array_from_pyobj(NPY_DOUBLE,a_Dims,a_Rank,capi_a_intent,a_capi);
  if (capi_a_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 7th argument `a' of linalg_utils.dgbmv to C/Fortran array" );
  } else {
    a = (double *)(capi_a_tmp->data);

  /* Processing variable alpha */
    f2py_success = double_from_pyobj(&alpha,alpha_capi,"linalg_utils.dgbmv() 6th argument (alpha) can't be converted to double");
  if (f2py_success) {
  /* Processing variable trans */
  slen(trans) = 1;
  f2py_success = string_from_pyobj(&trans,&slen(trans),"",trans_capi,"string_from_pyobj failed in converting 1st argument `trans' of linalg_utils.dgbmv to C string");
  if (f2py_success) {
  /* Processing variable kl */
    f2py_success = int_from_pyobj(&kl,kl_capi,"linalg_utils.dgbmv() 4th argument (kl) can't be converted to int");
  if (f2py_success) {
  /* Processing variable incx */
    f2py_success = int_from_pyobj(&incx,incx_capi,"linalg_utils.dgbmv() 9th argument (incx) can't be converted to int");
  if (f2py_success) {
  /* Processing variable incy */
    f2py_success = int_from_pyobj(&incy,incy_capi,"linalg_utils.dgbmv() 12nd argument (incy) can't be converted to int");
  if (f2py_success) {
  /* Processing variable m */
    f2py_success = int_from_pyobj(&m,m_capi,"linalg_utils.dgbmv() 2nd argument (m) can't be converted to int");
  if (f2py_success) {
  /* Processing variable beta */
    f2py_success = double_from_pyobj(&beta,beta_capi,"linalg_utils.dgbmv() 10th argument (beta) can't be converted to double");
  if (f2py_success) {
  /* Processing variable n */
    f2py_success = int_from_pyobj(&n,n_capi,"linalg_utils.dgbmv() 3rd argument (n) can't be converted to int");
  if (f2py_success) {
  /* Processing variable ku */
    f2py_success = int_from_pyobj(&ku,ku_capi,"linalg_utils.dgbmv() 5th argument (ku) can't be converted to int");
  if (f2py_success) {
  /* Processing variable y */
  ;
  capi_y_intent |= F2PY_INTENT_IN;
  capi_y_tmp = array_from_pyobj(NPY_DOUBLE,y_Dims,y_Rank,capi_y_intent,y_capi);
  if (capi_y_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 11st argument `y' of linalg_utils.dgbmv to C/Fortran array" );
  } else {
    y = (double *)(capi_y_tmp->data);

  /* Processing variable x */
  ;
  capi_x_intent |= F2PY_INTENT_IN;
  capi_x_tmp = array_from_pyobj(NPY_DOUBLE,x_Dims,x_Rank,capi_x_intent,x_capi);
  if (capi_x_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 8th argument `x' of linalg_utils.dgbmv to C/Fortran array" );
  } else {
    x = (double *)(capi_x_tmp->data);

  /* Processing variable lda */
  if (lda_capi == Py_None) lda = shape(a,0); else
    f2py_success = int_from_pyobj(&lda,lda_capi,"linalg_utils.dgbmv() 1st keyword (lda) can't be converted to int");
  if (f2py_success) {
  CHECKSCALAR(shape(a,0)==lda,"shape(a,0)==lda","1st keyword lda","dgbmv:lda=%d",lda) {
/*end of frompyobj*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_call_clock();
#endif
/*callfortranroutine*/
        (*f2py_func)(trans,&m,&n,&kl,&ku,&alpha,a,&lda,x,&incx,&beta,y,&incy,slen(trans));
if (PyErr_Occurred())
  f2py_success = 0;
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_call_clock();
#endif
/*end of callfortranroutine*/
    if (f2py_success) {
/*pyobjfrom*/
/*end of pyobjfrom*/
    CFUNCSMESS("Building return value.\n");
    capi_buildvalue = Py_BuildValue("");
/*closepyobjfrom*/
/*end of closepyobjfrom*/
    } /*if (f2py_success) after callfortranroutine*/
/*cleanupfrompyobj*/
  } /*CHECKSCALAR(shape(a,0)==lda)*/
  } /*if (f2py_success) of lda*/
  /* End of cleaning variable lda */
  if((PyObject *)capi_x_tmp!=x_capi) {
    Py_XDECREF(capi_x_tmp); }
  }  /*if (capi_x_tmp == NULL) ... else of x*/
  /* End of cleaning variable x */
  if((PyObject *)capi_y_tmp!=y_capi) {
    Py_XDECREF(capi_y_tmp); }
  }  /*if (capi_y_tmp == NULL) ... else of y*/
  /* End of cleaning variable y */
  } /*if (f2py_success) of ku*/
  /* End of cleaning variable ku */
  } /*if (f2py_success) of n*/
  /* End of cleaning variable n */
  } /*if (f2py_success) of beta*/
  /* End of cleaning variable beta */
  } /*if (f2py_success) of m*/
  /* End of cleaning variable m */
  } /*if (f2py_success) of incy*/
  /* End of cleaning variable incy */
  } /*if (f2py_success) of incx*/
  /* End of cleaning variable incx */
  } /*if (f2py_success) of kl*/
  /* End of cleaning variable kl */
    STRINGFREE(trans);
  }  /*if (f2py_success) of trans*/
  /* End of cleaning variable trans */
  } /*if (f2py_success) of alpha*/
  /* End of cleaning variable alpha */
  if((PyObject *)capi_a_tmp!=a_capi) {
    Py_XDECREF(capi_a_tmp); }
  }  /*if (capi_a_tmp == NULL) ... else of a*/
  /* End of cleaning variable a */
/*end of cleanupfrompyobj*/
  if (capi_buildvalue == NULL) {
/*routdebugfailure*/
  } else {
/*routdebugleave*/
  }
  CFUNCSMESS("Freeing memory.\n");
/*freemem*/
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_clock();
#endif
  return capi_buildvalue;
}
/******************************** end of dgbmv ********************************/

/************************************ ddot ************************************/
static char doc_f2py_rout_linalg_utils_ddot[] = "\
ddot = ddot(n,dx,incx,dy,incy)\n\nWrapper for ``ddot``.\
\n\nParameters\n----------\n"
"n : input int\n"
"dx : input rank-1 array('d') with bounds (*)\n"
"incx : input int\n"
"dy : input rank-1 array('d') with bounds (*)\n"
"incy : input int\n"
"\nReturns\n-------\n"
"ddot : float";
/* extern void F_WRAPPEDFUNC(ddot,DDOT)(double*,int*,double*,int*,double*,int*); */
static PyObject *f2py_rout_linalg_utils_ddot(const PyObject *capi_self,
                           PyObject *capi_args,
                           PyObject *capi_keywds,
                           void (*f2py_func)(double*,int*,double*,int*,double*,int*)) {
  PyObject * volatile capi_buildvalue = NULL;
  volatile int f2py_success = 1;
/*decl*/

  double ddot = 0;
  int n = 0;
  PyObject *n_capi = Py_None;
  double *dx = NULL;
  npy_intp dx_Dims[1] = {-1};
  const int dx_Rank = 1;
  PyArrayObject *capi_dx_tmp = NULL;
  int capi_dx_intent = 0;
  PyObject *dx_capi = Py_None;
  int incx = 0;
  PyObject *incx_capi = Py_None;
  double *dy = NULL;
  npy_intp dy_Dims[1] = {-1};
  const int dy_Rank = 1;
  PyArrayObject *capi_dy_tmp = NULL;
  int capi_dy_intent = 0;
  PyObject *dy_capi = Py_None;
  int incy = 0;
  PyObject *incy_capi = Py_None;
  static char *capi_kwlist[] = {"n","dx","incx","dy","incy",NULL};

/*routdebugenter*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_clock();
#endif
  if (!PyArg_ParseTupleAndKeywords(capi_args,capi_keywds,\
    "OOOOO:linalg_utils.ddot",\
    capi_kwlist,&n_capi,&dx_capi,&incx_capi,&dy_capi,&incy_capi))
    return NULL;
/*frompyobj*/
  /* Processing variable incx */
    f2py_success = int_from_pyobj(&incx,incx_capi,"linalg_utils.ddot() 3rd argument (incx) can't be converted to int");
  if (f2py_success) {
  /* Processing variable incy */
    f2py_success = int_from_pyobj(&incy,incy_capi,"linalg_utils.ddot() 5th argument (incy) can't be converted to int");
  if (f2py_success) {
  /* Processing variable n */
    f2py_success = int_from_pyobj(&n,n_capi,"linalg_utils.ddot() 1st argument (n) can't be converted to int");
  if (f2py_success) {
  /* Processing variable ddot */
  /* Processing variable dx */
  ;
  capi_dx_intent |= F2PY_INTENT_IN;
  capi_dx_tmp = array_from_pyobj(NPY_DOUBLE,dx_Dims,dx_Rank,capi_dx_intent,dx_capi);
  if (capi_dx_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 2nd argument `dx' of linalg_utils.ddot to C/Fortran array" );
  } else {
    dx = (double *)(capi_dx_tmp->data);

  /* Processing variable dy */
  ;
  capi_dy_intent |= F2PY_INTENT_IN;
  capi_dy_tmp = array_from_pyobj(NPY_DOUBLE,dy_Dims,dy_Rank,capi_dy_intent,dy_capi);
  if (capi_dy_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 4th argument `dy' of linalg_utils.ddot to C/Fortran array" );
  } else {
    dy = (double *)(capi_dy_tmp->data);

/*end of frompyobj*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_call_clock();
#endif
/*callfortranroutine*/
  (*f2py_func)(&ddot,&n,dx,&incx,dy,&incy);
if (PyErr_Occurred())
  f2py_success = 0;
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_call_clock();
#endif
/*end of callfortranroutine*/
    if (f2py_success) {
/*pyobjfrom*/
/*end of pyobjfrom*/
    CFUNCSMESS("Building return value.\n");
    capi_buildvalue = Py_BuildValue("d",ddot);
/*closepyobjfrom*/
/*end of closepyobjfrom*/
    } /*if (f2py_success) after callfortranroutine*/
/*cleanupfrompyobj*/
  if((PyObject *)capi_dy_tmp!=dy_capi) {
    Py_XDECREF(capi_dy_tmp); }
  }  /*if (capi_dy_tmp == NULL) ... else of dy*/
  /* End of cleaning variable dy */
  if((PyObject *)capi_dx_tmp!=dx_capi) {
    Py_XDECREF(capi_dx_tmp); }
  }  /*if (capi_dx_tmp == NULL) ... else of dx*/
  /* End of cleaning variable dx */
  /* End of cleaning variable ddot */
  } /*if (f2py_success) of n*/
  /* End of cleaning variable n */
  } /*if (f2py_success) of incy*/
  /* End of cleaning variable incy */
  } /*if (f2py_success) of incx*/
  /* End of cleaning variable incx */
/*end of cleanupfrompyobj*/
  if (capi_buildvalue == NULL) {
/*routdebugfailure*/
  } else {
/*routdebugleave*/
  }
  CFUNCSMESS("Freeing memory.\n");
/*freemem*/
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_clock();
#endif
  return capi_buildvalue;
}
/******************************** end of ddot ********************************/

/*********************************** dcopy ***********************************/
static char doc_f2py_rout_linalg_utils_dcopy[] = "\
dcopy(n,dx,incx,dy,incy)\n\nWrapper for ``dcopy``.\
\n\nParameters\n----------\n"
"n : input int\n"
"dx : input rank-1 array('d') with bounds (*)\n"
"incx : input int\n"
"dy : input rank-1 array('d') with bounds (*)\n"
"incy : input int";
/* extern void F_FUNC(dcopy,DCOPY)(int*,double*,int*,double*,int*); */
static PyObject *f2py_rout_linalg_utils_dcopy(const PyObject *capi_self,
                           PyObject *capi_args,
                           PyObject *capi_keywds,
                           void (*f2py_func)(int*,double*,int*,double*,int*)) {
  PyObject * volatile capi_buildvalue = NULL;
  volatile int f2py_success = 1;
/*decl*/

  int n = 0;
  PyObject *n_capi = Py_None;
  double *dx = NULL;
  npy_intp dx_Dims[1] = {-1};
  const int dx_Rank = 1;
  PyArrayObject *capi_dx_tmp = NULL;
  int capi_dx_intent = 0;
  PyObject *dx_capi = Py_None;
  int incx = 0;
  PyObject *incx_capi = Py_None;
  double *dy = NULL;
  npy_intp dy_Dims[1] = {-1};
  const int dy_Rank = 1;
  PyArrayObject *capi_dy_tmp = NULL;
  int capi_dy_intent = 0;
  PyObject *dy_capi = Py_None;
  int incy = 0;
  PyObject *incy_capi = Py_None;
  static char *capi_kwlist[] = {"n","dx","incx","dy","incy",NULL};

/*routdebugenter*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_clock();
#endif
  if (!PyArg_ParseTupleAndKeywords(capi_args,capi_keywds,\
    "OOOOO:linalg_utils.dcopy",\
    capi_kwlist,&n_capi,&dx_capi,&incx_capi,&dy_capi,&incy_capi))
    return NULL;
/*frompyobj*/
  /* Processing variable incx */
    f2py_success = int_from_pyobj(&incx,incx_capi,"linalg_utils.dcopy() 3rd argument (incx) can't be converted to int");
  if (f2py_success) {
  /* Processing variable incy */
    f2py_success = int_from_pyobj(&incy,incy_capi,"linalg_utils.dcopy() 5th argument (incy) can't be converted to int");
  if (f2py_success) {
  /* Processing variable dy */
  ;
  capi_dy_intent |= F2PY_INTENT_IN;
  capi_dy_tmp = array_from_pyobj(NPY_DOUBLE,dy_Dims,dy_Rank,capi_dy_intent,dy_capi);
  if (capi_dy_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 4th argument `dy' of linalg_utils.dcopy to C/Fortran array" );
  } else {
    dy = (double *)(capi_dy_tmp->data);

  /* Processing variable n */
    f2py_success = int_from_pyobj(&n,n_capi,"linalg_utils.dcopy() 1st argument (n) can't be converted to int");
  if (f2py_success) {
  /* Processing variable dx */
  ;
  capi_dx_intent |= F2PY_INTENT_IN;
  capi_dx_tmp = array_from_pyobj(NPY_DOUBLE,dx_Dims,dx_Rank,capi_dx_intent,dx_capi);
  if (capi_dx_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 2nd argument `dx' of linalg_utils.dcopy to C/Fortran array" );
  } else {
    dx = (double *)(capi_dx_tmp->data);

/*end of frompyobj*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_call_clock();
#endif
/*callfortranroutine*/
        (*f2py_func)(&n,dx,&incx,dy,&incy);
if (PyErr_Occurred())
  f2py_success = 0;
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_call_clock();
#endif
/*end of callfortranroutine*/
    if (f2py_success) {
/*pyobjfrom*/
/*end of pyobjfrom*/
    CFUNCSMESS("Building return value.\n");
    capi_buildvalue = Py_BuildValue("");
/*closepyobjfrom*/
/*end of closepyobjfrom*/
    } /*if (f2py_success) after callfortranroutine*/
/*cleanupfrompyobj*/
  if((PyObject *)capi_dx_tmp!=dx_capi) {
    Py_XDECREF(capi_dx_tmp); }
  }  /*if (capi_dx_tmp == NULL) ... else of dx*/
  /* End of cleaning variable dx */
  } /*if (f2py_success) of n*/
  /* End of cleaning variable n */
  if((PyObject *)capi_dy_tmp!=dy_capi) {
    Py_XDECREF(capi_dy_tmp); }
  }  /*if (capi_dy_tmp == NULL) ... else of dy*/
  /* End of cleaning variable dy */
  } /*if (f2py_success) of incy*/
  /* End of cleaning variable incy */
  } /*if (f2py_success) of incx*/
  /* End of cleaning variable incx */
/*end of cleanupfrompyobj*/
  if (capi_buildvalue == NULL) {
/*routdebugfailure*/
  } else {
/*routdebugleave*/
  }
  CFUNCSMESS("Freeing memory.\n");
/*freemem*/
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_clock();
#endif
  return capi_buildvalue;
}
/******************************** end of dcopy ********************************/

/*********************************** dcabs1 ***********************************/
static char doc_f2py_rout_linalg_utils_dcabs1[] = "\
dcabs1 = dcabs1(z)\n\nWrapper for ``dcabs1``.\
\n\nParameters\n----------\n"
"z : input complex\n"
"\nReturns\n-------\n"
"dcabs1 : float";
/* extern void F_WRAPPEDFUNC(dcabs1,DCABS1)(double*,complex_double*); */
static PyObject *f2py_rout_linalg_utils_dcabs1(const PyObject *capi_self,
                           PyObject *capi_args,
                           PyObject *capi_keywds,
                           void (*f2py_func)(double*,complex_double*)) {
  PyObject * volatile capi_buildvalue = NULL;
  volatile int f2py_success = 1;
/*decl*/

  double dcabs1 = 0;
  complex_double z;
  PyObject *z_capi = Py_None;
  static char *capi_kwlist[] = {"z",NULL};

/*routdebugenter*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_clock();
#endif
  if (!PyArg_ParseTupleAndKeywords(capi_args,capi_keywds,\
    "O:linalg_utils.dcabs1",\
    capi_kwlist,&z_capi))
    return NULL;
/*frompyobj*/
  /* Processing variable z */
    f2py_success = complex_double_from_pyobj(&z,z_capi,"linalg_utils.dcabs1() 1st argument (z) can't be converted to complex_double");
  if (f2py_success) {
  /* Processing variable dcabs1 */
/*end of frompyobj*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_call_clock();
#endif
/*callfortranroutine*/
  (*f2py_func)(&dcabs1,&z);
if (PyErr_Occurred())
  f2py_success = 0;
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_call_clock();
#endif
/*end of callfortranroutine*/
    if (f2py_success) {
/*pyobjfrom*/
/*end of pyobjfrom*/
    CFUNCSMESS("Building return value.\n");
    capi_buildvalue = Py_BuildValue("d",dcabs1);
/*closepyobjfrom*/
/*end of closepyobjfrom*/
    } /*if (f2py_success) after callfortranroutine*/
/*cleanupfrompyobj*/
  /* End of cleaning variable dcabs1 */
  }  /*if (f2py_success) of z frompyobj*/
  /* End of cleaning variable z */
/*end of cleanupfrompyobj*/
  if (capi_buildvalue == NULL) {
/*routdebugfailure*/
  } else {
/*routdebugleave*/
  }
  CFUNCSMESS("Freeing memory.\n");
/*freemem*/
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_clock();
#endif
  return capi_buildvalue;
}
/******************************* end of dcabs1 *******************************/

/*********************************** daxpy ***********************************/
static char doc_f2py_rout_linalg_utils_daxpy[] = "\
daxpy(n,da,dx,incx,dy,incy)\n\nWrapper for ``daxpy``.\
\n\nParameters\n----------\n"
"n : input int\n"
"da : input float\n"
"dx : input rank-1 array('d') with bounds (*)\n"
"incx : input int\n"
"dy : input rank-1 array('d') with bounds (*)\n"
"incy : input int";
/* extern void F_FUNC(daxpy,DAXPY)(int*,double*,double*,int*,double*,int*); */
static PyObject *f2py_rout_linalg_utils_daxpy(const PyObject *capi_self,
                           PyObject *capi_args,
                           PyObject *capi_keywds,
                           void (*f2py_func)(int*,double*,double*,int*,double*,int*)) {
  PyObject * volatile capi_buildvalue = NULL;
  volatile int f2py_success = 1;
/*decl*/

  int n = 0;
  PyObject *n_capi = Py_None;
  double da = 0;
  PyObject *da_capi = Py_None;
  double *dx = NULL;
  npy_intp dx_Dims[1] = {-1};
  const int dx_Rank = 1;
  PyArrayObject *capi_dx_tmp = NULL;
  int capi_dx_intent = 0;
  PyObject *dx_capi = Py_None;
  int incx = 0;
  PyObject *incx_capi = Py_None;
  double *dy = NULL;
  npy_intp dy_Dims[1] = {-1};
  const int dy_Rank = 1;
  PyArrayObject *capi_dy_tmp = NULL;
  int capi_dy_intent = 0;
  PyObject *dy_capi = Py_None;
  int incy = 0;
  PyObject *incy_capi = Py_None;
  static char *capi_kwlist[] = {"n","da","dx","incx","dy","incy",NULL};

/*routdebugenter*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_clock();
#endif
  if (!PyArg_ParseTupleAndKeywords(capi_args,capi_keywds,\
    "OOOOOO:linalg_utils.daxpy",\
    capi_kwlist,&n_capi,&da_capi,&dx_capi,&incx_capi,&dy_capi,&incy_capi))
    return NULL;
/*frompyobj*/
  /* Processing variable incx */
    f2py_success = int_from_pyobj(&incx,incx_capi,"linalg_utils.daxpy() 4th argument (incx) can't be converted to int");
  if (f2py_success) {
  /* Processing variable incy */
    f2py_success = int_from_pyobj(&incy,incy_capi,"linalg_utils.daxpy() 6th argument (incy) can't be converted to int");
  if (f2py_success) {
  /* Processing variable dy */
  ;
  capi_dy_intent |= F2PY_INTENT_IN;
  capi_dy_tmp = array_from_pyobj(NPY_DOUBLE,dy_Dims,dy_Rank,capi_dy_intent,dy_capi);
  if (capi_dy_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 5th argument `dy' of linalg_utils.daxpy to C/Fortran array" );
  } else {
    dy = (double *)(capi_dy_tmp->data);

  /* Processing variable n */
    f2py_success = int_from_pyobj(&n,n_capi,"linalg_utils.daxpy() 1st argument (n) can't be converted to int");
  if (f2py_success) {
  /* Processing variable dx */
  ;
  capi_dx_intent |= F2PY_INTENT_IN;
  capi_dx_tmp = array_from_pyobj(NPY_DOUBLE,dx_Dims,dx_Rank,capi_dx_intent,dx_capi);
  if (capi_dx_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 3rd argument `dx' of linalg_utils.daxpy to C/Fortran array" );
  } else {
    dx = (double *)(capi_dx_tmp->data);

  /* Processing variable da */
    f2py_success = double_from_pyobj(&da,da_capi,"linalg_utils.daxpy() 2nd argument (da) can't be converted to double");
  if (f2py_success) {
/*end of frompyobj*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_call_clock();
#endif
/*callfortranroutine*/
        (*f2py_func)(&n,&da,dx,&incx,dy,&incy);
if (PyErr_Occurred())
  f2py_success = 0;
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_call_clock();
#endif
/*end of callfortranroutine*/
    if (f2py_success) {
/*pyobjfrom*/
/*end of pyobjfrom*/
    CFUNCSMESS("Building return value.\n");
    capi_buildvalue = Py_BuildValue("");
/*closepyobjfrom*/
/*end of closepyobjfrom*/
    } /*if (f2py_success) after callfortranroutine*/
/*cleanupfrompyobj*/
  } /*if (f2py_success) of da*/
  /* End of cleaning variable da */
  if((PyObject *)capi_dx_tmp!=dx_capi) {
    Py_XDECREF(capi_dx_tmp); }
  }  /*if (capi_dx_tmp == NULL) ... else of dx*/
  /* End of cleaning variable dx */
  } /*if (f2py_success) of n*/
  /* End of cleaning variable n */
  if((PyObject *)capi_dy_tmp!=dy_capi) {
    Py_XDECREF(capi_dy_tmp); }
  }  /*if (capi_dy_tmp == NULL) ... else of dy*/
  /* End of cleaning variable dy */
  } /*if (f2py_success) of incy*/
  /* End of cleaning variable incy */
  } /*if (f2py_success) of incx*/
  /* End of cleaning variable incx */
/*end of cleanupfrompyobj*/
  if (capi_buildvalue == NULL) {
/*routdebugfailure*/
  } else {
/*routdebugleave*/
  }
  CFUNCSMESS("Freeing memory.\n");
/*freemem*/
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_clock();
#endif
  return capi_buildvalue;
}
/******************************** end of daxpy ********************************/

/*********************************** dasum ***********************************/
static char doc_f2py_rout_linalg_utils_dasum[] = "\
dasum = dasum(n,dx,incx)\n\nWrapper for ``dasum``.\
\n\nParameters\n----------\n"
"n : input int\n"
"dx : input rank-1 array('d') with bounds (*)\n"
"incx : input int\n"
"\nReturns\n-------\n"
"dasum : float";
/* extern void F_WRAPPEDFUNC(dasum,DASUM)(double*,int*,double*,int*); */
static PyObject *f2py_rout_linalg_utils_dasum(const PyObject *capi_self,
                           PyObject *capi_args,
                           PyObject *capi_keywds,
                           void (*f2py_func)(double*,int*,double*,int*)) {
  PyObject * volatile capi_buildvalue = NULL;
  volatile int f2py_success = 1;
/*decl*/

  double dasum = 0;
  int n = 0;
  PyObject *n_capi = Py_None;
  double *dx = NULL;
  npy_intp dx_Dims[1] = {-1};
  const int dx_Rank = 1;
  PyArrayObject *capi_dx_tmp = NULL;
  int capi_dx_intent = 0;
  PyObject *dx_capi = Py_None;
  int incx = 0;
  PyObject *incx_capi = Py_None;
  static char *capi_kwlist[] = {"n","dx","incx",NULL};

/*routdebugenter*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_clock();
#endif
  if (!PyArg_ParseTupleAndKeywords(capi_args,capi_keywds,\
    "OOO:linalg_utils.dasum",\
    capi_kwlist,&n_capi,&dx_capi,&incx_capi))
    return NULL;
/*frompyobj*/
  /* Processing variable incx */
    f2py_success = int_from_pyobj(&incx,incx_capi,"linalg_utils.dasum() 3rd argument (incx) can't be converted to int");
  if (f2py_success) {
  /* Processing variable n */
    f2py_success = int_from_pyobj(&n,n_capi,"linalg_utils.dasum() 1st argument (n) can't be converted to int");
  if (f2py_success) {
  /* Processing variable dasum */
  /* Processing variable dx */
  ;
  capi_dx_intent |= F2PY_INTENT_IN;
  capi_dx_tmp = array_from_pyobj(NPY_DOUBLE,dx_Dims,dx_Rank,capi_dx_intent,dx_capi);
  if (capi_dx_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 2nd argument `dx' of linalg_utils.dasum to C/Fortran array" );
  } else {
    dx = (double *)(capi_dx_tmp->data);

/*end of frompyobj*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_call_clock();
#endif
/*callfortranroutine*/
  (*f2py_func)(&dasum,&n,dx,&incx);
if (PyErr_Occurred())
  f2py_success = 0;
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_call_clock();
#endif
/*end of callfortranroutine*/
    if (f2py_success) {
/*pyobjfrom*/
/*end of pyobjfrom*/
    CFUNCSMESS("Building return value.\n");
    capi_buildvalue = Py_BuildValue("d",dasum);
/*closepyobjfrom*/
/*end of closepyobjfrom*/
    } /*if (f2py_success) after callfortranroutine*/
/*cleanupfrompyobj*/
  if((PyObject *)capi_dx_tmp!=dx_capi) {
    Py_XDECREF(capi_dx_tmp); }
  }  /*if (capi_dx_tmp == NULL) ... else of dx*/
  /* End of cleaning variable dx */
  /* End of cleaning variable dasum */
  } /*if (f2py_success) of n*/
  /* End of cleaning variable n */
  } /*if (f2py_success) of incx*/
  /* End of cleaning variable incx */
/*end of cleanupfrompyobj*/
  if (capi_buildvalue == NULL) {
/*routdebugfailure*/
  } else {
/*routdebugleave*/
  }
  CFUNCSMESS("Freeing memory.\n");
/*freemem*/
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_clock();
#endif
  return capi_buildvalue;
}
/******************************** end of dasum ********************************/

/*********************************** dpotrs ***********************************/
static char doc_f2py_rout_linalg_utils_dpotrs[] = "\
dpotrs(uplo,n,nrhs,a,b,info,[lda,ldb])\n\nWrapper for ``dpotrs``.\
\n\nParameters\n----------\n"
"uplo : input string(len=1)\n"
"n : input int\n"
"nrhs : input int\n"
"a : input rank-2 array('d') with bounds (lda,*)\n"
"b : input rank-2 array('d') with bounds (ldb,*)\n"
"info : input int\n"
"\nOther Parameters\n----------------\n"
"lda : input int, optional\n    Default: shape(a,0)\n"
"ldb : input int, optional\n    Default: shape(b,0)";
/* extern void F_FUNC(dpotrs,DPOTRS)(string,int*,int*,double*,int*,double*,int*,int*,size_t); */
static PyObject *f2py_rout_linalg_utils_dpotrs(const PyObject *capi_self,
                           PyObject *capi_args,
                           PyObject *capi_keywds,
                           void (*f2py_func)(string,int*,int*,double*,int*,double*,int*,int*,size_t)) {
  PyObject * volatile capi_buildvalue = NULL;
  volatile int f2py_success = 1;
/*decl*/

  string uplo = NULL;
  int slen(uplo);
  PyObject *uplo_capi = Py_None;
  int n = 0;
  PyObject *n_capi = Py_None;
  int nrhs = 0;
  PyObject *nrhs_capi = Py_None;
  double *a = NULL;
  npy_intp a_Dims[2] = {-1, -1};
  const int a_Rank = 2;
  PyArrayObject *capi_a_tmp = NULL;
  int capi_a_intent = 0;
  PyObject *a_capi = Py_None;
  int lda = 0;
  PyObject *lda_capi = Py_None;
  double *b = NULL;
  npy_intp b_Dims[2] = {-1, -1};
  const int b_Rank = 2;
  PyArrayObject *capi_b_tmp = NULL;
  int capi_b_intent = 0;
  PyObject *b_capi = Py_None;
  int ldb = 0;
  PyObject *ldb_capi = Py_None;
  int info = 0;
  PyObject *info_capi = Py_None;
  static char *capi_kwlist[] = {"uplo","n","nrhs","a","b","info","lda","ldb",NULL};

/*routdebugenter*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_clock();
#endif
  if (!PyArg_ParseTupleAndKeywords(capi_args,capi_keywds,\
    "OOOOOO|OO:linalg_utils.dpotrs",\
    capi_kwlist,&uplo_capi,&n_capi,&nrhs_capi,&a_capi,&b_capi,&info_capi,&lda_capi,&ldb_capi))
    return NULL;
/*frompyobj*/
  /* Processing variable info */
    f2py_success = int_from_pyobj(&info,info_capi,"linalg_utils.dpotrs() 6th argument (info) can't be converted to int");
  if (f2py_success) {
  /* Processing variable b */
  ;
  capi_b_intent |= F2PY_INTENT_IN;
  capi_b_tmp = array_from_pyobj(NPY_DOUBLE,b_Dims,b_Rank,capi_b_intent,b_capi);
  if (capi_b_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 5th argument `b' of linalg_utils.dpotrs to C/Fortran array" );
  } else {
    b = (double *)(capi_b_tmp->data);

  /* Processing variable uplo */
  slen(uplo) = 1;
  f2py_success = string_from_pyobj(&uplo,&slen(uplo),"",uplo_capi,"string_from_pyobj failed in converting 1st argument `uplo' of linalg_utils.dpotrs to C string");
  if (f2py_success) {
  /* Processing variable n */
    f2py_success = int_from_pyobj(&n,n_capi,"linalg_utils.dpotrs() 2nd argument (n) can't be converted to int");
  if (f2py_success) {
  /* Processing variable a */
  ;
  capi_a_intent |= F2PY_INTENT_IN;
  capi_a_tmp = array_from_pyobj(NPY_DOUBLE,a_Dims,a_Rank,capi_a_intent,a_capi);
  if (capi_a_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 4th argument `a' of linalg_utils.dpotrs to C/Fortran array" );
  } else {
    a = (double *)(capi_a_tmp->data);

  /* Processing variable nrhs */
    f2py_success = int_from_pyobj(&nrhs,nrhs_capi,"linalg_utils.dpotrs() 3rd argument (nrhs) can't be converted to int");
  if (f2py_success) {
  /* Processing variable ldb */
  if (ldb_capi == Py_None) ldb = shape(b,0); else
    f2py_success = int_from_pyobj(&ldb,ldb_capi,"linalg_utils.dpotrs() 2nd keyword (ldb) can't be converted to int");
  if (f2py_success) {
  CHECKSCALAR(shape(b,0)==ldb,"shape(b,0)==ldb","2nd keyword ldb","dpotrs:ldb=%d",ldb) {
  /* Processing variable lda */
  if (lda_capi == Py_None) lda = shape(a,0); else
    f2py_success = int_from_pyobj(&lda,lda_capi,"linalg_utils.dpotrs() 1st keyword (lda) can't be converted to int");
  if (f2py_success) {
  CHECKSCALAR(shape(a,0)==lda,"shape(a,0)==lda","1st keyword lda","dpotrs:lda=%d",lda) {
/*end of frompyobj*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_call_clock();
#endif
/*callfortranroutine*/
        (*f2py_func)(uplo,&n,&nrhs,a,&lda,b,&ldb,&info,slen(uplo));
if (PyErr_Occurred())
  f2py_success = 0;
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_call_clock();
#endif
/*end of callfortranroutine*/
    if (f2py_success) {
/*pyobjfrom*/
/*end of pyobjfrom*/
    CFUNCSMESS("Building return value.\n");
    capi_buildvalue = Py_BuildValue("");
/*closepyobjfrom*/
/*end of closepyobjfrom*/
    } /*if (f2py_success) after callfortranroutine*/
/*cleanupfrompyobj*/
  } /*CHECKSCALAR(shape(a,0)==lda)*/
  } /*if (f2py_success) of lda*/
  /* End of cleaning variable lda */
  } /*CHECKSCALAR(shape(b,0)==ldb)*/
  } /*if (f2py_success) of ldb*/
  /* End of cleaning variable ldb */
  } /*if (f2py_success) of nrhs*/
  /* End of cleaning variable nrhs */
  if((PyObject *)capi_a_tmp!=a_capi) {
    Py_XDECREF(capi_a_tmp); }
  }  /*if (capi_a_tmp == NULL) ... else of a*/
  /* End of cleaning variable a */
  } /*if (f2py_success) of n*/
  /* End of cleaning variable n */
    STRINGFREE(uplo);
  }  /*if (f2py_success) of uplo*/
  /* End of cleaning variable uplo */
  if((PyObject *)capi_b_tmp!=b_capi) {
    Py_XDECREF(capi_b_tmp); }
  }  /*if (capi_b_tmp == NULL) ... else of b*/
  /* End of cleaning variable b */
  } /*if (f2py_success) of info*/
  /* End of cleaning variable info */
/*end of cleanupfrompyobj*/
  if (capi_buildvalue == NULL) {
/*routdebugfailure*/
  } else {
/*routdebugleave*/
  }
  CFUNCSMESS("Freeing memory.\n");
/*freemem*/
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_clock();
#endif
  return capi_buildvalue;
}
/******************************* end of dpotrs *******************************/

/*********************************** dpotrf ***********************************/
static char doc_f2py_rout_linalg_utils_dpotrf[] = "\
dpotrf(uplo,n,a,info,[lda])\n\nWrapper for ``dpotrf``.\
\n\nParameters\n----------\n"
"uplo : input string(len=1)\n"
"n : input int\n"
"a : input rank-2 array('d') with bounds (lda,*)\n"
"info : input int\n"
"\nOther Parameters\n----------------\n"
"lda : input int, optional\n    Default: shape(a,0)";
/* extern void F_FUNC(dpotrf,DPOTRF)(string,int*,double*,int*,int*,size_t); */
static PyObject *f2py_rout_linalg_utils_dpotrf(const PyObject *capi_self,
                           PyObject *capi_args,
                           PyObject *capi_keywds,
                           void (*f2py_func)(string,int*,double*,int*,int*,size_t)) {
  PyObject * volatile capi_buildvalue = NULL;
  volatile int f2py_success = 1;
/*decl*/

  string uplo = NULL;
  int slen(uplo);
  PyObject *uplo_capi = Py_None;
  int n = 0;
  PyObject *n_capi = Py_None;
  double *a = NULL;
  npy_intp a_Dims[2] = {-1, -1};
  const int a_Rank = 2;
  PyArrayObject *capi_a_tmp = NULL;
  int capi_a_intent = 0;
  PyObject *a_capi = Py_None;
  int lda = 0;
  PyObject *lda_capi = Py_None;
  int info = 0;
  PyObject *info_capi = Py_None;
  static char *capi_kwlist[] = {"uplo","n","a","info","lda",NULL};

/*routdebugenter*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_clock();
#endif
  if (!PyArg_ParseTupleAndKeywords(capi_args,capi_keywds,\
    "OOOO|O:linalg_utils.dpotrf",\
    capi_kwlist,&uplo_capi,&n_capi,&a_capi,&info_capi,&lda_capi))
    return NULL;
/*frompyobj*/
  /* Processing variable a */
  ;
  capi_a_intent |= F2PY_INTENT_IN;
  capi_a_tmp = array_from_pyobj(NPY_DOUBLE,a_Dims,a_Rank,capi_a_intent,a_capi);
  if (capi_a_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 3rd argument `a' of linalg_utils.dpotrf to C/Fortran array" );
  } else {
    a = (double *)(capi_a_tmp->data);

  /* Processing variable uplo */
  slen(uplo) = 1;
  f2py_success = string_from_pyobj(&uplo,&slen(uplo),"",uplo_capi,"string_from_pyobj failed in converting 1st argument `uplo' of linalg_utils.dpotrf to C string");
  if (f2py_success) {
  /* Processing variable info */
    f2py_success = int_from_pyobj(&info,info_capi,"linalg_utils.dpotrf() 4th argument (info) can't be converted to int");
  if (f2py_success) {
  /* Processing variable n */
    f2py_success = int_from_pyobj(&n,n_capi,"linalg_utils.dpotrf() 2nd argument (n) can't be converted to int");
  if (f2py_success) {
  /* Processing variable lda */
  if (lda_capi == Py_None) lda = shape(a,0); else
    f2py_success = int_from_pyobj(&lda,lda_capi,"linalg_utils.dpotrf() 1st keyword (lda) can't be converted to int");
  if (f2py_success) {
  CHECKSCALAR(shape(a,0)==lda,"shape(a,0)==lda","1st keyword lda","dpotrf:lda=%d",lda) {
/*end of frompyobj*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_call_clock();
#endif
/*callfortranroutine*/
        (*f2py_func)(uplo,&n,a,&lda,&info,slen(uplo));
if (PyErr_Occurred())
  f2py_success = 0;
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_call_clock();
#endif
/*end of callfortranroutine*/
    if (f2py_success) {
/*pyobjfrom*/
/*end of pyobjfrom*/
    CFUNCSMESS("Building return value.\n");
    capi_buildvalue = Py_BuildValue("");
/*closepyobjfrom*/
/*end of closepyobjfrom*/
    } /*if (f2py_success) after callfortranroutine*/
/*cleanupfrompyobj*/
  } /*CHECKSCALAR(shape(a,0)==lda)*/
  } /*if (f2py_success) of lda*/
  /* End of cleaning variable lda */
  } /*if (f2py_success) of n*/
  /* End of cleaning variable n */
  } /*if (f2py_success) of info*/
  /* End of cleaning variable info */
    STRINGFREE(uplo);
  }  /*if (f2py_success) of uplo*/
  /* End of cleaning variable uplo */
  if((PyObject *)capi_a_tmp!=a_capi) {
    Py_XDECREF(capi_a_tmp); }
  }  /*if (capi_a_tmp == NULL) ... else of a*/
  /* End of cleaning variable a */
/*end of cleanupfrompyobj*/
  if (capi_buildvalue == NULL) {
/*routdebugfailure*/
  } else {
/*routdebugleave*/
  }
  CFUNCSMESS("Freeing memory.\n");
/*freemem*/
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_clock();
#endif
  return capi_buildvalue;
}
/******************************* end of dpotrf *******************************/

/*********************************** dpotf2 ***********************************/
static char doc_f2py_rout_linalg_utils_dpotf2[] = "\
dpotf2(uplo,n,a,info,[lda])\n\nWrapper for ``dpotf2``.\
\n\nParameters\n----------\n"
"uplo : input string(len=1)\n"
"n : input int\n"
"a : input rank-2 array('d') with bounds (lda,*)\n"
"info : input int\n"
"\nOther Parameters\n----------------\n"
"lda : input int, optional\n    Default: shape(a,0)";
/* extern void F_FUNC(dpotf2,DPOTF2)(string,int*,double*,int*,int*,size_t); */
static PyObject *f2py_rout_linalg_utils_dpotf2(const PyObject *capi_self,
                           PyObject *capi_args,
                           PyObject *capi_keywds,
                           void (*f2py_func)(string,int*,double*,int*,int*,size_t)) {
  PyObject * volatile capi_buildvalue = NULL;
  volatile int f2py_success = 1;
/*decl*/

  string uplo = NULL;
  int slen(uplo);
  PyObject *uplo_capi = Py_None;
  int n = 0;
  PyObject *n_capi = Py_None;
  double *a = NULL;
  npy_intp a_Dims[2] = {-1, -1};
  const int a_Rank = 2;
  PyArrayObject *capi_a_tmp = NULL;
  int capi_a_intent = 0;
  PyObject *a_capi = Py_None;
  int lda = 0;
  PyObject *lda_capi = Py_None;
  int info = 0;
  PyObject *info_capi = Py_None;
  static char *capi_kwlist[] = {"uplo","n","a","info","lda",NULL};

/*routdebugenter*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_clock();
#endif
  if (!PyArg_ParseTupleAndKeywords(capi_args,capi_keywds,\
    "OOOO|O:linalg_utils.dpotf2",\
    capi_kwlist,&uplo_capi,&n_capi,&a_capi,&info_capi,&lda_capi))
    return NULL;
/*frompyobj*/
  /* Processing variable info */
    f2py_success = int_from_pyobj(&info,info_capi,"linalg_utils.dpotf2() 4th argument (info) can't be converted to int");
  if (f2py_success) {
  /* Processing variable a */
  ;
  capi_a_intent |= F2PY_INTENT_IN;
  capi_a_tmp = array_from_pyobj(NPY_DOUBLE,a_Dims,a_Rank,capi_a_intent,a_capi);
  if (capi_a_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 3rd argument `a' of linalg_utils.dpotf2 to C/Fortran array" );
  } else {
    a = (double *)(capi_a_tmp->data);

  /* Processing variable uplo */
  slen(uplo) = 1;
  f2py_success = string_from_pyobj(&uplo,&slen(uplo),"",uplo_capi,"string_from_pyobj failed in converting 1st argument `uplo' of linalg_utils.dpotf2 to C string");
  if (f2py_success) {
  /* Processing variable n */
    f2py_success = int_from_pyobj(&n,n_capi,"linalg_utils.dpotf2() 2nd argument (n) can't be converted to int");
  if (f2py_success) {
  /* Processing variable lda */
  if (lda_capi == Py_None) lda = shape(a,0); else
    f2py_success = int_from_pyobj(&lda,lda_capi,"linalg_utils.dpotf2() 1st keyword (lda) can't be converted to int");
  if (f2py_success) {
  CHECKSCALAR(shape(a,0)==lda,"shape(a,0)==lda","1st keyword lda","dpotf2:lda=%d",lda) {
/*end of frompyobj*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_call_clock();
#endif
/*callfortranroutine*/
        (*f2py_func)(uplo,&n,a,&lda,&info,slen(uplo));
if (PyErr_Occurred())
  f2py_success = 0;
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_call_clock();
#endif
/*end of callfortranroutine*/
    if (f2py_success) {
/*pyobjfrom*/
/*end of pyobjfrom*/
    CFUNCSMESS("Building return value.\n");
    capi_buildvalue = Py_BuildValue("");
/*closepyobjfrom*/
/*end of closepyobjfrom*/
    } /*if (f2py_success) after callfortranroutine*/
/*cleanupfrompyobj*/
  } /*CHECKSCALAR(shape(a,0)==lda)*/
  } /*if (f2py_success) of lda*/
  /* End of cleaning variable lda */
  } /*if (f2py_success) of n*/
  /* End of cleaning variable n */
    STRINGFREE(uplo);
  }  /*if (f2py_success) of uplo*/
  /* End of cleaning variable uplo */
  if((PyObject *)capi_a_tmp!=a_capi) {
    Py_XDECREF(capi_a_tmp); }
  }  /*if (capi_a_tmp == NULL) ... else of a*/
  /* End of cleaning variable a */
  } /*if (f2py_success) of info*/
  /* End of cleaning variable info */
/*end of cleanupfrompyobj*/
  if (capi_buildvalue == NULL) {
/*routdebugfailure*/
  } else {
/*routdebugleave*/
  }
  CFUNCSMESS("Freeing memory.\n");
/*freemem*/
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_clock();
#endif
  return capi_buildvalue;
}
/******************************* end of dpotf2 *******************************/

/*********************************** ilaenv ***********************************/
static char doc_f2py_rout_linalg_utils_ilaenv[] = "\
ilaenv = ilaenv(ispec,name,opts,n1,n2,n3,n4)\n\nWrapper for ``ilaenv``.\
\n\nParameters\n----------\n"
"ispec : input int\n"
"name : input string(len=-1)\n"
"opts : input string(len=-1)\n"
"n1 : input int\n"
"n2 : input int\n"
"n3 : input int\n"
"n4 : input int\n"
"\nReturns\n-------\n"
"ilaenv : int";
/* extern void F_WRAPPEDFUNC(ilaenv,ILAENV)(int*,int*,string,string,int*,int*,int*,int*,size_t,size_t); */
static PyObject *f2py_rout_linalg_utils_ilaenv(const PyObject *capi_self,
                           PyObject *capi_args,
                           PyObject *capi_keywds,
                           void (*f2py_func)(int*,int*,string,string,int*,int*,int*,int*,size_t,size_t)) {
  PyObject * volatile capi_buildvalue = NULL;
  volatile int f2py_success = 1;
/*decl*/

  int ilaenv = 0;
  int ispec = 0;
  PyObject *ispec_capi = Py_None;
  string name = NULL;
  int slen(name);
  PyObject *name_capi = Py_None;
  string opts = NULL;
  int slen(opts);
  PyObject *opts_capi = Py_None;
  int n1 = 0;
  PyObject *n1_capi = Py_None;
  int n2 = 0;
  PyObject *n2_capi = Py_None;
  int n3 = 0;
  PyObject *n3_capi = Py_None;
  int n4 = 0;
  PyObject *n4_capi = Py_None;
  static char *capi_kwlist[] = {"ispec","name","opts","n1","n2","n3","n4",NULL};

/*routdebugenter*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_clock();
#endif
  if (!PyArg_ParseTupleAndKeywords(capi_args,capi_keywds,\
    "OOOOOOO:linalg_utils.ilaenv",\
    capi_kwlist,&ispec_capi,&name_capi,&opts_capi,&n1_capi,&n2_capi,&n3_capi,&n4_capi))
    return NULL;
/*frompyobj*/
  /* Processing variable name */
  slen(name) = -1;
  f2py_success = string_from_pyobj(&name,&slen(name),"",name_capi,"string_from_pyobj failed in converting 2nd argument `name' of linalg_utils.ilaenv to C string");
  if (f2py_success) {
  /* Processing variable ilaenv */
  /* Processing variable ispec */
    f2py_success = int_from_pyobj(&ispec,ispec_capi,"linalg_utils.ilaenv() 1st argument (ispec) can't be converted to int");
  if (f2py_success) {
  /* Processing variable n1 */
    f2py_success = int_from_pyobj(&n1,n1_capi,"linalg_utils.ilaenv() 4th argument (n1) can't be converted to int");
  if (f2py_success) {
  /* Processing variable n2 */
    f2py_success = int_from_pyobj(&n2,n2_capi,"linalg_utils.ilaenv() 5th argument (n2) can't be converted to int");
  if (f2py_success) {
  /* Processing variable n3 */
    f2py_success = int_from_pyobj(&n3,n3_capi,"linalg_utils.ilaenv() 6th argument (n3) can't be converted to int");
  if (f2py_success) {
  /* Processing variable n4 */
    f2py_success = int_from_pyobj(&n4,n4_capi,"linalg_utils.ilaenv() 7th argument (n4) can't be converted to int");
  if (f2py_success) {
  /* Processing variable opts */
  slen(opts) = -1;
  f2py_success = string_from_pyobj(&opts,&slen(opts),"",opts_capi,"string_from_pyobj failed in converting 3rd argument `opts' of linalg_utils.ilaenv to C string");
  if (f2py_success) {
/*end of frompyobj*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_call_clock();
#endif
/*callfortranroutine*/
  (*f2py_func)(&ilaenv,&ispec,name,opts,&n1,&n2,&n3,&n4,slen(name),slen(opts));
if (PyErr_Occurred())
  f2py_success = 0;
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_call_clock();
#endif
/*end of callfortranroutine*/
    if (f2py_success) {
/*pyobjfrom*/
/*end of pyobjfrom*/
    CFUNCSMESS("Building return value.\n");
    capi_buildvalue = Py_BuildValue("i",ilaenv);
/*closepyobjfrom*/
/*end of closepyobjfrom*/
    } /*if (f2py_success) after callfortranroutine*/
/*cleanupfrompyobj*/
    STRINGFREE(opts);
  }  /*if (f2py_success) of opts*/
  /* End of cleaning variable opts */
  } /*if (f2py_success) of n4*/
  /* End of cleaning variable n4 */
  } /*if (f2py_success) of n3*/
  /* End of cleaning variable n3 */
  } /*if (f2py_success) of n2*/
  /* End of cleaning variable n2 */
  } /*if (f2py_success) of n1*/
  /* End of cleaning variable n1 */
  } /*if (f2py_success) of ispec*/
  /* End of cleaning variable ispec */
  /* End of cleaning variable ilaenv */
    STRINGFREE(name);
  }  /*if (f2py_success) of name*/
  /* End of cleaning variable name */
/*end of cleanupfrompyobj*/
  if (capi_buildvalue == NULL) {
/*routdebugfailure*/
  } else {
/*routdebugleave*/
  }
  CFUNCSMESS("Freeing memory.\n");
/*freemem*/
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_clock();
#endif
  return capi_buildvalue;
}
/******************************* end of ilaenv *******************************/

/*********************************** dlamch ***********************************/
static char doc_f2py_rout_linalg_utils_dlamch[] = "\
dlamch = dlamch(cmach)\n\nWrapper for ``dlamch``.\
\n\nParameters\n----------\n"
"cmach : input string(len=1)\n"
"\nReturns\n-------\n"
"dlamch : float";
/* extern void F_WRAPPEDFUNC(dlamch,DLAMCH)(double*,string,size_t); */
static PyObject *f2py_rout_linalg_utils_dlamch(const PyObject *capi_self,
                           PyObject *capi_args,
                           PyObject *capi_keywds,
                           void (*f2py_func)(double*,string,size_t)) {
  PyObject * volatile capi_buildvalue = NULL;
  volatile int f2py_success = 1;
/*decl*/

  double dlamch = 0;
  string cmach = NULL;
  int slen(cmach);
  PyObject *cmach_capi = Py_None;
  static char *capi_kwlist[] = {"cmach",NULL};

/*routdebugenter*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_clock();
#endif
  if (!PyArg_ParseTupleAndKeywords(capi_args,capi_keywds,\
    "O:linalg_utils.dlamch",\
    capi_kwlist,&cmach_capi))
    return NULL;
/*frompyobj*/
  /* Processing variable cmach */
  slen(cmach) = 1;
  f2py_success = string_from_pyobj(&cmach,&slen(cmach),"",cmach_capi,"string_from_pyobj failed in converting 1st argument `cmach' of linalg_utils.dlamch to C string");
  if (f2py_success) {
  /* Processing variable dlamch */
/*end of frompyobj*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_call_clock();
#endif
/*callfortranroutine*/
  (*f2py_func)(&dlamch,cmach,slen(cmach));
if (PyErr_Occurred())
  f2py_success = 0;
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_call_clock();
#endif
/*end of callfortranroutine*/
    if (f2py_success) {
/*pyobjfrom*/
/*end of pyobjfrom*/
    CFUNCSMESS("Building return value.\n");
    capi_buildvalue = Py_BuildValue("d",dlamch);
/*closepyobjfrom*/
/*end of closepyobjfrom*/
    } /*if (f2py_success) after callfortranroutine*/
/*cleanupfrompyobj*/
  /* End of cleaning variable dlamch */
    STRINGFREE(cmach);
  }  /*if (f2py_success) of cmach*/
  /* End of cleaning variable cmach */
/*end of cleanupfrompyobj*/
  if (capi_buildvalue == NULL) {
/*routdebugfailure*/
  } else {
/*routdebugleave*/
  }
  CFUNCSMESS("Freeing memory.\n");
/*freemem*/
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_clock();
#endif
  return capi_buildvalue;
}
/******************************* end of dlamch *******************************/

/*********************************** dlamc1 ***********************************/
static char doc_f2py_rout_linalg_utils_dlamc1[] = "\
dlamc1(beta,t,rnd,ieee1)\n\nWrapper for ``dlamc1``.\
\n\nParameters\n----------\n"
"beta : input int\n"
"t : input int\n"
"rnd : input int\n"
"ieee1 : input int";
/* extern void F_FUNC(dlamc1,DLAMC1)(int*,int*,int*,int*); */
static PyObject *f2py_rout_linalg_utils_dlamc1(const PyObject *capi_self,
                           PyObject *capi_args,
                           PyObject *capi_keywds,
                           void (*f2py_func)(int*,int*,int*,int*)) {
  PyObject * volatile capi_buildvalue = NULL;
  volatile int f2py_success = 1;
/*decl*/

  int beta = 0;
  PyObject *beta_capi = Py_None;
  int t = 0;
  PyObject *t_capi = Py_None;
  int rnd = 0;
  PyObject *rnd_capi = Py_None;
  int ieee1 = 0;
  PyObject *ieee1_capi = Py_None;
  static char *capi_kwlist[] = {"beta","t","rnd","ieee1",NULL};

/*routdebugenter*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_clock();
#endif
  if (!PyArg_ParseTupleAndKeywords(capi_args,capi_keywds,\
    "OOOO:linalg_utils.dlamc1",\
    capi_kwlist,&beta_capi,&t_capi,&rnd_capi,&ieee1_capi))
    return NULL;
/*frompyobj*/
  /* Processing variable rnd */
    rnd = (int)PyObject_IsTrue(rnd_capi);
    f2py_success = 1;
  if (f2py_success) {
  /* Processing variable beta */
    f2py_success = int_from_pyobj(&beta,beta_capi,"linalg_utils.dlamc1() 1st argument (beta) can't be converted to int");
  if (f2py_success) {
  /* Processing variable t */
    f2py_success = int_from_pyobj(&t,t_capi,"linalg_utils.dlamc1() 2nd argument (t) can't be converted to int");
  if (f2py_success) {
  /* Processing variable ieee1 */
    ieee1 = (int)PyObject_IsTrue(ieee1_capi);
    f2py_success = 1;
  if (f2py_success) {
/*end of frompyobj*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_call_clock();
#endif
/*callfortranroutine*/
        (*f2py_func)(&beta,&t,&rnd,&ieee1);
if (PyErr_Occurred())
  f2py_success = 0;
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_call_clock();
#endif
/*end of callfortranroutine*/
    if (f2py_success) {
/*pyobjfrom*/
/*end of pyobjfrom*/
    CFUNCSMESS("Building return value.\n");
    capi_buildvalue = Py_BuildValue("");
/*closepyobjfrom*/
/*end of closepyobjfrom*/
    } /*if (f2py_success) after callfortranroutine*/
/*cleanupfrompyobj*/
  } /*if (f2py_success) of ieee1*/
  /* End of cleaning variable ieee1 */
  } /*if (f2py_success) of t*/
  /* End of cleaning variable t */
  } /*if (f2py_success) of beta*/
  /* End of cleaning variable beta */
  } /*if (f2py_success) of rnd*/
  /* End of cleaning variable rnd */
/*end of cleanupfrompyobj*/
  if (capi_buildvalue == NULL) {
/*routdebugfailure*/
  } else {
/*routdebugleave*/
  }
  CFUNCSMESS("Freeing memory.\n");
/*freemem*/
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_clock();
#endif
  return capi_buildvalue;
}
/******************************* end of dlamc1 *******************************/

/*********************************** dlamc2 ***********************************/
static char doc_f2py_rout_linalg_utils_dlamc2[] = "\
dlamc2(beta,t,rnd,eps,emin,rmin,emax,rmax)\n\nWrapper for ``dlamc2``.\
\n\nParameters\n----------\n"
"beta : input int\n"
"t : input int\n"
"rnd : input int\n"
"eps : input float\n"
"emin : input int\n"
"rmin : input float\n"
"emax : input int\n"
"rmax : input float";
/* extern void F_FUNC(dlamc2,DLAMC2)(int*,int*,int*,double*,int*,double*,int*,double*); */
static PyObject *f2py_rout_linalg_utils_dlamc2(const PyObject *capi_self,
                           PyObject *capi_args,
                           PyObject *capi_keywds,
                           void (*f2py_func)(int*,int*,int*,double*,int*,double*,int*,double*)) {
  PyObject * volatile capi_buildvalue = NULL;
  volatile int f2py_success = 1;
/*decl*/

  int beta = 0;
  PyObject *beta_capi = Py_None;
  int t = 0;
  PyObject *t_capi = Py_None;
  int rnd = 0;
  PyObject *rnd_capi = Py_None;
  double eps = 0;
  PyObject *eps_capi = Py_None;
  int emin = 0;
  PyObject *emin_capi = Py_None;
  double rmin = 0;
  PyObject *rmin_capi = Py_None;
  int emax = 0;
  PyObject *emax_capi = Py_None;
  double rmax = 0;
  PyObject *rmax_capi = Py_None;
  static char *capi_kwlist[] = {"beta","t","rnd","eps","emin","rmin","emax","rmax",NULL};

/*routdebugenter*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_clock();
#endif
  if (!PyArg_ParseTupleAndKeywords(capi_args,capi_keywds,\
    "OOOOOOOO:linalg_utils.dlamc2",\
    capi_kwlist,&beta_capi,&t_capi,&rnd_capi,&eps_capi,&emin_capi,&rmin_capi,&emax_capi,&rmax_capi))
    return NULL;
/*frompyobj*/
  /* Processing variable emax */
    f2py_success = int_from_pyobj(&emax,emax_capi,"linalg_utils.dlamc2() 7th argument (emax) can't be converted to int");
  if (f2py_success) {
  /* Processing variable rmin */
    f2py_success = double_from_pyobj(&rmin,rmin_capi,"linalg_utils.dlamc2() 6th argument (rmin) can't be converted to double");
  if (f2py_success) {
  /* Processing variable rmax */
    f2py_success = double_from_pyobj(&rmax,rmax_capi,"linalg_utils.dlamc2() 8th argument (rmax) can't be converted to double");
  if (f2py_success) {
  /* Processing variable rnd */
    rnd = (int)PyObject_IsTrue(rnd_capi);
    f2py_success = 1;
  if (f2py_success) {
  /* Processing variable beta */
    f2py_success = int_from_pyobj(&beta,beta_capi,"linalg_utils.dlamc2() 1st argument (beta) can't be converted to int");
  if (f2py_success) {
  /* Processing variable emin */
    f2py_success = int_from_pyobj(&emin,emin_capi,"linalg_utils.dlamc2() 5th argument (emin) can't be converted to int");
  if (f2py_success) {
  /* Processing variable eps */
    f2py_success = double_from_pyobj(&eps,eps_capi,"linalg_utils.dlamc2() 4th argument (eps) can't be converted to double");
  if (f2py_success) {
  /* Processing variable t */
    f2py_success = int_from_pyobj(&t,t_capi,"linalg_utils.dlamc2() 2nd argument (t) can't be converted to int");
  if (f2py_success) {
/*end of frompyobj*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_call_clock();
#endif
/*callfortranroutine*/
        (*f2py_func)(&beta,&t,&rnd,&eps,&emin,&rmin,&emax,&rmax);
if (PyErr_Occurred())
  f2py_success = 0;
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_call_clock();
#endif
/*end of callfortranroutine*/
    if (f2py_success) {
/*pyobjfrom*/
/*end of pyobjfrom*/
    CFUNCSMESS("Building return value.\n");
    capi_buildvalue = Py_BuildValue("");
/*closepyobjfrom*/
/*end of closepyobjfrom*/
    } /*if (f2py_success) after callfortranroutine*/
/*cleanupfrompyobj*/
  } /*if (f2py_success) of t*/
  /* End of cleaning variable t */
  } /*if (f2py_success) of eps*/
  /* End of cleaning variable eps */
  } /*if (f2py_success) of emin*/
  /* End of cleaning variable emin */
  } /*if (f2py_success) of beta*/
  /* End of cleaning variable beta */
  } /*if (f2py_success) of rnd*/
  /* End of cleaning variable rnd */
  } /*if (f2py_success) of rmax*/
  /* End of cleaning variable rmax */
  } /*if (f2py_success) of rmin*/
  /* End of cleaning variable rmin */
  } /*if (f2py_success) of emax*/
  /* End of cleaning variable emax */
/*end of cleanupfrompyobj*/
  if (capi_buildvalue == NULL) {
/*routdebugfailure*/
  } else {
/*routdebugleave*/
  }
  CFUNCSMESS("Freeing memory.\n");
/*freemem*/
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_clock();
#endif
  return capi_buildvalue;
}
/******************************* end of dlamc2 *******************************/

/*********************************** dlamc3 ***********************************/
static char doc_f2py_rout_linalg_utils_dlamc3[] = "\
dlamc3 = dlamc3(a,b)\n\nWrapper for ``dlamc3``.\
\n\nParameters\n----------\n"
"a : input float\n"
"b : input float\n"
"\nReturns\n-------\n"
"dlamc3 : float";
/* extern void F_WRAPPEDFUNC(dlamc3,DLAMC3)(double*,double*,double*); */
static PyObject *f2py_rout_linalg_utils_dlamc3(const PyObject *capi_self,
                           PyObject *capi_args,
                           PyObject *capi_keywds,
                           void (*f2py_func)(double*,double*,double*)) {
  PyObject * volatile capi_buildvalue = NULL;
  volatile int f2py_success = 1;
/*decl*/

  double dlamc3 = 0;
  double a = 0;
  PyObject *a_capi = Py_None;
  double b = 0;
  PyObject *b_capi = Py_None;
  static char *capi_kwlist[] = {"a","b",NULL};

/*routdebugenter*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_clock();
#endif
  if (!PyArg_ParseTupleAndKeywords(capi_args,capi_keywds,\
    "OO:linalg_utils.dlamc3",\
    capi_kwlist,&a_capi,&b_capi))
    return NULL;
/*frompyobj*/
  /* Processing variable a */
    f2py_success = double_from_pyobj(&a,a_capi,"linalg_utils.dlamc3() 1st argument (a) can't be converted to double");
  if (f2py_success) {
  /* Processing variable b */
    f2py_success = double_from_pyobj(&b,b_capi,"linalg_utils.dlamc3() 2nd argument (b) can't be converted to double");
  if (f2py_success) {
  /* Processing variable dlamc3 */
/*end of frompyobj*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_call_clock();
#endif
/*callfortranroutine*/
  (*f2py_func)(&dlamc3,&a,&b);
if (PyErr_Occurred())
  f2py_success = 0;
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_call_clock();
#endif
/*end of callfortranroutine*/
    if (f2py_success) {
/*pyobjfrom*/
/*end of pyobjfrom*/
    CFUNCSMESS("Building return value.\n");
    capi_buildvalue = Py_BuildValue("d",dlamc3);
/*closepyobjfrom*/
/*end of closepyobjfrom*/
    } /*if (f2py_success) after callfortranroutine*/
/*cleanupfrompyobj*/
  /* End of cleaning variable dlamc3 */
  } /*if (f2py_success) of b*/
  /* End of cleaning variable b */
  } /*if (f2py_success) of a*/
  /* End of cleaning variable a */
/*end of cleanupfrompyobj*/
  if (capi_buildvalue == NULL) {
/*routdebugfailure*/
  } else {
/*routdebugleave*/
  }
  CFUNCSMESS("Freeing memory.\n");
/*freemem*/
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_clock();
#endif
  return capi_buildvalue;
}
/******************************* end of dlamc3 *******************************/

/*********************************** dlamc4 ***********************************/
static char doc_f2py_rout_linalg_utils_dlamc4[] = "\
dlamc4(emin,start,base)\n\nWrapper for ``dlamc4``.\
\n\nParameters\n----------\n"
"emin : input int\n"
"start : input float\n"
"base : input int";
/* extern void F_FUNC(dlamc4,DLAMC4)(int*,double*,int*); */
static PyObject *f2py_rout_linalg_utils_dlamc4(const PyObject *capi_self,
                           PyObject *capi_args,
                           PyObject *capi_keywds,
                           void (*f2py_func)(int*,double*,int*)) {
  PyObject * volatile capi_buildvalue = NULL;
  volatile int f2py_success = 1;
/*decl*/

  int emin = 0;
  PyObject *emin_capi = Py_None;
  double start = 0;
  PyObject *start_capi = Py_None;
  int base = 0;
  PyObject *base_capi = Py_None;
  static char *capi_kwlist[] = {"emin","start","base",NULL};

/*routdebugenter*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_clock();
#endif
  if (!PyArg_ParseTupleAndKeywords(capi_args,capi_keywds,\
    "OOO:linalg_utils.dlamc4",\
    capi_kwlist,&emin_capi,&start_capi,&base_capi))
    return NULL;
/*frompyobj*/
  /* Processing variable emin */
    f2py_success = int_from_pyobj(&emin,emin_capi,"linalg_utils.dlamc4() 1st argument (emin) can't be converted to int");
  if (f2py_success) {
  /* Processing variable start */
    f2py_success = double_from_pyobj(&start,start_capi,"linalg_utils.dlamc4() 2nd argument (start) can't be converted to double");
  if (f2py_success) {
  /* Processing variable base */
    f2py_success = int_from_pyobj(&base,base_capi,"linalg_utils.dlamc4() 3rd argument (base) can't be converted to int");
  if (f2py_success) {
/*end of frompyobj*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_call_clock();
#endif
/*callfortranroutine*/
        (*f2py_func)(&emin,&start,&base);
if (PyErr_Occurred())
  f2py_success = 0;
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_call_clock();
#endif
/*end of callfortranroutine*/
    if (f2py_success) {
/*pyobjfrom*/
/*end of pyobjfrom*/
    CFUNCSMESS("Building return value.\n");
    capi_buildvalue = Py_BuildValue("");
/*closepyobjfrom*/
/*end of closepyobjfrom*/
    } /*if (f2py_success) after callfortranroutine*/
/*cleanupfrompyobj*/
  } /*if (f2py_success) of base*/
  /* End of cleaning variable base */
  } /*if (f2py_success) of start*/
  /* End of cleaning variable start */
  } /*if (f2py_success) of emin*/
  /* End of cleaning variable emin */
/*end of cleanupfrompyobj*/
  if (capi_buildvalue == NULL) {
/*routdebugfailure*/
  } else {
/*routdebugleave*/
  }
  CFUNCSMESS("Freeing memory.\n");
/*freemem*/
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_clock();
#endif
  return capi_buildvalue;
}
/******************************* end of dlamc4 *******************************/

/*********************************** dlamc5 ***********************************/
static char doc_f2py_rout_linalg_utils_dlamc5[] = "\
dlamc5(beta,p,emin,ieee,emax,rmax)\n\nWrapper for ``dlamc5``.\
\n\nParameters\n----------\n"
"beta : input int\n"
"p : input int\n"
"emin : input int\n"
"ieee : input int\n"
"emax : input int\n"
"rmax : input float";
/* extern void F_FUNC(dlamc5,DLAMC5)(int*,int*,int*,int*,int*,double*); */
static PyObject *f2py_rout_linalg_utils_dlamc5(const PyObject *capi_self,
                           PyObject *capi_args,
                           PyObject *capi_keywds,
                           void (*f2py_func)(int*,int*,int*,int*,int*,double*)) {
  PyObject * volatile capi_buildvalue = NULL;
  volatile int f2py_success = 1;
/*decl*/

  int beta = 0;
  PyObject *beta_capi = Py_None;
  int p = 0;
  PyObject *p_capi = Py_None;
  int emin = 0;
  PyObject *emin_capi = Py_None;
  int ieee = 0;
  PyObject *ieee_capi = Py_None;
  int emax = 0;
  PyObject *emax_capi = Py_None;
  double rmax = 0;
  PyObject *rmax_capi = Py_None;
  static char *capi_kwlist[] = {"beta","p","emin","ieee","emax","rmax",NULL};

/*routdebugenter*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_clock();
#endif
  if (!PyArg_ParseTupleAndKeywords(capi_args,capi_keywds,\
    "OOOOOO:linalg_utils.dlamc5",\
    capi_kwlist,&beta_capi,&p_capi,&emin_capi,&ieee_capi,&emax_capi,&rmax_capi))
    return NULL;
/*frompyobj*/
  /* Processing variable p */
    f2py_success = int_from_pyobj(&p,p_capi,"linalg_utils.dlamc5() 2nd argument (p) can't be converted to int");
  if (f2py_success) {
  /* Processing variable emax */
    f2py_success = int_from_pyobj(&emax,emax_capi,"linalg_utils.dlamc5() 5th argument (emax) can't be converted to int");
  if (f2py_success) {
  /* Processing variable rmax */
    f2py_success = double_from_pyobj(&rmax,rmax_capi,"linalg_utils.dlamc5() 6th argument (rmax) can't be converted to double");
  if (f2py_success) {
  /* Processing variable ieee */
    ieee = (int)PyObject_IsTrue(ieee_capi);
    f2py_success = 1;
  if (f2py_success) {
  /* Processing variable emin */
    f2py_success = int_from_pyobj(&emin,emin_capi,"linalg_utils.dlamc5() 3rd argument (emin) can't be converted to int");
  if (f2py_success) {
  /* Processing variable beta */
    f2py_success = int_from_pyobj(&beta,beta_capi,"linalg_utils.dlamc5() 1st argument (beta) can't be converted to int");
  if (f2py_success) {
/*end of frompyobj*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_call_clock();
#endif
/*callfortranroutine*/
        (*f2py_func)(&beta,&p,&emin,&ieee,&emax,&rmax);
if (PyErr_Occurred())
  f2py_success = 0;
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_call_clock();
#endif
/*end of callfortranroutine*/
    if (f2py_success) {
/*pyobjfrom*/
/*end of pyobjfrom*/
    CFUNCSMESS("Building return value.\n");
    capi_buildvalue = Py_BuildValue("");
/*closepyobjfrom*/
/*end of closepyobjfrom*/
    } /*if (f2py_success) after callfortranroutine*/
/*cleanupfrompyobj*/
  } /*if (f2py_success) of beta*/
  /* End of cleaning variable beta */
  } /*if (f2py_success) of emin*/
  /* End of cleaning variable emin */
  } /*if (f2py_success) of ieee*/
  /* End of cleaning variable ieee */
  } /*if (f2py_success) of rmax*/
  /* End of cleaning variable rmax */
  } /*if (f2py_success) of emax*/
  /* End of cleaning variable emax */
  } /*if (f2py_success) of p*/
  /* End of cleaning variable p */
/*end of cleanupfrompyobj*/
  if (capi_buildvalue == NULL) {
/*routdebugfailure*/
  } else {
/*routdebugleave*/
  }
  CFUNCSMESS("Freeing memory.\n");
/*freemem*/
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_clock();
#endif
  return capi_buildvalue;
}
/******************************* end of dlamc5 *******************************/

/*********************************** ilaver ***********************************/
static char doc_f2py_rout_linalg_utils_ilaver[] = "\
ilaver(vers_major,vers_minor,vers_patch)\n\nWrapper for ``ilaver``.\
\n\nParameters\n----------\n"
"vers_major : input int\n"
"vers_minor : input int\n"
"vers_patch : input int";
/* extern void F_FUNC(ilaver,ILAVER)(int*,int*,int*); */
static PyObject *f2py_rout_linalg_utils_ilaver(const PyObject *capi_self,
                           PyObject *capi_args,
                           PyObject *capi_keywds,
                           void (*f2py_func)(int*,int*,int*)) {
  PyObject * volatile capi_buildvalue = NULL;
  volatile int f2py_success = 1;
/*decl*/

  int vers_major = 0;
  PyObject *vers_major_capi = Py_None;
  int vers_minor = 0;
  PyObject *vers_minor_capi = Py_None;
  int vers_patch = 0;
  PyObject *vers_patch_capi = Py_None;
  static char *capi_kwlist[] = {"vers_major","vers_minor","vers_patch",NULL};

/*routdebugenter*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_clock();
#endif
  if (!PyArg_ParseTupleAndKeywords(capi_args,capi_keywds,\
    "OOO:linalg_utils.ilaver",\
    capi_kwlist,&vers_major_capi,&vers_minor_capi,&vers_patch_capi))
    return NULL;
/*frompyobj*/
  /* Processing variable vers_minor */
    f2py_success = int_from_pyobj(&vers_minor,vers_minor_capi,"linalg_utils.ilaver() 2nd argument (vers_minor) can't be converted to int");
  if (f2py_success) {
  /* Processing variable vers_patch */
    f2py_success = int_from_pyobj(&vers_patch,vers_patch_capi,"linalg_utils.ilaver() 3rd argument (vers_patch) can't be converted to int");
  if (f2py_success) {
  /* Processing variable vers_major */
    f2py_success = int_from_pyobj(&vers_major,vers_major_capi,"linalg_utils.ilaver() 1st argument (vers_major) can't be converted to int");
  if (f2py_success) {
/*end of frompyobj*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_call_clock();
#endif
/*callfortranroutine*/
        (*f2py_func)(&vers_major,&vers_minor,&vers_patch);
if (PyErr_Occurred())
  f2py_success = 0;
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_call_clock();
#endif
/*end of callfortranroutine*/
    if (f2py_success) {
/*pyobjfrom*/
/*end of pyobjfrom*/
    CFUNCSMESS("Building return value.\n");
    capi_buildvalue = Py_BuildValue("");
/*closepyobjfrom*/
/*end of closepyobjfrom*/
    } /*if (f2py_success) after callfortranroutine*/
/*cleanupfrompyobj*/
  } /*if (f2py_success) of vers_major*/
  /* End of cleaning variable vers_major */
  } /*if (f2py_success) of vers_patch*/
  /* End of cleaning variable vers_patch */
  } /*if (f2py_success) of vers_minor*/
  /* End of cleaning variable vers_minor */
/*end of cleanupfrompyobj*/
  if (capi_buildvalue == NULL) {
/*routdebugfailure*/
  } else {
/*routdebugleave*/
  }
  CFUNCSMESS("Freeing memory.\n");
/*freemem*/
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_clock();
#endif
  return capi_buildvalue;
}
/******************************* end of ilaver *******************************/

/*********************************** ieeeck ***********************************/
static char doc_f2py_rout_linalg_utils_ieeeck[] = "\
ieeeck = ieeeck(ispec,zero,one)\n\nWrapper for ``ieeeck``.\
\n\nParameters\n----------\n"
"ispec : input int\n"
"zero : input float\n"
"one : input float\n"
"\nReturns\n-------\n"
"ieeeck : int";
/* extern void F_WRAPPEDFUNC(ieeeck,IEEECK)(int*,int*,float*,float*); */
static PyObject *f2py_rout_linalg_utils_ieeeck(const PyObject *capi_self,
                           PyObject *capi_args,
                           PyObject *capi_keywds,
                           void (*f2py_func)(int*,int*,float*,float*)) {
  PyObject * volatile capi_buildvalue = NULL;
  volatile int f2py_success = 1;
/*decl*/

  int ieeeck = 0;
  int ispec = 0;
  PyObject *ispec_capi = Py_None;
  float zero = 0;
  PyObject *zero_capi = Py_None;
  float one = 0;
  PyObject *one_capi = Py_None;
  static char *capi_kwlist[] = {"ispec","zero","one",NULL};

/*routdebugenter*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_clock();
#endif
  if (!PyArg_ParseTupleAndKeywords(capi_args,capi_keywds,\
    "OOO:linalg_utils.ieeeck",\
    capi_kwlist,&ispec_capi,&zero_capi,&one_capi))
    return NULL;
/*frompyobj*/
  /* Processing variable ieeeck */
  /* Processing variable one */
    f2py_success = float_from_pyobj(&one,one_capi,"linalg_utils.ieeeck() 3rd argument (one) can't be converted to float");
  if (f2py_success) {
  /* Processing variable ispec */
    f2py_success = int_from_pyobj(&ispec,ispec_capi,"linalg_utils.ieeeck() 1st argument (ispec) can't be converted to int");
  if (f2py_success) {
  /* Processing variable zero */
    f2py_success = float_from_pyobj(&zero,zero_capi,"linalg_utils.ieeeck() 2nd argument (zero) can't be converted to float");
  if (f2py_success) {
/*end of frompyobj*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_call_clock();
#endif
/*callfortranroutine*/
  (*f2py_func)(&ieeeck,&ispec,&zero,&one);
if (PyErr_Occurred())
  f2py_success = 0;
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_call_clock();
#endif
/*end of callfortranroutine*/
    if (f2py_success) {
/*pyobjfrom*/
/*end of pyobjfrom*/
    CFUNCSMESS("Building return value.\n");
    capi_buildvalue = Py_BuildValue("i",ieeeck);
/*closepyobjfrom*/
/*end of closepyobjfrom*/
    } /*if (f2py_success) after callfortranroutine*/
/*cleanupfrompyobj*/
  } /*if (f2py_success) of zero*/
  /* End of cleaning variable zero */
  } /*if (f2py_success) of ispec*/
  /* End of cleaning variable ispec */
  } /*if (f2py_success) of one*/
  /* End of cleaning variable one */
  /* End of cleaning variable ieeeck */
/*end of cleanupfrompyobj*/
  if (capi_buildvalue == NULL) {
/*routdebugfailure*/
  } else {
/*routdebugleave*/
  }
  CFUNCSMESS("Freeing memory.\n");
/*freemem*/
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_clock();
#endif
  return capi_buildvalue;
}
/******************************* end of ieeeck *******************************/

/*********************************** iparmq ***********************************/
static char doc_f2py_rout_linalg_utils_iparmq[] = "\
iparmq = iparmq(ispec,name,opts,n,ilo,ihi,lwork)\n\nWrapper for ``iparmq``.\
\n\nParameters\n----------\n"
"ispec : input int\n"
"name : input string(len=-1)\n"
"opts : input string(len=-1)\n"
"n : input int\n"
"ilo : input int\n"
"ihi : input int\n"
"lwork : input int\n"
"\nReturns\n-------\n"
"iparmq : int";
/* extern void F_WRAPPEDFUNC(iparmq,IPARMQ)(int*,int*,string,string,int*,int*,int*,int*,size_t,size_t); */
static PyObject *f2py_rout_linalg_utils_iparmq(const PyObject *capi_self,
                           PyObject *capi_args,
                           PyObject *capi_keywds,
                           void (*f2py_func)(int*,int*,string,string,int*,int*,int*,int*,size_t,size_t)) {
  PyObject * volatile capi_buildvalue = NULL;
  volatile int f2py_success = 1;
/*decl*/

  int iparmq = 0;
  int ispec = 0;
  PyObject *ispec_capi = Py_None;
  string name = NULL;
  int slen(name);
  PyObject *name_capi = Py_None;
  string opts = NULL;
  int slen(opts);
  PyObject *opts_capi = Py_None;
  int n = 0;
  PyObject *n_capi = Py_None;
  int ilo = 0;
  PyObject *ilo_capi = Py_None;
  int ihi = 0;
  PyObject *ihi_capi = Py_None;
  int lwork = 0;
  PyObject *lwork_capi = Py_None;
  static char *capi_kwlist[] = {"ispec","name","opts","n","ilo","ihi","lwork",NULL};

/*routdebugenter*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_clock();
#endif
  if (!PyArg_ParseTupleAndKeywords(capi_args,capi_keywds,\
    "OOOOOOO:linalg_utils.iparmq",\
    capi_kwlist,&ispec_capi,&name_capi,&opts_capi,&n_capi,&ilo_capi,&ihi_capi,&lwork_capi))
    return NULL;
/*frompyobj*/
  /* Processing variable iparmq */
  /* Processing variable ihi */
    f2py_success = int_from_pyobj(&ihi,ihi_capi,"linalg_utils.iparmq() 6th argument (ihi) can't be converted to int");
  if (f2py_success) {
  /* Processing variable lwork */
    f2py_success = int_from_pyobj(&lwork,lwork_capi,"linalg_utils.iparmq() 7th argument (lwork) can't be converted to int");
  if (f2py_success) {
  /* Processing variable name */
  slen(name) = -1;
  f2py_success = string_from_pyobj(&name,&slen(name),"",name_capi,"string_from_pyobj failed in converting 2nd argument `name' of linalg_utils.iparmq to C string");
  if (f2py_success) {
  /* Processing variable ilo */
    f2py_success = int_from_pyobj(&ilo,ilo_capi,"linalg_utils.iparmq() 5th argument (ilo) can't be converted to int");
  if (f2py_success) {
  /* Processing variable n */
    f2py_success = int_from_pyobj(&n,n_capi,"linalg_utils.iparmq() 4th argument (n) can't be converted to int");
  if (f2py_success) {
  /* Processing variable ispec */
    f2py_success = int_from_pyobj(&ispec,ispec_capi,"linalg_utils.iparmq() 1st argument (ispec) can't be converted to int");
  if (f2py_success) {
  /* Processing variable opts */
  slen(opts) = -1;
  f2py_success = string_from_pyobj(&opts,&slen(opts),"",opts_capi,"string_from_pyobj failed in converting 3rd argument `opts' of linalg_utils.iparmq to C string");
  if (f2py_success) {
/*end of frompyobj*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_call_clock();
#endif
/*callfortranroutine*/
  (*f2py_func)(&iparmq,&ispec,name,opts,&n,&ilo,&ihi,&lwork,slen(name),slen(opts));
if (PyErr_Occurred())
  f2py_success = 0;
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_call_clock();
#endif
/*end of callfortranroutine*/
    if (f2py_success) {
/*pyobjfrom*/
/*end of pyobjfrom*/
    CFUNCSMESS("Building return value.\n");
    capi_buildvalue = Py_BuildValue("i",iparmq);
/*closepyobjfrom*/
/*end of closepyobjfrom*/
    } /*if (f2py_success) after callfortranroutine*/
/*cleanupfrompyobj*/
    STRINGFREE(opts);
  }  /*if (f2py_success) of opts*/
  /* End of cleaning variable opts */
  } /*if (f2py_success) of ispec*/
  /* End of cleaning variable ispec */
  } /*if (f2py_success) of n*/
  /* End of cleaning variable n */
  } /*if (f2py_success) of ilo*/
  /* End of cleaning variable ilo */
    STRINGFREE(name);
  }  /*if (f2py_success) of name*/
  /* End of cleaning variable name */
  } /*if (f2py_success) of lwork*/
  /* End of cleaning variable lwork */
  } /*if (f2py_success) of ihi*/
  /* End of cleaning variable ihi */
  /* End of cleaning variable iparmq */
/*end of cleanupfrompyobj*/
  if (capi_buildvalue == NULL) {
/*routdebugfailure*/
  } else {
/*routdebugleave*/
  }
  CFUNCSMESS("Freeing memory.\n");
/*freemem*/
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_clock();
#endif
  return capi_buildvalue;
}
/******************************* end of iparmq *******************************/
/*eof body*/

/******************* See f2py2e/f90mod_rules.py: buildhooks *******************/
/*need_f90modhooks*/

/************** See f2py2e/rules.py: module_rules['modulebody'] **************/

/******************* See f2py2e/common_rules.py: buildhooks *******************/

/*need_commonhooks*/

/**************************** See f2py2e/rules.py ****************************/

static FortranDataDef f2py_routine_defs[] = {
  {"remove_duplicates",-1,{{-1}},0,(char *)F_FUNC_US(remove_duplicates,REMOVE_DUPLICATES),(f2py_init_func)f2py_rout_linalg_utils_remove_duplicates,doc_f2py_rout_linalg_utils_remove_duplicates},
  {"check_repeats",-1,{{-1}},0,(char *)F_FUNC_US(check_repeats,CHECK_REPEATS),(f2py_init_func)f2py_rout_linalg_utils_check_repeats,doc_f2py_rout_linalg_utils_check_repeats},
  {"diag_call",-1,{{-1}},0,(char *)F_FUNC_US(diag_call,DIAG_CALL),(f2py_init_func)f2py_rout_linalg_utils_diag_call,doc_f2py_rout_linalg_utils_diag_call},
  {"basis_diag_call",-1,{{-1}},0,(char *)F_FUNC_US(basis_diag_call,BASIS_DIAG_CALL),(f2py_init_func)f2py_rout_linalg_utils_basis_diag_call,doc_f2py_rout_linalg_utils_basis_diag_call},
  {"gp_array_logp",-1,{{-1}},0,(char *)F_FUNC_US(gp_array_logp,GP_ARRAY_LOGP),(f2py_init_func)f2py_rout_linalg_utils_gp_array_logp,doc_f2py_rout_linalg_utils_gp_array_logp},
  {"asqs",-1,{{-1}},0,(char *)F_FUNC(asqs,ASQS),(f2py_init_func)f2py_rout_linalg_utils_asqs,doc_f2py_rout_linalg_utils_asqs},
  {"dcopy_wrap",-1,{{-1}},0,(char *)F_FUNC_US(dcopy_wrap,DCOPY_WRAP),(f2py_init_func)f2py_rout_linalg_utils_dcopy_wrap,doc_f2py_rout_linalg_utils_dcopy_wrap},
  {"dtrmm_wrap",-1,{{-1}},0,(char *)F_FUNC_US(dtrmm_wrap,DTRMM_WRAP),(f2py_init_func)f2py_rout_linalg_utils_dtrmm_wrap,doc_f2py_rout_linalg_utils_dtrmm_wrap},
  {"dtrsm_wrap",-1,{{-1}},0,(char *)F_FUNC_US(dtrsm_wrap,DTRSM_WRAP),(f2py_init_func)f2py_rout_linalg_utils_dtrsm_wrap,doc_f2py_rout_linalg_utils_dtrsm_wrap},
  {"dpotrf_wrap",-1,{{-1}},0,(char *)F_FUNC_US(dpotrf_wrap,DPOTRF_WRAP),(f2py_init_func)f2py_rout_linalg_utils_dpotrf_wrap,doc_f2py_rout_linalg_utils_dpotrf_wrap},
  {"dchdc_wrap",-1,{{-1}},0,(char *)F_FUNC_US(dchdc_wrap,DCHDC_WRAP),(f2py_init_func)f2py_rout_linalg_utils_dchdc_wrap,doc_f2py_rout_linalg_utils_dchdc_wrap},
  {"dpotrs_wrap",-1,{{-1}},0,(char *)F_FUNC_US(dpotrs_wrap,DPOTRS_WRAP),(f2py_init_func)f2py_rout_linalg_utils_dpotrs_wrap,doc_f2py_rout_linalg_utils_dpotrs_wrap},
  {"xerbla",-1,{{-1}},0,(char *)F_FUNC(xerbla,XERBLA),(f2py_init_func)f2py_rout_linalg_utils_xerbla,doc_f2py_rout_linalg_utils_xerbla},
  {"lsame",-1,{{-1}},0,(char *)F_WRAPPEDFUNC(lsame,LSAME),(f2py_init_func)f2py_rout_linalg_utils_lsame,doc_f2py_rout_linalg_utils_lsame},
  {"idamax",-1,{{-1}},0,(char *)F_WRAPPEDFUNC(idamax,IDAMAX),(f2py_init_func)f2py_rout_linalg_utils_idamax,doc_f2py_rout_linalg_utils_idamax},
  {"dznrm2",-1,{{-1}},0,(char *)F_WRAPPEDFUNC(dznrm2,DZNRM2),(f2py_init_func)f2py_rout_linalg_utils_dznrm2,doc_f2py_rout_linalg_utils_dznrm2},
  {"dzasum",-1,{{-1}},0,(char *)F_WRAPPEDFUNC(dzasum,DZASUM),(f2py_init_func)f2py_rout_linalg_utils_dzasum,doc_f2py_rout_linalg_utils_dzasum},
  {"dtrsv",-1,{{-1}},0,(char *)F_FUNC(dtrsv,DTRSV),(f2py_init_func)f2py_rout_linalg_utils_dtrsv,doc_f2py_rout_linalg_utils_dtrsv},
  {"dtrsm",-1,{{-1}},0,(char *)F_FUNC(dtrsm,DTRSM),(f2py_init_func)f2py_rout_linalg_utils_dtrsm,doc_f2py_rout_linalg_utils_dtrsm},
  {"dtrmv",-1,{{-1}},0,(char *)F_FUNC(dtrmv,DTRMV),(f2py_init_func)f2py_rout_linalg_utils_dtrmv,doc_f2py_rout_linalg_utils_dtrmv},
  {"dtrmm",-1,{{-1}},0,(char *)F_FUNC(dtrmm,DTRMM),(f2py_init_func)f2py_rout_linalg_utils_dtrmm,doc_f2py_rout_linalg_utils_dtrmm},
  {"dtpsv",-1,{{-1}},0,(char *)F_FUNC(dtpsv,DTPSV),(f2py_init_func)f2py_rout_linalg_utils_dtpsv,doc_f2py_rout_linalg_utils_dtpsv},
  {"dtpmv",-1,{{-1}},0,(char *)F_FUNC(dtpmv,DTPMV),(f2py_init_func)f2py_rout_linalg_utils_dtpmv,doc_f2py_rout_linalg_utils_dtpmv},
  {"dtbsv",-1,{{-1}},0,(char *)F_FUNC(dtbsv,DTBSV),(f2py_init_func)f2py_rout_linalg_utils_dtbsv,doc_f2py_rout_linalg_utils_dtbsv},
  {"dtbmv",-1,{{-1}},0,(char *)F_FUNC(dtbmv,DTBMV),(f2py_init_func)f2py_rout_linalg_utils_dtbmv,doc_f2py_rout_linalg_utils_dtbmv},
  {"dsyrk",-1,{{-1}},0,(char *)F_FUNC(dsyrk,DSYRK),(f2py_init_func)f2py_rout_linalg_utils_dsyrk,doc_f2py_rout_linalg_utils_dsyrk},
  {"dsyr2k",-1,{{-1}},0,(char *)F_FUNC(dsyr2k,DSYR2K),(f2py_init_func)f2py_rout_linalg_utils_dsyr2k,doc_f2py_rout_linalg_utils_dsyr2k},
  {"dsyr2",-1,{{-1}},0,(char *)F_FUNC(dsyr2,DSYR2),(f2py_init_func)f2py_rout_linalg_utils_dsyr2,doc_f2py_rout_linalg_utils_dsyr2},
  {"dsyr",-1,{{-1}},0,(char *)F_FUNC(dsyr,DSYR),(f2py_init_func)f2py_rout_linalg_utils_dsyr,doc_f2py_rout_linalg_utils_dsyr},
  {"dsymv",-1,{{-1}},0,(char *)F_FUNC(dsymv,DSYMV),(f2py_init_func)f2py_rout_linalg_utils_dsymv,doc_f2py_rout_linalg_utils_dsymv},
  {"dsymm",-1,{{-1}},0,(char *)F_FUNC(dsymm,DSYMM),(f2py_init_func)f2py_rout_linalg_utils_dsymm,doc_f2py_rout_linalg_utils_dsymm},
  {"dswap",-1,{{-1}},0,(char *)F_FUNC(dswap,DSWAP),(f2py_init_func)f2py_rout_linalg_utils_dswap,doc_f2py_rout_linalg_utils_dswap},
  {"dspr2",-1,{{-1}},0,(char *)F_FUNC(dspr2,DSPR2),(f2py_init_func)f2py_rout_linalg_utils_dspr2,doc_f2py_rout_linalg_utils_dspr2},
  {"dspr",-1,{{-1}},0,(char *)F_FUNC(dspr,DSPR),(f2py_init_func)f2py_rout_linalg_utils_dspr,doc_f2py_rout_linalg_utils_dspr},
  {"dspmv",-1,{{-1}},0,(char *)F_FUNC(dspmv,DSPMV),(f2py_init_func)f2py_rout_linalg_utils_dspmv,doc_f2py_rout_linalg_utils_dspmv},
  {"dsdot",-1,{{-1}},0,(char *)F_WRAPPEDFUNC(dsdot,DSDOT),(f2py_init_func)f2py_rout_linalg_utils_dsdot,doc_f2py_rout_linalg_utils_dsdot},
  {"dscal",-1,{{-1}},0,(char *)F_FUNC(dscal,DSCAL),(f2py_init_func)f2py_rout_linalg_utils_dscal,doc_f2py_rout_linalg_utils_dscal},
  {"dsbmv",-1,{{-1}},0,(char *)F_FUNC(dsbmv,DSBMV),(f2py_init_func)f2py_rout_linalg_utils_dsbmv,doc_f2py_rout_linalg_utils_dsbmv},
  {"drotmg",-1,{{-1}},0,(char *)F_FUNC(drotmg,DROTMG),(f2py_init_func)f2py_rout_linalg_utils_drotmg,doc_f2py_rout_linalg_utils_drotmg},
  {"drotm",-1,{{-1}},0,(char *)F_FUNC(drotm,DROTM),(f2py_init_func)f2py_rout_linalg_utils_drotm,doc_f2py_rout_linalg_utils_drotm},
  {"drotg",-1,{{-1}},0,(char *)F_FUNC(drotg,DROTG),(f2py_init_func)f2py_rout_linalg_utils_drotg,doc_f2py_rout_linalg_utils_drotg},
  {"drot",-1,{{-1}},0,(char *)F_FUNC(drot,DROT),(f2py_init_func)f2py_rout_linalg_utils_drot,doc_f2py_rout_linalg_utils_drot},
  {"dnrm2",-1,{{-1}},0,(char *)F_WRAPPEDFUNC(dnrm2,DNRM2),(f2py_init_func)f2py_rout_linalg_utils_dnrm2,doc_f2py_rout_linalg_utils_dnrm2},
  {"dger",-1,{{-1}},0,(char *)F_FUNC(dger,DGER),(f2py_init_func)f2py_rout_linalg_utils_dger,doc_f2py_rout_linalg_utils_dger},
  {"dgemv",-1,{{-1}},0,(char *)F_FUNC(dgemv,DGEMV),(f2py_init_func)f2py_rout_linalg_utils_dgemv,doc_f2py_rout_linalg_utils_dgemv},
  {"dgemm",-1,{{-1}},0,(char *)F_FUNC(dgemm,DGEMM),(f2py_init_func)f2py_rout_linalg_utils_dgemm,doc_f2py_rout_linalg_utils_dgemm},
  {"dgbmv",-1,{{-1}},0,(char *)F_FUNC(dgbmv,DGBMV),(f2py_init_func)f2py_rout_linalg_utils_dgbmv,doc_f2py_rout_linalg_utils_dgbmv},
  {"ddot",-1,{{-1}},0,(char *)F_WRAPPEDFUNC(ddot,DDOT),(f2py_init_func)f2py_rout_linalg_utils_ddot,doc_f2py_rout_linalg_utils_ddot},
  {"dcopy",-1,{{-1}},0,(char *)F_FUNC(dcopy,DCOPY),(f2py_init_func)f2py_rout_linalg_utils_dcopy,doc_f2py_rout_linalg_utils_dcopy},
  {"dcabs1",-1,{{-1}},0,(char *)F_WRAPPEDFUNC(dcabs1,DCABS1),(f2py_init_func)f2py_rout_linalg_utils_dcabs1,doc_f2py_rout_linalg_utils_dcabs1},
  {"daxpy",-1,{{-1}},0,(char *)F_FUNC(daxpy,DAXPY),(f2py_init_func)f2py_rout_linalg_utils_daxpy,doc_f2py_rout_linalg_utils_daxpy},
  {"dasum",-1,{{-1}},0,(char *)F_WRAPPEDFUNC(dasum,DASUM),(f2py_init_func)f2py_rout_linalg_utils_dasum,doc_f2py_rout_linalg_utils_dasum},
  {"dpotrs",-1,{{-1}},0,(char *)F_FUNC(dpotrs,DPOTRS),(f2py_init_func)f2py_rout_linalg_utils_dpotrs,doc_f2py_rout_linalg_utils_dpotrs},
  {"dpotrf",-1,{{-1}},0,(char *)F_FUNC(dpotrf,DPOTRF),(f2py_init_func)f2py_rout_linalg_utils_dpotrf,doc_f2py_rout_linalg_utils_dpotrf},
  {"dpotf2",-1,{{-1}},0,(char *)F_FUNC(dpotf2,DPOTF2),(f2py_init_func)f2py_rout_linalg_utils_dpotf2,doc_f2py_rout_linalg_utils_dpotf2},
  {"ilaenv",-1,{{-1}},0,(char *)F_WRAPPEDFUNC(ilaenv,ILAENV),(f2py_init_func)f2py_rout_linalg_utils_ilaenv,doc_f2py_rout_linalg_utils_ilaenv},
  {"dlamch",-1,{{-1}},0,(char *)F_WRAPPEDFUNC(dlamch,DLAMCH),(f2py_init_func)f2py_rout_linalg_utils_dlamch,doc_f2py_rout_linalg_utils_dlamch},
  {"dlamc1",-1,{{-1}},0,(char *)F_FUNC(dlamc1,DLAMC1),(f2py_init_func)f2py_rout_linalg_utils_dlamc1,doc_f2py_rout_linalg_utils_dlamc1},
  {"dlamc2",-1,{{-1}},0,(char *)F_FUNC(dlamc2,DLAMC2),(f2py_init_func)f2py_rout_linalg_utils_dlamc2,doc_f2py_rout_linalg_utils_dlamc2},
  {"dlamc3",-1,{{-1}},0,(char *)F_WRAPPEDFUNC(dlamc3,DLAMC3),(f2py_init_func)f2py_rout_linalg_utils_dlamc3,doc_f2py_rout_linalg_utils_dlamc3},
  {"dlamc4",-1,{{-1}},0,(char *)F_FUNC(dlamc4,DLAMC4),(f2py_init_func)f2py_rout_linalg_utils_dlamc4,doc_f2py_rout_linalg_utils_dlamc4},
  {"dlamc5",-1,{{-1}},0,(char *)F_FUNC(dlamc5,DLAMC5),(f2py_init_func)f2py_rout_linalg_utils_dlamc5,doc_f2py_rout_linalg_utils_dlamc5},
  {"ilaver",-1,{{-1}},0,(char *)F_FUNC(ilaver,ILAVER),(f2py_init_func)f2py_rout_linalg_utils_ilaver,doc_f2py_rout_linalg_utils_ilaver},
  {"ieeeck",-1,{{-1}},0,(char *)F_WRAPPEDFUNC(ieeeck,IEEECK),(f2py_init_func)f2py_rout_linalg_utils_ieeeck,doc_f2py_rout_linalg_utils_ieeeck},
  {"iparmq",-1,{{-1}},0,(char *)F_WRAPPEDFUNC(iparmq,IPARMQ),(f2py_init_func)f2py_rout_linalg_utils_iparmq,doc_f2py_rout_linalg_utils_iparmq},

/*eof routine_defs*/
  {NULL}
};

static PyMethodDef f2py_module_methods[] = {

  {NULL,NULL}
};

#if PY_VERSION_HEX >= 0x03000000
static struct PyModuleDef moduledef = {
  PyModuleDef_HEAD_INIT,
  "linalg_utils",
  NULL,
  -1,
  f2py_module_methods,
  NULL,
  NULL,
  NULL,
  NULL
};
#endif

#if PY_VERSION_HEX >= 0x03000000
#define RETVAL m
PyMODINIT_FUNC PyInit_linalg_utils(void) {
#else
#define RETVAL
PyMODINIT_FUNC initlinalg_utils(void) {
#endif
  int i;
  PyObject *m,*d, *s;
#if PY_VERSION_HEX >= 0x03000000
  m = linalg_utils_module = PyModule_Create(&moduledef);
#else
  m = linalg_utils_module = Py_InitModule("linalg_utils", f2py_module_methods);
#endif
  Py_TYPE(&PyFortran_Type) = &PyType_Type;
  import_array();
  if (PyErr_Occurred())
    {PyErr_SetString(PyExc_ImportError, "can't initialize module linalg_utils (failed to import numpy)"); return RETVAL;}
  d = PyModule_GetDict(m);
  s = PyString_FromString("$Revision: $");
  PyDict_SetItemString(d, "__version__", s);
#if PY_VERSION_HEX >= 0x03000000
  s = PyUnicode_FromString(
#else
  s = PyString_FromString(
#endif
    "This module 'linalg_utils' is auto-generated with f2py (version:2).\nFunctions:\n"
"  nr,rf,rt,nu,xu,ui = remove_duplicates(x)\n"
"  f,new_indices,n_new_indices = check_repeats(x,x_sofar,f_sofar)\n"
"  v = diag_call(x,cov_fun,cov_fun_extra_args=())\n"
"  v = basis_diag_call(basis_x)\n"
"  like = gp_array_logp(x,mu,sig,overwrite_x=0,overwrite_mu=0)\n"
"  asqs(c,s,cmin=0,cmax=-1)\n"
"  dcopy_wrap(x,y)\n"
"  dtrmm_wrap(a,b,side,transa,uplo,alpha)\n"
"  dtrsm_wrap(a,b,side,transa,uplo,alpha)\n"
"  info = dpotrf_wrap(a)\n"
"  piv,info = dchdc_wrap(a)\n"
"  info = dpotrs_wrap(chol_fac,b,uplo='')\n"
"  xerbla(srname,info)\n"
"  lsame = lsame(ca,cb)\n"
"  idamax = idamax(n,dx,incx)\n"
"  dznrm2 = dznrm2(n,x,incx)\n"
"  dzasum = dzasum(n,zx,incx)\n"
"  dtrsv(uplo,trans,diag,n,a,x,incx,lda=shape(a,0))\n"
"  dtrsm(side,uplo,transa,diag,m,n,alpha,a,b,lda=shape(a,0),ldb=shape(b,0))\n"
"  dtrmv(uplo,trans,diag,n,a,x,incx,lda=shape(a,0))\n"
"  dtrmm(side,uplo,transa,diag,m,n,alpha,a,b,lda=shape(a,0),ldb=shape(b,0))\n"
"  dtpsv(uplo,trans,diag,n,ap,x,incx)\n"
"  dtpmv(uplo,trans,diag,n,ap,x,incx)\n"
"  dtbsv(uplo,trans,diag,n,k,a,x,incx,lda=shape(a,0))\n"
"  dtbmv(uplo,trans,diag,n,k,a,x,incx,lda=shape(a,0))\n"
"  dsyrk(uplo,trans,n,k,alpha,a,beta,c,lda=shape(a,0),ldc=shape(c,0))\n"
"  dsyr2k(uplo,trans,n,k,alpha,a,b,beta,c,lda=shape(a,0),ldb=shape(b,0),ldc=shape(c,0))\n"
"  dsyr2(uplo,n,alpha,x,incx,y,incy,a,lda=shape(a,0))\n"
"  dsyr(uplo,n,alpha,x,incx,a,lda=shape(a,0))\n"
"  dsymv(uplo,n,alpha,a,x,incx,beta,y,incy,lda=shape(a,0))\n"
"  dsymm(side,uplo,m,n,alpha,a,b,beta,c,lda=shape(a,0),ldb=shape(b,0),ldc=shape(c,0))\n"
"  dswap(n,dx,incx,dy,incy)\n"
"  dspr2(uplo,n,alpha,x,incx,y,incy,ap)\n"
"  dspr(uplo,n,alpha,x,incx,ap)\n"
"  dspmv(uplo,n,alpha,ap,x,incx,beta,y,incy)\n"
"  dsdot = dsdot(n,sx,incx,sy,incy)\n"
"  dscal(n,da,dx,incx)\n"
"  dsbmv(uplo,n,k,alpha,a,x,incx,beta,y,incy,lda=shape(a,0))\n"
"  drotmg(dd1,dd2,dx1,dy1,dparam)\n"
"  drotm(n,dx,incx,dy,incy,dparam)\n"
"  drotg(da,db,c,s)\n"
"  drot(n,dx,incx,dy,incy,c,s)\n"
"  dnrm2 = dnrm2(n,x,incx)\n"
"  dger(m,n,alpha,x,incx,y,incy,a,lda=shape(a,0))\n"
"  dgemv(trans,m,n,alpha,a,x,incx,beta,y,incy,lda=shape(a,0))\n"
"  dgemm(transa,transb,m,n,k,alpha,a,b,beta,c,lda=shape(a,0),ldb=shape(b,0),ldc=shape(c,0))\n"
"  dgbmv(trans,m,n,kl,ku,alpha,a,x,incx,beta,y,incy,lda=shape(a,0))\n"
"  ddot = ddot(n,dx,incx,dy,incy)\n"
"  dcopy(n,dx,incx,dy,incy)\n"
"  dcabs1 = dcabs1(z)\n"
"  daxpy(n,da,dx,incx,dy,incy)\n"
"  dasum = dasum(n,dx,incx)\n"
"  dpotrs(uplo,n,nrhs,a,b,info,lda=shape(a,0),ldb=shape(b,0))\n"
"  dpotrf(uplo,n,a,info,lda=shape(a,0))\n"
"  dpotf2(uplo,n,a,info,lda=shape(a,0))\n"
"  ilaenv = ilaenv(ispec,name,opts,n1,n2,n3,n4)\n"
"  dlamch = dlamch(cmach)\n"
"  dlamc1(beta,t,rnd,ieee1)\n"
"  dlamc2(beta,t,rnd,eps,emin,rmin,emax,rmax)\n"
"  dlamc3 = dlamc3(a,b)\n"
"  dlamc4(emin,start,base)\n"
"  dlamc5(beta,p,emin,ieee,emax,rmax)\n"
"  ilaver(vers_major,vers_minor,vers_patch)\n"
"  ieeeck = ieeeck(ispec,zero,one)\n"
"  iparmq = iparmq(ispec,name,opts,n,ilo,ihi,lwork)\n"
".");
  PyDict_SetItemString(d, "__doc__", s);
  linalg_utils_error = PyErr_NewException ("linalg_utils.error", NULL, NULL);
  Py_DECREF(s);
  for(i=0;f2py_routine_defs[i].name!=NULL;i++)
    PyDict_SetItemString(d, f2py_routine_defs[i].name,PyFortranObject_NewAsAttr(&f2py_routine_defs[i]));














    {
      extern int F_FUNC(lsame,LSAME)(void);
      PyObject* o = PyDict_GetItemString(d,"lsame");
      PyObject_SetAttrString(o,"_cpointer", F2PyCapsule_FromVoidPtr((void*)F_FUNC(lsame,LSAME),NULL));
#if PY_VERSION_HEX >= 0x03000000
      PyObject_SetAttrString(o,"__name__", PyUnicode_FromString("lsame"));
#else
      PyObject_SetAttrString(o,"__name__", PyString_FromString("lsame"));
#endif
    }
    

    {
      extern int F_FUNC(idamax,IDAMAX)(void);
      PyObject* o = PyDict_GetItemString(d,"idamax");
      PyObject_SetAttrString(o,"_cpointer", F2PyCapsule_FromVoidPtr((void*)F_FUNC(idamax,IDAMAX),NULL));
#if PY_VERSION_HEX >= 0x03000000
      PyObject_SetAttrString(o,"__name__", PyUnicode_FromString("idamax"));
#else
      PyObject_SetAttrString(o,"__name__", PyString_FromString("idamax"));
#endif
    }
    

    {
      extern double F_FUNC(dznrm2,DZNRM2)(void);
      PyObject* o = PyDict_GetItemString(d,"dznrm2");
      PyObject_SetAttrString(o,"_cpointer", F2PyCapsule_FromVoidPtr((void*)F_FUNC(dznrm2,DZNRM2),NULL));
#if PY_VERSION_HEX >= 0x03000000
      PyObject_SetAttrString(o,"__name__", PyUnicode_FromString("dznrm2"));
#else
      PyObject_SetAttrString(o,"__name__", PyString_FromString("dznrm2"));
#endif
    }
    

    {
      extern double F_FUNC(dzasum,DZASUM)(void);
      PyObject* o = PyDict_GetItemString(d,"dzasum");
      PyObject_SetAttrString(o,"_cpointer", F2PyCapsule_FromVoidPtr((void*)F_FUNC(dzasum,DZASUM),NULL));
#if PY_VERSION_HEX >= 0x03000000
      PyObject_SetAttrString(o,"__name__", PyUnicode_FromString("dzasum"));
#else
      PyObject_SetAttrString(o,"__name__", PyString_FromString("dzasum"));
#endif
    }
    



















    {
      extern double F_FUNC(dsdot,DSDOT)(void);
      PyObject* o = PyDict_GetItemString(d,"dsdot");
      PyObject_SetAttrString(o,"_cpointer", F2PyCapsule_FromVoidPtr((void*)F_FUNC(dsdot,DSDOT),NULL));
#if PY_VERSION_HEX >= 0x03000000
      PyObject_SetAttrString(o,"__name__", PyUnicode_FromString("dsdot"));
#else
      PyObject_SetAttrString(o,"__name__", PyString_FromString("dsdot"));
#endif
    }
    







    {
      extern double F_FUNC(dnrm2,DNRM2)(void);
      PyObject* o = PyDict_GetItemString(d,"dnrm2");
      PyObject_SetAttrString(o,"_cpointer", F2PyCapsule_FromVoidPtr((void*)F_FUNC(dnrm2,DNRM2),NULL));
#if PY_VERSION_HEX >= 0x03000000
      PyObject_SetAttrString(o,"__name__", PyUnicode_FromString("dnrm2"));
#else
      PyObject_SetAttrString(o,"__name__", PyString_FromString("dnrm2"));
#endif
    }
    





    {
      extern double F_FUNC(ddot,DDOT)(void);
      PyObject* o = PyDict_GetItemString(d,"ddot");
      PyObject_SetAttrString(o,"_cpointer", F2PyCapsule_FromVoidPtr((void*)F_FUNC(ddot,DDOT),NULL));
#if PY_VERSION_HEX >= 0x03000000
      PyObject_SetAttrString(o,"__name__", PyUnicode_FromString("ddot"));
#else
      PyObject_SetAttrString(o,"__name__", PyString_FromString("ddot"));
#endif
    }
    


    {
      extern double F_FUNC(dcabs1,DCABS1)(void);
      PyObject* o = PyDict_GetItemString(d,"dcabs1");
      PyObject_SetAttrString(o,"_cpointer", F2PyCapsule_FromVoidPtr((void*)F_FUNC(dcabs1,DCABS1),NULL));
#if PY_VERSION_HEX >= 0x03000000
      PyObject_SetAttrString(o,"__name__", PyUnicode_FromString("dcabs1"));
#else
      PyObject_SetAttrString(o,"__name__", PyString_FromString("dcabs1"));
#endif
    }
    


    {
      extern double F_FUNC(dasum,DASUM)(void);
      PyObject* o = PyDict_GetItemString(d,"dasum");
      PyObject_SetAttrString(o,"_cpointer", F2PyCapsule_FromVoidPtr((void*)F_FUNC(dasum,DASUM),NULL));
#if PY_VERSION_HEX >= 0x03000000
      PyObject_SetAttrString(o,"__name__", PyUnicode_FromString("dasum"));
#else
      PyObject_SetAttrString(o,"__name__", PyString_FromString("dasum"));
#endif
    }
    




    {
      extern int F_FUNC(ilaenv,ILAENV)(void);
      PyObject* o = PyDict_GetItemString(d,"ilaenv");
      PyObject_SetAttrString(o,"_cpointer", F2PyCapsule_FromVoidPtr((void*)F_FUNC(ilaenv,ILAENV),NULL));
#if PY_VERSION_HEX >= 0x03000000
      PyObject_SetAttrString(o,"__name__", PyUnicode_FromString("ilaenv"));
#else
      PyObject_SetAttrString(o,"__name__", PyString_FromString("ilaenv"));
#endif
    }
    

    {
      extern double F_FUNC(dlamch,DLAMCH)(void);
      PyObject* o = PyDict_GetItemString(d,"dlamch");
      PyObject_SetAttrString(o,"_cpointer", F2PyCapsule_FromVoidPtr((void*)F_FUNC(dlamch,DLAMCH),NULL));
#if PY_VERSION_HEX >= 0x03000000
      PyObject_SetAttrString(o,"__name__", PyUnicode_FromString("dlamch"));
#else
      PyObject_SetAttrString(o,"__name__", PyString_FromString("dlamch"));
#endif
    }
    



    {
      extern double F_FUNC(dlamc3,DLAMC3)(void);
      PyObject* o = PyDict_GetItemString(d,"dlamc3");
      PyObject_SetAttrString(o,"_cpointer", F2PyCapsule_FromVoidPtr((void*)F_FUNC(dlamc3,DLAMC3),NULL));
#if PY_VERSION_HEX >= 0x03000000
      PyObject_SetAttrString(o,"__name__", PyUnicode_FromString("dlamc3"));
#else
      PyObject_SetAttrString(o,"__name__", PyString_FromString("dlamc3"));
#endif
    }
    




    {
      extern int F_FUNC(ieeeck,IEEECK)(void);
      PyObject* o = PyDict_GetItemString(d,"ieeeck");
      PyObject_SetAttrString(o,"_cpointer", F2PyCapsule_FromVoidPtr((void*)F_FUNC(ieeeck,IEEECK),NULL));
#if PY_VERSION_HEX >= 0x03000000
      PyObject_SetAttrString(o,"__name__", PyUnicode_FromString("ieeeck"));
#else
      PyObject_SetAttrString(o,"__name__", PyString_FromString("ieeeck"));
#endif
    }
    

    {
      extern int F_FUNC(iparmq,IPARMQ)(void);
      PyObject* o = PyDict_GetItemString(d,"iparmq");
      PyObject_SetAttrString(o,"_cpointer", F2PyCapsule_FromVoidPtr((void*)F_FUNC(iparmq,IPARMQ),NULL));
#if PY_VERSION_HEX >= 0x03000000
      PyObject_SetAttrString(o,"__name__", PyUnicode_FromString("iparmq"));
#else
      PyObject_SetAttrString(o,"__name__", PyString_FromString("iparmq"));
#endif
    }
    
/*eof initf2pywraphooks*/
/*eof initf90modhooks*/

/*eof initcommonhooks*/


#ifdef F2PY_REPORT_ATEXIT
  if (! PyErr_Occurred())
    on_exit(f2py_report_on_exit,(void*)"linalg_utils");
#endif

  return RETVAL;
}
#ifdef __cplusplus
}
#endif
